/**
 * vis-timeline and vis-graph2d
 * https://visjs.github.io/vis-timeline/
 *
 * Create a fully customizable, interactive timeline with items and ranges.
 *
 * @version 7.3.7
 * @date    2020-06-20T13:17:46.663Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
 *
 * @license
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */
import t from"moment";import{DataSet as e,createNewDataPipeFrom as i,DataView as n}from"vis-data/peer/esm/vis-data.js";var o="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function r(t,e){return t(e={exports:{}},e.exports),e.exports}function s(t){return t&&t.default||t}var a,l=function(t){return t&&t.Math==Math&&t},h=l("object"==typeof globalThis&&globalThis)||l("object"==typeof window&&window)||l("object"==typeof self&&self)||l("object"==typeof o&&o)||Function("return this")(),u=function(t){try{return!!t()}catch(t){return!0}},d=!u((function(){return 7!=Object.defineProperty({},1,{get:function(){return 7}})[1]})),c={}.propertyIsEnumerable,p=Object.getOwnPropertyDescriptor,m={f:p&&!c.call({1:2},1)?function(t){var e=p(this,t);return!!e&&e.enumerable}:c},f=function(t,e){return{enumerable:!(1&t),configurable:!(2&t),writable:!(4&t),value:e}},g={}.toString,v=function(t){return g.call(t).slice(8,-1)},y="".split,b=u((function(){return!Object("z").propertyIsEnumerable(0)}))?function(t){return"String"==v(t)?y.call(t,""):Object(t)}:Object,w=function(t){if(null==t)throw TypeError("Can't call method on "+t);return t},_=function(t){return b(w(t))},k=function(t){return"object"==typeof t?null!==t:"function"==typeof t},x=function(t,e){if(!k(t))return t;var i,n;if(e&&"function"==typeof(i=t.toString)&&!k(n=i.call(t)))return n;if("function"==typeof(i=t.valueOf)&&!k(n=i.call(t)))return n;if(!e&&"function"==typeof(i=t.toString)&&!k(n=i.call(t)))return n;throw TypeError("Can't convert object to primitive value")},S={}.hasOwnProperty,D=function(t,e){return S.call(t,e)},C=h.document,T=k(C)&&k(C.createElement),O=function(t){return T?C.createElement(t):{}},E=!d&&!u((function(){return 7!=Object.defineProperty(O("div"),"a",{get:function(){return 7}}).a})),I=Object.getOwnPropertyDescriptor,M={f:d?I:function(t,e){if(t=_(t),e=x(e,!0),E)try{return I(t,e)}catch(t){}if(D(t,e))return f(!m.f.call(t,e),t[e])}},A=/#|\.prototype\./,P=function(t,e){var i=R[N(t)];return i==j||i!=L&&("function"==typeof e?u(e):!!e)},N=P.normalize=function(t){return String(t).replace(A,".").toLowerCase()},R=P.data={},L=P.NATIVE="N",j=P.POLYFILL="P",F=P,z={},G=function(t){if("function"!=typeof t)throw TypeError(String(t)+" is not a function");return t},H=function(t,e,i){if(G(t),void 0===e)return t;switch(i){case 0:return function(){return t.call(e)};case 1:return function(i){return t.call(e,i)};case 2:return function(i,n){return t.call(e,i,n)};case 3:return function(i,n,o){return t.call(e,i,n,o)}}return function(){return t.apply(e,arguments)}},B=function(t){if(!k(t))throw TypeError(String(t)+" is not an object");return t},Y=Object.defineProperty,W={f:d?Y:function(t,e,i){if(B(t),e=x(e,!0),B(i),E)try{return Y(t,e,i)}catch(t){}if("get"in i||"set"in i)throw TypeError("Accessors not supported");return"value"in i&&(t[e]=i.value),t}},V=d?function(t,e,i){return W.f(t,e,f(1,i))}:function(t,e,i){return t[e]=i,t},U=M.f,X=function(t){var e=function(e,i,n){if(this instanceof t){switch(arguments.length){case 0:return new t;case 1:return new t(e);case 2:return new t(e,i)}return new t(e,i,n)}return t.apply(this,arguments)};return e.prototype=t.prototype,e},q=function(t,e){var i,n,o,r,s,a,l,u,d=t.target,c=t.global,p=t.stat,m=t.proto,f=c?h:p?h[d]:(h[d]||{}).prototype,g=c?z:z[d]||(z[d]={}),v=g.prototype;for(o in e)i=!F(c?o:d+(p?".":"#")+o,t.forced)&&f&&D(f,o),s=g[o],i&&(a=t.noTargetGet?(u=U(f,o))&&u.value:f[o]),r=i&&a?a:e[o],i&&typeof s==typeof r||(l=t.bind&&i?H(r,h):t.wrap&&i?X(r):m&&"function"==typeof r?H(Function.call,r):r,(t.sham||r&&r.sham||s&&s.sham)&&V(l,"sham",!0),g[o]=l,m&&(D(z,n=d+"Prototype")||V(z,n,{}),z[n][o]=r,t.real&&v&&!v[o]&&V(v,o,r)))},K=function(t){return"function"==typeof t?t:void 0},$=function(t,e){return arguments.length<2?K(z[t])||K(h[t]):z[t]&&z[t][e]||h[t]&&h[t][e]},Z=Math.ceil,Q=Math.floor,J=function(t){return isNaN(t=+t)?0:(t>0?Q:Z)(t)},tt=Math.min,et=function(t){return t>0?tt(J(t),9007199254740991):0},it=Math.max,nt=Math.min,ot=function(t,e){var i=J(t);return i<0?it(i+e,0):nt(i,e)},rt=function(t){return function(e,i,n){var o,r=_(e),s=et(r.length),a=ot(n,s);if(t&&i!=i){for(;s>a;)if((o=r[a++])!=o)return!0}else for(;s>a;a++)if((t||a in r)&&r[a]===i)return t||a||0;return!t&&-1}},st={includes:rt(!0),indexOf:rt(!1)},at={},lt=st.indexOf,ht=function(t,e){var i,n=_(t),o=0,r=[];for(i in n)!D(at,i)&&D(n,i)&&r.push(i);for(;e.length>o;)D(n,i=e[o++])&&(~lt(r,i)||r.push(i));return r},ut=["constructor","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","toLocaleString","toString","valueOf"],dt=Object.keys||function(t){return ht(t,ut)},ct=d?Object.defineProperties:function(t,e){B(t);for(var i,n=dt(e),o=n.length,r=0;o>r;)W.f(t,i=n[r++],e[i]);return t},pt=$("document","documentElement"),mt=h["__core-js_shared__"]||function(t,e){try{V(h,t,e)}catch(i){h[t]=e}return e}("__core-js_shared__",{}),ft=r((function(t){(t.exports=function(t,e){return mt[t]||(mt[t]=void 0!==e?e:{})})("versions",[]).push({version:"3.6.4",mode:"pure",copyright:"© 2020 Denis Pushkarev (zloirock.ru)"})})),gt=0,vt=Math.random(),yt=function(t){return"Symbol("+String(void 0===t?"":t)+")_"+(++gt+vt).toString(36)},bt=ft("keys"),wt=function(t){return bt[t]||(bt[t]=yt(t))},_t=wt("IE_PROTO"),kt=function(){},xt=function(t){return"<script>"+t+"<\/script>"},St=function(){try{a=document.domain&&new ActiveXObject("htmlfile")}catch(t){}var t,e;St=a?function(t){t.write(xt("")),t.close();var e=t.parentWindow.Object;return t=null,e}(a):((e=O("iframe")).style.display="none",pt.appendChild(e),e.src=String("javascript:"),(t=e.contentWindow.document).open(),t.write(xt("document.F=Object")),t.close(),t.F);for(var i=ut.length;i--;)delete St.prototype[ut[i]];return St()};at[_t]=!0;var Dt=Object.create||function(t,e){var i;return null!==t?(kt.prototype=B(t),i=new kt,kt.prototype=null,i[_t]=t):i=St(),void 0===e?i:ct(i,e)},Ct=[].slice,Tt={},Ot=function(t,e,i){if(!(e in Tt)){for(var n=[],o=0;o<e;o++)n[o]="a["+o+"]";Tt[e]=Function("C,a","return new C("+n.join(",")+")")}return Tt[e](t,i)},Et=Function.bind||function(t){var e=G(this),i=Ct.call(arguments,1),n=function(){var o=i.concat(Ct.call(arguments));return this instanceof n?Ot(e,o.length,o):e.apply(t,o)};return k(e.prototype)&&(n.prototype=e.prototype),n},It=$("Reflect","construct"),Mt=u((function(){function t(){}return!(It((function(){}),[],t)instanceof t)})),At=!u((function(){It((function(){}))})),Pt=Mt||At;q({target:"Reflect",stat:!0,forced:Pt,sham:Pt},{construct:function(t,e){G(t),B(e);var i=arguments.length<3?t:G(arguments[2]);if(At&&!Mt)return It(t,e,i);if(t==i){switch(e.length){case 0:return new t;case 1:return new t(e[0]);case 2:return new t(e[0],e[1]);case 3:return new t(e[0],e[1],e[2]);case 4:return new t(e[0],e[1],e[2],e[3])}var n=[null];return n.push.apply(n,e),new(Et.apply(t,n))}var o=i.prototype,r=Dt(k(o)?o:Object.prototype),s=Function.apply.call(t,r,e);return k(s)?s:r}});var Nt=z.Reflect.construct,Rt={},Lt=Function.toString;"function"!=typeof mt.inspectSource&&(mt.inspectSource=function(t){return Lt.call(t)});var jt,Ft,zt,Gt=mt.inspectSource,Ht=h.WeakMap,Bt="function"==typeof Ht&&/native code/.test(Gt(Ht)),Yt=h.WeakMap;if(Bt){var Wt=new Yt,Vt=Wt.get,Ut=Wt.has,Xt=Wt.set;jt=function(t,e){return Xt.call(Wt,t,e),e},Ft=function(t){return Vt.call(Wt,t)||{}},zt=function(t){return Ut.call(Wt,t)}}else{var qt=wt("state");at[qt]=!0,jt=function(t,e){return V(t,qt,e),e},Ft=function(t){return D(t,qt)?t[qt]:{}},zt=function(t){return D(t,qt)}}var Kt,$t,Zt,Qt={set:jt,get:Ft,has:zt,enforce:function(t){return zt(t)?Ft(t):jt(t,{})},getterFor:function(t){return function(e){var i;if(!k(e)||(i=Ft(e)).type!==t)throw TypeError("Incompatible receiver, "+t+" required");return i}}},Jt=function(t){return Object(w(t))},te=!u((function(){function t(){}return t.prototype.constructor=null,Object.getPrototypeOf(new t)!==t.prototype})),ee=wt("IE_PROTO"),ie=Object.prototype,ne=te?Object.getPrototypeOf:function(t){return t=Jt(t),D(t,ee)?t[ee]:"function"==typeof t.constructor&&t instanceof t.constructor?t.constructor.prototype:t instanceof Object?ie:null},oe=!!Object.getOwnPropertySymbols&&!u((function(){return!String(Symbol())})),re=oe&&!Symbol.sham&&"symbol"==typeof Symbol.iterator,se=ft("wks"),ae=h.Symbol,le=re?ae:ae&&ae.withoutSetter||yt,he=function(t){return D(se,t)||(oe&&D(ae,t)?se[t]=ae[t]:se[t]=le("Symbol."+t)),se[t]},ue=(he("iterator"),!1);[].keys&&("next"in(Zt=[].keys())?($t=ne(ne(Zt)))!==Object.prototype&&(Kt=$t):ue=!0),null==Kt&&(Kt={});var de={IteratorPrototype:Kt,BUGGY_SAFARI_ITERATORS:ue},ce={};ce[he("toStringTag")]="z";var pe="[object z]"===String(ce),me=he("toStringTag"),fe="Arguments"==v(function(){return arguments}()),ge=pe?v:function(t){var e,i,n;return void 0===t?"Undefined":null===t?"Null":"string"==typeof(i=function(t,e){try{return t[e]}catch(t){}}(e=Object(t),me))?i:fe?v(e):"Object"==(n=v(e))&&"function"==typeof e.callee?"Arguments":n},ve=pe?{}.toString:function(){return"[object "+ge(this)+"]"},ye=W.f,be=he("toStringTag"),we=function(t,e,i,n){if(t){var o=i?t:t.prototype;D(o,be)||ye(o,be,{configurable:!0,value:e}),n&&!pe&&V(o,"toString",ve)}},_e=de.IteratorPrototype,ke=function(){return this},xe=Object.setPrototypeOf||("__proto__"in{}?function(){var t,e=!1,i={};try{(t=Object.getOwnPropertyDescriptor(Object.prototype,"__proto__").set).call(i,[]),e=i instanceof Array}catch(t){}return function(i,n){return B(i),function(t){if(!k(t)&&null!==t)throw TypeError("Can't set "+String(t)+" as a prototype")}(n),e?t.call(i,n):i.__proto__=n,i}}():void 0),Se=function(t,e,i,n){n&&n.enumerable?t[e]=i:V(t,e,i)},De=de.IteratorPrototype,Ce=de.BUGGY_SAFARI_ITERATORS,Te=he("iterator"),Oe=function(){return this},Ee=function(t,e,i,n,o,r,s){!function(t,e,i){var n=e+" Iterator";t.prototype=Dt(_e,{next:f(1,i)}),we(t,n,!1,!0),Rt[n]=ke}(i,e,n);var a,l,h,u=function(t){if(t===o&&g)return g;if(!Ce&&t in p)return p[t];switch(t){case"keys":case"values":case"entries":return function(){return new i(this,t)}}return function(){return new i(this)}},d=e+" Iterator",c=!1,p=t.prototype,m=p[Te]||p["@@iterator"]||o&&p[o],g=!Ce&&m||u(o),v="Array"==e&&p.entries||m;if(v&&(a=ne(v.call(new t)),De!==Object.prototype&&a.next&&(we(a,d,!0,!0),Rt[d]=Oe)),"values"==o&&m&&"values"!==m.name&&(c=!0,g=function(){return m.call(this)}),s&&p[Te]!==g&&V(p,Te,g),Rt[e]=g,o)if(l={values:u("values"),keys:r?g:u("keys"),entries:u("entries")},s)for(h in l)!Ce&&!c&&h in p||Se(p,h,l[h]);else q({target:e,proto:!0,forced:Ce||c},l);return l},Ie=Qt.set,Me=Qt.getterFor("Array Iterator");Ee(Array,"Array",(function(t,e){Ie(this,{type:"Array Iterator",target:_(t),index:0,kind:e})}),(function(){var t=Me(this),e=t.target,i=t.kind,n=t.index++;return!e||n>=e.length?(t.target=void 0,{value:void 0,done:!0}):"keys"==i?{value:n,done:!1}:"values"==i?{value:e[n],done:!1}:{value:[n,e[n]],done:!1}}),"values");Rt.Arguments=Rt.Array;var Ae=he("toStringTag");for(var Pe in{CSSRuleList:0,CSSStyleDeclaration:0,CSSValueList:0,ClientRectList:0,DOMRectList:0,DOMStringList:0,DOMTokenList:1,DataTransferItemList:0,FileList:0,HTMLAllCollection:0,HTMLCollection:0,HTMLFormElement:0,HTMLSelectElement:0,MediaList:0,MimeTypeArray:0,NamedNodeMap:0,NodeList:1,PaintRequestList:0,Plugin:0,PluginArray:0,SVGLengthList:0,SVGNumberList:0,SVGPathSegList:0,SVGPointList:0,SVGStringList:0,SVGTransformList:0,SourceBufferList:0,StyleSheetList:0,TextTrackCueList:0,TextTrackList:0,TouchList:0}){var Ne=h[Pe],Re=Ne&&Ne.prototype;Re&&ge(Re)!==Ae&&V(Re,Ae,Pe),Rt[Pe]=Rt.Array}var Le=Array.isArray||function(t){return"Array"==v(t)},je=he("species"),Fe=function(t,e){var i;return Le(t)&&("function"!=typeof(i=t.constructor)||i!==Array&&!Le(i.prototype)?k(i)&&null===(i=i[je])&&(i=void 0):i=void 0),new(void 0===i?Array:i)(0===e?0:e)},ze=[].push,Ge=function(t){var e=1==t,i=2==t,n=3==t,o=4==t,r=6==t,s=5==t||r;return function(a,l,h,u){for(var d,c,p=Jt(a),m=b(p),f=H(l,h,3),g=et(m.length),v=0,y=u||Fe,w=e?y(a,g):i?y(a,0):void 0;g>v;v++)if((s||v in m)&&(c=f(d=m[v],v,p),t))if(e)w[v]=c;else if(c)switch(t){case 3:return!0;case 5:return d;case 6:return v;case 2:ze.call(w,d)}else if(o)return!1;return r?-1:n||o?o:w}},He={forEach:Ge(0),map:Ge(1),filter:Ge(2),some:Ge(3),every:Ge(4),find:Ge(5),findIndex:Ge(6)},Be=function(t,e){var i=[][t];return!!i&&u((function(){i.call(null,e||function(){throw 1},1)}))},Ye=Object.defineProperty,We={},Ve=function(t){throw t},Ue=function(t,e){if(D(We,t))return We[t];e||(e={});var i=[][t],n=!!D(e,"ACCESSORS")&&e.ACCESSORS,o=D(e,0)?e[0]:Ve,r=D(e,1)?e[1]:void 0;return We[t]=!!i&&!u((function(){if(n&&!d)return!0;var t={length:-1};n?Ye(t,1,{enumerable:!0,get:Ve}):t[1]=1,i.call(t,o,r)}))},Xe=He.forEach,qe=Be("forEach"),Ke=Ue("forEach"),$e=qe&&Ke?[].forEach:function(t){return Xe(this,t,arguments.length>1?arguments[1]:void 0)};q({target:"Array",proto:!0,forced:[].forEach!=$e},{forEach:$e});var Ze,Qe,Je=function(t){return z[t+"Prototype"]},ti=Je("Array").forEach,ei=Array.prototype,ii={DOMTokenList:!0,NodeList:!0},ni=function(t){var e=t.forEach;return t===ei||t instanceof Array&&e===ei.forEach||ii.hasOwnProperty(ge(t))?ti:e},oi=$("navigator","userAgent")||"",ri=h.process,si=ri&&ri.versions,ai=si&&si.v8;ai?Qe=(Ze=ai.split("."))[0]+Ze[1]:oi&&(!(Ze=oi.match(/Edge\/(\d+)/))||Ze[1]>=74)&&(Ze=oi.match(/Chrome\/(\d+)/))&&(Qe=Ze[1]);var li=Qe&&+Qe,hi=he("species"),ui=function(t){return li>=51||!u((function(){var e=[];return(e.constructor={})[hi]=function(){return{foo:1}},1!==e[t](Boolean).foo}))},di=He.filter,ci=ui("filter"),pi=Ue("filter");q({target:"Array",proto:!0,forced:!ci||!pi},{filter:function(t){return di(this,t,arguments.length>1?arguments[1]:void 0)}});var mi=Je("Array").filter,fi=Array.prototype,gi=function(t){var e=t.filter;return t===fi||t instanceof Array&&e===fi.filter?mi:e},vi=[].slice,yi=/MSIE .\./.test(oi),bi=function(t){return function(e,i){var n=arguments.length>2,o=n?vi.call(arguments,2):void 0;return t(n?function(){("function"==typeof e?e:Function(e)).apply(this,o)}:e,i)}};q({global:!0,bind:!0,forced:yi},{setTimeout:bi(h.setTimeout),setInterval:bi(h.setInterval)});var wi=z.setTimeout;q({target:"Function",proto:!0},{bind:Et});var _i=Je("Function").bind,ki=Function.prototype,xi=function(t){var e=t.bind;return t===ki||t instanceof Function&&e===ki.bind?_i:e};q({target:"Array",stat:!0},{isArray:Le});var Si=z.Array.isArray,Di=Si;var Ci=function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")};q({target:"Object",stat:!0,forced:!d,sham:!d},{defineProperty:W.f});var Ti=r((function(t){var e=z.Object,i=t.exports=function(t,i,n){return e.defineProperty(t,i,n)};e.defineProperty.sham&&(i.sham=!0)})),Oi=Ti;function Ei(t,e){for(var i=0;i<e.length;i++){var n=e[i];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Oi(t,n.key,n)}}var Ii=function(t,e,i){return e&&Ei(t.prototype,e),i&&Ei(t,i),t};var Mi=function(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t};q({target:"Object",stat:!0,sham:!d},{create:Dt});var Ai=z.Object,Pi=function(t,e){return Ai.create(t,e)},Ni=Pi;q({target:"Object",stat:!0},{setPrototypeOf:xe});var Ri=z.Object.setPrototypeOf,Li=r((function(t){function e(i,n){return t.exports=e=Ri||function(t,e){return t.__proto__=e,t},e(i,n)}t.exports=e}));var ji=function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Ni(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&Li(t,e)},Fi={f:he},zi=W.f,Gi=function(t){var e=z.Symbol||(z.Symbol={});D(e,t)||zi(e,t,{value:Fi.f(t)})};Gi("iterator");var Hi=function(t){return function(e,i){var n,o,r=String(w(e)),s=J(i),a=r.length;return s<0||s>=a?t?"":void 0:(n=r.charCodeAt(s))<55296||n>56319||s+1===a||(o=r.charCodeAt(s+1))<56320||o>57343?t?r.charAt(s):n:t?r.slice(s,s+2):o-56320+(n-55296<<10)+65536}},Bi={codeAt:Hi(!1),charAt:Hi(!0)}.charAt,Yi=Qt.set,Wi=Qt.getterFor("String Iterator");Ee(String,"String",(function(t){Yi(this,{type:"String Iterator",string:String(t),index:0})}),(function(){var t,e=Wi(this),i=e.string,n=e.index;return n>=i.length?{value:void 0,done:!0}:(t=Bi(i,n),e.index+=t.length,{value:t,done:!1})}));var Vi=Fi.f("iterator"),Ui=function(t,e,i){var n=x(e);n in t?W.f(t,n,f(0,i)):t[n]=i},Xi=he("isConcatSpreadable"),qi=li>=51||!u((function(){var t=[];return t[Xi]=!1,t.concat()[0]!==t})),Ki=ui("concat"),$i=function(t){if(!k(t))return!1;var e=t[Xi];return void 0!==e?!!e:Le(t)};q({target:"Array",proto:!0,forced:!qi||!Ki},{concat:function(t){var e,i,n,o,r,s=Jt(this),a=Fe(s,0),l=0;for(e=-1,n=arguments.length;e<n;e++)if(r=-1===e?s:arguments[e],$i(r)){if(l+(o=et(r.length))>9007199254740991)throw TypeError("Maximum allowed index exceeded");for(i=0;i<o;i++,l++)i in r&&Ui(a,l,r[i])}else{if(l>=9007199254740991)throw TypeError("Maximum allowed index exceeded");Ui(a,l++,r)}return a.length=l,a}});var Zi=Object.freeze({__proto__:null}),Qi=ut.concat("length","prototype"),Ji={f:Object.getOwnPropertyNames||function(t){return ht(t,Qi)}},tn=Ji.f,en={}.toString,nn="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[],on={f:function(t){return nn&&"[object Window]"==en.call(t)?function(t){try{return tn(t)}catch(t){return nn.slice()}}(t):tn(_(t))}},rn={f:Object.getOwnPropertySymbols},sn=He.forEach,an=wt("hidden"),ln=he("toPrimitive"),hn=Qt.set,un=Qt.getterFor("Symbol"),dn=Object.prototype,cn=h.Symbol,pn=$("JSON","stringify"),mn=M.f,fn=W.f,gn=on.f,vn=m.f,yn=ft("symbols"),bn=ft("op-symbols"),wn=ft("string-to-symbol-registry"),_n=ft("symbol-to-string-registry"),kn=ft("wks"),xn=h.QObject,Sn=!xn||!xn.prototype||!xn.prototype.findChild,Dn=d&&u((function(){return 7!=Dt(fn({},"a",{get:function(){return fn(this,"a",{value:7}).a}})).a}))?function(t,e,i){var n=mn(dn,e);n&&delete dn[e],fn(t,e,i),n&&t!==dn&&fn(dn,e,n)}:fn,Cn=function(t,e){var i=yn[t]=Dt(cn.prototype);return hn(i,{type:"Symbol",tag:t,description:e}),d||(i.description=e),i},Tn=re?function(t){return"symbol"==typeof t}:function(t){return Object(t)instanceof cn},On=function(t,e,i){t===dn&&On(bn,e,i),B(t);var n=x(e,!0);return B(i),D(yn,n)?(i.enumerable?(D(t,an)&&t[an][n]&&(t[an][n]=!1),i=Dt(i,{enumerable:f(0,!1)})):(D(t,an)||fn(t,an,f(1,{})),t[an][n]=!0),Dn(t,n,i)):fn(t,n,i)},En=function(t,e){B(t);var i=_(e),n=dt(i).concat(Pn(i));return sn(n,(function(e){d&&!In.call(i,e)||On(t,e,i[e])})),t},In=function(t){var e=x(t,!0),i=vn.call(this,e);return!(this===dn&&D(yn,e)&&!D(bn,e))&&(!(i||!D(this,e)||!D(yn,e)||D(this,an)&&this[an][e])||i)},Mn=function(t,e){var i=_(t),n=x(e,!0);if(i!==dn||!D(yn,n)||D(bn,n)){var o=mn(i,n);return!o||!D(yn,n)||D(i,an)&&i[an][n]||(o.enumerable=!0),o}},An=function(t){var e=gn(_(t)),i=[];return sn(e,(function(t){D(yn,t)||D(at,t)||i.push(t)})),i},Pn=function(t){var e=t===dn,i=gn(e?bn:_(t)),n=[];return sn(i,(function(t){!D(yn,t)||e&&!D(dn,t)||n.push(yn[t])})),n};if(oe||(Se((cn=function(){if(this instanceof cn)throw TypeError("Symbol is not a constructor");var t=arguments.length&&void 0!==arguments[0]?String(arguments[0]):void 0,e=yt(t),i=function(t){this===dn&&i.call(bn,t),D(this,an)&&D(this[an],e)&&(this[an][e]=!1),Dn(this,e,f(1,t))};return d&&Sn&&Dn(dn,e,{configurable:!0,set:i}),Cn(e,t)}).prototype,"toString",(function(){return un(this).tag})),Se(cn,"withoutSetter",(function(t){return Cn(yt(t),t)})),m.f=In,W.f=On,M.f=Mn,Ji.f=on.f=An,rn.f=Pn,Fi.f=function(t){return Cn(he(t),t)},d&&fn(cn.prototype,"description",{configurable:!0,get:function(){return un(this).description}})),q({global:!0,wrap:!0,forced:!oe,sham:!oe},{Symbol:cn}),sn(dt(kn),(function(t){Gi(t)})),q({target:"Symbol",stat:!0,forced:!oe},{for:function(t){var e=String(t);if(D(wn,e))return wn[e];var i=cn(e);return wn[e]=i,_n[i]=e,i},keyFor:function(t){if(!Tn(t))throw TypeError(t+" is not a symbol");if(D(_n,t))return _n[t]},useSetter:function(){Sn=!0},useSimple:function(){Sn=!1}}),q({target:"Object",stat:!0,forced:!oe,sham:!d},{create:function(t,e){return void 0===e?Dt(t):En(Dt(t),e)},defineProperty:On,defineProperties:En,getOwnPropertyDescriptor:Mn}),q({target:"Object",stat:!0,forced:!oe},{getOwnPropertyNames:An,getOwnPropertySymbols:Pn}),q({target:"Object",stat:!0,forced:u((function(){rn.f(1)}))},{getOwnPropertySymbols:function(t){return rn.f(Jt(t))}}),pn){var Nn=!oe||u((function(){var t=cn();return"[null]"!=pn([t])||"{}"!=pn({a:t})||"{}"!=pn(Object(t))}));q({target:"JSON",stat:!0,forced:Nn},{stringify:function(t,e,i){for(var n,o=[t],r=1;arguments.length>r;)o.push(arguments[r++]);if(n=e,(k(e)||void 0!==t)&&!Tn(t))return Le(e)||(e=function(t,e){if("function"==typeof n&&(e=n.call(this,t,e)),!Tn(e))return e}),o[1]=e,pn.apply(null,o)}})}cn.prototype[ln]||V(cn.prototype,ln,cn.prototype.valueOf),we(cn,"Symbol"),at[an]=!0,Gi("asyncIterator");var Rn=Object.freeze({__proto__:null});Gi("hasInstance"),Gi("isConcatSpreadable"),Gi("match"),Gi("matchAll"),Gi("replace"),Gi("search"),Gi("species"),Gi("split"),Gi("toPrimitive"),Gi("toStringTag"),Gi("unscopables"),we(Math,"Math",!0),we(h.JSON,"JSON",!0),s(Zi),s(Rn);var Ln=z.Symbol;Gi("asyncDispose"),Gi("dispose"),Gi("observable"),Gi("patternMatch"),Gi("replaceAll");var jn=Ln,Fn=r((function(t){function e(i){return t.exports=e="function"==typeof jn&&"symbol"==typeof Vi?function(t){return typeof t}:function(t){return t&&"function"==typeof jn&&t.constructor===jn&&t!==jn.prototype?"symbol":typeof t},e(i)}t.exports=e}));var zn=function(t,e){return!e||"object"!==Fn(e)&&"function"!=typeof e?Mi(t):e},Gn=u((function(){ne(1)}));q({target:"Object",stat:!0,forced:Gn,sham:!te},{getPrototypeOf:function(t){return ne(Jt(t))}});var Hn=z.Object.getPrototypeOf,Bn=Hn,Yn=r((function(t){function e(i){return t.exports=e=Ri?Bn:function(t){return t.__proto__||Bn(t)},e(i)}t.exports=e})),Wn="undefined"!=typeof window&&window.moment||t,Vn=Ti;q({target:"Object",stat:!0,forced:!d,sham:!d},{defineProperties:ct});var Un=r((function(t){var e=z.Object,i=t.exports=function(t,i){return e.defineProperties(t,i)};e.defineProperties.sham&&(i.sham=!0)})),Xn=$("Reflect","ownKeys")||function(t){var e=Ji.f(B(t)),i=rn.f;return i?e.concat(i(t)):e};q({target:"Object",stat:!0,sham:!d},{getOwnPropertyDescriptors:function(t){for(var e,i,n=_(t),o=M.f,r=Xn(n),s={},a=0;r.length>a;)void 0!==(i=o(n,e=r[a++]))&&Ui(s,e,i);return s}});var qn=z.Object.getOwnPropertyDescriptors,Kn=M.f,$n=u((function(){Kn(1)}));q({target:"Object",stat:!0,forced:!d||$n,sham:!d},{getOwnPropertyDescriptor:function(t,e){return Kn(_(t),e)}});var Zn=r((function(t){var e=z.Object,i=t.exports=function(t,i){return e.getOwnPropertyDescriptor(t,i)};e.getOwnPropertyDescriptor.sham&&(i.sham=!0)})),Qn=z.Object.getOwnPropertySymbols;var Jn=function(t,e,i){return e in t?Oi(t,e,{value:i,enumerable:!0,configurable:!0,writable:!0}):t[e]=i,t},to=u((function(){dt(1)}));q({target:"Object",stat:!0,forced:to},{keys:function(t){return dt(Jt(t))}});var eo=z.Object.keys,io=function(t){return function(e,i,n,o){G(i);var r=Jt(e),s=b(r),a=et(r.length),l=t?a-1:0,h=t?-1:1;if(n<2)for(;;){if(l in s){o=s[l],l+=h;break}if(l+=h,t?l<0:a<=l)throw TypeError("Reduce of empty array with no initial value")}for(;t?l>=0:a>l;l+=h)l in s&&(o=i(o,s[l],l,r));return o}},no={left:io(!1),right:io(!0)}.left,oo=Be("reduce"),ro=Ue("reduce",{1:0});q({target:"Array",proto:!0,forced:!oo||!ro},{reduce:function(t){return no(this,t,arguments.length,arguments.length>1?arguments[1]:void 0)}});var so=Je("Array").reduce,ao=Array.prototype,lo=function(t){var e=t.reduce;return t===ao||t instanceof Array&&e===ao.reduce?so:e},ho=He.map,uo=ui("map"),co=Ue("map");q({target:"Array",proto:!0,forced:!uo||!co},{map:function(t){return ho(this,t,arguments.length>1?arguments[1]:void 0)}});var po=Je("Array").map,mo=Array.prototype,fo=function(t){var e=t.map;return t===mo||t instanceof Array&&e===mo.map?po:e},go=he("iterator"),vo=function(t){if(null!=t)return t[go]||t["@@iterator"]||Rt[ge(t)]},yo=function(t){var e=vo(t);if("function"!=typeof e)throw TypeError(String(t)+" is not iterable");return B(e.call(t))},bo=vo,wo=function(t,e,i,n){try{return n?e(B(i)[0],i[1]):e(i)}catch(e){var o=t.return;throw void 0!==o&&B(o.call(t)),e}},_o=he("iterator"),ko=Array.prototype,xo=function(t){return void 0!==t&&(Rt.Array===t||ko[_o]===t)},So=he("iterator"),Do=!1;try{var Co=0,To={next:function(){return{done:!!Co++}},return:function(){Do=!0}};To[So]=function(){return this},Array.from(To,(function(){throw 2}))}catch(t){}var Oo=!function(t,e){if(!e&&!Do)return!1;var i=!1;try{var n={};n[So]=function(){return{next:function(){return{done:i=!0}}}},t(n)}catch(t){}return i}((function(t){Array.from(t)}));q({target:"Array",stat:!0,forced:Oo},{from:function(t){var e,i,n,o,r,s,a=Jt(t),l="function"==typeof this?this:Array,h=arguments.length,u=h>1?arguments[1]:void 0,d=void 0!==u,c=vo(a),p=0;if(d&&(u=H(u,h>2?arguments[2]:void 0,2)),null==c||l==Array&&xo(c))for(i=new l(e=et(a.length));e>p;p++)s=d?u(a[p],p):a[p],Ui(i,p,s);else for(r=(o=c.call(a)).next,i=new l;!(n=r.call(o)).done;p++)s=d?wo(o,u,[n.value,p],!0):n.value,Ui(i,p,s);return i.length=p,i}});var Eo,Io=z.Array.from,Mo=Io,Ao=Pi,Po="\t\n\v\f\r                　\u2028\u2029\ufeff",No="["+Po+"]",Ro=RegExp("^"+No+No+"*"),Lo=RegExp(No+No+"*$"),jo=function(t){return function(e){var i=String(w(e));return 1&t&&(i=i.replace(Ro,"")),2&t&&(i=i.replace(Lo,"")),i}},Fo={start:jo(1),end:jo(2),trim:jo(3)},zo=Fo.trim;q({target:"String",proto:!0,forced:(Eo="trim",u((function(){return!!Po[Eo]()||"​᠎"!="​᠎"[Eo]()||Po[Eo].name!==Eo})))},{trim:function(){return zo(this)}});var Go=Je("String").trim,Ho=String.prototype,Bo=function(t){var e=t.trim;return"string"==typeof t||t===Ho||t instanceof String&&e===Ho.trim?Go:e},Yo=Fo.trim,Wo=h.parseInt,Vo=/^[+-]?0[Xx]/,Uo=8!==Wo(Po+"08")||22!==Wo(Po+"0x16")?function(t,e){var i=Yo(String(t));return Wo(i,e>>>0||(Vo.test(i)?16:10))}:Wo;q({global:!0,forced:parseInt!=Uo},{parseInt:Uo});var Xo=z.parseInt,qo=m.f,Ko=function(t){return function(e){for(var i,n=_(e),o=dt(n),r=o.length,s=0,a=[];r>s;)i=o[s++],d&&!qo.call(n,i)||a.push(t?[i,n[i]]:n[i]);return a}},$o={entries:Ko(!0),values:Ko(!1)}.values;q({target:"Object",stat:!0},{values:function(t){return $o(t)}});var Zo=z.Object.values,Qo=Hn,Jo=st.indexOf,tr=[].indexOf,er=!!tr&&1/[1].indexOf(1,-0)<0,ir=Be("indexOf"),nr=Ue("indexOf",{ACCESSORS:!0,1:0});q({target:"Array",proto:!0,forced:er||!ir||!nr},{indexOf:function(t){return er?tr.apply(this,arguments)||0:Jo(this,t,arguments.length>1?arguments[1]:void 0)}});var or=Je("Array").indexOf,rr=Array.prototype,sr=function(t){var e=t.indexOf;return t===rr||t instanceof Array&&e===rr.indexOf?or:e},ar=Object.assign,lr=Object.defineProperty,hr=!ar||u((function(){if(d&&1!==ar({b:1},ar(lr({},"a",{enumerable:!0,get:function(){lr(this,"b",{value:3,enumerable:!1})}}),{b:2})).b)return!0;var t={},e={},i=Symbol();return t[i]=7,"abcdefghijklmnopqrst".split("").forEach((function(t){e[t]=t})),7!=ar({},t)[i]||"abcdefghijklmnopqrst"!=dt(ar({},e)).join("")}))?function(t,e){for(var i=Jt(t),n=arguments.length,o=1,r=rn.f,s=m.f;n>o;)for(var a,l=b(arguments[o++]),h=r?dt(l).concat(r(l)):dt(l),u=h.length,c=0;u>c;)a=h[c++],d&&!s.call(l,a)||(i[a]=l[a]);return i}:ar;q({target:"Object",stat:!0,forced:Object.assign!==hr},{assign:hr});var ur=z.Object.assign,dr=Si;var cr=function(t){if(dr(t))return t},pr=he("iterator"),mr=function(t){var e=Object(t);return void 0!==e[pr]||"@@iterator"in e||Rt.hasOwnProperty(ge(e))};var fr=function(t,e){if(void 0!==jn&&mr(Object(t))){var i=[],n=!0,o=!1,r=void 0;try{for(var s,a=yo(t);!(n=(s=a.next()).done)&&(i.push(s.value),!e||i.length!==e);n=!0);}catch(t){o=!0,r=t}finally{try{n||null==a.return||a.return()}finally{if(o)throw r}}return i}},gr=Io,vr=ui("slice"),yr=Ue("slice",{ACCESSORS:!0,0:0,1:2}),br=he("species"),wr=[].slice,_r=Math.max;q({target:"Array",proto:!0,forced:!vr||!yr},{slice:function(t,e){var i,n,o,r=_(this),s=et(r.length),a=ot(t,s),l=ot(void 0===e?s:e,s);if(Le(r)&&("function"!=typeof(i=r.constructor)||i!==Array&&!Le(i.prototype)?k(i)&&null===(i=i[br])&&(i=void 0):i=void 0,i===Array||void 0===i))return wr.call(r,a,l);for(n=new(void 0===i?Array:i)(_r(l-a,0)),o=0;a<l;a++,o++)a in r&&Ui(n,o,r[a]);return n.length=o,n}});var kr=Je("Array").slice,xr=Array.prototype,Sr=function(t){var e=t.slice;return t===xr||t instanceof Array&&e===xr.slice?kr:e},Dr=Sr;var Cr=function(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n};var Tr=function(t,e){var i;if(t){if("string"==typeof t)return Cr(t,e);var n=Dr(i=Object.prototype.toString.call(t)).call(i,8,-1);return"Object"===n&&t.constructor&&(n=t.constructor.name),"Map"===n||"Set"===n?gr(t):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?Cr(t,e):void 0}};var Or=function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")};var Er=function(t,e){return cr(t)||fr(t,e)||Tr(t,e)||Or()};q({target:"Date",stat:!0},{now:function(){return(new Date).getTime()}});var Ir=z.Date.now;q({target:"Reflect",stat:!0},{ownKeys:Xn});var Mr=z.Reflect.ownKeys,Ar=Sr;var Pr=function(t){if(dr(t))return Cr(t)};var Nr=function(t){if(void 0!==jn&&mr(Object(t)))return gr(t)};var Rr=function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")};var Lr=function(t){return Pr(t)||Nr(t)||Tr(t)||Rr()},jr=Je("Array").concat,Fr=Array.prototype,zr=function(t){var e=t.concat;return t===Fr||t instanceof Array&&e===Fr.concat?jr:e},Gr=Ln;function Hr(t,e){var i=eo(t);if(Qn){var n=Qn(t);e&&(n=gi(n).call(n,(function(e){return Zn(t,e).enumerable}))),i.push.apply(i,n)}return i}function Br(t){for(var e=1;e<arguments.length;e++){var i,n=null!=arguments[e]?arguments[e]:{};if(e%2)ni(i=Hr(Object(n),!0)).call(i,(function(e){Jn(t,e,n[e])}));else if(qn)Un(t,qn(n));else{var o;ni(o=Hr(Object(n))).call(o,(function(e){Vn(t,e,Zn(n,e))}))}}return t}function Yr(t,e){var i;if(void 0===Gr||null==bo(t)){if(Di(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return Wr(t,e);var n=Ar(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Mo(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Wr(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var r,s=!0,a=!1;return{s:function(){i=yo(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,r=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw r}}}}function Wr(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}
/**
 * vis-util
 * https://github.com/visjs/vis-util
 *
 * utilitie collection for visjs
 *
 * @version 4.3.2
 * @date    2020-06-15T14:15:22.151Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
 *
 * @license
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */var Vr=Gr("DELETE");function Ur(){var t=Xr.apply(void 0,arguments);return Kr(t),console.log(t),t}function Xr(){for(var t=arguments.length,e=new Array(t),i=0;i<t;i++)e[i]=arguments[i];if(e.length<2)return e[0];var n;if(e.length>2)return Xr.apply(void 0,zr(n=[Ur(e[0],e[1])]).call(n,Lr(Ar(e).call(e,2))));var o,r=e[0],s=e[1],a=Yr(Mr(s));try{for(a.s();!(o=a.n()).done;){var l=o.value;Object.prototype.propertyIsEnumerable.call(s,s[l])||(s[l]===Vr?delete r[l]:null===r[l]||null===s[l]||"object"!==Fn(r[l])||"object"!==Fn(s[l])||Di(r[l])||Di(s[l])?r[l]=qr(s[l]):r[l]=Xr(r[l],s[l]))}}catch(t){a.e(t)}finally{a.f()}return r}function qr(t){return Di(t)?fo(t).call(t,(function(t){return qr(t)})):"object"===Fn(t)&&null!==t?Xr({},t):t}function Kr(t){for(var e=0,i=eo(t);e<i.length;e++){var n=i[e];t[n]===Vr?delete t[n]:"object"===Fn(t[n])&&null!==t[n]&&Kr(t[n])}}function $r(t){var e=function(){for(var t=Zr(),e=t(" "),i=t(" "),n=t(" "),o=0;o<arguments.length;o++)(e-=t(o<0||arguments.length<=o?void 0:arguments[o]))<0&&(e+=1),(i-=t(o<0||arguments.length<=o?void 0:arguments[o]))<0&&(i+=1),(n-=t(o<0||arguments.length<=o?void 0:arguments[o]))<0&&(n+=1);return[e,i,n]}(t),i=Er(e,3),n=i[0],o=i[1],r=i[2],s=1,a=function(){var t=2091639*n+2.3283064365386963e-10*s;return n=o,o=r,r=t-(s=0|t)};return a.uint32=function(){return 4294967296*a()},a.fract53=function(){return a()+11102230246251565e-32*(2097152*a()|0)},a.algorithm="Alea",a.seed=t,a.version="0.9",a}function Zr(){var t=4022871197;return function(e){for(var i=e.toString(),n=0;n<i.length;n++){var o=.02519603282416938*(t+=i.charCodeAt(n));o-=t=o>>>0,t=(o*=t)>>>0,t+=4294967296*(o-=t)}return 2.3283064365386963e-10*(t>>>0)}}var Qr=/^\/?Date\((-?\d+)/i,Jr=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i,ts=/^#?([a-f\d])([a-f\d])([a-f\d])$/i,es=/^rgb\( *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *\)$/i,is=/^rgba\( *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *([01]|0?\.\d+) *\)$/i;function ns(t){return t instanceof Number||"number"==typeof t}function os(t){return t instanceof String||"string"==typeof t}function rs(t){return"object"===Fn(t)&&null!==t}function ss(t,e,i,n){var o=!1;!0===n&&(o=null===e[i]&&void 0!==t[i]),o?delete t[i]:t[i]=e[i]}var as=ur;function ls(t,e){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];for(var o in e)if(Object.prototype.hasOwnProperty.call(e,o)||!0===i)if("object"===Fn(e[o])&&null!==e[o]&&Qo(e[o])===Object.prototype)void 0===t[o]?t[o]=ls({},e[o],i):"object"===Fn(t[o])&&null!==t[o]&&Qo(t[o])===Object.prototype?ls(t[o],e[o],i):ss(t,e,o,n);else if(Di(e[o])){var r;t[o]=Ar(r=e[o]).call(r)}else ss(t,e,o,n);return t}function hs(t){var e=Fn(t);return"object"===e?null===t?"null":t instanceof Boolean?"Boolean":t instanceof Number?"Number":t instanceof String?"String":Di(t)?"Array":t instanceof Date?"Date":"Object":"number"===e?"Number":"boolean"===e?"Boolean":"string"===e?"String":void 0===e?"undefined":e}var us=Zo;var ds={asBoolean:function(t,e){return"function"==typeof t&&(t=t()),null!=t?0!=t:e||null},asNumber:function(t,e){return"function"==typeof t&&(t=t()),null!=t?Number(t)||e||null:e||null},asString:function(t,e){return"function"==typeof t&&(t=t()),null!=t?String(t):e||null},asSize:function(t,e){return"function"==typeof t&&(t=t()),os(t)?t:ns(t)?t+"px":e||null},asElement:function(t,e){return"function"==typeof t&&(t=t()),t||e||null}};function cs(t){var e;switch(t.length){case 3:case 4:return(e=ts.exec(t))?{r:Xo(e[1]+e[1],16),g:Xo(e[2]+e[2],16),b:Xo(e[3]+e[3],16)}:null;case 6:case 7:return(e=Jr.exec(t))?{r:Xo(e[1],16),g:Xo(e[2],16),b:Xo(e[3],16)}:null;default:return null}}function ps(t,e,i){var n;return"#"+Ar(n=((1<<24)+(t<<16)+(e<<8)+i).toString(16)).call(n,1)}function ms(t,e,i){t/=255,e/=255,i/=255;var n=Math.min(t,Math.min(e,i)),o=Math.max(t,Math.max(e,i));return n===o?{h:0,s:0,v:n}:{h:60*((t===n?3:i===n?1:5)-(t===n?e-i:i===n?t-e:i-t)/(o-n))/360,s:(o-n)/o,v:o}}var fs=function(t){var e,i={};return ni(e=t.split(";")).call(e,(function(t){if(""!=Bo(t).call(t)){var e,n,o=t.split(":"),r=Bo(e=o[0]).call(e),s=Bo(n=o[1]).call(n);i[r]=s}})),i},gs=function(t){var e;return fo(e=eo(t)).call(e,(function(e){return e+": "+t[e]})).join("; ")};function vs(t,e,i){var n,o,r,s=Math.floor(6*t),a=6*t-s,l=i*(1-e),h=i*(1-a*e),u=i*(1-(1-a)*e);switch(s%6){case 0:n=i,o=u,r=l;break;case 1:n=h,o=i,r=l;break;case 2:n=l,o=i,r=u;break;case 3:n=l,o=h,r=i;break;case 4:n=u,o=l,r=i;break;case 5:n=i,o=l,r=h}return{r:Math.floor(255*n),g:Math.floor(255*o),b:Math.floor(255*r)}}function ys(t,e,i){var n=vs(t,e,i);return ps(n.r,n.g,n.b)}function bs(t){var e=cs(t);if(!e)throw new TypeError("'".concat(t,"' is not a valid color."));return ms(e.r,e.g,e.b)}function ws(t){return/(^#[0-9A-F]{6}$)|(^#[0-9A-F]{3}$)/i.test(t)}function _s(t){return es.test(t)}function ks(t){if(null===t||"object"!==Fn(t))return null;if(t instanceof Element)return t;var e=Ao(t);for(var i in t)Object.prototype.hasOwnProperty.call(t,i)&&"object"==Fn(t[i])&&(e[i]=ks(t[i]));return e}function xs(t,e){var i=eo(t);if(Qn){var n=Qn(t);e&&(n=gi(n).call(n,(function(e){return Zn(t,e).enumerable}))),i.push.apply(i,n)}return i}function Ss(t){for(var e=1;e<arguments.length;e++){var i,n=null!=arguments[e]?arguments[e]:{};if(e%2)ni(i=xs(Object(n),!0)).call(i,(function(e){Jn(t,e,n[e])}));else if(qn)Un(t,qn(n));else{var o;ni(o=xs(Object(n))).call(o,(function(e){Vn(t,e,Zn(n,e))}))}}return t}var Ds=/^\/?Date\((-?\d+)/i;function Cs(e,i){var n;if(void 0!==e){if(null===e)return null;if(!i)return e;if("string"!=typeof i&&!(i instanceof String))throw new Error("Type must be a string");switch(i){case"boolean":case"Boolean":return Boolean(e);case"number":case"Number":return os(e)&&!isNaN(Date.parse(e))?t(e).valueOf():Number(e.valueOf());case"string":case"String":return String(e);case"Date":if(ns(e))return new Date(e);if(e instanceof Date)return new Date(e.valueOf());if(t.isMoment(e))return new Date(e.valueOf());if(os(e))return(n=Ds.exec(e))?new Date(Number(n[1])):t(new Date(e)).toDate();throw new Error("Cannot convert object of type "+hs(e)+" to type Date");case"Moment":if(ns(e))return t(e);if(e instanceof Date)return t(e.valueOf());if(t.isMoment(e))return t(e);if(os(e))return n=Ds.exec(e),t(n?Number(n[1]):e);throw new Error("Cannot convert object of type "+hs(e)+" to type Date");case"ISODate":if(ns(e))return new Date(e);if(e instanceof Date)return e.toISOString();if(t.isMoment(e))return e.toDate().toISOString();if(os(e))return(n=Ds.exec(e))?new Date(Number(n[1])).toISOString():t(e).format();throw new Error("Cannot convert object of type "+hs(e)+" to type ISODate");case"ASPDate":if(ns(e))return"/Date("+e+")/";if(e instanceof Date||t.isMoment(e))return"/Date("+e.valueOf()+")/";if(os(e))return"/Date("+((n=Ds.exec(e))?new Date(Number(n[1])).valueOf():new Date(e).valueOf())+")/";throw new Error("Cannot convert object of type "+hs(e)+" to type ASPDate");default:throw new Error("Unknown type ".concat(i))}}}function Ts(t){var n,o,r,s,a,l,h=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{start:"Date",end:"Date"},u=t._idProp,d=new e({fieldId:u}),c=fo(n=i(t)).call(n,(function(t){var e;return lo(e=eo(t)).call(e,(function(e,i){return e[i]=Cs(t[i],h[i]),e}),{})})).to(d);return c.all().start(),{add:function(){var e;return(e=t.getDataSet()).add.apply(e,arguments)},remove:function(){var e;return(e=t.getDataSet()).remove.apply(e,arguments)},update:function(){var e;return(e=t.getDataSet()).update.apply(e,arguments)},updateOnly:function(){var e;return(e=t.getDataSet()).updateOnly.apply(e,arguments)},forEach:xi(o=ni(d)).call(o,d),get:xi(r=d.get).call(r,d),getIds:xi(s=d.getIds).call(s,d),off:xi(a=d.off).call(a,d),on:xi(l=d.on).call(l,d),get length(){return d.length},idProp:u,type:h,rawDS:t,coercedDS:d,dispose:function(){return c.stop()}}}var Os=Ss(Ss({},Object.freeze({__proto__:null,Alea:function(){for(var t=arguments.length,e=new Array(t),i=0;i<t;i++)e[i]=arguments[i];return $r(e.length?e:[Ir()])},DELETE:Vr,HSVToHex:ys,HSVToRGB:vs,RGBToHSV:ms,RGBToHex:ps,addClassName:function(t,e){var i=t.className.split(" "),n=e.split(" ");i=zr(i).call(i,gi(n).call(n,(function(t){return sr(i).call(i,t)<0}))),t.className=i.join(" ")},addCssText:function(t,e){var i=fs(t.style.cssText),n=fs(e),o=Br(Br({},i),n);t.style.cssText=gs(o)},addEventListener:function(t,e,i,n){var o;t.addEventListener?(void 0===n&&(n=!1),"mousewheel"===e&&sr(o=navigator.userAgent).call(o,"Firefox")>=0&&(e="DOMMouseScroll"),t.addEventListener(e,i,n)):t.attachEvent("on"+e,i)},binarySearchCustom:function(t,e,i,n){for(var o=0,r=0,s=t.length-1;r<=s&&o<1e4;){var a=Math.floor((r+s)/2),l=t[a],h=e(void 0===n?l[i]:l[i][n]);if(0==h)return a;-1==h?r=a+1:s=a-1,o++}return-1},binarySearchValue:function(t,e,i,n,o){var r,s,a,l,h=0,u=0,d=t.length-1;for(o=null!=o?o:function(t,e){return t==e?0:t<e?-1:1};u<=d&&h<1e4;){if(l=Math.floor(.5*(d+u)),r=t[Math.max(0,l-1)][i],s=t[l][i],a=t[Math.min(t.length-1,l+1)][i],0==o(s,e))return l;if(o(r,e)<0&&o(s,e)>0)return"before"==n?Math.max(0,l-1):l;if(o(s,e)<0&&o(a,e)>0)return"before"==n?l:Math.min(t.length-1,l+1);o(s,e)<0?u=l+1:d=l-1,h++}return-1},bridgeObject:ks,copyAndExtendArray:function(t,e){var i;return zr(i=[]).call(i,Lr(t),[e])},copyArray:function(t){return Ar(t).call(t)},deepExtend:ls,deepObjectAssign:Ur,easingFunctions:{linear:function(t){return t},easeInQuad:function(t){return t*t},easeOutQuad:function(t){return t*(2-t)},easeInOutQuad:function(t){return t<.5?2*t*t:(4-2*t)*t-1},easeInCubic:function(t){return t*t*t},easeOutCubic:function(t){return--t*t*t+1},easeInOutCubic:function(t){return t<.5?4*t*t*t:(t-1)*(2*t-2)*(2*t-2)+1},easeInQuart:function(t){return t*t*t*t},easeOutQuart:function(t){return 1- --t*t*t*t},easeInOutQuart:function(t){return t<.5?8*t*t*t*t:1-8*--t*t*t*t},easeInQuint:function(t){return t*t*t*t*t},easeOutQuint:function(t){return 1+--t*t*t*t*t},easeInOutQuint:function(t){return t<.5?16*t*t*t*t*t:1+16*--t*t*t*t*t}},equalArray:function(t,e){if(t.length!==e.length)return!1;for(var i=0,n=t.length;i<n;i++)if(t[i]!=e[i])return!1;return!0},extend:as,fillIfDefined:function t(e,i){var n=arguments.length>2&&void 0!==arguments[2]&&arguments[2];for(var o in e)if(void 0!==i[o])if(null===i[o]||"object"!==Fn(i[o]))ss(e,i,o,n);else{var r=e[o],s=i[o];rs(r)&&rs(s)&&t(r,s,n)}},forEach:function(t,e){if(Di(t))for(var i=t.length,n=0;n<i;n++)e(t[n],n,t);else for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&e(t[o],o,t)},getAbsoluteLeft:function(t){return t.getBoundingClientRect().left},getAbsoluteRight:function(t){return t.getBoundingClientRect().right},getAbsoluteTop:function(t){return t.getBoundingClientRect().top},getScrollBarWidth:function(){var t=document.createElement("p");t.style.width="100%",t.style.height="200px";var e=document.createElement("div");e.style.position="absolute",e.style.top="0px",e.style.left="0px",e.style.visibility="hidden",e.style.width="200px",e.style.height="150px",e.style.overflow="hidden",e.appendChild(t),document.body.appendChild(e);var i=t.offsetWidth;e.style.overflow="scroll";var n=t.offsetWidth;return i==n&&(n=e.clientWidth),document.body.removeChild(e),i-n},getTarget:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:window.event,e=null;return t&&(t.target?e=t.target:t.srcElement&&(e=t.srcElement)),e instanceof Element&&(null==e.nodeType||3!=e.nodeType||(e=e.parentNode)instanceof Element)?e:null},getType:hs,hasParent:function(t,e){for(var i=t;i;){if(i===e)return!0;if(!i.parentNode)return!1;i=i.parentNode}return!1},hexToHSV:bs,hexToRGB:cs,insertSort:function(t,e){for(var i=0;i<t.length;i++){var n=t[i],o=void 0;for(o=i;o>0&&e(n,t[o-1])<0;o--)t[o]=t[o-1];t[o]=n}return t},isDate:function(t){if(t instanceof Date)return!0;if(os(t)){if(Qr.exec(t))return!0;if(!isNaN(Date.parse(t)))return!0}return!1},isNumber:ns,isObject:rs,isString:os,isValidHex:ws,isValidRGB:_s,isValidRGBA:function(t){return is.test(t)},mergeOptions:function(t,e,i){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{},o=function(t){return null!=t},r=function(t){return null!==t&&"object"===Fn(t)},s=function(t){for(var e in t)if(Object.prototype.hasOwnProperty.call(t,e))return!1;return!0};if(!r(t))throw new Error("Parameter mergeTarget must be an object");if(!r(e))throw new Error("Parameter options must be an object");if(!o(i))throw new Error("Parameter option must have a value");if(!r(n))throw new Error("Parameter globalOptions must be an object");var a=function(t,e,i){r(t[i])||(t[i]={});var n=e[i],o=t[i];for(var s in n)Object.prototype.hasOwnProperty.call(n,s)&&(o[s]=n[s])},l=e[i],h=r(n)&&!s(n),u=h?n[i]:void 0,d=u?u.enabled:void 0;if(void 0!==l){if("boolean"==typeof l)return r(t[i])||(t[i]={}),void(t[i].enabled=l);if(null===l&&!r(t[i])){if(!o(u))return;t[i]=Ao(u)}if(r(l)){var c=!0;void 0!==l.enabled?c=l.enabled:void 0!==d&&(c=u.enabled),a(t,e,i),t[i].enabled=c}}},option:ds,overrideOpacity:function(t,e){if(-1!==sr(t).call(t,"rgba"))return t;if(-1!==sr(t).call(t,"rgb")){var i=t.substr(sr(t).call(t,"(")+1).replace(")","").split(",");return"rgba("+i[0]+","+i[1]+","+i[2]+","+e+")"}var n=cs(t);return null==n?t:"rgba("+n.r+","+n.g+","+n.b+","+e+")"},parseColor:function(t,e){if(os(t)){var i=t;if(_s(i)){var n,o=fo(n=i.substr(4).substr(0,i.length-5).split(",")).call(n,(function(t){return Xo(t)}));i=ps(o[0],o[1],o[2])}if(!0===ws(i)){var r=bs(i),s={h:r.h,s:.8*r.s,v:Math.min(1,1.02*r.v)},a={h:r.h,s:Math.min(1,1.25*r.s),v:.8*r.v},l=ys(a.h,a.s,a.v),h=ys(s.h,s.s,s.v);return{background:i,border:l,highlight:{background:h,border:l},hover:{background:h,border:l}}}return{background:i,border:i,highlight:{background:i,border:i},hover:{background:i,border:i}}}return e?{background:t.background||e.background,border:t.border||e.border,highlight:os(t.highlight)?{border:t.highlight,background:t.highlight}:{background:t.highlight&&t.highlight.background||e.highlight.background,border:t.highlight&&t.highlight.border||e.highlight.border},hover:os(t.hover)?{border:t.hover,background:t.hover}:{border:t.hover&&t.hover.border||e.hover.border,background:t.hover&&t.hover.background||e.hover.background}}:{background:t.background||void 0,border:t.border||void 0,highlight:os(t.highlight)?{border:t.highlight,background:t.highlight}:{background:t.highlight&&t.highlight.background||void 0,border:t.highlight&&t.highlight.border||void 0},hover:os(t.hover)?{border:t.hover,background:t.hover}:{border:t.hover&&t.hover.border||void 0,background:t.hover&&t.hover.background||void 0}}},preventDefault:function(t){t||(t=window.event),t&&(t.preventDefault?t.preventDefault():t.returnValue=!1)},pureDeepObjectAssign:function(t){for(var e,i=arguments.length,n=new Array(i>1?i-1:0),o=1;o<i;o++)n[o-1]=arguments[o];return Ur.apply(void 0,zr(e=[{},t]).call(e,n))},recursiveDOMDelete:function t(e){if(e)for(;!0===e.hasChildNodes();){var i=e.firstChild;i&&(t(i),e.removeChild(i))}},removeClassName:function(t,e){var i=t.className.split(" "),n=e.split(" ");i=gi(i).call(i,(function(t){return sr(n).call(n,t)<0})),t.className=i.join(" ")},removeCssText:function(t,e){var i=fs(t.style.cssText),n=fs(e);for(var o in n)Object.prototype.hasOwnProperty.call(n,o)&&delete i[o];t.style.cssText=gs(i)},removeEventListener:function(t,e,i,n){var o;t.removeEventListener?(void 0===n&&(n=!1),"mousewheel"===e&&sr(o=navigator.userAgent).call(o,"Firefox")>=0&&(e="DOMMouseScroll"),t.removeEventListener(e,i,n)):t.detachEvent("on"+e,i)},selectiveBridgeObject:function(t,e){if(null!==e&&"object"===Fn(e)){for(var i=Ao(e),n=0;n<t.length;n++)Object.prototype.hasOwnProperty.call(e,t[n])&&"object"==Fn(e[t[n]])&&(i[t[n]]=ks(e[t[n]]));return i}return null},selectiveDeepExtend:function(t,e,i){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if(Di(i))throw new TypeError("Arrays are not supported by deepExtend");for(var o=0;o<t.length;o++){var r=t[o];if(Object.prototype.hasOwnProperty.call(i,r))if(i[r]&&i[r].constructor===Object)void 0===e[r]&&(e[r]={}),e[r].constructor===Object?ls(e[r],i[r],!1,n):ss(e,i,r,n);else{if(Di(i[r]))throw new TypeError("Arrays are not supported by deepExtend");ss(e,i,r,n)}}return e},selectiveExtend:function(t,e){if(!Di(t))throw new Error("Array with property names expected as first argument");for(var i=arguments.length,n=new Array(i>2?i-2:0),o=2;o<i;o++)n[o-2]=arguments[o];for(var r=0,s=n;r<s.length;r++)for(var a=s[r],l=0;l<t.length;l++){var h=t[l];a&&Object.prototype.hasOwnProperty.call(a,h)&&(e[h]=a[h])}return e},selectiveNotDeepExtend:function(t,e,i){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if(Di(i))throw new TypeError("Arrays are not supported by deepExtend");for(var o in i)if(Object.prototype.hasOwnProperty.call(i,o)&&-1===sr(t).call(t,o))if(i[o]&&i[o].constructor===Object)void 0===e[o]&&(e[o]={}),e[o].constructor===Object?ls(e[o],i[o]):ss(e,i,o,n);else if(Di(i[o])){e[o]=[];for(var r=0;r<i[o].length;r++)e[o].push(i[o][r])}else ss(e,i,o,n);return e},throttle:function(t){var e=!1;return function(){e||(e=!0,requestAnimationFrame((function(){e=!1,t()})))}},toArray:us,topMost:function(t,e){var i;Di(e)||(e=[e]);var n,o=Yr(t);try{for(o.s();!(n=o.n()).done;){var r=n.value;if(r){i=r[e[0]];for(var s=1;s<e.length;s++)i&&(i=i[e[s]]);if(void 0!==i)break}}}catch(t){o.e(t)}finally{o.f()}return i},updateProperty:function(t,e,i){return t[e]!==i&&(t[e]=i,!0)}})),{},{convert:Cs}),Es=Fo.trim,Is=h.parseFloat,Ms=1/Is(Po+"-0")!=-1/0?function(t){var e=Es(String(t)),i=Is(e);return 0===i&&"-"==e.charAt(0)?-0:i}:Is;q({global:!0,forced:parseFloat!=Ms},{parseFloat:Ms});var As=z.parseFloat,Ps=$("JSON","stringify"),Ns=/[\uD800-\uDFFF]/g,Rs=/^[\uD800-\uDBFF]$/,Ls=/^[\uDC00-\uDFFF]$/,js=function(t,e,i){var n=i.charAt(e-1),o=i.charAt(e+1);return Rs.test(t)&&!Ls.test(o)||Ls.test(t)&&!Rs.test(n)?"\\u"+t.charCodeAt(0).toString(16):t},Fs=u((function(){return'"\\udf06\\ud834"'!==Ps("\udf06\ud834")||'"\\udead"'!==Ps("\udead")}));Ps&&q({target:"JSON",stat:!0,forced:Fs},{stringify:function(t,e,i){var n=Ps.apply(null,arguments);return"string"==typeof n?n.replace(Ns,js):n}}),z.JSON||(z.JSON={stringify:JSON.stringify});var zs=function(t,e,i){return z.JSON.stringify.apply(null,arguments)},Gs=function(){function t(e,i){Ci(this,t),this.options=null,this.props=null}return Ii(t,[{key:"setOptions",value:function(t){t&&Os.extend(this.options,t)}},{key:"redraw",value:function(){return!1}},{key:"destroy",value:function(){}},{key:"_isResized",value:function(){var t=this.props._previousWidth!==this.props.width||this.props._previousHeight!==this.props.height;return this.props._previousWidth=this.props.width,this.props._previousHeight=this.props.height,t}}]),t}(),Hs=[],Bs=Hs.sort,Ys=u((function(){Hs.sort(void 0)})),Ws=u((function(){Hs.sort(null)})),Vs=Be("sort");q({target:"Array",proto:!0,forced:Ys||!Ws||!Vs},{sort:function(t){return void 0===t?Bs.call(Jt(this)):Bs.call(Jt(this),G(t))}});var Us=Je("Array").sort,Xs=Array.prototype,qs=function(t){var e=t.sort;return t===Xs||t instanceof Array&&e===Xs.sort?Us:e};q({target:"String",proto:!0},{repeat:"".repeat||function(t){var e=String(w(this)),i="",n=J(t);if(n<0||n==1/0)throw RangeError("Wrong number of repetitions");for(;n>0;(n>>>=1)&&(e+=e))1&n&&(i+=e);return i}});var Ks=Je("String").repeat,$s=String.prototype,Zs=function(t){var e=t.repeat;return"string"==typeof t||t===$s||t instanceof String&&e===$s.repeat?Ks:e};function Qs(t,e,i){if(i&&!Di(i))return Qs(t,e,[i]);if(e.hiddenDates=[],i&&1==Di(i)){for(var n,o=0;o<i.length;o++)if(void 0===Zs(i[o])){var r={};r.start=t(i[o].start).toDate().valueOf(),r.end=t(i[o].end).toDate().valueOf(),e.hiddenDates.push(r)}qs(n=e.hiddenDates).call(n,(function(t,e){return t.start-e.start}))}}function Js(t,e,i){if(i&&!Di(i))return Js(t,e,[i]);if(i&&void 0!==e.domProps.centerContainer.width){Qs(t,e,i);for(var n=t(e.range.start),o=t(e.range.end),r=(e.range.end-e.range.start)/e.domProps.centerContainer.width,s=0;s<i.length;s++)if(void 0!==Zs(i[s])){var a=t(i[s].start),l=t(i[s].end);if("Invalid Date"==a._d)throw new Error("Supplied start date is not valid: ".concat(i[s].start));if("Invalid Date"==l._d)throw new Error("Supplied end date is not valid: ".concat(i[s].end));if(l-a>=4*r){var h=0,u=o.clone();switch(Zs(i[s])){case"daily":a.day()!=l.day()&&(h=1),a.dayOfYear(n.dayOfYear()),a.year(n.year()),a.subtract(7,"days"),l.dayOfYear(n.dayOfYear()),l.year(n.year()),l.subtract(7-h,"days"),u.add(1,"weeks");break;case"weekly":var d=l.diff(a,"days"),c=a.day();a.date(n.date()),a.month(n.month()),a.year(n.year()),l=a.clone(),a.day(c),l.day(c),l.add(d,"days"),a.subtract(1,"weeks"),l.subtract(1,"weeks"),u.add(1,"weeks");break;case"monthly":a.month()!=l.month()&&(h=1),a.month(n.month()),a.year(n.year()),a.subtract(1,"months"),l.month(n.month()),l.year(n.year()),l.subtract(1,"months"),l.add(h,"months"),u.add(1,"months");break;case"yearly":a.year()!=l.year()&&(h=1),a.year(n.year()),a.subtract(1,"years"),l.year(n.year()),l.subtract(1,"years"),l.add(h,"years"),u.add(1,"years");break;default:return void console.log("Wrong repeat format, allowed are: daily, weekly, monthly, yearly. Given:",Zs(i[s]))}for(;a<u;)switch(e.hiddenDates.push({start:a.valueOf(),end:l.valueOf()}),Zs(i[s])){case"daily":a.add(1,"days"),l.add(1,"days");break;case"weekly":a.add(1,"weeks"),l.add(1,"weeks");break;case"monthly":a.add(1,"months"),l.add(1,"months");break;case"yearly":a.add(1,"y"),l.add(1,"y");break;default:return void console.log("Wrong repeat format, allowed are: daily, weekly, monthly, yearly. Given:",Zs(i[s]))}e.hiddenDates.push({start:a.valueOf(),end:l.valueOf()})}}ta(e);var p=ua(e.range.start,e.hiddenDates),m=ua(e.range.end,e.hiddenDates),f=e.range.start,g=e.range.end;1==p.hidden&&(f=1==e.range.startToFront?p.startDate-1:p.endDate+1),1==m.hidden&&(g=1==e.range.endToFront?m.startDate-1:m.endDate+1),1!=p.hidden&&1!=m.hidden||e.range._applyRange(f,g)}}function ta(t){for(var e,i=t.hiddenDates,n=[],o=0;o<i.length;o++)for(var r=0;r<i.length;r++)o!=r&&1!=i[r].remove&&1!=i[o].remove&&(i[r].start>=i[o].start&&i[r].end<=i[o].end?i[r].remove=!0:i[r].start>=i[o].start&&i[r].start<=i[o].end?(i[o].end=i[r].end,i[r].remove=!0):i[r].end>=i[o].start&&i[r].end<=i[o].end&&(i[o].start=i[r].start,i[r].remove=!0));for(o=0;o<i.length;o++)!0!==i[o].remove&&n.push(i[o]);t.hiddenDates=n,qs(e=t.hiddenDates).call(e,(function(t,e){return t.start-e.start}))}function ea(t,e,i){for(var n=!1,o=e.current.valueOf(),r=0;r<e.hiddenDates.length;r++){var s=e.hiddenDates[r].start,a=e.hiddenDates[r].end;if(o>=s&&o<a){n=!0;break}}if(1==n&&o<e._end.valueOf()&&o!=i){var l=t(i),h=t(a);l.year()!=h.year()?e.switchedYear=!0:l.month()!=h.month()?e.switchedMonth=!0:l.dayOfYear()!=h.dayOfYear()&&(e.switchedDay=!0),e.current=h}}function ia(t,e,i){var n;if(0==t.body.hiddenDates.length)return n=t.range.conversion(i),(e.valueOf()-n.offset)*n.scale;var o=ua(e,t.body.hiddenDates);1==o.hidden&&(e=o.startDate);var r=oa(t.body.hiddenDates,t.range.start,t.range.end);if(e<t.range.start){n=t.range.conversion(i,r);var s=ra(t.body.hiddenDates,e,n.offset);return e=t.options.moment(e).toDate().valueOf(),e+=s,-(n.offset-e.valueOf())*n.scale}if(e>t.range.end){var a={start:t.range.start,end:e};return e=sa(t.options.moment,t.body.hiddenDates,a,e),n=t.range.conversion(i,r),(e.valueOf()-n.offset)*n.scale}return e=sa(t.options.moment,t.body.hiddenDates,t.range,e),n=t.range.conversion(i,r),(e.valueOf()-n.offset)*n.scale}function na(t,e,i){if(0==t.body.hiddenDates.length){var n=t.range.conversion(i);return new Date(e/n.scale+n.offset)}var o=oa(t.body.hiddenDates,t.range.start,t.range.end),r=(t.range.end-t.range.start-o)*e/i,s=la(t.body.hiddenDates,t.range,r);return new Date(s+r+t.range.start)}function oa(t,e,i){for(var n=0,o=0;o<t.length;o++){var r=t[o].start,s=t[o].end;r>=e&&s<i&&(n+=s-r)}return n}function ra(t,e,i){for(var n=0,o=0;o<t.length;o++){var r=t[o].start,s=t[o].end;r>=e&&s<=i&&(n+=s-r)}return n}function sa(t,e,i,n){return n=t(n).toDate().valueOf(),n-=aa(t,e,i,n)}function aa(t,e,i,n){var o=0;n=t(n).toDate().valueOf();for(var r=0;r<e.length;r++){var s=e[r].start,a=e[r].end;s>=i.start&&a<i.end&&n>=a&&(o+=a-s)}return o}function la(t,e,i){for(var n=0,o=0,r=e.start,s=0;s<t.length;s++){var a=t[s].start,l=t[s].end;if(a>=e.start&&l<e.end){if(o+=a-r,r=l,o>=i)break;n+=l-a}}return n}function ha(t,e,i,n){var o=ua(e,t);return 1==o.hidden?i<0?1==n?o.startDate-(o.endDate-e)-1:o.startDate-1:1==n?o.endDate+(e-o.startDate)+1:o.endDate+1:e}function ua(t,e){for(var i=0;i<e.length;i++){var n=e[i].start,o=e[i].end;if(t>=n&&t<o)return{hidden:!0,startDate:n,endDate:o}}return{hidden:!1,startDate:n,endDate:o}}var da=Object.freeze({__proto__:null,convertHiddenOptions:Qs,updateHiddenDates:Js,removeDuplicates:ta,printDates:function(t){for(var e=0;e<t.length;e++)console.log(e,new Date(t[e].start),new Date(t[e].end),t[e].start,t[e].end,t[e].remove)},stepOverHiddenDates:ea,toScreen:ia,toTime:na,getHiddenDurationBetween:oa,getHiddenDurationBeforeStart:ra,correctTimeForHidden:sa,getHiddenDurationBefore:aa,getAccumulatedHiddenDuration:la,snapAwayFromHidden:ha,getIsHidden:ua});function ca(t){var e=function(){if("undefined"==typeof Reflect||!Nt)return!1;if(Nt.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Nt(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=Yn(t);if(e){var o=Yn(this).constructor;i=Nt(n,arguments,o)}else i=n.apply(this,arguments);return zn(this,i)}}var pa=function(t){ji(i,Gs);var e=ca(i);function i(t,n){var o,r,s,a,l,h,u,d;Ci(this,i),d=e.call(this);var c=Wn().hours(0).minutes(0).seconds(0).milliseconds(0),p=c.clone().add(-3,"days").valueOf(),m=c.clone().add(3,"days").valueOf();return d.millisecondsPerPixelCache=void 0,void 0===n?(d.start=p,d.end=m):(d.start=n.start||p,d.end=n.end||m),d.rolling=!1,d.body=t,d.deltaDifference=0,d.scaleOffset=0,d.startToFront=!1,d.endToFront=!0,d.defaultOptions={rtl:!1,start:null,end:null,moment:Wn,direction:"horizontal",moveable:!0,zoomable:!0,min:null,max:null,zoomMin:10,zoomMax:31536e10,rollingMode:{follow:!1,offset:.5}},d.options=Os.extend({},d.defaultOptions),d.props={touch:{}},d.animationTimer=null,d.body.emitter.on("panstart",xi(o=d._onDragStart).call(o,Mi(d))),d.body.emitter.on("panmove",xi(r=d._onDrag).call(r,Mi(d))),d.body.emitter.on("panend",xi(s=d._onDragEnd).call(s,Mi(d))),d.body.emitter.on("mousewheel",xi(a=d._onMouseWheel).call(a,Mi(d))),d.body.emitter.on("touch",xi(l=d._onTouch).call(l,Mi(d))),d.body.emitter.on("pinch",xi(h=d._onPinch).call(h,Mi(d))),d.body.dom.rollingModeBtn.addEventListener("click",xi(u=d.startRolling).call(u,Mi(d))),d.setOptions(n),d}return Ii(i,[{key:"setOptions",value:function(t){if(t){Os.selectiveExtend(["animation","direction","min","max","zoomMin","zoomMax","moveable","zoomable","moment","activate","hiddenDates","zoomKey","zoomFriction","rtl","showCurrentTime","rollingMode","horizontalScroll"],this.options,t),t.rollingMode&&t.rollingMode.follow&&this.startRolling(),("start"in t||"end"in t)&&this.setRange(t.start,t.end)}}},{key:"startRolling",value:function(){var t=this;!function e(){t.stopRolling(),t.rolling=!0;var i=t.end-t.start,n=Os.convert(new Date,"Date").valueOf(),o=t.options.rollingMode&&t.options.rollingMode.offset||.5,r=n-i*o,s=n+i*(1-o);t.setRange(r,s,{animation:!1}),(i=1/t.conversion(t.body.domProps.center.width).scale/10)<30&&(i=30),i>1e3&&(i=1e3),t.body.dom.rollingModeBtn.style.visibility="hidden",t.currentTimeTimer=wi(e,i)}()}},{key:"stopRolling",value:function(){void 0!==this.currentTimeTimer&&(clearTimeout(this.currentTimeTimer),this.rolling=!1,this.body.dom.rollingModeBtn.style.visibility="visible")}},{key:"setRange",value:function(t,e,i,n,o){i||(i={}),!0!==i.byUser&&(i.byUser=!1);var r=this,s=null!=t?Os.convert(t,"Date").valueOf():null,a=null!=e?Os.convert(e,"Date").valueOf():null;if(this._cancelAnimation(),this.millisecondsPerPixelCache=void 0,i.animation){var l,h=this.start,u=this.end,d="object"===Fn(i.animation)&&"duration"in i.animation?i.animation.duration:500,c="object"===Fn(i.animation)&&"easingFunction"in i.animation?i.animation.easingFunction:"easeInOutQuad",p=Os.easingFunctions[c];if(!p)throw new Error(zr(l="Unknown easing function ".concat(zs(c),". Choose from: ")).call(l,eo(Os.easingFunctions).join(", ")));var m=Ir(),f=!1;return function t(){if(!r.props.touch.dragging){var e=Ir()-m,l=p(e/d),c=e>d,v=c||null===s?s:h+(s-h)*l,y=c||null===a?a:u+(a-u)*l;g=r._applyRange(v,y),Js(r.options.moment,r.body,r.options.hiddenDates),f=f||g;var b={start:new Date(r.start),end:new Date(r.end),byUser:i.byUser,event:i.event};if(o&&o(l,g,c),g&&r.body.emitter.emit("rangechange",b),c){if(f&&(r.body.emitter.emit("rangechanged",b),n))return n()}else r.animationTimer=wi(t,20)}}()}var g=this._applyRange(s,a);if(Js(this.options.moment,this.body,this.options.hiddenDates),g){var v={start:new Date(this.start),end:new Date(this.end),byUser:i.byUser,event:i.event};if(this.body.emitter.emit("rangechange",v),clearTimeout(r.timeoutID),r.timeoutID=wi((function(){r.body.emitter.emit("rangechanged",v)}),200),n)return n()}}},{key:"getMillisecondsPerPixel",value:function(){return void 0===this.millisecondsPerPixelCache&&(this.millisecondsPerPixelCache=(this.end-this.start)/this.body.dom.center.clientWidth),this.millisecondsPerPixelCache}},{key:"_cancelAnimation",value:function(){this.animationTimer&&(clearTimeout(this.animationTimer),this.animationTimer=null)}},{key:"_applyRange",value:function(t,e){var i,n=null!=t?Os.convert(t,"Date").valueOf():this.start,o=null!=e?Os.convert(e,"Date").valueOf():this.end,r=null!=this.options.max?Os.convert(this.options.max,"Date").valueOf():null,s=null!=this.options.min?Os.convert(this.options.min,"Date").valueOf():null;if(isNaN(n)||null===n)throw new Error('Invalid start "'.concat(t,'"'));if(isNaN(o)||null===o)throw new Error('Invalid end "'.concat(e,'"'));if(o<n&&(o=n),null!==s&&n<s&&(n+=i=s-n,o+=i,null!=r&&o>r&&(o=r)),null!==r&&o>r&&(n-=i=o-r,o-=i,null!=s&&n<s&&(n=s)),null!==this.options.zoomMin){var a=As(this.options.zoomMin);if(a<0&&(a=0),o-n<a){this.end-this.start===a&&n>=this.start-.5&&o<=this.end?(n=this.start,o=this.end):(n-=(i=a-(o-n))/2,o+=i/2)}}if(null!==this.options.zoomMax){var l=As(this.options.zoomMax);l<0&&(l=0),o-n>l&&(this.end-this.start===l&&n<this.start&&o>this.end?(n=this.start,o=this.end):(n+=(i=o-n-l)/2,o-=i/2))}var h=this.start!=n||this.end!=o;return n>=this.start&&n<=this.end||o>=this.start&&o<=this.end||this.start>=n&&this.start<=o||this.end>=n&&this.end<=o||this.body.emitter.emit("checkRangedItems"),this.start=n,this.end=o,h}},{key:"getRange",value:function(){return{start:this.start,end:this.end}}},{key:"conversion",value:function(t,e){return i.conversion(this.start,this.end,t,e)}},{key:"_onDragStart",value:function(t){this.deltaDifference=0,this.previousDelta=0,this.options.moveable&&this._isInsideRange(t)&&this.props.touch.allowDragging&&(this.stopRolling(),this.props.touch.start=this.start,this.props.touch.end=this.end,this.props.touch.dragging=!0,this.body.dom.root&&(this.body.dom.root.style.cursor="move"))}},{key:"_onDrag",value:function(t){if(t&&this.props.touch.dragging&&this.options.moveable&&this.props.touch.allowDragging){var e=this.options.direction;ma(e);var i="horizontal"==e?t.deltaX:t.deltaY;i-=this.deltaDifference;var n=this.props.touch.end-this.props.touch.start;n-=oa(this.body.hiddenDates,this.start,this.end);var o,r="horizontal"==e?this.body.domProps.center.width:this.body.domProps.center.height;o=this.options.rtl?i/r*n:-i/r*n;var s=this.props.touch.start+o,a=this.props.touch.end+o,l=ha(this.body.hiddenDates,s,this.previousDelta-i,!0),h=ha(this.body.hiddenDates,a,this.previousDelta-i,!0);if(l!=s||h!=a)return this.deltaDifference+=i,this.props.touch.start=l,this.props.touch.end=h,void this._onDrag(t);this.previousDelta=i,this._applyRange(s,a);var u=new Date(this.start),d=new Date(this.end);this.body.emitter.emit("rangechange",{start:u,end:d,byUser:!0,event:t}),this.body.emitter.emit("panmove")}}},{key:"_onDragEnd",value:function(t){this.props.touch.dragging&&this.options.moveable&&this.props.touch.allowDragging&&(this.props.touch.dragging=!1,this.body.dom.root&&(this.body.dom.root.style.cursor="auto"),this.body.emitter.emit("rangechanged",{start:new Date(this.start),end:new Date(this.end),byUser:!0,event:t}))}},{key:"_onMouseWheel",value:function(t){var e=0;if(t.wheelDelta?e=t.wheelDelta/120:t.detail?e=-t.detail/3:t.deltaY&&(e=-t.deltaY/3),!(this.options.zoomKey&&!t[this.options.zoomKey]&&this.options.zoomable||!this.options.zoomable&&this.options.moveable)&&this.options.zoomable&&this.options.moveable&&this._isInsideRange(t)&&e){var i,n,o=this.options.zoomFriction||5;if(i=e<0?1-e/o:1/(1+e/o),this.rolling){var r=this.options.rollingMode&&this.options.rollingMode.offset||.5;n=this.start+(this.end-this.start)*r}else{var s=this.getPointer({x:t.clientX,y:t.clientY},this.body.dom.center);n=this._pointerToDate(s)}this.zoom(i,n,e,t),t.preventDefault()}}},{key:"_onTouch",value:function(t){this.props.touch.start=this.start,this.props.touch.end=this.end,this.props.touch.allowDragging=!0,this.props.touch.center=null,this.props.touch.centerDate=null,this.scaleOffset=0,this.deltaDifference=0,Os.preventDefault(t)}},{key:"_onPinch",value:function(t){if(this.options.zoomable&&this.options.moveable){Os.preventDefault(t),this.props.touch.allowDragging=!1,this.props.touch.center||(this.props.touch.center=this.getPointer(t.center,this.body.dom.center),this.props.touch.centerDate=this._pointerToDate(this.props.touch.center)),this.stopRolling();var e=1/(t.scale+this.scaleOffset),i=this.props.touch.centerDate,n=oa(this.body.hiddenDates,this.start,this.end),o=aa(this.options.moment,this.body.hiddenDates,this,i),r=n-o,s=i-o+(this.props.touch.start-(i-o))*e,a=i+r+(this.props.touch.end-(i+r))*e;this.startToFront=1-e<=0,this.endToFront=e-1<=0;var l=ha(this.body.hiddenDates,s,1-e,!0),h=ha(this.body.hiddenDates,a,e-1,!0);l==s&&h==a||(this.props.touch.start=l,this.props.touch.end=h,this.scaleOffset=1-t.scale,s=l,a=h);var u={animation:!1,byUser:!0,event:t};this.setRange(s,a,u),this.startToFront=!1,this.endToFront=!0}}},{key:"_isInsideRange",value:function(t){var e=t.center?t.center.x:t.clientX,i=this.body.dom.centerContainer.getBoundingClientRect(),n=this.options.rtl?e-i.left:i.right-e,o=this.body.util.toTime(n);return o>=this.start&&o<=this.end}},{key:"_pointerToDate",value:function(t){var e,i=this.options.direction;if(ma(i),"horizontal"==i)return this.body.util.toTime(t.x).valueOf();var n=this.body.domProps.center.height;return e=this.conversion(n),t.y/e.scale+e.offset}},{key:"getPointer",value:function(t,e){var i=e.getBoundingClientRect();return this.options.rtl?{x:i.right-t.x,y:t.y-i.top}:{x:t.x-i.left,y:t.y-i.top}}},{key:"zoom",value:function(t,e,i,n){null==e&&(e=(this.start+this.end)/2);var o=oa(this.body.hiddenDates,this.start,this.end),r=aa(this.options.moment,this.body.hiddenDates,this,e),s=o-r,a=e-r+(this.start-(e-r))*t,l=e+s+(this.end-(e+s))*t;this.startToFront=!(i>0),this.endToFront=!(-i>0);var h=ha(this.body.hiddenDates,a,i,!0),u=ha(this.body.hiddenDates,l,-i,!0);h==a&&u==l||(a=h,l=u);var d={animation:!1,byUser:!0,event:n};this.setRange(a,l,d),this.startToFront=!1,this.endToFront=!0}},{key:"move",value:function(t){var e=this.end-this.start,i=this.start+e*t,n=this.end+e*t;this.start=i,this.end=n}},{key:"moveTo",value:function(t){var e=(this.start+this.end)/2-t,i=this.start-e,n=this.end-e;this.setRange(i,n,{animation:!1,byUser:!0,event:null})}}],[{key:"conversion",value:function(t,e,i,n){return void 0===n&&(n=0),0!=i&&e-t!=0?{offset:t,scale:i/(e-t-n)}:{offset:0,scale:1}}}]),i}();function ma(t){if("horizontal"!=t&&"vertical"!=t)throw new TypeError('Unknown direction "'.concat(t,'". Choose "horizontal" or "vertical".'))}var fa=z.setInterval,ga=He.some,va=Be("some"),ya=Ue("some");q({target:"Array",proto:!0,forced:!va||!ya},{some:function(t){return ga(this,t,arguments.length>1?arguments[1]:void 0)}});var ba=Je("Array").some,wa=Array.prototype,_a=function(t){var e=t.some;return t===wa||t instanceof Array&&e===wa.some?ba:e},ka=ui("splice"),xa=Ue("splice",{ACCESSORS:!0,0:0,1:2}),Sa=Math.max,Da=Math.min;q({target:"Array",proto:!0,forced:!ka||!xa},{splice:function(t,e){var i,n,o,r,s,a,l=Jt(this),h=et(l.length),u=ot(t,h),d=arguments.length;if(0===d?i=n=0:1===d?(i=0,n=h-u):(i=d-2,n=Da(Sa(J(e),0),h-u)),h+i-n>9007199254740991)throw TypeError("Maximum allowed length exceeded");for(o=Fe(l,n),r=0;r<n;r++)(s=u+r)in l&&Ui(o,r,l[s]);if(o.length=n,i<n){for(r=u;r<h-n;r++)a=r+i,(s=r+n)in l?l[a]=l[s]:delete l[a];for(r=h;r>h-n+i;r--)delete l[r-1]}else if(i>n)for(r=h-n;r>u;r--)a=r+i-1,(s=r+n-1)in l?l[a]=l[s]:delete l[a];for(r=0;r<i;r++)l[r+u]=arguments[r+2];return l.length=h-n+i,o}});var Ca=Je("Array").splice,Ta=Array.prototype,Oa=function(t){var e=t.splice;return t===Ta||t instanceof Array&&e===Ta.splice?Ca:e},Ea=r((function(t){function e(t){if(t)return function(t){for(var i in e.prototype)t[i]=e.prototype[i];return t}(t)}t.exports=e,e.prototype.on=e.prototype.addEventListener=function(t,e){return this._callbacks=this._callbacks||{},(this._callbacks["$"+t]=this._callbacks["$"+t]||[]).push(e),this},e.prototype.once=function(t,e){function i(){this.off(t,i),e.apply(this,arguments)}return i.fn=e,this.on(t,i),this},e.prototype.off=e.prototype.removeListener=e.prototype.removeAllListeners=e.prototype.removeEventListener=function(t,e){if(this._callbacks=this._callbacks||{},0==arguments.length)return this._callbacks={},this;var i,n=this._callbacks["$"+t];if(!n)return this;if(1==arguments.length)return delete this._callbacks["$"+t],this;for(var o=0;o<n.length;o++)if((i=n[o])===e||i.fn===e){n.splice(o,1);break}return 0===n.length&&delete this._callbacks["$"+t],this},e.prototype.emit=function(t){this._callbacks=this._callbacks||{};for(var e=new Array(arguments.length-1),i=this._callbacks["$"+t],n=1;n<arguments.length;n++)e[n-1]=arguments[n];if(i){n=0;for(var o=(i=i.slice(0)).length;n<o;++n)i[n].apply(this,e)}return this},e.prototype.listeners=function(t){return this._callbacks=this._callbacks||{},this._callbacks["$"+t]||[]},e.prototype.hasListeners=function(t){return!!this.listeners(t).length}})),Ia=r((function(t,e){var i;t.exports=(i=null,function t(e,n){var o=n||{preventDefault:!1};if(e.Manager){var r=e,s=function(e,i){var n=Object.create(o);return i&&r.assign(n,i),t(new r(e,n),n)};return r.assign(s,r),s.Manager=function(e,i){var n=Object.create(o);return i&&r.assign(n,i),t(new r.Manager(e,n),n)},s}var a=Object.create(e),l=e.element;function h(t){return t.match(/[^ ]+/g)}function u(t){if("hammer.input"!==t.type){if(t.srcEvent._handled||(t.srcEvent._handled={}),t.srcEvent._handled[t.type])return;t.srcEvent._handled[t.type]=!0}var e=!1;t.stopPropagation=function(){e=!0};var n=t.srcEvent.stopPropagation.bind(t.srcEvent);"function"==typeof n&&(t.srcEvent.stopPropagation=function(){n(),t.stopPropagation()}),t.firstTarget=i;for(var o=i;o&&!e;){var r=o.hammer;if(r)for(var s,a=0;a<r.length;a++)if(s=r[a]._handlers[t.type])for(var l=0;l<s.length&&!e;l++)s[l](t);o=o.parentNode}}return l.hammer||(l.hammer=[]),l.hammer.push(a),e.on("hammer.input",(function(t){!0!==o.preventDefault&&o.preventDefault!==t.pointerType||t.preventDefault(),t.isFirst&&(i=t.target)})),a._handlers={},a.on=function(t,i){return h(t).forEach((function(t){var n=a._handlers[t];n||(a._handlers[t]=n=[],e.on(t,u)),n.push(i)})),a},a.off=function(t,i){return h(t).forEach((function(t){var n=a._handlers[t];n&&((n=i?n.filter((function(t){return t!==i})):[]).length>0?a._handlers[t]=n:(e.off(t,u),delete a._handlers[t]))})),a},a.emit=function(t,n){i=n.target,e.emit(t,n)},a.destroy=function(){var t=e.element.hammer,i=t.indexOf(a);-1!==i&&t.splice(i,1),t.length||delete e.element.hammer,a._handlers={},e.destroy()},a})}));
/*! Hammer.JS - v2.0.17-rc - 2019-12-16
 * http://naver.github.io/egjs
 *
 * Forked By Naver egjs
 * Copyright (c) hammerjs
 * Licensed under the MIT license */
function Ma(){return(Ma=Object.assign||function(t){for(var e=1;e<arguments.length;e++){var i=arguments[e];for(var n in i)Object.prototype.hasOwnProperty.call(i,n)&&(t[n]=i[n])}return t}).apply(this,arguments)}function Aa(t,e){t.prototype=Object.create(e.prototype),t.prototype.constructor=t,t.__proto__=e}function Pa(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t}var Na,Ra="function"!=typeof Object.assign?function(t){if(null==t)throw new TypeError("Cannot convert undefined or null to object");for(var e=Object(t),i=1;i<arguments.length;i++){var n=arguments[i];if(null!=n)for(var o in n)n.hasOwnProperty(o)&&(e[o]=n[o])}return e}:Object.assign,La=["","webkit","Moz","MS","ms","o"],ja="undefined"==typeof document?{style:{}}:document.createElement("div"),Fa=Math.round,za=Math.abs,Ga=Date.now;function Ha(t,e){for(var i,n,o=e[0].toUpperCase()+e.slice(1),r=0;r<La.length;){if((n=(i=La[r])?i+o:e)in t)return n;r++}}Na="undefined"==typeof window?{}:window;var Ba=Ha(ja.style,"touchAction"),Ya=void 0!==Ba;var Wa=function(){if(!Ya)return!1;var t={},e=Na.CSS&&Na.CSS.supports;return["auto","manipulation","pan-y","pan-x","pan-x pan-y","none"].forEach((function(i){return t[i]=!e||Na.CSS.supports("touch-action",i)})),t}(),Va="ontouchstart"in Na,Ua=void 0!==Ha(Na,"PointerEvent"),Xa=Va&&/mobile|tablet|ip(ad|hone|od)|android/i.test(navigator.userAgent),qa=["x","y"],Ka=["clientX","clientY"];function $a(t,e,i){var n;if(t)if(t.forEach)t.forEach(e,i);else if(void 0!==t.length)for(n=0;n<t.length;)e.call(i,t[n],n,t),n++;else for(n in t)t.hasOwnProperty(n)&&e.call(i,t[n],n,t)}function Za(t,e){return"function"==typeof t?t.apply(e&&e[0]||void 0,e):t}function Qa(t,e){return t.indexOf(e)>-1}var Ja=function(){function t(t,e){this.manager=t,this.set(e)}var e=t.prototype;return e.set=function(t){"compute"===t&&(t=this.compute()),Ya&&this.manager.element.style&&Wa[t]&&(this.manager.element.style[Ba]=t),this.actions=t.toLowerCase().trim()},e.update=function(){this.set(this.manager.options.touchAction)},e.compute=function(){var t=[];return $a(this.manager.recognizers,(function(e){Za(e.options.enable,[e])&&(t=t.concat(e.getTouchAction()))})),function(t){if(Qa(t,"none"))return"none";var e=Qa(t,"pan-x"),i=Qa(t,"pan-y");return e&&i?"none":e||i?e?"pan-x":"pan-y":Qa(t,"manipulation")?"manipulation":"auto"}(t.join(" "))},e.preventDefaults=function(t){var e=t.srcEvent,i=t.offsetDirection;if(this.manager.session.prevented)e.preventDefault();else{var n=this.actions,o=Qa(n,"none")&&!Wa.none,r=Qa(n,"pan-y")&&!Wa["pan-y"],s=Qa(n,"pan-x")&&!Wa["pan-x"];if(o){var a=1===t.pointers.length,l=t.distance<2,h=t.deltaTime<250;if(a&&l&&h)return}if(!s||!r)return o||r&&6&i||s&&24&i?this.preventSrc(e):void 0}},e.preventSrc=function(t){this.manager.session.prevented=!0,t.preventDefault()},t}();function tl(t,e){for(;t;){if(t===e)return!0;t=t.parentNode}return!1}function el(t){var e=t.length;if(1===e)return{x:Fa(t[0].clientX),y:Fa(t[0].clientY)};for(var i=0,n=0,o=0;o<e;)i+=t[o].clientX,n+=t[o].clientY,o++;return{x:Fa(i/e),y:Fa(n/e)}}function il(t){for(var e=[],i=0;i<t.pointers.length;)e[i]={clientX:Fa(t.pointers[i].clientX),clientY:Fa(t.pointers[i].clientY)},i++;return{timeStamp:Ga(),pointers:e,center:el(e),deltaX:t.deltaX,deltaY:t.deltaY}}function nl(t,e,i){i||(i=qa);var n=e[i[0]]-t[i[0]],o=e[i[1]]-t[i[1]];return Math.sqrt(n*n+o*o)}function ol(t,e,i){i||(i=qa);var n=e[i[0]]-t[i[0]],o=e[i[1]]-t[i[1]];return 180*Math.atan2(o,n)/Math.PI}function rl(t,e){return t===e?1:za(t)>=za(e)?t<0?2:4:e<0?8:16}function sl(t,e,i){return{x:e/t||0,y:i/t||0}}function al(t,e){var i=t.session,n=e.pointers,o=n.length;i.firstInput||(i.firstInput=il(e)),o>1&&!i.firstMultiple?i.firstMultiple=il(e):1===o&&(i.firstMultiple=!1);var r=i.firstInput,s=i.firstMultiple,a=s?s.center:r.center,l=e.center=el(n);e.timeStamp=Ga(),e.deltaTime=e.timeStamp-r.timeStamp,e.angle=ol(a,l),e.distance=nl(a,l),function(t,e){var i=e.center,n=t.offsetDelta||{},o=t.prevDelta||{},r=t.prevInput||{};1!==e.eventType&&4!==r.eventType||(o=t.prevDelta={x:r.deltaX||0,y:r.deltaY||0},n=t.offsetDelta={x:i.x,y:i.y}),e.deltaX=o.x+(i.x-n.x),e.deltaY=o.y+(i.y-n.y)}(i,e),e.offsetDirection=rl(e.deltaX,e.deltaY);var h,u,d=sl(e.deltaTime,e.deltaX,e.deltaY);e.overallVelocityX=d.x,e.overallVelocityY=d.y,e.overallVelocity=za(d.x)>za(d.y)?d.x:d.y,e.scale=s?(h=s.pointers,nl((u=n)[0],u[1],Ka)/nl(h[0],h[1],Ka)):1,e.rotation=s?function(t,e){return ol(e[1],e[0],Ka)+ol(t[1],t[0],Ka)}(s.pointers,n):0,e.maxPointers=i.prevInput?e.pointers.length>i.prevInput.maxPointers?e.pointers.length:i.prevInput.maxPointers:e.pointers.length,function(t,e){var i,n,o,r,s=t.lastInterval||e,a=e.timeStamp-s.timeStamp;if(8!==e.eventType&&(a>25||void 0===s.velocity)){var l=e.deltaX-s.deltaX,h=e.deltaY-s.deltaY,u=sl(a,l,h);n=u.x,o=u.y,i=za(u.x)>za(u.y)?u.x:u.y,r=rl(l,h),t.lastInterval=e}else i=s.velocity,n=s.velocityX,o=s.velocityY,r=s.direction;e.velocity=i,e.velocityX=n,e.velocityY=o,e.direction=r}(i,e);var c,p=t.element,m=e.srcEvent;tl(c=m.composedPath?m.composedPath()[0]:m.path?m.path[0]:m.target,p)&&(p=c),e.target=p}function ll(t,e,i){var n=i.pointers.length,o=i.changedPointers.length,r=1&e&&n-o==0,s=12&e&&n-o==0;i.isFirst=!!r,i.isFinal=!!s,r&&(t.session={}),i.eventType=e,al(t,i),t.emit("hammer.input",i),t.recognize(i),t.session.prevInput=i}function hl(t){return t.trim().split(/\s+/g)}function ul(t,e,i){$a(hl(e),(function(e){t.addEventListener(e,i,!1)}))}function dl(t,e,i){$a(hl(e),(function(e){t.removeEventListener(e,i,!1)}))}function cl(t){var e=t.ownerDocument||t;return e.defaultView||e.parentWindow||window}var pl=function(){function t(t,e){var i=this;this.manager=t,this.callback=e,this.element=t.element,this.target=t.options.inputTarget,this.domHandler=function(e){Za(t.options.enable,[t])&&i.handler(e)},this.init()}var e=t.prototype;return e.handler=function(){},e.init=function(){this.evEl&&ul(this.element,this.evEl,this.domHandler),this.evTarget&&ul(this.target,this.evTarget,this.domHandler),this.evWin&&ul(cl(this.element),this.evWin,this.domHandler)},e.destroy=function(){this.evEl&&dl(this.element,this.evEl,this.domHandler),this.evTarget&&dl(this.target,this.evTarget,this.domHandler),this.evWin&&dl(cl(this.element),this.evWin,this.domHandler)},t}();function ml(t,e,i){if(t.indexOf&&!i)return t.indexOf(e);for(var n=0;n<t.length;){if(i&&t[n][i]==e||!i&&t[n]===e)return n;n++}return-1}var fl={pointerdown:1,pointermove:2,pointerup:4,pointercancel:8,pointerout:8},gl={2:"touch",3:"pen",4:"mouse",5:"kinect"},vl="pointerdown",yl="pointermove pointerup pointercancel";Na.MSPointerEvent&&!Na.PointerEvent&&(vl="MSPointerDown",yl="MSPointerMove MSPointerUp MSPointerCancel");var bl=function(t){function e(){var i,n=e.prototype;return n.evEl=vl,n.evWin=yl,(i=t.apply(this,arguments)||this).store=i.manager.session.pointerEvents=[],i}return Aa(e,t),e.prototype.handler=function(t){var e=this.store,i=!1,n=t.type.toLowerCase().replace("ms",""),o=fl[n],r=gl[t.pointerType]||t.pointerType,s="touch"===r,a=ml(e,t.pointerId,"pointerId");1&o&&(0===t.button||s)?a<0&&(e.push(t),a=e.length-1):12&o&&(i=!0),a<0||(e[a]=t,this.callback(this.manager,o,{pointers:e,changedPointers:[t],pointerType:r,srcEvent:t}),i&&e.splice(a,1))},e}(pl);function wl(t){return Array.prototype.slice.call(t,0)}function _l(t,e,i){for(var n=[],o=[],r=0;r<t.length;){var s=e?t[r][e]:t[r];ml(o,s)<0&&n.push(t[r]),o[r]=s,r++}return i&&(n=e?n.sort((function(t,i){return t[e]>i[e]})):n.sort()),n}var kl={touchstart:1,touchmove:2,touchend:4,touchcancel:8},xl=function(t){function e(){var i;return e.prototype.evTarget="touchstart touchmove touchend touchcancel",(i=t.apply(this,arguments)||this).targetIds={},i}return Aa(e,t),e.prototype.handler=function(t){var e=kl[t.type],i=Sl.call(this,t,e);i&&this.callback(this.manager,e,{pointers:i[0],changedPointers:i[1],pointerType:"touch",srcEvent:t})},e}(pl);function Sl(t,e){var i,n,o=wl(t.touches),r=this.targetIds;if(3&e&&1===o.length)return r[o[0].identifier]=!0,[o,o];var s=wl(t.changedTouches),a=[],l=this.target;if(n=o.filter((function(t){return tl(t.target,l)})),1===e)for(i=0;i<n.length;)r[n[i].identifier]=!0,i++;for(i=0;i<s.length;)r[s[i].identifier]&&a.push(s[i]),12&e&&delete r[s[i].identifier],i++;return a.length?[_l(n.concat(a),"identifier",!0),a]:void 0}var Dl={mousedown:1,mousemove:2,mouseup:4},Cl=function(t){function e(){var i,n=e.prototype;return n.evEl="mousedown",n.evWin="mousemove mouseup",(i=t.apply(this,arguments)||this).pressed=!1,i}return Aa(e,t),e.prototype.handler=function(t){var e=Dl[t.type];1&e&&0===t.button&&(this.pressed=!0),2&e&&1!==t.which&&(e=4),this.pressed&&(4&e&&(this.pressed=!1),this.callback(this.manager,e,{pointers:[t],changedPointers:[t],pointerType:"mouse",srcEvent:t}))},e}(pl);function Tl(t){var e=t.changedPointers[0];if(e.identifier===this.primaryTouch){var i={x:e.clientX,y:e.clientY},n=this.lastTouches;this.lastTouches.push(i);setTimeout((function(){var t=n.indexOf(i);t>-1&&n.splice(t,1)}),2500)}}function Ol(t,e){1&t?(this.primaryTouch=e.changedPointers[0].identifier,Tl.call(this,e)):12&t&&Tl.call(this,e)}function El(t){for(var e=t.srcEvent.clientX,i=t.srcEvent.clientY,n=0;n<this.lastTouches.length;n++){var o=this.lastTouches[n],r=Math.abs(e-o.x),s=Math.abs(i-o.y);if(r<=25&&s<=25)return!0}return!1}var Il=function(){return function(t){function e(e,i){var n;return(n=t.call(this,e,i)||this).handler=function(t,e,i){var o="touch"===i.pointerType,r="mouse"===i.pointerType;if(!(r&&i.sourceCapabilities&&i.sourceCapabilities.firesTouchEvents)){if(o)Ol.call(Pa(Pa(n)),e,i);else if(r&&El.call(Pa(Pa(n)),i))return;n.callback(t,e,i)}},n.touch=new xl(n.manager,n.handler),n.mouse=new Cl(n.manager,n.handler),n.primaryTouch=null,n.lastTouches=[],n}return Aa(e,t),e.prototype.destroy=function(){this.touch.destroy(),this.mouse.destroy()},e}(pl)}();function Ml(t,e,i){return!!Array.isArray(t)&&($a(t,i[e],i),!0)}var Al=1;function Pl(t,e){var i=e.manager;return i?i.get(t):t}function Nl(t){return 16&t?"cancel":8&t?"end":4&t?"move":2&t?"start":""}var Rl=function(){function t(t){void 0===t&&(t={}),this.options=Ma({enable:!0},t),this.id=Al++,this.manager=null,this.state=1,this.simultaneous={},this.requireFail=[]}var e=t.prototype;return e.set=function(t){return Ra(this.options,t),this.manager&&this.manager.touchAction.update(),this},e.recognizeWith=function(t){if(Ml(t,"recognizeWith",this))return this;var e=this.simultaneous;return e[(t=Pl(t,this)).id]||(e[t.id]=t,t.recognizeWith(this)),this},e.dropRecognizeWith=function(t){return Ml(t,"dropRecognizeWith",this)||(t=Pl(t,this),delete this.simultaneous[t.id]),this},e.requireFailure=function(t){if(Ml(t,"requireFailure",this))return this;var e=this.requireFail;return-1===ml(e,t=Pl(t,this))&&(e.push(t),t.requireFailure(this)),this},e.dropRequireFailure=function(t){if(Ml(t,"dropRequireFailure",this))return this;t=Pl(t,this);var e=ml(this.requireFail,t);return e>-1&&this.requireFail.splice(e,1),this},e.hasRequireFailures=function(){return this.requireFail.length>0},e.canRecognizeWith=function(t){return!!this.simultaneous[t.id]},e.emit=function(t){var e=this,i=this.state;function n(i){e.manager.emit(i,t)}i<8&&n(e.options.event+Nl(i)),n(e.options.event),t.additionalEvent&&n(t.additionalEvent),i>=8&&n(e.options.event+Nl(i))},e.tryEmit=function(t){if(this.canEmit())return this.emit(t);this.state=32},e.canEmit=function(){for(var t=0;t<this.requireFail.length;){if(!(33&this.requireFail[t].state))return!1;t++}return!0},e.recognize=function(t){var e=Ra({},t);if(!Za(this.options.enable,[this,e]))return this.reset(),void(this.state=32);56&this.state&&(this.state=1),this.state=this.process(e),30&this.state&&this.tryEmit(e)},e.process=function(t){},e.getTouchAction=function(){},e.reset=function(){},t}(),Ll=function(t){function e(e){var i;return void 0===e&&(e={}),(i=t.call(this,Ma({event:"tap",pointers:1,taps:1,interval:300,time:250,threshold:9,posThreshold:10},e))||this).pTime=!1,i.pCenter=!1,i._timer=null,i._input=null,i.count=0,i}Aa(e,t);var i=e.prototype;return i.getTouchAction=function(){return["manipulation"]},i.process=function(t){var e=this,i=this.options,n=t.pointers.length===i.pointers,o=t.distance<i.threshold,r=t.deltaTime<i.time;if(this.reset(),1&t.eventType&&0===this.count)return this.failTimeout();if(o&&r&&n){if(4!==t.eventType)return this.failTimeout();var s=!this.pTime||t.timeStamp-this.pTime<i.interval,a=!this.pCenter||nl(this.pCenter,t.center)<i.posThreshold;if(this.pTime=t.timeStamp,this.pCenter=t.center,a&&s?this.count+=1:this.count=1,this._input=t,0===this.count%i.taps)return this.hasRequireFailures()?(this._timer=setTimeout((function(){e.state=8,e.tryEmit()}),i.interval),2):8}return 32},i.failTimeout=function(){var t=this;return this._timer=setTimeout((function(){t.state=32}),this.options.interval),32},i.reset=function(){clearTimeout(this._timer)},i.emit=function(){8===this.state&&(this._input.tapCount=this.count,this.manager.emit(this.options.event,this._input))},e}(Rl),jl=function(t){function e(e){return void 0===e&&(e={}),t.call(this,Ma({pointers:1},e))||this}Aa(e,t);var i=e.prototype;return i.attrTest=function(t){var e=this.options.pointers;return 0===e||t.pointers.length===e},i.process=function(t){var e=this.state,i=t.eventType,n=6&e,o=this.attrTest(t);return n&&(8&i||!o)?16|e:n||o?4&i?8|e:2&e?4|e:2:32},e}(Rl);function Fl(t){return 16===t?"down":8===t?"up":2===t?"left":4===t?"right":""}var zl=function(t){function e(e){var i;return void 0===e&&(e={}),(i=t.call(this,Ma({event:"pan",threshold:10,pointers:1,direction:30},e))||this).pX=null,i.pY=null,i}Aa(e,t);var i=e.prototype;return i.getTouchAction=function(){var t=this.options.direction,e=[];return 6&t&&e.push("pan-y"),24&t&&e.push("pan-x"),e},i.directionTest=function(t){var e=this.options,i=!0,n=t.distance,o=t.direction,r=t.deltaX,s=t.deltaY;return o&e.direction||(6&e.direction?(o=0===r?1:r<0?2:4,i=r!==this.pX,n=Math.abs(t.deltaX)):(o=0===s?1:s<0?8:16,i=s!==this.pY,n=Math.abs(t.deltaY))),t.direction=o,i&&n>e.threshold&&o&e.direction},i.attrTest=function(t){return jl.prototype.attrTest.call(this,t)&&(2&this.state||!(2&this.state)&&this.directionTest(t))},i.emit=function(e){this.pX=e.deltaX,this.pY=e.deltaY;var i=Fl(e.direction);i&&(e.additionalEvent=this.options.event+i),t.prototype.emit.call(this,e)},e}(jl),Gl=function(t){function e(e){return void 0===e&&(e={}),t.call(this,Ma({event:"swipe",threshold:10,velocity:.3,direction:30,pointers:1},e))||this}Aa(e,t);var i=e.prototype;return i.getTouchAction=function(){return zl.prototype.getTouchAction.call(this)},i.attrTest=function(e){var i,n=this.options.direction;return 30&n?i=e.overallVelocity:6&n?i=e.overallVelocityX:24&n&&(i=e.overallVelocityY),t.prototype.attrTest.call(this,e)&&n&e.offsetDirection&&e.distance>this.options.threshold&&e.maxPointers===this.options.pointers&&za(i)>this.options.velocity&&4&e.eventType},i.emit=function(t){var e=Fl(t.offsetDirection);e&&this.manager.emit(this.options.event+e,t),this.manager.emit(this.options.event,t)},e}(jl),Hl=function(t){function e(e){return void 0===e&&(e={}),t.call(this,Ma({event:"pinch",threshold:0,pointers:2},e))||this}Aa(e,t);var i=e.prototype;return i.getTouchAction=function(){return["none"]},i.attrTest=function(e){return t.prototype.attrTest.call(this,e)&&(Math.abs(e.scale-1)>this.options.threshold||2&this.state)},i.emit=function(e){if(1!==e.scale){var i=e.scale<1?"in":"out";e.additionalEvent=this.options.event+i}t.prototype.emit.call(this,e)},e}(jl),Bl=function(t){function e(e){return void 0===e&&(e={}),t.call(this,Ma({event:"rotate",threshold:0,pointers:2},e))||this}Aa(e,t);var i=e.prototype;return i.getTouchAction=function(){return["none"]},i.attrTest=function(e){return t.prototype.attrTest.call(this,e)&&(Math.abs(e.rotation)>this.options.threshold||2&this.state)},e}(jl),Yl=function(t){function e(e){var i;return void 0===e&&(e={}),(i=t.call(this,Ma({event:"press",pointers:1,time:251,threshold:9},e))||this)._timer=null,i._input=null,i}Aa(e,t);var i=e.prototype;return i.getTouchAction=function(){return["auto"]},i.process=function(t){var e=this,i=this.options,n=t.pointers.length===i.pointers,o=t.distance<i.threshold,r=t.deltaTime>i.time;if(this._input=t,!o||!n||12&t.eventType&&!r)this.reset();else if(1&t.eventType)this.reset(),this._timer=setTimeout((function(){e.state=8,e.tryEmit()}),i.time);else if(4&t.eventType)return 8;return 32},i.reset=function(){clearTimeout(this._timer)},i.emit=function(t){8===this.state&&(t&&4&t.eventType?this.manager.emit(this.options.event+"up",t):(this._input.timeStamp=Ga(),this.manager.emit(this.options.event,this._input)))},e}(Rl),Wl={domEvents:!1,touchAction:"compute",enable:!0,inputTarget:null,inputClass:null,cssProps:{userSelect:"none",touchSelect:"none",touchCallout:"none",contentZooming:"none",userDrag:"none",tapHighlightColor:"rgba(0,0,0,0)"}},Vl=[[Bl,{enable:!1}],[Hl,{enable:!1},["rotate"]],[Gl,{direction:6}],[zl,{direction:6},["swipe"]],[Ll],[Ll,{event:"doubletap",taps:2},["tap"]],[Yl]];function Ul(t,e){var i,n=t.element;n.style&&($a(t.options.cssProps,(function(o,r){i=Ha(n.style,r),e?(t.oldCssProps[i]=n.style[i],n.style[i]=o):n.style[i]=t.oldCssProps[i]||""})),e||(t.oldCssProps={}))}var Xl=function(){function t(t,e){var i,n=this;this.options=Ra({},Wl,e||{}),this.options.inputTarget=this.options.inputTarget||t,this.handlers={},this.session={},this.recognizers=[],this.oldCssProps={},this.element=t,this.input=new((i=this).options.inputClass||(Ua?bl:Xa?xl:Va?Il:Cl))(i,ll),this.touchAction=new Ja(this,this.options.touchAction),Ul(this,!0),$a(this.options.recognizers,(function(t){var e=n.add(new t[0](t[1]));t[2]&&e.recognizeWith(t[2]),t[3]&&e.requireFailure(t[3])}),this)}var e=t.prototype;return e.set=function(t){return Ra(this.options,t),t.touchAction&&this.touchAction.update(),t.inputTarget&&(this.input.destroy(),this.input.target=t.inputTarget,this.input.init()),this},e.stop=function(t){this.session.stopped=t?2:1},e.recognize=function(t){var e=this.session;if(!e.stopped){var i;this.touchAction.preventDefaults(t);var n=this.recognizers,o=e.curRecognizer;(!o||o&&8&o.state)&&(e.curRecognizer=null,o=null);for(var r=0;r<n.length;)i=n[r],2===e.stopped||o&&i!==o&&!i.canRecognizeWith(o)?i.reset():i.recognize(t),!o&&14&i.state&&(e.curRecognizer=i,o=i),r++}},e.get=function(t){if(t instanceof Rl)return t;for(var e=this.recognizers,i=0;i<e.length;i++)if(e[i].options.event===t)return e[i];return null},e.add=function(t){if(Ml(t,"add",this))return this;var e=this.get(t.options.event);return e&&this.remove(e),this.recognizers.push(t),t.manager=this,this.touchAction.update(),t},e.remove=function(t){if(Ml(t,"remove",this))return this;var e=this.get(t);if(t){var i=this.recognizers,n=ml(i,e);-1!==n&&(i.splice(n,1),this.touchAction.update())}return this},e.on=function(t,e){if(void 0===t||void 0===e)return this;var i=this.handlers;return $a(hl(t),(function(t){i[t]=i[t]||[],i[t].push(e)})),this},e.off=function(t,e){if(void 0===t)return this;var i=this.handlers;return $a(hl(t),(function(t){e?i[t]&&i[t].splice(ml(i[t],e),1):delete i[t]})),this},e.emit=function(t,e){this.options.domEvents&&function(t,e){var i=document.createEvent("Event");i.initEvent(t,!0,!0),i.gesture=e,e.target.dispatchEvent(i)}(t,e);var i=this.handlers[t]&&this.handlers[t].slice();if(i&&i.length){e.type=t,e.preventDefault=function(){e.srcEvent.preventDefault()};for(var n=0;n<i.length;)i[n](e),n++}},e.destroy=function(){this.element&&Ul(this,!1),this.handlers={},this.session={},this.input.destroy(),this.element=null},t}(),ql={touchstart:1,touchmove:2,touchend:4,touchcancel:8},Kl=function(t){function e(){var i,n=e.prototype;return n.evTarget="touchstart",n.evWin="touchstart touchmove touchend touchcancel",(i=t.apply(this,arguments)||this).started=!1,i}return Aa(e,t),e.prototype.handler=function(t){var e=ql[t.type];if(1===e&&(this.started=!0),this.started){var i=$l.call(this,t,e);12&e&&i[0].length-i[1].length==0&&(this.started=!1),this.callback(this.manager,e,{pointers:i[0],changedPointers:i[1],pointerType:"touch",srcEvent:t})}},e}(pl);function $l(t,e){var i=wl(t.touches),n=wl(t.changedTouches);return 12&e&&(i=_l(i.concat(n),"identifier",!0)),[i,n]}function Zl(t,e,i){var n="DEPRECATED METHOD: "+e+"\n"+i+" AT \n";return function(){var e=new Error("get-stack-trace"),i=e&&e.stack?e.stack.replace(/^[^\(]+?[\n$]/gm,"").replace(/^\s+at\s+/gm,"").replace(/^Object.<anonymous>\s*\(/gm,"{anonymous}()@"):"Unknown Stack Trace",o=window.console&&(window.console.warn||window.console.log);return o&&o.call(window.console,n,i),t.apply(this,arguments)}}var Ql=Zl((function(t,e,i){for(var n=Object.keys(e),o=0;o<n.length;)(!i||i&&void 0===t[n[o]])&&(t[n[o]]=e[n[o]]),o++;return t}),"extend","Use `assign`."),Jl=Zl((function(t,e){return Ql(t,e,!0)}),"merge","Use `assign`.");function th(t,e,i){var n,o=e.prototype;(n=t.prototype=Object.create(o)).constructor=t,n._super=o,i&&Ra(n,i)}function eh(t,e){return function(){return t.apply(e,arguments)}}var ih,nh=function(){var t=function(t,e){return void 0===e&&(e={}),new Xl(t,Ma({recognizers:Vl.concat()},e))};return t.VERSION="2.0.17-rc",t.DIRECTION_ALL=30,t.DIRECTION_DOWN=16,t.DIRECTION_LEFT=2,t.DIRECTION_RIGHT=4,t.DIRECTION_UP=8,t.DIRECTION_HORIZONTAL=6,t.DIRECTION_VERTICAL=24,t.DIRECTION_NONE=1,t.DIRECTION_DOWN=16,t.INPUT_START=1,t.INPUT_MOVE=2,t.INPUT_END=4,t.INPUT_CANCEL=8,t.STATE_POSSIBLE=1,t.STATE_BEGAN=2,t.STATE_CHANGED=4,t.STATE_ENDED=8,t.STATE_RECOGNIZED=8,t.STATE_CANCELLED=16,t.STATE_FAILED=32,t.Manager=Xl,t.Input=pl,t.TouchAction=Ja,t.TouchInput=xl,t.MouseInput=Cl,t.PointerEventInput=bl,t.TouchMouseInput=Il,t.SingleTouchInput=Kl,t.Recognizer=Rl,t.AttrRecognizer=jl,t.Tap=Ll,t.Pan=zl,t.Swipe=Gl,t.Pinch=Hl,t.Rotate=Bl,t.Press=Yl,t.on=ul,t.off=dl,t.each=$a,t.merge=Jl,t.extend=Ql,t.bindFn=eh,t.assign=Ra,t.inherit=th,t.bindFn=eh,t.prefixed=Ha,t.toArray=wl,t.inArray=ml,t.uniqueArray=_l,t.splitStr=hl,t.boolOrFn=Za,t.hasParent=tl,t.addEventListeners=ul,t.removeEventListeners=dl,t.defaults=Ra({},Wl,{preset:Vl}),t}();"undefined"!=typeof window?ih=Ia(window.Hammer||nh,{preventDefault:"mouse"}):ih=function(){return{on:t=function(){},off:t,destroy:t,emit:t,get:function(e){return{set:t}}};var t};var oh=ih;function rh(t,e){e.inputHandler=function(t){t.isFirst&&e(t)},t.on("hammer.input",e.inputHandler)}var sh=function(){function t(e,i,n,o,r){Ci(this,t),this.moment=r&&r.moment||Wn,this.options=r||{},this.current=this.moment(),this._start=this.moment(),this._end=this.moment(),this.autoScale=!0,this.scale="day",this.step=1,this.setRange(e,i,n),this.switchedDay=!1,this.switchedMonth=!1,this.switchedYear=!1,Di(o)?this.hiddenDates=o:this.hiddenDates=null!=o?[o]:[],this.format=t.FORMAT}return Ii(t,[{key:"setMoment",value:function(t){this.moment=t,this.current=this.moment(this.current.valueOf()),this._start=this.moment(this._start.valueOf()),this._end=this.moment(this._end.valueOf())}},{key:"setFormat",value:function(e){var i=Os.deepExtend({},t.FORMAT);this.format=Os.deepExtend(i,e)}},{key:"setRange",value:function(t,e,i){if(!(t instanceof Date&&e instanceof Date))throw"No legal start or end date in method setRange";this._start=null!=t?this.moment(t.valueOf()):Ir(),this._end=null!=e?this.moment(e.valueOf()):Ir(),this.autoScale&&this.setMinimumStep(i)}},{key:"start",value:function(){this.current=this._start.clone(),this.roundToMinor()}},{key:"roundToMinor",value:function(){switch("week"==this.scale&&this.current.weekday(0),this.scale){case"year":this.current.year(this.step*Math.floor(this.current.year()/this.step)),this.current.month(0);case"month":this.current.date(1);case"week":case"day":case"weekday":this.current.hours(0);case"hour":this.current.minutes(0);case"minute":this.current.seconds(0);case"second":this.current.milliseconds(0)}if(1!=this.step){var t=this.current.clone();switch(this.scale){case"millisecond":this.current.subtract(this.current.milliseconds()%this.step,"milliseconds");break;case"second":this.current.subtract(this.current.seconds()%this.step,"seconds");break;case"minute":this.current.subtract(this.current.minutes()%this.step,"minutes");break;case"hour":this.current.subtract(this.current.hours()%this.step,"hours");break;case"weekday":case"day":this.current.subtract((this.current.date()-1)%this.step,"day");break;case"week":this.current.subtract(this.current.week()%this.step,"week");break;case"month":this.current.subtract(this.current.month()%this.step,"month");break;case"year":this.current.subtract(this.current.year()%this.step,"year")}t.isSame(this.current)||(this.current=this.moment(ha(this.hiddenDates,this.current.valueOf(),-1,!0)))}}},{key:"hasNext",value:function(){return this.current.valueOf()<=this._end.valueOf()}},{key:"next",value:function(){var t=this.current.valueOf();switch(this.scale){case"millisecond":this.current.add(this.step,"millisecond");break;case"second":this.current.add(this.step,"second");break;case"minute":this.current.add(this.step,"minute");break;case"hour":this.current.add(this.step,"hour"),this.current.month()<6?this.current.subtract(this.current.hours()%this.step,"hour"):this.current.hours()%this.step!=0&&this.current.add(this.step-this.current.hours()%this.step,"hour");break;case"weekday":case"day":this.current.add(this.step,"day");break;case"week":if(0!==this.current.weekday())this.current.weekday(0),this.current.add(this.step,"week");else if(!1===this.options.showMajorLabels)this.current.add(this.step,"week");else{var e=this.current.clone();e.add(1,"week"),e.isSame(this.current,"month")?this.current.add(this.step,"week"):(this.current.add(this.step,"week"),this.current.date(1))}break;case"month":this.current.add(this.step,"month");break;case"year":this.current.add(this.step,"year")}if(1!=this.step)switch(this.scale){case"millisecond":this.current.milliseconds()>0&&this.current.milliseconds()<this.step&&this.current.milliseconds(0);break;case"second":this.current.seconds()>0&&this.current.seconds()<this.step&&this.current.seconds(0);break;case"minute":this.current.minutes()>0&&this.current.minutes()<this.step&&this.current.minutes(0);break;case"hour":this.current.hours()>0&&this.current.hours()<this.step&&this.current.hours(0);break;case"weekday":case"day":this.current.date()<this.step+1&&this.current.date(1);break;case"week":this.current.week()<this.step&&this.current.week(1);break;case"month":this.current.month()<this.step&&this.current.month(0)}this.current.valueOf()==t&&(this.current=this._end.clone()),this.switchedDay=!1,this.switchedMonth=!1,this.switchedYear=!1,ea(this.moment,this,t)}},{key:"getCurrent",value:function(){return this.current.clone()}},{key:"setScale",value:function(t){t&&"string"==typeof t.scale&&(this.scale=t.scale,this.step=t.step>0?t.step:1,this.autoScale=!1)}},{key:"setAutoScale",value:function(t){this.autoScale=t}},{key:"setMinimumStep",value:function(t){if(null!=t){31104e9>t&&(this.scale="year",this.step=1e3),15552e9>t&&(this.scale="year",this.step=500),31104e8>t&&(this.scale="year",this.step=100),15552e8>t&&(this.scale="year",this.step=50),31104e7>t&&(this.scale="year",this.step=10),15552e7>t&&(this.scale="year",this.step=5),31104e6>t&&(this.scale="year",this.step=1),7776e6>t&&(this.scale="month",this.step=3),2592e6>t&&(this.scale="month",this.step=1),6048e5>t&&this.options.showWeekScale&&(this.scale="week",this.step=1),1728e5>t&&(this.scale="day",this.step=2),864e5>t&&(this.scale="day",this.step=1),432e5>t&&(this.scale="weekday",this.step=1),144e5>t&&(this.scale="hour",this.step=4),36e5>t&&(this.scale="hour",this.step=1),9e5>t&&(this.scale="minute",this.step=15),6e5>t&&(this.scale="minute",this.step=10),3e5>t&&(this.scale="minute",this.step=5),6e4>t&&(this.scale="minute",this.step=1),15e3>t&&(this.scale="second",this.step=15),1e4>t&&(this.scale="second",this.step=10),5e3>t&&(this.scale="second",this.step=5),1e3>t&&(this.scale="second",this.step=1),200>t&&(this.scale="millisecond",this.step=200),100>t&&(this.scale="millisecond",this.step=100),50>t&&(this.scale="millisecond",this.step=50),10>t&&(this.scale="millisecond",this.step=10),5>t&&(this.scale="millisecond",this.step=5),1>t&&(this.scale="millisecond",this.step=1)}}},{key:"isMajor",value:function(){if(1==this.switchedYear)switch(this.scale){case"year":case"month":case"week":case"weekday":case"day":case"hour":case"minute":case"second":case"millisecond":return!0;default:return!1}else if(1==this.switchedMonth)switch(this.scale){case"week":case"weekday":case"day":case"hour":case"minute":case"second":case"millisecond":return!0;default:return!1}else if(1==this.switchedDay)switch(this.scale){case"millisecond":case"second":case"minute":case"hour":return!0;default:return!1}var t=this.moment(this.current);switch(this.scale){case"millisecond":return 0==t.milliseconds();case"second":return 0==t.seconds();case"minute":return 0==t.hours()&&0==t.minutes();case"hour":return 0==t.hours();case"weekday":case"day":case"week":return 1==t.date();case"month":return 0==t.month();case"year":default:return!1}}},{key:"getLabelMinor",value:function(t){if(null==t&&(t=this.current),t instanceof Date&&(t=this.moment(t)),"function"==typeof this.format.minorLabels)return this.format.minorLabels(t,this.scale,this.step);var e=this.format.minorLabels[this.scale];switch(this.scale){case"week":if(1===t.date()&&0!==t.weekday())return"";default:return e&&e.length>0?this.moment(t).format(e):""}}},{key:"getLabelMajor",value:function(t){if(null==t&&(t=this.current),t instanceof Date&&(t=this.moment(t)),"function"==typeof this.format.majorLabels)return this.format.majorLabels(t,this.scale,this.step);var e=this.format.majorLabels[this.scale];return e&&e.length>0?this.moment(t).format(e):""}},{key:"getClassName",value:function(){var t,e=this.moment,i=this.moment(this.current),n=i.locale?i.locale("en"):i.lang("en"),o=this.step,r=[];function s(t){return t/o%2==0?" vis-even":" vis-odd"}function a(t){return t.isSame(Ir(),"day")?" vis-today":t.isSame(e().add(1,"day"),"day")?" vis-tomorrow":t.isSame(e().add(-1,"day"),"day")?" vis-yesterday":""}function l(t){return t.isSame(Ir(),"week")?" vis-current-week":""}function h(t){return t.isSame(Ir(),"month")?" vis-current-month":""}switch(this.scale){case"millisecond":r.push(a(n)),r.push(s(n.milliseconds()));break;case"second":r.push(a(n)),r.push(s(n.seconds()));break;case"minute":r.push(a(n)),r.push(s(n.minutes()));break;case"hour":r.push(zr(t="vis-h".concat(n.hours())).call(t,4==this.step?"-h"+(n.hours()+4):"")),r.push(a(n)),r.push(s(n.hours()));break;case"weekday":r.push("vis-".concat(n.format("dddd").toLowerCase())),r.push(a(n)),r.push(l(n)),r.push(s(n.date()));break;case"day":r.push("vis-day".concat(n.date())),r.push("vis-".concat(n.format("MMMM").toLowerCase())),r.push(a(n)),r.push(h(n)),r.push(this.step<=2?a(n):""),r.push(this.step<=2?"vis-".concat(n.format("dddd").toLowerCase()):""),r.push(s(n.date()-1));break;case"week":r.push("vis-week".concat(n.format("w"))),r.push(l(n)),r.push(s(n.week()));break;case"month":r.push("vis-".concat(n.format("MMMM").toLowerCase())),r.push(h(n)),r.push(s(n.month()));break;case"year":r.push("vis-year".concat(n.year())),r.push(function(t){return t.isSame(Ir(),"year")?" vis-current-year":""}(n)),r.push(s(n.year()))}return gi(r).call(r,String).join(" ")}}],[{key:"snap",value:function(t,e,i){var n=Wn(t);if("year"==e){var o=n.year()+Math.round(n.month()/12);n.year(Math.round(o/i)*i),n.month(0),n.date(0),n.hours(0),n.minutes(0),n.seconds(0),n.milliseconds(0)}else if("month"==e)n.date()>15?(n.date(1),n.add(1,"month")):n.date(1),n.hours(0),n.minutes(0),n.seconds(0),n.milliseconds(0);else if("week"==e)n.weekday()>2?(n.weekday(0),n.add(1,"week")):n.weekday(0),n.hours(0),n.minutes(0),n.seconds(0),n.milliseconds(0);else if("day"==e){switch(i){case 5:case 2:n.hours(24*Math.round(n.hours()/24));break;default:n.hours(12*Math.round(n.hours()/12))}n.minutes(0),n.seconds(0),n.milliseconds(0)}else if("weekday"==e){switch(i){case 5:case 2:n.hours(12*Math.round(n.hours()/12));break;default:n.hours(6*Math.round(n.hours()/6))}n.minutes(0),n.seconds(0),n.milliseconds(0)}else if("hour"==e){switch(i){case 4:n.minutes(60*Math.round(n.minutes()/60));break;default:n.minutes(30*Math.round(n.minutes()/30))}n.seconds(0),n.milliseconds(0)}else if("minute"==e){switch(i){case 15:case 10:n.minutes(5*Math.round(n.minutes()/5)),n.seconds(0);break;case 5:n.seconds(60*Math.round(n.seconds()/60));break;default:n.seconds(30*Math.round(n.seconds()/30))}n.milliseconds(0)}else if("second"==e)switch(i){case 15:case 10:n.seconds(5*Math.round(n.seconds()/5)),n.milliseconds(0);break;case 5:n.milliseconds(1e3*Math.round(n.milliseconds()/1e3));break;default:n.milliseconds(500*Math.round(n.milliseconds()/500))}else if("millisecond"==e){var r=i>5?i/2:1;n.milliseconds(Math.round(n.milliseconds()/r)*r)}return n}}]),t}();function ah(t){var e=function(){if("undefined"==typeof Reflect||!Nt)return!1;if(Nt.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Nt(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=Yn(t);if(e){var o=Yn(this).constructor;i=Nt(n,arguments,o)}else i=n.apply(this,arguments);return zn(this,i)}}sh.FORMAT={minorLabels:{millisecond:"SSS",second:"s",minute:"HH:mm",hour:"HH:mm",weekday:"ddd D",day:"D",week:"w",month:"MMM",year:"YYYY"},majorLabels:{millisecond:"HH:mm:ss",second:"D MMMM HH:mm",minute:"ddd D MMMM",hour:"ddd D MMMM",weekday:"MMMM YYYY",day:"MMMM YYYY",week:"MMMM YYYY",month:"YYYY",year:""}};var lh=function(t){ji(i,Gs);var e=ah(i);function i(t,n){var o;return Ci(this,i),(o=e.call(this)).dom={foreground:null,lines:[],majorTexts:[],minorTexts:[],redundant:{lines:[],majorTexts:[],minorTexts:[]}},o.props={range:{start:0,end:0,minimumStep:0},lineTop:0},o.defaultOptions={orientation:{axis:"bottom"},showMinorLabels:!0,showMajorLabels:!0,showWeekScale:!1,maxMinorChars:7,format:sh.FORMAT,moment:Wn,timeAxis:null},o.options=Os.extend({},o.defaultOptions),o.body=t,o._create(),o.setOptions(n),o}return Ii(i,[{key:"setOptions",value:function(t){t&&(Os.selectiveExtend(["showMinorLabels","showMajorLabels","showWeekScale","maxMinorChars","hiddenDates","timeAxis","moment","rtl"],this.options,t),Os.selectiveDeepExtend(["format"],this.options,t),"orientation"in t&&("string"==typeof t.orientation?this.options.orientation.axis=t.orientation:"object"===Fn(t.orientation)&&"axis"in t.orientation&&(this.options.orientation.axis=t.orientation.axis)),"locale"in t&&("function"==typeof Wn.locale?Wn.locale(t.locale):Wn.lang(t.locale)))}},{key:"_create",value:function(){this.dom.foreground=document.createElement("div"),this.dom.background=document.createElement("div"),this.dom.foreground.className="vis-time-axis vis-foreground",this.dom.background.className="vis-time-axis vis-background"}},{key:"destroy",value:function(){this.dom.foreground.parentNode&&this.dom.foreground.parentNode.removeChild(this.dom.foreground),this.dom.background.parentNode&&this.dom.background.parentNode.removeChild(this.dom.background),this.body=null}},{key:"redraw",value:function(){var t=this.props,e=this.dom.foreground,i=this.dom.background,n="top"==this.options.orientation.axis?this.body.dom.top:this.body.dom.bottom,o=e.parentNode!==n;this._calculateCharSize();var r=this.options.showMinorLabels&&"none"!==this.options.orientation.axis,s=this.options.showMajorLabels&&"none"!==this.options.orientation.axis;t.minorLabelHeight=r?t.minorCharHeight:0,t.majorLabelHeight=s?t.majorCharHeight:0,t.height=t.minorLabelHeight+t.majorLabelHeight,t.width=e.offsetWidth,t.minorLineHeight=this.body.domProps.root.height-t.majorLabelHeight-("top"==this.options.orientation.axis?this.body.domProps.bottom.height:this.body.domProps.top.height),t.minorLineWidth=1,t.majorLineHeight=t.minorLineHeight+t.majorLabelHeight,t.majorLineWidth=1;var a=e.nextSibling,l=i.nextSibling;return e.parentNode&&e.parentNode.removeChild(e),i.parentNode&&i.parentNode.removeChild(i),e.style.height="".concat(this.props.height,"px"),this._repaintLabels(),a?n.insertBefore(e,a):n.appendChild(e),l?this.body.dom.backgroundVertical.insertBefore(i,l):this.body.dom.backgroundVertical.appendChild(i),this._isResized()||o}},{key:"_repaintLabels",value:function(){var t=this.options.orientation.axis,e=Os.convert(this.body.range.start,"Number"),i=Os.convert(this.body.range.end,"Number"),n=this.body.util.toTime((this.props.minorCharWidth||10)*this.options.maxMinorChars).valueOf(),o=n-aa(this.options.moment,this.body.hiddenDates,this.body.range,n);o-=this.body.util.toTime(0).valueOf();var r=new sh(new Date(e),new Date(i),o,this.body.hiddenDates,this.options);r.setMoment(this.options.moment),this.options.format&&r.setFormat(this.options.format),this.options.timeAxis&&r.setScale(this.options.timeAxis),this.step=r;var s,a,l,h,u,d,c=this.dom;c.redundant.lines=c.lines,c.redundant.majorTexts=c.majorTexts,c.redundant.minorTexts=c.minorTexts,c.lines=[],c.majorTexts=[],c.minorTexts=[];var p,m,f,g=0,v=void 0,y=0;for(r.start(),a=r.getCurrent(),h=this.body.util.toScreen(a);r.hasNext()&&y<1e3;){switch(y++,u=r.isMajor(),f=r.getClassName(),s=a,l=h,r.next(),a=r.getCurrent(),p=g,g=(h=this.body.util.toScreen(a))-l,r.scale){case"week":d=!0;break;default:d=g>=.4*p}if(this.options.showMinorLabels&&d){var b=this._repaintMinorText(l,r.getLabelMinor(s),t,f);b.style.width="".concat(g,"px")}u&&this.options.showMajorLabels?(l>0&&(null==v&&(v=l),b=this._repaintMajorText(l,r.getLabelMajor(s),t,f)),m=this._repaintMajorLine(l,g,t,f)):d?m=this._repaintMinorLine(l,g,t,f):m&&(m.style.width="".concat(Xo(m.style.width)+g,"px"))}if(1e3!==y||hh||(console.warn("Something is wrong with the Timeline scale. Limited drawing of grid lines to ".concat(1e3," lines.")),hh=!0),this.options.showMajorLabels){var w=this.body.util.toTime(0),_=r.getLabelMajor(w),k=_.length*(this.props.majorCharWidth||10)+10;(null==v||k<v)&&this._repaintMajorText(0,_,t,f)}ni(Os).call(Os,this.dom.redundant,(function(t){for(;t.length;){var e=t.pop();e&&e.parentNode&&e.parentNode.removeChild(e)}}))}},{key:"_repaintMinorText",value:function(t,e,i,n){var o=this.dom.redundant.minorTexts.shift();if(!o){var r=document.createTextNode("");(o=document.createElement("div")).appendChild(r),this.dom.foreground.appendChild(o)}this.dom.minorTexts.push(o),o.innerHTML=e;var s="top"==i?this.props.majorLabelHeight:0;return this._setXY(o,t,s),o.className="vis-text vis-minor ".concat(n),o}},{key:"_repaintMajorText",value:function(t,e,i,n){var o=this.dom.redundant.majorTexts.shift();if(!o){var r=document.createElement("div");(o=document.createElement("div")).appendChild(r),this.dom.foreground.appendChild(o)}o.childNodes[0].innerHTML=e,o.className="vis-text vis-major ".concat(n);var s="top"==i?0:this.props.minorLabelHeight;return this._setXY(o,t,s),this.dom.majorTexts.push(o),o}},{key:"_setXY",value:function(t,e,i){var n,o=this.options.rtl?-1*e:e;t.style.transform=zr(n="translate(".concat(o,"px, ")).call(n,i,"px)")}},{key:"_repaintMinorLine",value:function(t,e,i,n){var o,r=this.dom.redundant.lines.shift();r||(r=document.createElement("div"),this.dom.background.appendChild(r)),this.dom.lines.push(r);var s=this.props;r.style.width="".concat(e,"px"),r.style.height="".concat(s.minorLineHeight,"px");var a="top"==i?s.majorLabelHeight:this.body.domProps.top.height,l=t-s.minorLineWidth/2;return this._setXY(r,l,a),r.className=zr(o="vis-grid ".concat(this.options.rtl?"vis-vertical-rtl":"vis-vertical"," vis-minor ")).call(o,n),r}},{key:"_repaintMajorLine",value:function(t,e,i,n){var o,r=this.dom.redundant.lines.shift();r||(r=document.createElement("div"),this.dom.background.appendChild(r)),this.dom.lines.push(r);var s=this.props;r.style.width="".concat(e,"px"),r.style.height="".concat(s.majorLineHeight,"px");var a="top"==i?0:this.body.domProps.top.height,l=t-s.majorLineWidth/2;return this._setXY(r,l,a),r.className=zr(o="vis-grid ".concat(this.options.rtl?"vis-vertical-rtl":"vis-vertical"," vis-major ")).call(o,n),r}},{key:"_calculateCharSize",value:function(){this.dom.measureCharMinor||(this.dom.measureCharMinor=document.createElement("DIV"),this.dom.measureCharMinor.className="vis-text vis-minor vis-measure",this.dom.measureCharMinor.style.position="absolute",this.dom.measureCharMinor.appendChild(document.createTextNode("0")),this.dom.foreground.appendChild(this.dom.measureCharMinor)),this.props.minorCharHeight=this.dom.measureCharMinor.clientHeight,this.props.minorCharWidth=this.dom.measureCharMinor.clientWidth,this.dom.measureCharMajor||(this.dom.measureCharMajor=document.createElement("DIV"),this.dom.measureCharMajor.className="vis-text vis-major vis-measure",this.dom.measureCharMajor.style.position="absolute",this.dom.measureCharMajor.appendChild(document.createTextNode("0")),this.dom.foreground.appendChild(this.dom.measureCharMajor)),this.props.majorCharHeight=this.dom.measureCharMajor.clientHeight,this.props.majorCharWidth=this.dom.measureCharMajor.clientWidth}}]),i}(),hh=!1,uh=r((function(t,e){t.exports=function(t){var e,i=t&&t.preventDefault||!1,n=t&&t.container||window,o={},r={keydown:{},keyup:{}},s={};for(e=97;e<=122;e++)s[String.fromCharCode(e)]={code:e-97+65,shift:!1};for(e=65;e<=90;e++)s[String.fromCharCode(e)]={code:e,shift:!0};for(e=0;e<=9;e++)s[""+e]={code:48+e,shift:!1};for(e=1;e<=12;e++)s["F"+e]={code:111+e,shift:!1};for(e=0;e<=9;e++)s["num"+e]={code:96+e,shift:!1};s["num*"]={code:106,shift:!1},s["num+"]={code:107,shift:!1},s["num-"]={code:109,shift:!1},s["num/"]={code:111,shift:!1},s["num."]={code:110,shift:!1},s.left={code:37,shift:!1},s.up={code:38,shift:!1},s.right={code:39,shift:!1},s.down={code:40,shift:!1},s.space={code:32,shift:!1},s.enter={code:13,shift:!1},s.shift={code:16,shift:void 0},s.esc={code:27,shift:!1},s.backspace={code:8,shift:!1},s.tab={code:9,shift:!1},s.ctrl={code:17,shift:!1},s.alt={code:18,shift:!1},s.delete={code:46,shift:!1},s.pageup={code:33,shift:!1},s.pagedown={code:34,shift:!1},s["="]={code:187,shift:!1},s["-"]={code:189,shift:!1},s["]"]={code:221,shift:!1},s["["]={code:219,shift:!1};var a=function(t){h(t,"keydown")},l=function(t){h(t,"keyup")},h=function(t,e){if(void 0!==r[e][t.keyCode]){for(var n=r[e][t.keyCode],o=0;o<n.length;o++)(void 0===n[o].shift||1==n[o].shift&&1==t.shiftKey||0==n[o].shift&&0==t.shiftKey)&&n[o].fn(t);1==i&&t.preventDefault()}};return o.bind=function(t,e,i){if(void 0===i&&(i="keydown"),void 0===s[t])throw new Error("unsupported key: "+t);void 0===r[i][s[t].code]&&(r[i][s[t].code]=[]),r[i][s[t].code].push({fn:e,shift:s[t].shift})},o.bindAll=function(t,e){for(var i in void 0===e&&(e="keydown"),s)s.hasOwnProperty(i)&&o.bind(i,t,e)},o.getKey=function(t){for(var e in s)if(s.hasOwnProperty(e)){if(1==t.shiftKey&&1==s[e].shift&&t.keyCode==s[e].code)return e;if(0==t.shiftKey&&0==s[e].shift&&t.keyCode==s[e].code)return e;if(t.keyCode==s[e].code&&"shift"==e)return e}return"unknown key, currently not supported"},o.unbind=function(t,e,i){if(void 0===i&&(i="keydown"),void 0===s[t])throw new Error("unsupported key: "+t);if(void 0!==e){var n=[],o=r[i][s[t].code];if(void 0!==o)for(var a=0;a<o.length;a++)o[a].fn==e&&o[a].shift==s[t].shift||n.push(r[i][s[t].code][a]);r[i][s[t].code]=n}else r[i][s[t].code]=[]},o.reset=function(){r={keydown:{},keyup:{}}},o.destroy=function(){r={keydown:{},keyup:{}},n.removeEventListener("keydown",a,!0),n.removeEventListener("keyup",l,!0)},n.addEventListener("keydown",a,!0),n.addEventListener("keyup",l,!0),o}}));function dh(t){var e,i;this.active=!1,this.dom={container:t},this.dom.overlay=document.createElement("div"),this.dom.overlay.className="vis-overlay",this.dom.container.appendChild(this.dom.overlay),this.hammer=oh(this.dom.overlay),this.hammer.on("tap",xi(e=this._onTapOverlay).call(e,this));var n=this,o=["tap","doubletap","press","pinch","pan","panstart","panmove","panend"];ni(o).call(o,(function(t){n.hammer.on(t,(function(t){t.stopPropagation()}))})),document&&document.body&&(this.onClick=function(e){(function(t,e){for(;t;){if(t===e)return!0;t=t.parentNode}return!1})(e.target,t)||n.deactivate()},document.body.addEventListener("click",this.onClick)),void 0!==this.keycharm&&this.keycharm.destroy(),this.keycharm=uh(),this.escListener=xi(i=this.deactivate).call(i,this)}Ea(dh.prototype),dh.current=null,dh.prototype.destroy=function(){this.deactivate(),this.dom.overlay.parentNode.removeChild(this.dom.overlay),this.onClick&&document.body.removeEventListener("click",this.onClick),void 0!==this.keycharm&&this.keycharm.destroy(),this.keycharm=null,this.hammer.destroy(),this.hammer=null},dh.prototype.activate=function(){var t;dh.current&&dh.current.deactivate(),dh.current=this,this.active=!0,this.dom.overlay.style.display="none",Os.addClassName(this.dom.container,"vis-active"),this.emit("change"),this.emit("activate"),xi(t=this.keycharm).call(t,"esc",this.escListener)},dh.prototype.deactivate=function(){dh.current===this&&(dh.current=null),this.active=!1,this.dom.overlay.style.display="",Os.removeClassName(this.dom.container,"vis-active"),this.keycharm.unbind("esc",this.escListener),this.emit("change"),this.emit("deactivate")},dh.prototype._onTapOverlay=function(t){this.activate(),t.stopPropagation()};var ch={current:"current",time:"time",deleteSelected:"Delete selected"},ph={current:"attuale",time:"tempo",deleteSelected:"Cancella la selezione"},mh={current:"huidige",time:"tijd",deleteSelected:"Selectie verwijderen"},fh={current:"Aktuelle",time:"Zeit",deleteSelected:"Lösche Auswahl"},gh={current:"actuel",time:"heure",deleteSelected:"Effacer la selection"},vh={current:"corriente",time:"hora",deleteSelected:"Eliminar selección"},yh={current:"поточний",time:"час",deleteSelected:"Видалити обране"},bh={current:"текущее",time:"время",deleteSelected:"Удалить выбранное"},wh={current:"aktualny",time:"czas",deleteSelected:"Usuń wybrane"},_h={current:"atual",time:"data",deleteSelected:"Apagar selecionado"},kh={current:"現在",time:"時刻",deleteSelected:"選択されたものを削除"},xh={en:ch,en_EN:ch,en_US:ch,it:ph,it_IT:ph,it_CH:ph,nl:mh,nl_NL:mh,nl_BE:mh,de:fh,de_DE:fh,fr:gh,fr_FR:gh,fr_CA:gh,fr_BE:gh,es:vh,es_ES:vh,uk:yh,uk_UA:yh,ru:bh,ru_RU:bh,pl:wh,pl_PL:wh,pt:_h,pt_BR:_h,pt_PT:_h,ja:kh,ja_JP:kh};function Sh(t){var e=function(){if("undefined"==typeof Reflect||!Nt)return!1;if(Nt.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Nt(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=Yn(t);if(e){var o=Yn(this).constructor;i=Nt(n,arguments,o)}else i=n.apply(this,arguments);return zn(this,i)}}var Dh=function(t){ji(i,Gs);var e=Sh(i);function i(t,n){var o,r;Ci(this,i),(r=e.call(this)).body=t,r.defaultOptions={moment:Wn,locales:xh,locale:"en",id:void 0,title:void 0},r.options=Os.extend({},r.defaultOptions),r.setOptions(n),r.options.locales=Os.extend({},xh,r.options.locales);var s=r.defaultOptions.locales[r.defaultOptions.locale];return ni(o=eo(r.options.locales)).call(o,(function(t){r.options.locales[t]=Os.extend({},s,r.options.locales[t])})),n&&null!=n.time?r.customTime=n.time:r.customTime=new Date,r.eventParams={},r._create(),r}return Ii(i,[{key:"setOptions",value:function(t){t&&Os.selectiveExtend(["moment","locale","locales","id","title","rtl","snap"],this.options,t)}},{key:"_create",value:function(){var t,e,i,n=document.createElement("div");n["custom-time"]=this,n.className="vis-custom-time ".concat(this.options.id||""),n.style.position="absolute",n.style.top="0px",n.style.height="100%",this.bar=n;var o=document.createElement("div");function r(t){this.body.range._onMouseWheel(t)}o.style.position="relative",o.style.top="0px",this.options.rtl?o.style.right="-10px":o.style.left="-10px",o.style.height="100%",o.style.width="20px",o.addEventListener?(o.addEventListener("mousewheel",xi(r).call(r,this),!1),o.addEventListener("DOMMouseScroll",xi(r).call(r,this),!1)):o.attachEvent("onmousewheel",xi(r).call(r,this)),n.appendChild(o),this.hammer=new oh(o),this.hammer.on("panstart",xi(t=this._onDragStart).call(t,this)),this.hammer.on("panmove",xi(e=this._onDrag).call(e,this)),this.hammer.on("panend",xi(i=this._onDragEnd).call(i,this)),this.hammer.get("pan").set({threshold:5,direction:oh.DIRECTION_ALL})}},{key:"destroy",value:function(){this.hide(),this.hammer.destroy(),this.hammer=null,this.body=null}},{key:"redraw",value:function(){var t=this.body.dom.backgroundVertical;this.bar.parentNode!=t&&(this.bar.parentNode&&this.bar.parentNode.removeChild(this.bar),t.appendChild(this.bar));var e=this.body.util.toScreen(this.customTime),i=this.options.locales[this.options.locale];i||(this.warned||(console.warn("WARNING: options.locales['".concat(this.options.locale,"'] not found. See https://visjs.github.io/vis-timeline/docs/timeline/#Localization")),this.warned=!0),i=this.options.locales.en);var n,o=this.options.title;void 0===o?o=(o=zr(n="".concat(i.time,": ")).call(n,this.options.moment(this.customTime).format("dddd, MMMM Do YYYY, H:mm:ss"))).charAt(0).toUpperCase()+o.substring(1):"function"==typeof o&&(o=o.call(this,this.customTime));return this.options.rtl?this.bar.style.right="".concat(e,"px"):this.bar.style.left="".concat(e,"px"),this.bar.title=o,!1}},{key:"hide",value:function(){this.bar.parentNode&&this.bar.parentNode.removeChild(this.bar)}},{key:"setCustomTime",value:function(t){this.customTime=Os.convert(t,"Date"),this.redraw()}},{key:"getCustomTime",value:function(){return new Date(this.customTime.valueOf())}},{key:"setCustomMarker",value:function(t,e){var i,n,o=document.createElement("div");(o.className="vis-custom-time-marker",o.innerHTML=t,o.style.position="absolute",e)&&(o.setAttribute("contenteditable","true"),o.addEventListener("pointerdown",(function(){o.focus()})),o.addEventListener("input",xi(i=this._onMarkerChange).call(i,this)),o.title=t,o.addEventListener("blur",xi(n=function(t){this.title!=t.target.innerHTML&&(this._onMarkerChanged(t),this.title=t.target.innerHTML)}).call(n,this)));this.bar.appendChild(o)}},{key:"setCustomTitle",value:function(t){this.options.title=t}},{key:"_onDragStart",value:function(t){this.eventParams.dragging=!0,this.eventParams.customTime=this.customTime,t.stopPropagation()}},{key:"_onDrag",value:function(t){if(this.eventParams.dragging){var e=this.options.rtl?-1*t.deltaX:t.deltaX,i=this.body.util.toScreen(this.eventParams.customTime)+e,n=this.body.util.toTime(i),o=this.body.util.getScale(),r=this.body.util.getStep(),s=this.options.snap,a=s?s(n,o,r):n;this.setCustomTime(a),this.body.emitter.emit("timechange",{id:this.options.id,time:new Date(this.customTime.valueOf()),event:t}),t.stopPropagation()}}},{key:"_onDragEnd",value:function(t){this.eventParams.dragging&&(this.body.emitter.emit("timechanged",{id:this.options.id,time:new Date(this.customTime.valueOf()),event:t}),t.stopPropagation())}},{key:"_onMarkerChange",value:function(t){this.body.emitter.emit("markerchange",{id:this.options.id,title:t.target.innerHTML,event:t}),t.stopPropagation()}},{key:"_onMarkerChanged",value:function(t){this.body.emitter.emit("markerchanged",{id:this.options.id,title:t.target.innerHTML,event:t}),t.stopPropagation()}}],[{key:"customTimeFromTarget",value:function(t){for(var e=t.target;e;){if(e.hasOwnProperty("custom-time"))return e["custom-time"];e=e.parentNode}return null}}]),i}(),Ch=function(){function t(){Ci(this,t)}return Ii(t,[{key:"_create",value:function(t){var e,i,n,o=this;this.dom={},this.dom.container=t,this.dom.container.style.position="relative",this.dom.root=document.createElement("div"),this.dom.background=document.createElement("div"),this.dom.backgroundVertical=document.createElement("div"),this.dom.backgroundHorizontal=document.createElement("div"),this.dom.centerContainer=document.createElement("div"),this.dom.leftContainer=document.createElement("div"),this.dom.rightContainer=document.createElement("div"),this.dom.center=document.createElement("div"),this.dom.left=document.createElement("div"),this.dom.right=document.createElement("div"),this.dom.top=document.createElement("div"),this.dom.bottom=document.createElement("div"),this.dom.shadowTop=document.createElement("div"),this.dom.shadowBottom=document.createElement("div"),this.dom.shadowTopLeft=document.createElement("div"),this.dom.shadowBottomLeft=document.createElement("div"),this.dom.shadowTopRight=document.createElement("div"),this.dom.shadowBottomRight=document.createElement("div"),this.dom.rollingModeBtn=document.createElement("div"),this.dom.loadingScreen=document.createElement("div"),this.dom.root.className="vis-timeline",this.dom.background.className="vis-panel vis-background",this.dom.backgroundVertical.className="vis-panel vis-background vis-vertical",this.dom.backgroundHorizontal.className="vis-panel vis-background vis-horizontal",this.dom.centerContainer.className="vis-panel vis-center",this.dom.leftContainer.className="vis-panel vis-left",this.dom.rightContainer.className="vis-panel vis-right",this.dom.top.className="vis-panel vis-top",this.dom.bottom.className="vis-panel vis-bottom",this.dom.left.className="vis-content",this.dom.center.className="vis-content",this.dom.right.className="vis-content",this.dom.shadowTop.className="vis-shadow vis-top",this.dom.shadowBottom.className="vis-shadow vis-bottom",this.dom.shadowTopLeft.className="vis-shadow vis-top",this.dom.shadowBottomLeft.className="vis-shadow vis-bottom",this.dom.shadowTopRight.className="vis-shadow vis-top",this.dom.shadowBottomRight.className="vis-shadow vis-bottom",this.dom.rollingModeBtn.className="vis-rolling-mode-btn",this.dom.loadingScreen.className="vis-loading-screen",this.dom.root.appendChild(this.dom.background),this.dom.root.appendChild(this.dom.backgroundVertical),this.dom.root.appendChild(this.dom.backgroundHorizontal),this.dom.root.appendChild(this.dom.centerContainer),this.dom.root.appendChild(this.dom.leftContainer),this.dom.root.appendChild(this.dom.rightContainer),this.dom.root.appendChild(this.dom.top),this.dom.root.appendChild(this.dom.bottom),this.dom.root.appendChild(this.dom.rollingModeBtn),this.dom.centerContainer.appendChild(this.dom.center),this.dom.leftContainer.appendChild(this.dom.left),this.dom.rightContainer.appendChild(this.dom.right),this.dom.centerContainer.appendChild(this.dom.shadowTop),this.dom.centerContainer.appendChild(this.dom.shadowBottom),this.dom.leftContainer.appendChild(this.dom.shadowTopLeft),this.dom.leftContainer.appendChild(this.dom.shadowBottomLeft),this.dom.rightContainer.appendChild(this.dom.shadowTopRight),this.dom.rightContainer.appendChild(this.dom.shadowBottomRight),this.props={root:{},background:{},centerContainer:{},leftContainer:{},rightContainer:{},center:{},left:{},right:{},top:{},bottom:{},border:{},scrollTop:0,scrollTopMin:0},this.on("rangechange",(function(){!0===o.initialDrawDone&&o._redraw()})),this.on("rangechanged",(function(){o.initialRangeChangeDone||(o.initialRangeChangeDone=!0)})),this.on("touch",xi(e=this._onTouch).call(e,this)),this.on("panmove",xi(i=this._onDrag).call(i,this));var r=this;this._origRedraw=xi(n=this._redraw).call(n,this),this._redraw=Os.throttle(this._origRedraw),this.on("_change",(function(t){r.itemSet&&r.itemSet.initialItemSetDrawn&&t&&1==t.queue?r._redraw():r._origRedraw()})),this.hammer=new oh(this.dom.root);var s=this.hammer.get("pinch").set({enable:!0});s&&function(t){t.getTouchAction=function(){return["pan-y"]}}(s),this.hammer.get("pan").set({threshold:5,direction:oh.DIRECTION_ALL}),this.timelineListeners={};var a,l,h=["tap","doubletap","press","pinch","pan","panstart","panmove","panend"];function u(t){this.isActive()&&this.emit("mousewheel",t);var e=0,i=0;if("detail"in t&&(i=-1*t.detail),"wheelDelta"in t&&(i=t.wheelDelta),"wheelDeltaY"in t&&(i=t.wheelDeltaY),"wheelDeltaX"in t&&(e=-1*t.wheelDeltaX),"axis"in t&&t.axis===t.HORIZONTAL_AXIS&&(e=-1*i,i=0),"deltaY"in t&&(i=-1*t.deltaY),"deltaX"in t&&(e=t.deltaX),t.deltaMode&&(1===t.deltaMode?(e*=40,i*=40):(e*=40,i*=800)),this.options.preferZoom){if(!this.options.zoomKey||t[this.options.zoomKey])return}else if(this.options.zoomKey&&t[this.options.zoomKey])return;if(this.options.verticalScroll||this.options.horizontalScroll)if(this.options.verticalScroll&&Math.abs(i)>=Math.abs(e)){var n=this.props.scrollTop,o=n+i;if(this.isActive())this._setScrollTop(o)!==n&&(this._redraw(),this.emit("scroll",t),t.preventDefault())}else if(this.options.horizontalScroll){var r=(Math.abs(e)>=Math.abs(i)?e:i)/120*(this.range.end-this.range.start)/20,s=this.range.start+r,a=this.range.end+r,l={animation:!1,byUser:!0,event:t};this.range.setRange(s,a,l),t.preventDefault()}}ni(h).call(h,(function(t){var e=function(e){r.isActive()&&r.emit(t,e)};r.hammer.on(t,e),r.timelineListeners[t]=e})),rh(this.hammer,(function(t){r.emit("touch",t)})),a=this.hammer,(l=function(t){r.emit("release",t)}).inputHandler=function(t){t.isFinal&&l(t)},a.on("hammer.input",l.inputHandler);var d="onwheel"in document.createElement("div")?"wheel":void 0!==document.onmousewheel?"mousewheel":this.dom.centerContainer.addEventListener?"DOMMouseScroll":"onmousewheel";function c(t){if(r.options.verticalScroll)if(r._isProgramaticallyScrolled)r._isProgramaticallyScrolled=!1;else if(t.preventDefault(),r.isActive()){var e=-t.target.scrollTop;r._setScrollTop(e),r._redraw(),r.emit("scrollSide",t)}}this.dom.top.addEventListener,this.dom.bottom.addEventListener,this.dom.centerContainer.addEventListener(d,xi(u).call(u,this),!1),this.dom.top.addEventListener(d,xi(u).call(u,this),!1),this.dom.bottom.addEventListener(d,xi(u).call(u,this),!1),this.dom.left.parentNode.addEventListener("scroll",xi(c).call(c,this)),this.dom.right.parentNode.addEventListener("scroll",xi(c).call(c,this));var p=!1;function m(t){var e;if(t.preventDefault&&(r.emit("dragover",r.getEventProperties(t)),t.preventDefault()),sr(e=t.target.className).call(e,"timeline")>-1&&!p)return t.dataTransfer.dropEffect="move",p=!0,!1}function f(t){t.preventDefault&&t.preventDefault(),t.stopPropagation&&t.stopPropagation();try{var e=JSON.parse(t.dataTransfer.getData("text"));if(!e||!e.content)return}catch(t){return!1}return p=!1,t.center={x:t.clientX,y:t.clientY},"item"!==e.target?r.itemSet._onAddItem(t):r.itemSet._onDropObjectOnItem(t),r.emit("drop",r.getEventProperties(t)),!1}if(this.dom.center.addEventListener("dragover",xi(m).call(m,this),!1),this.dom.center.addEventListener("drop",xi(f).call(f,this),!1),this.customTimes=[],this.touch={},this.redrawCount=0,this.initialDrawDone=!1,this.initialRangeChangeDone=!1,!t)throw new Error("No container provided");t.appendChild(this.dom.root),t.appendChild(this.dom.loadingScreen)}},{key:"setOptions",value:function(t){var e;if(t){if(Os.selectiveExtend(["width","height","minHeight","maxHeight","autoResize","start","end","clickToUse","dataAttributes","hiddenDates","locale","locales","moment","preferZoom","rtl","zoomKey","horizontalScroll","verticalScroll","longSelectPressTime"],this.options,t),this.dom.rollingModeBtn.style.visibility="hidden",this.options.rtl&&(this.dom.container.style.direction="rtl",this.dom.backgroundVertical.className="vis-panel vis-background vis-vertical-rtl"),this.options.verticalScroll&&(this.options.rtl?this.dom.rightContainer.className="vis-panel vis-right vis-vertical-scroll":this.dom.leftContainer.className="vis-panel vis-left vis-vertical-scroll"),"object"!==Fn(this.options.orientation)&&(this.options.orientation={item:void 0,axis:void 0}),"orientation"in t&&("string"==typeof t.orientation?this.options.orientation={item:t.orientation,axis:t.orientation}:"object"===Fn(t.orientation)&&("item"in t.orientation&&(this.options.orientation.item=t.orientation.item),"axis"in t.orientation&&(this.options.orientation.axis=t.orientation.axis))),"both"===this.options.orientation.axis){if(!this.timeAxis2){var i=this.timeAxis2=new lh(this.body);i.setOptions=function(t){var e=t?Os.extend({},t):{};e.orientation="top",lh.prototype.setOptions.call(i,e)},this.components.push(i)}}else if(this.timeAxis2){var n,o,r=sr(n=this.components).call(n,this.timeAxis2);if(-1!==r)Oa(o=this.components).call(o,r,1);this.timeAxis2.destroy(),this.timeAxis2=null}"function"==typeof t.drawPoints&&(t.drawPoints={onRender:t.drawPoints}),"hiddenDates"in this.options&&Qs(this.options.moment,this.body,this.options.hiddenDates),"clickToUse"in t&&(t.clickToUse?this.activator||(this.activator=new dh(this.dom.root)):this.activator&&(this.activator.destroy(),delete this.activator)),this._initAutoResize()}if(ni(e=this.components).call(e,(function(e){return e.setOptions(t)})),"configure"in t){var s;this.configurator||(this.configurator=this._createConfigurator()),this.configurator.setOptions(t.configure);var a=Os.deepExtend({},this.options);ni(s=this.components).call(s,(function(t){Os.deepExtend(a,t.options)})),this.configurator.setModuleOptions({global:a})}this._redraw()}},{key:"isActive",value:function(){return!this.activator||this.activator.active}},{key:"destroy",value:function(){var t;for(var e in this.setItems(null),this.setGroups(null),this.off(),this._stopAutoResize(),this.dom.root.parentNode&&this.dom.root.parentNode.removeChild(this.dom.root),this.dom=null,this.activator&&(this.activator.destroy(),delete this.activator),this.timelineListeners)this.timelineListeners.hasOwnProperty(e)&&delete this.timelineListeners[e];this.timelineListeners=null,this.hammer&&this.hammer.destroy(),this.hammer=null,ni(t=this.components).call(t,(function(t){return t.destroy()})),this.body=null}},{key:"setCustomTime",value:function(t,e){var i,n=gi(i=this.customTimes).call(i,(function(t){return e===t.options.id}));if(0===n.length)throw new Error("No custom time bar found with id ".concat(zs(e)));n.length>0&&n[0].setCustomTime(t)}},{key:"getCustomTime",value:function(t){var e,i=gi(e=this.customTimes).call(e,(function(e){return e.options.id===t}));if(0===i.length)throw new Error("No custom time bar found with id ".concat(zs(t)));return i[0].getCustomTime()}},{key:"setCustomTimeMarker",value:function(t,e,i){var n,o=gi(n=this.customTimes).call(n,(function(t){return t.options.id===e}));if(0===o.length)throw new Error("No custom time bar found with id ".concat(zs(e)));o.length>0&&o[0].setCustomMarker(t,i)}},{key:"setCustomTimeTitle",value:function(t,e){var i,n=gi(i=this.customTimes).call(i,(function(t){return t.options.id===e}));if(0===n.length)throw new Error("No custom time bar found with id ".concat(zs(e)));if(n.length>0)return n[0].setCustomTitle(t)}},{key:"getEventProperties",value:function(t){return{event:t}}},{key:"addCustomTime",value:function(t,e){var i,n=void 0!==t?Os.convert(t,"Date"):new Date;if(_a(i=this.customTimes).call(i,(function(t){return t.options.id===e})))throw new Error("A custom time with id ".concat(zs(e)," already exists"));var o=new Dh(this.body,Os.extend({},this.options,{time:n,id:e,snap:this.itemSet.options.snap}));return this.customTimes.push(o),this.components.push(o),this._redraw(),e}},{key:"removeCustomTime",value:function(t){var e,i=this,n=gi(e=this.customTimes).call(e,(function(e){return e.options.id===t}));if(0===n.length)throw new Error("No custom time bar found with id ".concat(zs(t)));ni(n).call(n,(function(t){var e,n,o,r;Oa(e=i.customTimes).call(e,sr(n=i.customTimes).call(n,t),1),Oa(o=i.components).call(o,sr(r=i.components).call(r,t),1),t.destroy()}))}},{key:"getVisibleItems",value:function(){return this.itemSet&&this.itemSet.getVisibleItems()||[]}},{key:"getVisibleGroups",value:function(){return this.itemSet&&this.itemSet.getVisibleGroups()||[]}},{key:"fit",value:function(t,e){var i=this.getDataRange();if(null!==i.min||null!==i.max){var n=i.max-i.min,o=new Date(i.min.valueOf()-.01*n),r=new Date(i.max.valueOf()+.01*n),s=!t||void 0===t.animation||t.animation;this.range.setRange(o,r,{animation:s},e)}}},{key:"getDataRange",value:function(){throw new Error("Cannot invoke abstract method getDataRange")}},{key:"setWindow",value:function(t,e,i,n){var o,r;"function"==typeof arguments[2]&&(n=arguments[2],i={}),1==arguments.length?(o=void 0===(r=arguments[0]).animation||r.animation,this.range.setRange(r.start,r.end,{animation:o})):2==arguments.length&&"function"==typeof arguments[1]?(r=arguments[0],n=arguments[1],o=void 0===r.animation||r.animation,this.range.setRange(r.start,r.end,{animation:o},n)):(o=!i||void 0===i.animation||i.animation,this.range.setRange(t,e,{animation:o},n))}},{key:"moveTo",value:function(t,e,i){"function"==typeof arguments[1]&&(i=arguments[1],e={});var n=this.range.end-this.range.start,o=Os.convert(t,"Date").valueOf(),r=o-n/2,s=o+n/2,a=!e||void 0===e.animation||e.animation;this.range.setRange(r,s,{animation:a},i)}},{key:"getWindow",value:function(){var t=this.range.getRange();return{start:new Date(t.start),end:new Date(t.end)}}},{key:"zoomIn",value:function(t,e,i){if(!(!t||t<0||t>1)){"function"==typeof arguments[1]&&(i=arguments[1],e={});var n=this.getWindow(),o=n.start.valueOf(),r=n.end.valueOf(),s=r-o,a=s/(1+t),l=(s-a)/2,h=o+l,u=r-l;this.setWindow(h,u,e,i)}}},{key:"zoomOut",value:function(t,e,i){if(!(!t||t<0||t>1)){"function"==typeof arguments[1]&&(i=arguments[1],e={});var n=this.getWindow(),o=n.start.valueOf(),r=n.end.valueOf(),s=r-o,a=o-s*t/2,l=r+s*t/2;this.setWindow(a,l,e,i)}}},{key:"redraw",value:function(){this._redraw()}},{key:"_redraw",value:function(){var t;this.redrawCount++;var e=this.dom;if(e&&e.container&&0!=e.root.offsetWidth){var i=!1,n=this.options,o=this.props;Js(this.options.moment,this.body,this.options.hiddenDates),"top"==n.orientation?(Os.addClassName(e.root,"vis-top"),Os.removeClassName(e.root,"vis-bottom")):(Os.removeClassName(e.root,"vis-top"),Os.addClassName(e.root,"vis-bottom")),n.rtl?(Os.addClassName(e.root,"vis-rtl"),Os.removeClassName(e.root,"vis-ltr")):(Os.addClassName(e.root,"vis-ltr"),Os.removeClassName(e.root,"vis-rtl")),e.root.style.maxHeight=Os.option.asSize(n.maxHeight,""),e.root.style.minHeight=Os.option.asSize(n.minHeight,""),e.root.style.width=Os.option.asSize(n.width,"");var r=e.root.offsetWidth;o.border.left=1,o.border.right=1,o.border.top=1,o.border.bottom=1,o.center.height=e.center.offsetHeight,o.left.height=e.left.offsetHeight,o.right.height=e.right.offsetHeight,o.top.height=e.top.clientHeight||-o.border.top,o.bottom.height=e.bottom.clientHeight||-o.border.bottom;var s=Math.max(o.left.height,o.center.height,o.right.height),a=o.top.height+s+o.bottom.height+o.border.top+o.border.bottom;e.root.style.height=Os.option.asSize(n.height,"".concat(a,"px")),o.root.height=e.root.offsetHeight,o.background.height=o.root.height;var l=o.root.height-o.top.height-o.bottom.height;o.centerContainer.height=l,o.leftContainer.height=l,o.rightContainer.height=o.leftContainer.height,o.root.width=r,o.background.width=o.root.width,this.initialDrawDone||(o.scrollbarWidth=Os.getScrollBarWidth());var h=e.leftContainer.clientWidth,u=e.rightContainer.clientWidth;n.verticalScroll?n.rtl?(o.left.width=h||-o.border.left,o.right.width=u+o.scrollbarWidth||-o.border.right):(o.left.width=h+o.scrollbarWidth||-o.border.left,o.right.width=u||-o.border.right):(o.left.width=h||-o.border.left,o.right.width=u||-o.border.right),this._setDOM();var d=this._updateScrollTop();"top"!=n.orientation.item&&(d+=Math.max(o.centerContainer.height-o.center.height-o.border.top-o.border.bottom,0)),e.center.style.transform="translateY(".concat(d,"px)");var c=0==o.scrollTop?"hidden":"",p=o.scrollTop==o.scrollTopMin?"hidden":"";e.shadowTop.style.visibility=c,e.shadowBottom.style.visibility=p,e.shadowTopLeft.style.visibility=c,e.shadowBottomLeft.style.visibility=p,e.shadowTopRight.style.visibility=c,e.shadowBottomRight.style.visibility=p,n.verticalScroll&&(e.rightContainer.className="vis-panel vis-right vis-vertical-scroll",e.leftContainer.className="vis-panel vis-left vis-vertical-scroll",e.shadowTopRight.style.visibility="hidden",e.shadowBottomRight.style.visibility="hidden",e.shadowTopLeft.style.visibility="hidden",e.shadowBottomLeft.style.visibility="hidden",e.left.style.top="0px",e.right.style.top="0px"),(!n.verticalScroll||o.center.height<o.centerContainer.height)&&(e.left.style.top="".concat(d,"px"),e.right.style.top="".concat(d,"px"),e.rightContainer.className=e.rightContainer.className.replace(new RegExp("(?:^|\\s)vis-vertical-scroll(?:\\s|$)")," "),e.leftContainer.className=e.leftContainer.className.replace(new RegExp("(?:^|\\s)vis-vertical-scroll(?:\\s|$)")," "),o.left.width=h||-o.border.left,o.right.width=u||-o.border.right,this._setDOM());var m=o.center.height>o.centerContainer.height;this.hammer.get("pan").set({direction:m?oh.DIRECTION_ALL:oh.DIRECTION_HORIZONTAL}),this.hammer.get("press").set({time:this.options.longSelectPressTime}),ni(t=this.components).call(t,(function(t){i=t.redraw()||i}));if(i){if(this.redrawCount<5)return void this.body.emitter.emit("_change");console.log("WARNING: infinite loop in redraw?")}else this.redrawCount=0;this.body.emitter.emit("changed")}}},{key:"_setDOM",value:function(){var t=this.props,e=this.dom;t.leftContainer.width=t.left.width,t.rightContainer.width=t.right.width;var i=t.root.width-t.left.width-t.right.width;t.center.width=i,t.centerContainer.width=i,t.top.width=i,t.bottom.width=i,e.background.style.height="".concat(t.background.height,"px"),e.backgroundVertical.style.height="".concat(t.background.height,"px"),e.backgroundHorizontal.style.height="".concat(t.centerContainer.height,"px"),e.centerContainer.style.height="".concat(t.centerContainer.height,"px"),e.leftContainer.style.height="".concat(t.leftContainer.height,"px"),e.rightContainer.style.height="".concat(t.rightContainer.height,"px"),e.background.style.width="".concat(t.background.width,"px"),e.backgroundVertical.style.width="".concat(t.centerContainer.width,"px"),e.backgroundHorizontal.style.width="".concat(t.background.width,"px"),e.centerContainer.style.width="".concat(t.center.width,"px"),e.top.style.width="".concat(t.top.width,"px"),e.bottom.style.width="".concat(t.bottom.width,"px"),e.background.style.left="0",e.background.style.top="0",e.backgroundVertical.style.left="".concat(t.left.width+t.border.left,"px"),e.backgroundVertical.style.top="0",e.backgroundHorizontal.style.left="0",e.backgroundHorizontal.style.top="".concat(t.top.height,"px"),e.centerContainer.style.left="".concat(t.left.width,"px"),e.centerContainer.style.top="".concat(t.top.height,"px"),e.leftContainer.style.left="0",e.leftContainer.style.top="".concat(t.top.height,"px"),e.rightContainer.style.left="".concat(t.left.width+t.center.width,"px"),e.rightContainer.style.top="".concat(t.top.height,"px"),e.top.style.left="".concat(t.left.width,"px"),e.top.style.top="0",e.bottom.style.left="".concat(t.left.width,"px"),e.bottom.style.top="".concat(t.top.height+t.centerContainer.height,"px"),e.center.style.left="0",e.left.style.left="0",e.right.style.left="0"}},{key:"setCurrentTime",value:function(t){if(!this.currentTime)throw new Error("Option showCurrentTime must be true");this.currentTime.setCurrentTime(t)}},{key:"getCurrentTime",value:function(){if(!this.currentTime)throw new Error("Option showCurrentTime must be true");return this.currentTime.getCurrentTime()}},{key:"_toTime",value:function(t){return na(this,t,this.props.center.width)}},{key:"_toGlobalTime",value:function(t){return na(this,t,this.props.root.width)}},{key:"_toScreen",value:function(t){return ia(this,t,this.props.center.width)}},{key:"_toGlobalScreen",value:function(t){return ia(this,t,this.props.root.width)}},{key:"_initAutoResize",value:function(){1==this.options.autoResize?this._startAutoResize():this._stopAutoResize()}},{key:"_startAutoResize",value:function(){var t=this;this._stopAutoResize(),this._onResize=function(){if(1==t.options.autoResize){if(t.dom.root){var e=t.dom.root.offsetHeight,i=t.dom.root.offsetWidth;i==t.props.lastWidth&&e==t.props.lastHeight||(t.props.lastWidth=i,t.props.lastHeight=e,t.props.scrollbarWidth=Os.getScrollBarWidth(),t.body.emitter.emit("_change"))}}else t._stopAutoResize()},Os.addEventListener(window,"resize",this._onResize),t.dom.root&&(t.props.lastWidth=t.dom.root.offsetWidth,t.props.lastHeight=t.dom.root.offsetHeight),this.watchTimer=fa(this._onResize,1e3)}},{key:"_stopAutoResize",value:function(){this.watchTimer&&(clearInterval(this.watchTimer),this.watchTimer=void 0),this._onResize&&(Os.removeEventListener(window,"resize",this._onResize),this._onResize=null)}},{key:"_onTouch",value:function(t){this.touch.allowDragging=!0,this.touch.initialScrollTop=this.props.scrollTop}},{key:"_onPinch",value:function(t){this.touch.allowDragging=!1}},{key:"_onDrag",value:function(t){if(t&&this.touch.allowDragging){var e=t.deltaY,i=this._getScrollTop(),n=this._setScrollTop(this.touch.initialScrollTop+e);this.options.verticalScroll&&(this.dom.left.parentNode.scrollTop=-this.props.scrollTop,this.dom.right.parentNode.scrollTop=-this.props.scrollTop),n!=i&&this.emit("verticalDrag")}}},{key:"_setScrollTop",value:function(t){return this.props.scrollTop=t,this._updateScrollTop(),this.props.scrollTop}},{key:"_updateScrollTop",value:function(){var t=Math.min(this.props.centerContainer.height-this.props.center.height,0);return t!=this.props.scrollTopMin&&("top"!=this.options.orientation.item&&(this.props.scrollTop+=t-this.props.scrollTopMin),this.props.scrollTopMin=t),this.props.scrollTop>0&&(this.props.scrollTop=0),this.props.scrollTop<t&&(this.props.scrollTop=t),this.options.verticalScroll&&(this.dom.left.parentNode.scrollTop=-this.props.scrollTop,this.dom.right.parentNode.scrollTop=-this.props.scrollTop),this._isProgramaticallyScrolled=!0,this.props.scrollTop}},{key:"_getScrollTop",value:function(){return this.props.scrollTop}},{key:"_createConfigurator",value:function(){throw new Error("Cannot invoke abstract method _createConfigurator")}}]),t}();function Th(t){var e=function(){if("undefined"==typeof Reflect||!Nt)return!1;if(Nt.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Nt(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=Yn(t);if(e){var o=Yn(this).constructor;i=Nt(n,arguments,o)}else i=n.apply(this,arguments);return zn(this,i)}}Ea(Ch.prototype);var Oh=function(t){ji(i,Gs);var e=Th(i);function i(t,n){var o,r;Ci(this,i),(r=e.call(this)).body=t,r.defaultOptions={rtl:!1,showCurrentTime:!0,alignCurrentTime:void 0,moment:Wn,locales:xh,locale:"en"},r.options=Os.extend({},r.defaultOptions),r.setOptions(n),r.options.locales=Os.extend({},xh,r.options.locales);var s=r.defaultOptions.locales[r.defaultOptions.locale];return ni(o=eo(r.options.locales)).call(o,(function(t){r.options.locales[t]=Os.extend({},s,r.options.locales[t])})),r.offset=0,r._create(),r}return Ii(i,[{key:"_create",value:function(){var t=document.createElement("div");t.className="vis-current-time",t.style.position="absolute",t.style.top="0px",t.style.height="100%",this.bar=t}},{key:"destroy",value:function(){this.options.showCurrentTime=!1,this.redraw(),this.body=null}},{key:"setOptions",value:function(t){t&&Os.selectiveExtend(["rtl","showCurrentTime","alignCurrentTime","moment","locale","locales"],this.options,t)}},{key:"redraw",value:function(){if(this.options.showCurrentTime){var t,e,i=this.body.dom.backgroundVertical;this.bar.parentNode!=i&&(this.bar.parentNode&&this.bar.parentNode.removeChild(this.bar),i.appendChild(this.bar),this.start());var n=this.options.moment(Ir()+this.offset);this.options.alignCurrentTime&&(n=n.startOf(this.options.alignCurrentTime));var o=this.body.util.toScreen(n),r=this.options.locales[this.options.locale];r||(this.warned||(console.warn("WARNING: options.locales['".concat(this.options.locale,"'] not found. See https://visjs.github.io/vis-timeline/docs/timeline/#Localization")),this.warned=!0),r=this.options.locales.en);var s=zr(t=zr(e="".concat(r.current," ")).call(e,r.time,": ")).call(t,n.format("dddd, MMMM Do YYYY, H:mm:ss"));s=s.charAt(0).toUpperCase()+s.substring(1),this.options.rtl?this.bar.style.transform="translateX(".concat(-1*o,"px)"):this.bar.style.transform="translateX(".concat(o,"px)"),this.bar.title=s}else this.bar.parentNode&&this.bar.parentNode.removeChild(this.bar),this.stop();return!1}},{key:"start",value:function(){var t=this;!function e(){t.stop();var i=1/t.body.range.conversion(t.body.domProps.center.width).scale/10;i<30&&(i=30),i>1e3&&(i=1e3),t.redraw(),t.body.emitter.emit("currentTimeTick"),t.currentTimeTimer=wi(e,i)}()}},{key:"stop",value:function(){void 0!==this.currentTimeTimer&&(clearTimeout(this.currentTimeTimer),delete this.currentTimeTimer)}},{key:"setCurrentTime",value:function(t){var e=Os.convert(t,"Date").valueOf(),i=Ir();this.offset=e-i,this.redraw()}},{key:"getCurrentTime",value:function(){return new Date(Ir()+this.offset)}}]),i}(),Eh=!u((function(){return Object.isExtensible(Object.preventExtensions({}))})),Ih=r((function(t){var e=W.f,i=yt("meta"),n=0,o=Object.isExtensible||function(){return!0},r=function(t){e(t,i,{value:{objectID:"O"+ ++n,weakData:{}}})},s=t.exports={REQUIRED:!1,fastKey:function(t,e){if(!k(t))return"symbol"==typeof t?t:("string"==typeof t?"S":"P")+t;if(!D(t,i)){if(!o(t))return"F";if(!e)return"E";r(t)}return t[i].objectID},getWeakData:function(t,e){if(!D(t,i)){if(!o(t))return!0;if(!e)return!1;r(t)}return t[i].weakData},onFreeze:function(t){return Eh&&s.REQUIRED&&o(t)&&!D(t,i)&&r(t),t}};at[i]=!0})),Mh=(Ih.REQUIRED,Ih.fastKey,Ih.getWeakData,Ih.onFreeze,r((function(t){var e=function(t,e){this.stopped=t,this.result=e};(t.exports=function(t,i,n,o,r){var s,a,l,h,u,d,c,p=H(i,n,o?2:1);if(r)s=t;else{if("function"!=typeof(a=vo(t)))throw TypeError("Target is not iterable");if(xo(a)){for(l=0,h=et(t.length);h>l;l++)if((u=o?p(B(c=t[l])[0],c[1]):p(t[l]))&&u instanceof e)return u;return new e(!1)}s=a.call(t)}for(d=s.next;!(c=d.call(s)).done;)if("object"==typeof(u=wo(s,p,c.value,o))&&u&&u instanceof e)return u;return new e(!1)}).stop=function(t){return new e(!0,t)}}))),Ah=function(t,e,i){if(!(t instanceof e))throw TypeError("Incorrect "+(i?i+" ":"")+"invocation");return t},Ph=W.f,Nh=He.forEach,Rh=Qt.set,Lh=Qt.getterFor,jh=function(t,e,i){for(var n in e)i&&i.unsafe&&t[n]?t[n]=e[n]:Se(t,n,e[n],i);return t},Fh=he("species"),zh=W.f,Gh=Ih.fastKey,Hh=Qt.set,Bh=Qt.getterFor,Yh=(function(t,e,i){var n,o=-1!==t.indexOf("Map"),r=-1!==t.indexOf("Weak"),s=o?"set":"add",a=h[t],l=a&&a.prototype,c={};if(d&&"function"==typeof a&&(r||l.forEach&&!u((function(){(new a).entries().next()})))){n=e((function(e,i){Rh(Ah(e,n,t),{type:t,collection:new a}),null!=i&&Mh(i,e[s],e,o)}));var p=Lh(t);Nh(["add","clear","delete","forEach","get","has","set","keys","values","entries"],(function(t){var e="add"==t||"set"==t;t in l&&(!r||"clear"!=t)&&V(n.prototype,t,(function(i,n){var o=p(this).collection;if(!e&&r&&!k(i))return"get"==t&&void 0;var s=o[t](0===i?0:i,n);return e?this:s}))})),r||Ph(n.prototype,"size",{configurable:!0,get:function(){return p(this).collection.size}})}else n=i.getConstructor(e,t,o,s),Ih.REQUIRED=!0;we(n,t,!1,!0),c[t]=n,q({global:!0,forced:!0},c),r||i.setStrong(n,t,o)}("Set",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),{getConstructor:function(t,e,i,n){var o=t((function(t,r){Ah(t,o,e),Hh(t,{type:e,index:Dt(null),first:void 0,last:void 0,size:0}),d||(t.size=0),null!=r&&Mh(r,t[n],t,i)})),r=Bh(e),s=function(t,e,i){var n,o,s=r(t),l=a(t,e);return l?l.value=i:(s.last=l={index:o=Gh(e,!0),key:e,value:i,previous:n=s.last,next:void 0,removed:!1},s.first||(s.first=l),n&&(n.next=l),d?s.size++:t.size++,"F"!==o&&(s.index[o]=l)),t},a=function(t,e){var i,n=r(t),o=Gh(e);if("F"!==o)return n.index[o];for(i=n.first;i;i=i.next)if(i.key==e)return i};return jh(o.prototype,{clear:function(){for(var t=r(this),e=t.index,i=t.first;i;)i.removed=!0,i.previous&&(i.previous=i.previous.next=void 0),delete e[i.index],i=i.next;t.first=t.last=void 0,d?t.size=0:this.size=0},delete:function(t){var e=r(this),i=a(this,t);if(i){var n=i.next,o=i.previous;delete e.index[i.index],i.removed=!0,o&&(o.next=n),n&&(n.previous=o),e.first==i&&(e.first=n),e.last==i&&(e.last=o),d?e.size--:this.size--}return!!i},forEach:function(t){for(var e,i=r(this),n=H(t,arguments.length>1?arguments[1]:void 0,3);e=e?e.next:i.first;)for(n(e.value,e.key,this);e&&e.removed;)e=e.previous},has:function(t){return!!a(this,t)}}),jh(o.prototype,i?{get:function(t){var e=a(this,t);return e&&e.value},set:function(t,e){return s(this,0===t?0:t,e)}}:{add:function(t){return s(this,t=0===t?0:t,t)}}),d&&zh(o.prototype,"size",{get:function(){return r(this).size}}),o},setStrong:function(t,e,i){var n=e+" Iterator",o=Bh(e),r=Bh(n);Ee(t,e,(function(t,e){Hh(this,{type:n,target:t,state:o(t),kind:e,last:void 0})}),(function(){for(var t=r(this),e=t.kind,i=t.last;i&&i.removed;)i=i.previous;return t.target&&(t.last=i=i?i.next:t.state.first)?"keys"==e?{value:i.key,done:!1}:"values"==e?{value:i.value,done:!1}:{value:[i.key,i.value],done:!1}:(t.target=void 0,{value:void 0,done:!0})}),i?"entries":"values",!i,!0),function(t){var e=$(t),i=W.f;d&&e&&!e[Fh]&&i(e,Fh,{configurable:!0,get:function(){return this}})}(e)}}),z.Set),Wh=He.find,Vh=!0,Uh=Ue("find");"find"in[]&&Array(1).find((function(){Vh=!1})),q({target:"Array",proto:!0,forced:Vh||!Uh},{find:function(t){return Wh(this,t,arguments.length>1?arguments[1]:void 0)}});var Xh=Je("Array").find,qh=Array.prototype,Kh=function(t){var e=t.find;return t===qh||t instanceof Array&&e===qh.find?Xh:e},$h="undefined"!=typeof crypto&&crypto.getRandomValues&&crypto.getRandomValues.bind(crypto)||"undefined"!=typeof msCrypto&&"function"==typeof msCrypto.getRandomValues&&msCrypto.getRandomValues.bind(msCrypto),Zh=new Uint8Array(16);function Qh(){if(!$h)throw new Error("crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported");return $h(Zh)}for(var Jh=[],tu=0;tu<256;++tu)Jh[tu]=(tu+256).toString(16).substr(1);function eu(t,e,i){var n=e&&i||0;"string"==typeof t&&(e="binary"===t?new Array(16):null,t=null);var o=(t=t||{}).random||(t.rng||Qh)();if(o[6]=15&o[6]|64,o[8]=63&o[8]|128,e)for(var r=0;r<16;++r)e[n+r]=o[r];return e||function(t,e){var i=e||0,n=Jh;return[n[t[i++]],n[t[i++]],n[t[i++]],n[t[i++]],"-",n[t[i++]],n[t[i++]],"-",n[t[i++]],n[t[i++]],"-",n[t[i++]],n[t[i++]],"-",n[t[i++]],n[t[i++]],n[t[i++]],n[t[i++]],n[t[i++]],n[t[i++]]].join("")}(o)}var iu=st.includes,nu=Ue("indexOf",{ACCESSORS:!0,1:0});q({target:"Array",proto:!0,forced:!nu},{includes:function(t){return iu(this,t,arguments.length>1?arguments[1]:void 0)}});var ou=Je("Array").includes,ru=he("match"),su=function(t){if(function(t){var e;return k(t)&&(void 0!==(e=t[ru])?!!e:"RegExp"==v(t))}(t))throw TypeError("The method doesn't accept regular expressions");return t},au=he("match");q({target:"String",proto:!0,forced:!function(t){var e=/./;try{"/./"[t](e)}catch(i){try{return e[au]=!1,"/./"[t](e)}catch(t){}}return!1}("includes")},{includes:function(t){return!!~String(w(this)).indexOf(su(t),arguments.length>1?arguments[1]:void 0)}});var lu=Je("String").includes,hu=Array.prototype,uu=String.prototype,du=function(t){var e=t.includes;return t===hu||t instanceof Array&&e===hu.includes?ou:"string"==typeof t||t===uu||t instanceof String&&e===uu.includes?lu:e};function cu(t){qs(t).call(t,(function(t,e){return t.data.start-e.data.start}))}function pu(t){qs(t).call(t,(function(t,e){return("end"in t.data?t.data.end:t.data.start)-("end"in e.data?e.data.end:e.data.start)}))}function mu(t,e,i,n){if(i)for(var o=0;o<t.length;o++)t[o].top=null;for(o=0;o<t.length;o++){var r=t[o];if(r.stack&&null===r.top){r.top=e.axis;var s=!1;do{for(var a=null,l=0,h=t.length;l<h;l++){var u=t[l];if(s=n()||!1)return!0;if(null!==u.top&&u!==r&&u.stack&&bu(r,u,e.item,u.options.rtl)){a=u;break}}null!=a&&(r.top=a.top+a.height+e.item.vertical)}while(a)}}return s}function fu(t,e,i){for(var n=0;n<t.length;n++)t[n].top=null;var o=i.height;for(n=0;n<t.length;n++){var r=t[n];if(r.stack&&null===r.top){r.top=r.baseTop;do{for(var s=null,a=0,l=t.length;a<l;a++){var h=t[a];if(null!==h.top&&h!==r&&bu(r,h,e.item,h.options.rtl)){s=h;break}}null!=s&&(r.top=s.top+s.height+e.item.vertical),r.top+r.height>o&&(o=r.top+r.height)}while(s)}}i.height=o-i.top+.5*e.item.vertical}function gu(t,e,i,n){for(var o=0;o<t.length;o++)if(null==t[o].data.subgroup)t[o].top=e.item.vertical;else if(void 0!==t[o].data.subgroup&&n){var r=0;for(var s in i)i.hasOwnProperty(s)&&1==i[s].visible&&i[s].index<i[t[o].data.subgroup].index&&(r+=i[s].height,i[t[o].data.subgroup].top=r);t[o].top=r+.5*e.item.vertical}n||vu(t,e,i)}function vu(t,e,i){for(var n in i)if(i.hasOwnProperty(n)){i[n].top=0;do{var o=null;for(var r in i)if(null!==i[r].top&&r!==n&&i[n].index>i[r].index&&wu(i[n],i[r])){o=i[r];break}null!=o&&(i[n].top=o.top+o.height)}while(o)}for(var s=0;s<t.length;s++)void 0!==t[s].data.subgroup&&(t[s].top=i[t[s].data.subgroup].top+.5*e.item.vertical)}function yu(t,e,i){var n=!1,o=[];for(var r in i)i[r].hasOwnProperty("index")?o[i[r].index]=r:o.push(r);for(var s=0;s<o.length;s++)if(r=o[s],i.hasOwnProperty(r)){for(var a in n=n||i[r].stack,i[r].top=0,i)i[a].visible&&i[r].index>i[a].index&&(i[r].top+=i[a].height);for(var l=t[r],h=0;h<l.length;h++)void 0!==l[h].data.subgroup&&(l[h].top=i[l[h].data.subgroup].top+.5*e.item.vertical,i[r].stack&&(l[h].baseTop=l[h].top));n&&i[r].stack&&fu(t[r],e,i[r])}}function bu(t,e,i,n){return n?t.right-i.horizontal+.001<e.right+e.width&&t.right+t.width+i.horizontal-.001>e.right&&t.top-i.vertical+.001<e.top+e.height&&t.top+t.height+i.vertical-.001>e.top:t.left-i.horizontal+.001<e.left+e.width&&t.left+t.width+i.horizontal-.001>e.left&&t.top-i.vertical+.001<e.top+e.height&&t.top+t.height+i.vertical-.001>e.top}function wu(t,e){var i=t.start<e.end&&t.end>e.start,n=t.top<e.top+e.height&&t.top+t.height>e.top;return i&&n}var _u=Object.freeze({__proto__:null,orderByStart:cu,orderByEnd:pu,stack:mu,substack:fu,nostack:gu,stackSubgroups:vu,stackSubgroupsWithInnerStack:yu,collision:bu,collisionByTimes:wu}),ku="__background__",xu=function(){function t(e,i,n){var o=this;if(Ci(this,t),this.groupId=e,this.subgroups={},this.subgroupStack={},this.subgroupStackAll=!1,this.subgroupVisibility={},this.doInnerStack=!1,this.shouldBailStackItems=!1,this.subgroupIndex=0,this.subgroupOrderer=i&&i.subgroupOrder,this.itemSet=n,this.isVisible=null,this.stackDirty=!0,this._disposeCallbacks=[],i&&i.nestedGroups&&(this.nestedGroups=i.nestedGroups,0==i.showNested?this.showNested=!1:this.showNested=!0),i&&i.subgroupStack)if("boolean"==typeof i.subgroupStack)this.doInnerStack=i.subgroupStack,this.subgroupStackAll=i.subgroupStack;else for(var r in i.subgroupStack)this.subgroupStack[r]=i.subgroupStack[r],this.doInnerStack=this.doInnerStack||i.subgroupStack[r];i&&i.heightMode?this.heightMode=i.heightMode:this.heightMode=n.options.groupHeightMode,this.nestedInGroup=null,this.dom={},this.props={label:{width:0,height:0}},this.className=null,this.items={},this.visibleItems=[],this.itemsInRange=[],this.orderedItems={byStart:[],byEnd:[]},this.checkRangedItems=!1;var s=function(){o.checkRangedItems=!0};this.itemSet.body.emitter.on("checkRangedItems",s),this._disposeCallbacks.push((function(){o.itemSet.body.emitter.off("checkRangedItems",s)})),this._create(),this.setData(i)}return Ii(t,[{key:"_create",value:function(){var t=document.createElement("div");this.itemSet.options.groupEditable.order?t.className="vis-label draggable":t.className="vis-label",this.dom.label=t;var e=document.createElement("div");e.className="vis-inner",t.appendChild(e),this.dom.inner=e;var i=document.createElement("div");i.className="vis-group",i["vis-group"]=this,this.dom.foreground=i,this.dom.background=document.createElement("div"),this.dom.background.className="vis-group",this.dom.axis=document.createElement("div"),this.dom.axis.className="vis-group",this.dom.marker=document.createElement("div"),this.dom.marker.style.visibility="hidden",this.dom.marker.style.position="absolute",this.dom.marker.innerHTML="",this.dom.background.appendChild(this.dom.marker)}},{key:"setData",value:function(t){if(!this.itemSet.groupTouchParams.isDragging){var e,i,n;if(t&&t.subgroupVisibility)for(var o in t.subgroupVisibility)this.subgroupVisibility[o]=t.subgroupVisibility[o];if(this.itemSet.options&&this.itemSet.options.groupTemplate)e=(i=xi(n=this.itemSet.options.groupTemplate).call(n,this))(t,this.dom.inner);else e=t&&t.content;if(e instanceof Element){for(;this.dom.inner.firstChild;)this.dom.inner.removeChild(this.dom.inner.firstChild);this.dom.inner.appendChild(e)}else e instanceof Object&&e.isReactComponent||(e instanceof Object?i(t,this.dom.inner):this.dom.inner.innerHTML=null!=e?e:this.groupId||"");this.dom.label.title=t&&t.title||"",this.dom.inner.firstChild?Os.removeClassName(this.dom.inner,"vis-hidden"):Os.addClassName(this.dom.inner,"vis-hidden"),t&&t.nestedGroups?(this.nestedGroups&&this.nestedGroups==t.nestedGroups||(this.nestedGroups=t.nestedGroups),void 0===t.showNested&&void 0!==this.showNested||(0==t.showNested?this.showNested=!1:this.showNested=!0),Os.addClassName(this.dom.label,"vis-nesting-group"),this.showNested?(Os.removeClassName(this.dom.label,"collapsed"),Os.addClassName(this.dom.label,"expanded")):(Os.removeClassName(this.dom.label,"expanded"),Os.addClassName(this.dom.label,"collapsed"))):this.nestedGroups&&(this.nestedGroups=null,Os.removeClassName(this.dom.label,"collapsed"),Os.removeClassName(this.dom.label,"expanded"),Os.removeClassName(this.dom.label,"vis-nesting-group")),t&&(t.treeLevel||t.nestedInGroup)?(Os.addClassName(this.dom.label,"vis-nested-group"),t.treeLevel?Os.addClassName(this.dom.label,"vis-group-level-"+t.treeLevel):Os.addClassName(this.dom.label,"vis-group-level-unknown-but-gte1")):Os.addClassName(this.dom.label,"vis-group-level-0");var r=t&&t.className||null;r!=this.className&&(this.className&&(Os.removeClassName(this.dom.label,this.className),Os.removeClassName(this.dom.foreground,this.className),Os.removeClassName(this.dom.background,this.className),Os.removeClassName(this.dom.axis,this.className)),Os.addClassName(this.dom.label,r),Os.addClassName(this.dom.foreground,r),Os.addClassName(this.dom.background,r),Os.addClassName(this.dom.axis,r),this.className=r),this.style&&(Os.removeCssText(this.dom.label,this.style),this.style=null),t&&t.style&&(Os.addCssText(this.dom.label,t.style),this.style=t.style)}}},{key:"getLabelWidth",value:function(){return this.props.label.width}},{key:"_didMarkerHeightChange",value:function(){var t=this.dom.marker.clientHeight;if(t!=this.lastMarkerHeight){this.lastMarkerHeight=t;var e={},i=0;if(ni(Os).call(Os,this.items,(function(t,n){if(t.dirty=!0,t.displayed){e[n]=t.redraw(!0),i=e[n].length}})),i>0)for(var n=function(t){ni(Os).call(Os,e,(function(e){e[t]()}))},o=0;o<i;o++)n(o);return!0}return!1}},{key:"_calculateGroupSizeAndPosition",value:function(){var t=this.dom.foreground,e=t.offsetTop,i=t.offsetLeft,n=t.offsetWidth;this.top=e,this.right=i,this.width=n}},{key:"_shouldBailItemsRedraw",value:function(){var t=this,e=this.itemSet.options.onTimeout,i={relativeBailingTime:this.itemSet.itemsSettingTime,bailTimeMs:e&&e.timeoutMs,userBailFunction:e&&e.callback,shouldBailStackItems:this.shouldBailStackItems},n=null;if(!this.itemSet.initialDrawDone){if(i.shouldBailStackItems)return!0;Math.abs(Ir()-new Date(i.relativeBailingTime))>i.bailTimeMs&&(i.userBailFunction&&null==this.itemSet.userContinueNotBail?i.userBailFunction((function(e){t.itemSet.userContinueNotBail=e,n=!e})):n=0==t.itemSet.userContinueNotBail)}return n}},{key:"_redrawItems",value:function(t,e,i,n){var o=this;if(t||this.stackDirty||this.isVisible&&!e){var r,s,a,l,h,u,d={byEnd:gi(r=this.orderedItems.byEnd).call(r,(function(t){return!t.isCluster})),byStart:gi(s=this.orderedItems.byStart).call(s,(function(t){return!t.isCluster}))},c={byEnd:Lr(new Yh(gi(a=fo(l=this.orderedItems.byEnd).call(l,(function(t){return t.cluster}))).call(a,(function(t){return!!t})))),byStart:Lr(new Yh(gi(h=fo(u=this.orderedItems.byStart).call(u,(function(t){return t.cluster}))).call(h,(function(t){return!!t}))))},p=function(){var t,e,i,r=o._updateItemsInRange(d,gi(t=o.visibleItems).call(t,(function(t){return!t.isCluster})),n),s=o._updateClustersInRange(c,gi(e=o.visibleItems).call(e,(function(t){return t.isCluster})),n);return zr(i=[]).call(i,Lr(r),Lr(s))},m=function(t){var e={},i=function(i){var n,r=gi(n=o.visibleItems).call(n,(function(t){return t.data.subgroup===i}));e[i]=t?qs(r).call(r,(function(e,i){return t(e.data,i.data)})):r};for(var n in o.subgroups)i(n);return e};if("function"==typeof this.itemSet.options.order){var f=this;if(this.doInnerStack&&this.itemSet.options.stackSubgroups){yu(m(this.itemSet.options.order),i,this.subgroups),this.visibleItems=p(),this._updateSubGroupHeights(i)}else{var g,v,y,b;this.visibleItems=p(),this._updateSubGroupHeights(i);var w=qs(g=gi(v=Ar(y=this.visibleItems).call(y)).call(v,(function(t){return t.isCluster||!t.isCluster&&!t.cluster}))).call(g,(function(t,e){return f.itemSet.options.order(t.data,e.data)}));this.shouldBailStackItems=mu(w,i,!0,xi(b=this._shouldBailItemsRedraw).call(b,this))}}else{var _;if(this.visibleItems=p(),this._updateSubGroupHeights(i),this.itemSet.options.stack)if(this.doInnerStack&&this.itemSet.options.stackSubgroups)yu(m(),i,this.subgroups);else this.shouldBailStackItems=mu(this.visibleItems,i,!0,xi(_=this._shouldBailItemsRedraw).call(_,this));else gu(this.visibleItems,i,this.subgroups,this.itemSet.options.stackSubgroups)}for(var k=0;k<this.visibleItems.length;k++)this.visibleItems[k].repositionX(),void 0!==this.subgroupVisibility[this.visibleItems[k].data.subgroup]&&(this.subgroupVisibility[this.visibleItems[k].data.subgroup]||this.visibleItems[k].hide());this.itemSet.options.cluster&&ni(Os).call(Os,this.items,(function(t){t.cluster&&t.displayed&&t.hide()})),this.shouldBailStackItems&&this.itemSet.body.emitter.emit("destroyTimeline"),this.stackDirty=!1}}},{key:"_didResize",value:function(t,e){t=Os.updateProperty(this,"height",e)||t;var i=this.dom.inner.clientWidth,n=this.dom.inner.clientHeight;return t=Os.updateProperty(this.props.label,"width",i)||t,t=Os.updateProperty(this.props.label,"height",n)||t}},{key:"_applyGroupHeight",value:function(t){this.dom.background.style.height="".concat(t,"px"),this.dom.foreground.style.height="".concat(t,"px"),this.dom.label.style.height="".concat(t,"px")}},{key:"_updateItemsVerticalPosition",value:function(t){for(var e=0,i=this.visibleItems.length;e<i;e++){var n=this.visibleItems[e];n.repositionY(t),this.isVisible||this.groupId==ku||n.displayed&&n.hide()}}},{key:"redraw",value:function(t,e,i,n){var o,r,s,a,l,h,u,d=this,c=!1,p=this.isVisible,m=[function(){i=d._didMarkerHeightChange.call(d)||i},xi(o=this._updateSubGroupHeights).call(o,this,e),xi(r=this._calculateGroupSizeAndPosition).call(r,this),function(){var i;d.isVisible=xi(i=d._isGroupVisible).call(i,d)(t,e)},function(){var n;xi(n=d._redrawItems).call(n,d)(i,p,e,t)},xi(s=this._updateSubgroupsSizes).call(s,this),function(){var t;h=xi(t=d._calculateHeight).call(t,d)(e)},xi(a=this._calculateGroupSizeAndPosition).call(a,this),function(){var t;c=xi(t=d._didResize).call(t,d)(c,h)},function(){var t;xi(t=d._applyGroupHeight).call(t,d)(h)},function(){var t;xi(t=d._updateItemsVerticalPosition).call(t,d)(e)},xi(l=function(){return!d.isVisible&&d.height&&(c=!1),c}).call(l,this)];return n?m:(ni(m).call(m,(function(t){u=t()})),u)}},{key:"_updateSubGroupHeights",value:function(t){var e=this;if(eo(this.subgroups).length>0){var i=this;this._resetSubgroups(),ni(Os).call(Os,this.visibleItems,(function(n){void 0!==n.data.subgroup&&(i.subgroups[n.data.subgroup].height=Math.max(i.subgroups[n.data.subgroup].height,n.height+t.item.vertical),i.subgroups[n.data.subgroup].visible=void 0===e.subgroupVisibility[n.data.subgroup]||Boolean(e.subgroupVisibility[n.data.subgroup]))}))}}},{key:"_isGroupVisible",value:function(t,e){return this.top<=t.body.domProps.centerContainer.height-t.body.domProps.scrollTop+e.axis&&this.top+this.height+e.axis>=-t.body.domProps.scrollTop}},{key:"_calculateHeight",value:function(t){var e,i;if((i="fixed"===this.heightMode?Os.toArray(this.items):this.visibleItems).length>0){var n=i[0].top,o=i[0].top+i[0].height;if(ni(Os).call(Os,i,(function(t){n=Math.min(n,t.top),o=Math.max(o,t.top+t.height)})),n>t.axis){var r=n-t.axis;o-=r,ni(Os).call(Os,i,(function(t){t.top-=r}))}e=Math.ceil(o+t.item.vertical/2),"fitItems"!==this.heightMode&&(e=Math.max(e,this.props.label.height))}else e=this.props.label.height;return e}},{key:"show",value:function(){this.dom.label.parentNode||this.itemSet.dom.labelSet.appendChild(this.dom.label),this.dom.foreground.parentNode||this.itemSet.dom.foreground.appendChild(this.dom.foreground),this.dom.background.parentNode||this.itemSet.dom.background.appendChild(this.dom.background),this.dom.axis.parentNode||this.itemSet.dom.axis.appendChild(this.dom.axis)}},{key:"hide",value:function(){var t=this.dom.label;t.parentNode&&t.parentNode.removeChild(t);var e=this.dom.foreground;e.parentNode&&e.parentNode.removeChild(e);var i=this.dom.background;i.parentNode&&i.parentNode.removeChild(i);var n=this.dom.axis;n.parentNode&&n.parentNode.removeChild(n)}},{key:"add",value:function(t){var e;if(this.items[t.id]=t,t.setParent(this),this.stackDirty=!0,void 0!==t.data.subgroup&&(this._addToSubgroup(t),this.orderSubgroups()),!du(e=this.visibleItems).call(e,t)){var i=this.itemSet.body.range;this._checkIfVisible(t,this.visibleItems,i)}}},{key:"_addToSubgroup",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:t.data.subgroup;null!=e&&void 0===this.subgroups[e]&&(this.subgroups[e]={height:0,top:0,start:t.data.start,end:t.data.end||t.data.start,visible:!1,index:this.subgroupIndex,items:[],stack:this.subgroupStackAll||this.subgroupStack[e]||!1},this.subgroupIndex++),new Date(t.data.start)<new Date(this.subgroups[e].start)&&(this.subgroups[e].start=t.data.start);var i=t.data.end||t.data.start;new Date(i)>new Date(this.subgroups[e].end)&&(this.subgroups[e].end=i),this.subgroups[e].items.push(t)}},{key:"_updateSubgroupsSizes",value:function(){var t=this;if(t.subgroups){var e=function(e){var i,n=t.subgroups[e].items[0].data.end||t.subgroups[e].items[0].data.start,o=t.subgroups[e].items[0].data.start,r=n-1;ni(i=t.subgroups[e].items).call(i,(function(t){new Date(t.data.start)<new Date(o)&&(o=t.data.start);var e=t.data.end||t.data.start;new Date(e)>new Date(r)&&(r=e)})),t.subgroups[e].start=o,t.subgroups[e].end=new Date(r-1)};for(var i in t.subgroups)e(i)}}},{key:"orderSubgroups",value:function(){if(void 0!==this.subgroupOrderer){var t=[];if("string"==typeof this.subgroupOrderer){for(var e in this.subgroups)t.push({subgroup:e,sortField:this.subgroups[e].items[0].data[this.subgroupOrderer]});qs(t).call(t,(function(t,e){return t.sortField-e.sortField}))}else if("function"==typeof this.subgroupOrderer){for(var i in this.subgroups)t.push(this.subgroups[i].items[0].data);qs(t).call(t,this.subgroupOrderer)}if(t.length>0)for(var n=0;n<t.length;n++)this.subgroups[t[n].subgroup].index=n}}},{key:"_resetSubgroups",value:function(){for(var t in this.subgroups)this.subgroups.hasOwnProperty(t)&&(this.subgroups[t].visible=!1,this.subgroups[t].height=0)}},{key:"remove",value:function(t){var e,i;delete this.items[t.id],t.setParent(null),this.stackDirty=!0;var n=sr(e=this.visibleItems).call(e,t);-1!=n&&Oa(i=this.visibleItems).call(i,n,1),void 0!==t.data.subgroup&&(this._removeFromSubgroup(t),this.orderSubgroups())}},{key:"_removeFromSubgroup",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:t.data.subgroup;if(null!=e){var i=this.subgroups[e];if(i){var n,o,r=sr(n=i.items).call(n,t);if(r>=0)Oa(o=i.items).call(o,r,1),i.items.length?this._updateSubgroupsSizes():delete this.subgroups[e]}}}},{key:"removeFromDataSet",value:function(t){this.itemSet.removeItem(t.id)}},{key:"order",value:function(){for(var t=Os.toArray(this.items),e=[],i=[],n=0;n<t.length;n++)void 0!==t[n].data.end&&i.push(t[n]),e.push(t[n]);this.orderedItems={byStart:e,byEnd:i},cu(this.orderedItems.byStart),pu(this.orderedItems.byEnd)}},{key:"_updateItemsInRange",value:function(t,e,i){var n=[],o={};if(!this.isVisible&&this.groupId!=ku){for(var r=0;r<e.length;r++){var s=e[r];s.displayed&&s.hide()}return n}var a=(i.end-i.start)/4,l=i.start-a,h=i.end+a;if(e.length>0)for(var u=0;u<e.length;u++)this._checkIfVisibleWithReference(e[u],n,o,i);var d=Os.binarySearchCustom(t.byStart,(function(t){return t<l?-1:t<=h?0:1}),"data","start");if(this._traceVisible(d,t.byStart,n,o,(function(t){return t.data.start<l||t.data.start>h})),1==this.checkRangedItems){this.checkRangedItems=!1;for(var c=0;c<t.byEnd.length;c++)this._checkIfVisibleWithReference(t.byEnd[c],n,o,i)}else{var p=Os.binarySearchCustom(t.byEnd,(function(t){var e=t.start;return t.end<l?-1:e<=h?0:1}),"data");this._traceVisible(p,t.byEnd,n,o,(function(t){return t.data.end<l||t.data.start>h}))}for(var m={},f=0,g=0;g<n.length;g++){var v=n[g];if(!v.displayed){m[g]=v.redraw(!0),f=m[g].length}}if(f>0)for(var y=function(t){ni(Os).call(Os,m,(function(e){e[t]()}))},b=0;b<f;b++)y(b);for(var w=0;w<n.length;w++)n[w].repositionX();return n}},{key:"_traceVisible",value:function(t,e,i,n,o){if(-1!=t){for(var r=t;r>=0;r--){var s=e[r];if(o(s))break;s.isCluster&&!s.hasItems()||s.cluster||void 0===n[s.id]&&(n[s.id]=!0,i.push(s))}for(var a=t+1;a<e.length;a++){var l=e[a];if(o(l))break;l.isCluster&&!l.hasItems()||l.cluster||void 0===n[l.id]&&(n[l.id]=!0,i.push(l))}}}},{key:"_checkIfVisible",value:function(t,e,i){t.isVisible(i)?(t.displayed||t.show(),t.repositionX(),e.push(t)):t.displayed&&t.hide()}},{key:"_checkIfVisibleWithReference",value:function(t,e,i,n){t.isVisible(n)?void 0===i[t.id]&&(i[t.id]=!0,e.push(t)):t.displayed&&t.hide()}},{key:"_updateClustersInRange",value:function(t,e,i){var n=[],o={};if(e.length>0)for(var r=0;r<e.length;r++)this._checkIfVisibleWithReference(e[r],n,o,i);for(var s=0;s<t.byStart.length;s++)this._checkIfVisibleWithReference(t.byStart[s],n,o,i);for(var a=0;a<t.byEnd.length;a++)this._checkIfVisibleWithReference(t.byEnd[a],n,o,i);for(var l={},h=0,u=0;u<n.length;u++){var d=n[u];if(!d.displayed){l[u]=d.redraw(!0),h=l[u].length}}if(h>0)for(var c=0;c<h;c++)ni(Os).call(Os,l,(function(t){t[c]()}));for(var p=0;p<n.length;p++)n[p].repositionX();return n}},{key:"changeSubgroup",value:function(t,e,i){this._removeFromSubgroup(t,e),this._addToSubgroup(t,i),this.orderSubgroups()}},{key:"dispose",value:function(){var t;for(this.hide();t=this._disposeCallbacks.pop();)t()}}]),t}();function Su(t){var e=function(){if("undefined"==typeof Reflect||!Nt)return!1;if(Nt.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Nt(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=Yn(t);if(e){var o=Yn(this).constructor;i=Nt(n,arguments,o)}else i=n.apply(this,arguments);return zn(this,i)}}var Du=function(t){ji(i,xu);var e=Su(i);function i(t,n,o){var r;return Ci(this,i),(r=e.call(this,t,n,o)).width=0,r.height=0,r.top=0,r.left=0,r}return Ii(i,[{key:"redraw",value:function(t,e,i){this.visibleItems=this._updateItemsInRange(this.orderedItems,this.visibleItems,t),this.width=this.dom.background.offsetWidth,this.dom.background.style.height="0";for(var n=0,o=this.visibleItems.length;n<o;n++){this.visibleItems[n].repositionY(e)}return!1}},{key:"show",value:function(){this.dom.background.parentNode||this.itemSet.dom.background.appendChild(this.dom.background)}}]),i}();function Cu(t,e){var i;if(void 0===Gr||null==bo(t)){if(Di(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return Tu(t,e);var n=Ar(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Mo(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Tu(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var r,s=!0,a=!1;return{s:function(){i=yo(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,r=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw r}}}}function Tu(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}var Ou=function(){function t(e,i,n){var o,r=this;Ci(this,t),this.id=null,this.parent=null,this.data=e,this.dom=null,this.conversion=i||{},this.defaultOptions={locales:xh,locale:"en"},this.options=Os.extend({},this.defaultOptions,n),this.options.locales=Os.extend({},xh,this.options.locales);var s=this.defaultOptions.locales[this.defaultOptions.locale];ni(o=eo(this.options.locales)).call(o,(function(t){r.options.locales[t]=Os.extend({},s,r.options.locales[t])})),this.selected=!1,this.displayed=!1,this.groupShowing=!0,this.selectable=n&&n.selectable||!1,this.dirty=!0,this.top=null,this.right=null,this.left=null,this.width=null,this.height=null,this.setSelectability(e),this.editable=null,this._updateEditStatus()}return Ii(t,[{key:"select",value:function(){this.selectable&&(this.selected=!0,this.dirty=!0,this.displayed&&this.redraw())}},{key:"unselect",value:function(){this.selected=!1,this.dirty=!0,this.displayed&&this.redraw()}},{key:"setData",value:function(t){null!=t.group&&this.data.group!=t.group&&null!=this.parent&&this.parent.itemSet._moveToGroup(this,t.group),this.setSelectability(t),this.parent&&(this.parent.stackDirty=!0),null!=t.subgroup&&this.data.subgroup!=t.subgroup&&null!=this.parent&&this.parent.changeSubgroup(this,this.data.subgroup,t.subgroup),this.data=t,this._updateEditStatus(),this.dirty=!0,this.displayed&&this.redraw()}},{key:"setSelectability",value:function(t){t&&(this.selectable=void 0===t.selectable||Boolean(t.selectable))}},{key:"setParent",value:function(t){this.displayed?(this.hide(),this.parent=t,this.parent&&this.show()):this.parent=t}},{key:"isVisible",value:function(t){return!1}},{key:"show",value:function(){return!1}},{key:"hide",value:function(){return!1}},{key:"redraw",value:function(){}},{key:"repositionX",value:function(){}},{key:"repositionY",value:function(){}},{key:"_repaintDragCenter",value:function(){if(this.selected&&this.editable.updateTime&&!this.dom.dragCenter){var t,e,i=this,n=document.createElement("div");n.className="vis-drag-center",n.dragCenterItem=this,this.hammerDragCenter=new oh(n),this.hammerDragCenter.on("tap",(function(t){i.parent.itemSet.body.emitter.emit("click",{event:t,item:i.id})})),this.hammerDragCenter.on("doubletap",(function(t){t.stopPropagation(),i.parent.itemSet._onUpdateItem(i),i.parent.itemSet.body.emitter.emit("doubleClick",{event:t,item:i.id})})),this.hammerDragCenter.on("panstart",(function(t){t.stopPropagation(),i.parent.itemSet._onDragStart(t)})),this.hammerDragCenter.on("panmove",xi(t=i.parent.itemSet._onDrag).call(t,i.parent.itemSet)),this.hammerDragCenter.on("panend",xi(e=i.parent.itemSet._onDragEnd).call(e,i.parent.itemSet)),this.dom.box?this.dom.dragLeft?this.dom.box.insertBefore(n,this.dom.dragLeft):this.dom.box.appendChild(n):this.dom.point&&this.dom.point.appendChild(n),this.dom.dragCenter=n}else!this.selected&&this.dom.dragCenter&&(this.dom.dragCenter.parentNode&&this.dom.dragCenter.parentNode.removeChild(this.dom.dragCenter),this.dom.dragCenter=null,this.hammerDragCenter&&(this.hammerDragCenter.destroy(),this.hammerDragCenter=null))}},{key:"_repaintDeleteButton",value:function(t){var e=(this.options.editable.overrideItems||null==this.editable)&&this.options.editable.remove||!this.options.editable.overrideItems&&null!=this.editable&&this.editable.remove;if(this.selected&&e&&!this.dom.deleteButton){var i=this,n=document.createElement("div");this.options.rtl?n.className="vis-delete-rtl":n.className="vis-delete";var o=this.options.locales[this.options.locale];o||(this.warned||(console.warn("WARNING: options.locales['".concat(this.options.locale,"'] not found. See https://visjs.github.io/vis-timeline/docs/timeline/#Localization")),this.warned=!0),o=this.options.locales.en),n.title=o.deleteSelected,this.hammerDeleteButton=new oh(n).on("tap",(function(t){t.stopPropagation(),i.parent.removeFromDataSet(i)})),t.appendChild(n),this.dom.deleteButton=n}else!this.selected&&this.dom.deleteButton&&(this.dom.deleteButton.parentNode&&this.dom.deleteButton.parentNode.removeChild(this.dom.deleteButton),this.dom.deleteButton=null,this.hammerDeleteButton&&(this.hammerDeleteButton.destroy(),this.hammerDeleteButton=null))}},{key:"_repaintOnItemUpdateTimeTooltip",value:function(t){if(this.options.tooltipOnItemUpdateTime){var e=(this.options.editable.updateTime||!0===this.data.editable)&&!1!==this.data.editable;if(this.selected&&e&&!this.dom.onItemUpdateTimeTooltip){var i=document.createElement("div");i.className="vis-onUpdateTime-tooltip",t.appendChild(i),this.dom.onItemUpdateTimeTooltip=i}else!this.selected&&this.dom.onItemUpdateTimeTooltip&&(this.dom.onItemUpdateTimeTooltip.parentNode&&this.dom.onItemUpdateTimeTooltip.parentNode.removeChild(this.dom.onItemUpdateTimeTooltip),this.dom.onItemUpdateTimeTooltip=null);if(this.dom.onItemUpdateTimeTooltip){this.dom.onItemUpdateTimeTooltip.style.visibility=this.parent.itemSet.touchParams.itemIsDragging?"visible":"hidden",this.dom.onItemUpdateTimeTooltip.style.transform="translateX(-50%)",this.dom.onItemUpdateTimeTooltip.style.left="50%";var n,o,r=this.parent.itemSet.body.domProps.scrollTop;if(("top"==this.options.orientation.item?this.top:this.parent.height-this.top-this.height)+this.parent.top-50<-r?(this.dom.onItemUpdateTimeTooltip.style.bottom="",this.dom.onItemUpdateTimeTooltip.style.top="".concat(this.height+2,"px")):(this.dom.onItemUpdateTimeTooltip.style.top="",this.dom.onItemUpdateTimeTooltip.style.bottom="".concat(this.height+2,"px")),this.options.tooltipOnItemUpdateTime&&this.options.tooltipOnItemUpdateTime.template)n=xi(o=this.options.tooltipOnItemUpdateTime.template).call(o,this)(this.data);else n="start: ".concat(Wn(this.data.start).format("MM/DD/YYYY hh:mm")),this.data.end&&(n+="<br> end: ".concat(Wn(this.data.end).format("MM/DD/YYYY hh:mm")));this.dom.onItemUpdateTimeTooltip.innerHTML=n}}}},{key:"_getItemData",value:function(){return this.parent.itemSet.itemsData.get(this.id)}},{key:"_updateContents",value:function(t){var e,i,n,o,r,s,a=this._getItemData(),l=(this.dom.box||this.dom.point).getElementsByClassName("vis-item-visible-frame")[0];this.options.visibleFrameTemplate?n=(o=xi(r=this.options.visibleFrameTemplate).call(r,this))(a,l):n="";if(l)if(n instanceof Object&&!(n instanceof Element))o(a,l);else if(this._contentToString(this.itemVisibleFrameContent)!==this._contentToString(n)){if(n instanceof Element)l.innerHTML="",l.appendChild(n);else if(null!=n)l.innerHTML=n;else if("background"!=this.data.type||void 0!==this.data.content)throw new Error('Property "content" missing in item '.concat(this.id));this.itemVisibleFrameContent=n}this.options.template?e=(i=xi(s=this.options.template).call(s,this))(a,t,this.data):e=this.data.content;if(e instanceof Object&&!(e instanceof Element))i(a,t);else if(this._contentToString(this.content)!==this._contentToString(e)){if(e instanceof Element)t.innerHTML="",t.appendChild(e);else if(null!=e)t.innerHTML=e;else if("background"!=this.data.type||void 0!==this.data.content)throw new Error('Property "content" missing in item '.concat(this.id));this.content=e}}},{key:"_updateDataAttributes",value:function(t){if(this.options.dataAttributes&&this.options.dataAttributes.length>0){var e=[];if(Di(this.options.dataAttributes))e=this.options.dataAttributes;else{if("all"!=this.options.dataAttributes)return;e=eo(this.data)}var i,n=Cu(e);try{for(n.s();!(i=n.n()).done;){var o=i.value,r=this.data[o];null!=r?t.setAttribute("data-".concat(o),r):t.removeAttribute("data-".concat(o))}}catch(t){n.e(t)}finally{n.f()}}}},{key:"_updateStyle",value:function(t){this.style&&(Os.removeCssText(t,this.style),this.style=null),this.data.style&&(Os.addCssText(t,this.data.style),this.style=this.data.style)}},{key:"_contentToString",value:function(t){return"string"==typeof t?t:t&&"outerHTML"in t?t.outerHTML:t}},{key:"_updateEditStatus",value:function(){this.options&&("boolean"==typeof this.options.editable?this.editable={updateTime:this.options.editable,updateGroup:this.options.editable,remove:this.options.editable}:"object"===Fn(this.options.editable)&&(this.editable={},Os.selectiveExtend(["updateTime","updateGroup","remove"],this.editable,this.options.editable))),this.options&&this.options.editable&&!0===this.options.editable.overrideItems||this.data&&("boolean"==typeof this.data.editable?this.editable={updateTime:this.data.editable,updateGroup:this.data.editable,remove:this.data.editable}:"object"===Fn(this.data.editable)&&(this.editable={},Os.selectiveExtend(["updateTime","updateGroup","remove"],this.editable,this.data.editable)))}},{key:"getWidthLeft",value:function(){return 0}},{key:"getWidthRight",value:function(){return 0}},{key:"getTitle",value:function(){var t;return this.options.tooltip&&this.options.tooltip.template?xi(t=this.options.tooltip.template).call(t,this)(this._getItemData(),this.data):this.data.title}}]),t}();function Eu(t){var e=function(){if("undefined"==typeof Reflect||!Nt)return!1;if(Nt.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Nt(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=Yn(t);if(e){var o=Yn(this).constructor;i=Nt(n,arguments,o)}else i=n.apply(this,arguments);return zn(this,i)}}Ou.prototype.stack=!0;var Iu=function(t){ji(i,Ou);var e=Eu(i);function i(t,n,o){var r;if(Ci(this,i),(r=e.call(this,t,n,o)).props={dot:{width:0,height:0},line:{width:0,height:0}},t&&null==t.start)throw new Error('Property "start" missing in item '.concat(t));return r}return Ii(i,[{key:"isVisible",value:function(t){if(this.cluster)return!1;var e,i=this.data.align||this.options.align,n=this.width*t.getMillisecondsPerPixel();return e="right"==i?this.data.start.getTime()>t.start&&this.data.start.getTime()-n<t.end:"left"==i?this.data.start.getTime()+n>t.start&&this.data.start.getTime()<t.end:this.data.start.getTime()+n/2>t.start&&this.data.start.getTime()-n/2<t.end,e}},{key:"_createDomElement",value:function(){this.dom||(this.dom={},this.dom.box=document.createElement("DIV"),this.dom.content=document.createElement("DIV"),this.dom.content.className="vis-item-content",this.dom.box.appendChild(this.dom.content),this.dom.line=document.createElement("DIV"),this.dom.line.className="vis-line",this.dom.dot=document.createElement("DIV"),this.dom.dot.className="vis-dot",this.dom.box["vis-item"]=this,this.dirty=!0)}},{key:"_appendDomElement",value:function(){if(!this.parent)throw new Error("Cannot redraw item: no parent attached");if(!this.dom.box.parentNode){var t=this.parent.dom.foreground;if(!t)throw new Error("Cannot redraw item: parent has no foreground container element");t.appendChild(this.dom.box)}if(!this.dom.line.parentNode){var e=this.parent.dom.background;if(!e)throw new Error("Cannot redraw item: parent has no background container element");e.appendChild(this.dom.line)}if(!this.dom.dot.parentNode){var i=this.parent.dom.axis;if(!e)throw new Error("Cannot redraw item: parent has no axis container element");i.appendChild(this.dom.dot)}this.displayed=!0}},{key:"_updateDirtyDomComponents",value:function(){if(this.dirty){this._updateContents(this.dom.content),this._updateDataAttributes(this.dom.box),this._updateStyle(this.dom.box);var t=this.editable.updateTime||this.editable.updateGroup,e=(this.data.className?" "+this.data.className:"")+(this.selected?" vis-selected":"")+(t?" vis-editable":" vis-readonly");this.dom.box.className="vis-item vis-box".concat(e),this.dom.line.className="vis-item vis-line".concat(e),this.dom.dot.className="vis-item vis-dot".concat(e)}}},{key:"_getDomComponentsSizes",value:function(){return{previous:{right:this.dom.box.style.right,left:this.dom.box.style.left},dot:{height:this.dom.dot.offsetHeight,width:this.dom.dot.offsetWidth},line:{width:this.dom.line.offsetWidth},box:{width:this.dom.box.offsetWidth,height:this.dom.box.offsetHeight}}}},{key:"_updateDomComponentsSizes",value:function(t){this.options.rtl?this.dom.box.style.right="0px":this.dom.box.style.left="0px",this.props.dot.height=t.dot.height,this.props.dot.width=t.dot.width,this.props.line.width=t.line.width,this.width=t.box.width,this.height=t.box.height,this.options.rtl?this.dom.box.style.right=t.previous.right:this.dom.box.style.left=t.previous.left,this.dirty=!1}},{key:"_repaintDomAdditionals",value:function(){this._repaintOnItemUpdateTimeTooltip(this.dom.box),this._repaintDragCenter(),this._repaintDeleteButton(this.dom.box)}},{key:"redraw",value:function(t){var e,i,n,o,r,s,a=this,l=[xi(e=this._createDomElement).call(e,this),xi(i=this._appendDomElement).call(i,this),xi(n=this._updateDirtyDomComponents).call(n,this),function(){a.dirty&&(r=a._getDomComponentsSizes())},function(){var t;a.dirty&&xi(t=a._updateDomComponentsSizes).call(t,a)(r)},xi(o=this._repaintDomAdditionals).call(o,this)];return t?l:(ni(l).call(l,(function(t){s=t()})),s)}},{key:"show",value:function(t){if(!this.displayed)return this.redraw(t)}},{key:"hide",value:function(){if(this.displayed){var t=this.dom;t.box.remove?t.box.remove():t.box.parentNode&&t.box.parentNode.removeChild(t.box),t.line.remove?t.line.remove():t.line.parentNode&&t.line.parentNode.removeChild(t.line),t.dot.remove?t.dot.remove():t.dot.parentNode&&t.dot.parentNode.removeChild(t.dot),this.displayed=!1}}},{key:"repositionXY",value:function(){var t=this.options.rtl,e=function(t,e,i){var n,o=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if(void 0!==e||void 0!==i){var r=o?-1*e:e;t.style.transform=void 0!==i?void 0!==e?zr(n="translate(".concat(r,"px, ")).call(n,i,"px)"):"translateY(".concat(i,"px)"):"translateX(".concat(r,"px)")}};e(this.dom.box,this.boxX,this.boxY,t),e(this.dom.dot,this.dotX,this.dotY,t),e(this.dom.line,this.lineX,this.lineY,t)}},{key:"repositionX",value:function(){var t=this.conversion.toScreen(this.data.start),e=void 0===this.data.align?this.options.align:this.data.align,i=this.props.line.width,n=this.props.dot.width;"right"==e?(this.boxX=t-this.width,this.lineX=t-i,this.dotX=t-i/2-n/2):"left"==e?(this.boxX=t,this.lineX=t,this.dotX=t+i/2-n/2):(this.boxX=t-this.width/2,this.lineX=this.options.rtl?t-i:t-i/2,this.dotX=t-n/2),this.options.rtl?this.right=this.boxX:this.left=this.boxX,this.repositionXY()}},{key:"repositionY",value:function(){var t=this.options.orientation.item,e=this.dom.line.style;if("top"==t){var i=this.parent.top+this.top+1;this.boxY=this.top||0,e.height="".concat(i,"px"),e.bottom="",e.top="0"}else{var n=this.parent.itemSet.props.height-this.parent.top-this.parent.height+this.top;this.boxY=this.parent.height-this.top-(this.height||0),e.height="".concat(n,"px"),e.top="",e.bottom="0"}this.dotY=-this.props.dot.height/2,this.repositionXY()}},{key:"getWidthLeft",value:function(){return this.width/2}},{key:"getWidthRight",value:function(){return this.width/2}}]),i}();function Mu(t){var e=function(){if("undefined"==typeof Reflect||!Nt)return!1;if(Nt.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Nt(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=Yn(t);if(e){var o=Yn(this).constructor;i=Nt(n,arguments,o)}else i=n.apply(this,arguments);return zn(this,i)}}var Au=function(t){ji(i,Ou);var e=Mu(i);function i(t,n,o){var r;if(Ci(this,i),(r=e.call(this,t,n,o)).props={dot:{top:0,width:0,height:0},content:{height:0,marginLeft:0,marginRight:0}},t&&null==t.start)throw new Error('Property "start" missing in item '.concat(t));return r}return Ii(i,[{key:"isVisible",value:function(t){if(this.cluster)return!1;var e=this.width*t.getMillisecondsPerPixel();return this.data.start.getTime()+e>t.start&&this.data.start<t.end}},{key:"_createDomElement",value:function(){this.dom||(this.dom={},this.dom.point=document.createElement("div"),this.dom.content=document.createElement("div"),this.dom.content.className="vis-item-content",this.dom.point.appendChild(this.dom.content),this.dom.dot=document.createElement("div"),this.dom.point.appendChild(this.dom.dot),this.dom.point["vis-item"]=this,this.dirty=!0)}},{key:"_appendDomElement",value:function(){if(!this.parent)throw new Error("Cannot redraw item: no parent attached");if(!this.dom.point.parentNode){var t=this.parent.dom.foreground;if(!t)throw new Error("Cannot redraw item: parent has no foreground container element");t.appendChild(this.dom.point)}this.displayed=!0}},{key:"_updateDirtyDomComponents",value:function(){if(this.dirty){this._updateContents(this.dom.content),this._updateDataAttributes(this.dom.point),this._updateStyle(this.dom.point);var t=this.editable.updateTime||this.editable.updateGroup,e=(this.data.className?" "+this.data.className:"")+(this.selected?" vis-selected":"")+(t?" vis-editable":" vis-readonly");this.dom.point.className="vis-item vis-point".concat(e),this.dom.dot.className="vis-item vis-dot".concat(e)}}},{key:"_getDomComponentsSizes",value:function(){return{dot:{width:this.dom.dot.offsetWidth,height:this.dom.dot.offsetHeight},content:{width:this.dom.content.offsetWidth,height:this.dom.content.offsetHeight},point:{width:this.dom.point.offsetWidth,height:this.dom.point.offsetHeight}}}},{key:"_updateDomComponentsSizes",value:function(t){this.props.dot.width=t.dot.width,this.props.dot.height=t.dot.height,this.props.content.height=t.content.height,this.options.rtl?this.dom.content.style.marginRight="".concat(2*this.props.dot.width,"px"):this.dom.content.style.marginLeft="".concat(2*this.props.dot.width,"px"),this.width=t.point.width,this.height=t.point.height,this.dom.dot.style.top="".concat((this.height-this.props.dot.height)/2,"px");var e=this.props.dot.width,i=this.options.rtl?e/2*-1:e/2;this.dom.dot.style.transform="translateX(".concat(i,"px"),this.dirty=!1}},{key:"_repaintDomAdditionals",value:function(){this._repaintOnItemUpdateTimeTooltip(this.dom.point),this._repaintDragCenter(),this._repaintDeleteButton(this.dom.point)}},{key:"redraw",value:function(t){var e,i,n,o,r,s,a=this,l=[xi(e=this._createDomElement).call(e,this),xi(i=this._appendDomElement).call(i,this),xi(n=this._updateDirtyDomComponents).call(n,this),function(){a.dirty&&(r=a._getDomComponentsSizes())},function(){var t;a.dirty&&xi(t=a._updateDomComponentsSizes).call(t,a)(r)},xi(o=this._repaintDomAdditionals).call(o,this)];return t?l:(ni(l).call(l,(function(t){s=t()})),s)}},{key:"repositionXY",value:function(){var t=this.options.rtl,e=function(t,e,i){var n,o=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if(void 0!==e||void 0!==i){var r=o?-1*e:e;t.style.transform=void 0!==i?void 0!==e?zr(n="translate(".concat(r,"px, ")).call(n,i,"px)"):"translateY(".concat(i,"px)"):"translateX(".concat(r,"px)")}};e(this.dom.point,this.pointX,this.pointY,t)}},{key:"show",value:function(t){if(!this.displayed)return this.redraw(t)}},{key:"hide",value:function(){this.displayed&&(this.dom.point.parentNode&&this.dom.point.parentNode.removeChild(this.dom.point),this.displayed=!1)}},{key:"repositionX",value:function(){var t=this.conversion.toScreen(this.data.start);this.pointX=t,this.options.rtl?this.right=t-this.props.dot.width:this.left=t-this.props.dot.width,this.repositionXY()}},{key:"repositionY",value:function(){var t=this.options.orientation.item;this.pointY="top"==t?this.top:this.parent.height-this.top-this.height,this.repositionXY()}},{key:"getWidthLeft",value:function(){return this.props.dot.width}},{key:"getWidthRight",value:function(){return this.props.dot.width}}]),i}();function Pu(t){var e=function(){if("undefined"==typeof Reflect||!Nt)return!1;if(Nt.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Nt(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=Yn(t);if(e){var o=Yn(this).constructor;i=Nt(n,arguments,o)}else i=n.apply(this,arguments);return zn(this,i)}}var Nu=function(t){ji(i,Ou);var e=Pu(i);function i(t,n,o){var r;if(Ci(this,i),(r=e.call(this,t,n,o)).props={content:{width:0}},r.overflow=!1,t){if(null==t.start)throw new Error('Property "start" missing in item '.concat(t.id));if(null==t.end)throw new Error('Property "end" missing in item '.concat(t.id))}return r}return Ii(i,[{key:"isVisible",value:function(t){return!this.cluster&&(this.data.start<t.end&&this.data.end>t.start)}},{key:"_createDomElement",value:function(){this.dom||(this.dom={},this.dom.box=document.createElement("div"),this.dom.frame=document.createElement("div"),this.dom.frame.className="vis-item-overflow",this.dom.box.appendChild(this.dom.frame),this.dom.visibleFrame=document.createElement("div"),this.dom.visibleFrame.className="vis-item-visible-frame",this.dom.box.appendChild(this.dom.visibleFrame),this.dom.content=document.createElement("div"),this.dom.content.className="vis-item-content",this.dom.frame.appendChild(this.dom.content),this.dom.box["vis-item"]=this,this.dirty=!0)}},{key:"_appendDomElement",value:function(){if(!this.parent)throw new Error("Cannot redraw item: no parent attached");if(!this.dom.box.parentNode){var t=this.parent.dom.foreground;if(!t)throw new Error("Cannot redraw item: parent has no foreground container element");t.appendChild(this.dom.box)}this.displayed=!0}},{key:"_updateDirtyDomComponents",value:function(){if(this.dirty){this._updateContents(this.dom.content),this._updateDataAttributes(this.dom.box),this._updateStyle(this.dom.box);var t=this.editable.updateTime||this.editable.updateGroup,e=(this.data.className?" "+this.data.className:"")+(this.selected?" vis-selected":"")+(t?" vis-editable":" vis-readonly");this.dom.box.className=this.baseClassName+e,this.dom.content.style.maxWidth="none"}}},{key:"_getDomComponentsSizes",value:function(){return this.overflow="hidden"!==window.getComputedStyle(this.dom.frame).overflow,this.whiteSpace="nowrap"!==window.getComputedStyle(this.dom.content).whiteSpace,{content:{width:this.dom.content.offsetWidth},box:{height:this.dom.box.offsetHeight}}}},{key:"_updateDomComponentsSizes",value:function(t){this.props.content.width=t.content.width,this.height=t.box.height,this.dom.content.style.maxWidth="",this.dirty=!1}},{key:"_repaintDomAdditionals",value:function(){this._repaintOnItemUpdateTimeTooltip(this.dom.box),this._repaintDeleteButton(this.dom.box),this._repaintDragCenter(),this._repaintDragLeft(),this._repaintDragRight()}},{key:"redraw",value:function(t){var e,i,n,o,r,s,a=this,l=[xi(e=this._createDomElement).call(e,this),xi(i=this._appendDomElement).call(i,this),xi(n=this._updateDirtyDomComponents).call(n,this),function(){var t;a.dirty&&(r=xi(t=a._getDomComponentsSizes).call(t,a)())},function(){var t;a.dirty&&xi(t=a._updateDomComponentsSizes).call(t,a)(r)},xi(o=this._repaintDomAdditionals).call(o,this)];return t?l:(ni(l).call(l,(function(t){s=t()})),s)}},{key:"show",value:function(t){if(!this.displayed)return this.redraw(t)}},{key:"hide",value:function(){if(this.displayed){var t=this.dom.box;t.parentNode&&t.parentNode.removeChild(t),this.displayed=!1}}},{key:"repositionX",value:function(t){var e,i,n=this.parent.width,o=this.conversion.toScreen(this.data.start),r=this.conversion.toScreen(this.data.end),s=void 0===this.data.align?this.options.align:this.data.align;!1===this.data.limitSize||void 0!==t&&!0!==t||(o<-n&&(o=-n),r>2*n&&(r=2*n));var a=Math.max(Math.round(1e3*(r-o))/1e3,1);switch(this.overflow?(this.options.rtl?this.right=o:this.left=o,this.width=a+this.props.content.width,i=this.props.content.width):(this.options.rtl?this.right=o:this.left=o,this.width=a,i=Math.min(r-o,this.props.content.width)),this.options.rtl?this.dom.box.style.transform="translateX(".concat(-1*this.right,"px)"):this.dom.box.style.transform="translateX(".concat(this.left,"px)"),this.dom.box.style.width="".concat(a,"px"),this.whiteSpace&&(this.height=this.dom.box.offsetHeight),s){case"left":this.dom.content.style.transform="translateX(0)";break;case"right":if(this.options.rtl){var l=-1*Math.max(a-i,0);this.dom.content.style.transform="translateX(".concat(l,"px)")}else this.dom.content.style.transform="translateX(".concat(Math.max(a-i,0),"px)");break;case"center":if(this.options.rtl){var h=-1*Math.max((a-i)/2,0);this.dom.content.style.transform="translateX(".concat(h,"px)")}else this.dom.content.style.transform="translateX(".concat(Math.max((a-i)/2,0),"px)");break;default:if(e=this.overflow?r>0?Math.max(-o,0):-i:o<0?-o:0,this.options.rtl){var u=-1*e;this.dom.content.style.transform="translateX(".concat(u,"px)")}else this.dom.content.style.transform="translateX(".concat(e,"px)")}}},{key:"repositionY",value:function(){var t=this.options.orientation.item,e=this.dom.box;e.style.top="".concat("top"==t?this.top:this.parent.height-this.top-this.height,"px")}},{key:"_repaintDragLeft",value:function(){if((this.selected||this.options.itemsAlwaysDraggable.range)&&this.editable.updateTime&&!this.dom.dragLeft){var t=document.createElement("div");t.className="vis-drag-left",t.dragLeftItem=this,this.dom.box.appendChild(t),this.dom.dragLeft=t}else this.selected||this.options.itemsAlwaysDraggable.range||!this.dom.dragLeft||(this.dom.dragLeft.parentNode&&this.dom.dragLeft.parentNode.removeChild(this.dom.dragLeft),this.dom.dragLeft=null)}},{key:"_repaintDragRight",value:function(){if((this.selected||this.options.itemsAlwaysDraggable.range)&&this.editable.updateTime&&!this.dom.dragRight){var t=document.createElement("div");t.className="vis-drag-right",t.dragRightItem=this,this.dom.box.appendChild(t),this.dom.dragRight=t}else this.selected||this.options.itemsAlwaysDraggable.range||!this.dom.dragRight||(this.dom.dragRight.parentNode&&this.dom.dragRight.parentNode.removeChild(this.dom.dragRight),this.dom.dragRight=null)}}]),i}();function Ru(t){var e=function(){if("undefined"==typeof Reflect||!Nt)return!1;if(Nt.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Nt(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=Yn(t);if(e){var o=Yn(this).constructor;i=Nt(n,arguments,o)}else i=n.apply(this,arguments);return zn(this,i)}}Nu.prototype.baseClassName="vis-item vis-range";var Lu=function(t){ji(i,Ou);var e=Ru(i);function i(t,n,o){var r;if(Ci(this,i),(r=e.call(this,t,n,o)).props={content:{width:0}},r.overflow=!1,t){if(null==t.start)throw new Error('Property "start" missing in item '.concat(t.id));if(null==t.end)throw new Error('Property "end" missing in item '.concat(t.id))}return r}return Ii(i,[{key:"isVisible",value:function(t){return this.data.start<t.end&&this.data.end>t.start}},{key:"_createDomElement",value:function(){this.dom||(this.dom={},this.dom.box=document.createElement("div"),this.dom.frame=document.createElement("div"),this.dom.frame.className="vis-item-overflow",this.dom.box.appendChild(this.dom.frame),this.dom.content=document.createElement("div"),this.dom.content.className="vis-item-content",this.dom.frame.appendChild(this.dom.content),this.dirty=!0)}},{key:"_appendDomElement",value:function(){if(!this.parent)throw new Error("Cannot redraw item: no parent attached");if(!this.dom.box.parentNode){var t=this.parent.dom.background;if(!t)throw new Error("Cannot redraw item: parent has no background container element");t.appendChild(this.dom.box)}this.displayed=!0}},{key:"_updateDirtyDomComponents",value:function(){if(this.dirty){this._updateContents(this.dom.content),this._updateDataAttributes(this.dom.content),this._updateStyle(this.dom.box);var t=(this.data.className?" "+this.data.className:"")+(this.selected?" vis-selected":"");this.dom.box.className=this.baseClassName+t}}},{key:"_getDomComponentsSizes",value:function(){return this.overflow="hidden"!==window.getComputedStyle(this.dom.content).overflow,{content:{width:this.dom.content.offsetWidth}}}},{key:"_updateDomComponentsSizes",value:function(t){this.props.content.width=t.content.width,this.height=0,this.dirty=!1}},{key:"_repaintDomAdditionals",value:function(){}},{key:"redraw",value:function(t){var e,i,n,o,r,s,a=this,l=[xi(e=this._createDomElement).call(e,this),xi(i=this._appendDomElement).call(i,this),xi(n=this._updateDirtyDomComponents).call(n,this),function(){var t;a.dirty&&(r=xi(t=a._getDomComponentsSizes).call(t,a)())},function(){var t;a.dirty&&xi(t=a._updateDomComponentsSizes).call(t,a)(r)},xi(o=this._repaintDomAdditionals).call(o,this)];return t?l:(ni(l).call(l,(function(t){s=t()})),s)}},{key:"repositionY",value:function(t){var e,i=this.options.orientation.item;if(void 0!==this.data.subgroup){var n=this.data.subgroup;this.dom.box.style.height="".concat(this.parent.subgroups[n].height,"px"),this.dom.box.style.top="".concat("top"==i?this.parent.top+this.parent.subgroups[n].top:this.parent.top+this.parent.height-this.parent.subgroups[n].top-this.parent.subgroups[n].height,"px"),this.dom.box.style.bottom=""}else this.parent instanceof Du?(e=Math.max(this.parent.height,this.parent.itemSet.body.domProps.center.height,this.parent.itemSet.body.domProps.centerContainer.height),this.dom.box.style.bottom="bottom"==i?"0":"",this.dom.box.style.top="top"==i?"0":""):(e=this.parent.height,this.dom.box.style.top="".concat(this.parent.top,"px"),this.dom.box.style.bottom="");this.dom.box.style.height="".concat(e,"px")}}]),i}();Lu.prototype.baseClassName="vis-item vis-background",Lu.prototype.stack=!1,Lu.prototype.show=Nu.prototype.show,Lu.prototype.hide=Nu.prototype.hide,Lu.prototype.repositionX=Nu.prototype.repositionX;var ju=function(){function t(e,i){Ci(this,t),this.container=e,this.overflowMethod=i||"cap",this.x=0,this.y=0,this.padding=5,this.hidden=!1,this.frame=document.createElement("div"),this.frame.className="vis-tooltip",this.container.appendChild(this.frame)}return Ii(t,[{key:"setPosition",value:function(t,e){this.x=Xo(t),this.y=Xo(e)}},{key:"setText",value:function(t){t instanceof Element?(this.frame.innerHTML="",this.frame.appendChild(t)):this.frame.innerHTML=t}},{key:"show",value:function(t){if(void 0===t&&(t=!0),!0===t){var e=this.frame.clientHeight,i=this.frame.clientWidth,n=this.frame.parentNode.clientHeight,o=this.frame.parentNode.clientWidth,r=0,s=0;if("flip"==this.overflowMethod||"none"==this.overflowMethod){var a=!1,l=!0;"flip"==this.overflowMethod&&(this.y-e<this.padding&&(l=!1),this.x+i>o-this.padding&&(a=!0)),r=a?this.x-i:this.x,s=l?this.y-e:this.y}else(s=this.y-e)+e+this.padding>n&&(s=n-e-this.padding),s<this.padding&&(s=this.padding),(r=this.x)+i+this.padding>o&&(r=o-i-this.padding),r<this.padding&&(r=this.padding);this.frame.style.left=r+"px",this.frame.style.top=s+"px",this.frame.style.visibility="visible",this.hidden=!1}else this.hide()}},{key:"hide",value:function(){this.hidden=!0,this.frame.style.left="0",this.frame.style.top="0",this.frame.style.visibility="hidden"}},{key:"destroy",value:function(){this.frame.parentNode.removeChild(this.frame)}}]),t}(),Fu=He.every,zu=Be("every"),Gu=Ue("every");q({target:"Array",proto:!0,forced:!zu||!Gu},{every:function(t){return Fu(this,t,arguments.length>1?arguments[1]:void 0)}});var Hu=Je("Array").every,Bu=Array.prototype,Yu=function(t){var e=t.every;return t===Bu||t instanceof Array&&e===Bu.every?Hu:e};function Wu(t,e){var i;if(void 0===Gr||null==bo(t)){if(Di(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return Vu(t,e);var n=Ar(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Mo(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Vu(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var r,s=!0,a=!1;return{s:function(){i=yo(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,r=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw r}}}}function Vu(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}function Uu(t){var e=function(){if("undefined"==typeof Reflect||!Nt)return!1;if(Nt.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Nt(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=Yn(t);if(e){var o=Yn(this).constructor;i=Nt(n,arguments,o)}else i=n.apply(this,arguments);return zn(this,i)}}var Xu=function(t){ji(i,Ou);var e=Uu(i);function i(t,n,o){var r;Ci(this,i);var s=ur({},{fitOnDoubleClick:!0},o,{editable:!1});if((r=e.call(this,t,n,s)).props={content:{width:0,height:0}},!t||null==t.uiItems)throw new Error('Property "uiItems" missing in item '+t.id);return r.id=eu(),r.group=t.group,r._setupRange(),r.emitter=r.data.eventEmitter,r.range=r.data.range,r.attached=!1,r.isCluster=!0,r.data.isCluster=!0,r}return Ii(i,[{key:"hasItems",value:function(){return this.data.uiItems&&this.data.uiItems.length&&this.attached}},{key:"setUiItems",value:function(t){this.detach(),this.data.uiItems=t,this._setupRange(),this.attach()}},{key:"isVisible",value:function(t){var e=this.data.end?this.data.end-this.data.start:0,i=this.width*t.getMillisecondsPerPixel(),n=Math.max(this.data.start.getTime()+e,this.data.start.getTime()+i);return this.data.start<t.end&&n>t.start&&this.hasItems()}},{key:"getData",value:function(){return{isCluster:!0,id:this.id,items:this.data.items||[],data:this.data}}},{key:"redraw",value:function(t){var e,i,n,o,r,s,a,l,h=[xi(e=this._createDomElement).call(e,this),xi(i=this._appendDomElement).call(i,this),xi(n=this._updateDirtyDomComponents).call(n,this),xi(o=function(){this.dirty&&(a=this._getDomComponentsSizes())}).call(o,this),xi(r=function(){var t;this.dirty&&xi(t=this._updateDomComponentsSizes).call(t,this)(a)}).call(r,this),xi(s=this._repaintDomAdditionals).call(s,this)];return t?h:(ni(h).call(h,(function(t){l=t()})),l)}},{key:"show",value:function(){this.displayed||this.redraw()}},{key:"hide",value:function(){if(this.displayed){var t=this.dom;t.box.parentNode&&t.box.parentNode.removeChild(t.box),this.options.showStipes&&(t.line.parentNode&&t.line.parentNode.removeChild(t.line),t.dot.parentNode&&t.dot.parentNode.removeChild(t.dot)),this.displayed=!1}}},{key:"repositionX",value:function(){var t=this.conversion.toScreen(this.data.start),e=this.data.end?this.conversion.toScreen(this.data.end):0;if(e)this.repositionXWithRanges(t,e);else{var i=void 0===this.data.align?this.options.align:this.data.align;this.repositionXWithoutRanges(t,i)}this.options.showStipes&&(this.dom.line.style.display=this._isStipeVisible()?"block":"none",this.dom.dot.style.display=this._isStipeVisible()?"block":"none",this._isStipeVisible()&&this.repositionStype(t,e))}},{key:"repositionStype",value:function(t,e){this.dom.line.style.display="block",this.dom.dot.style.display="block";var i=this.dom.line.offsetWidth,n=this.dom.dot.offsetWidth;if(e){var o=i+t+(e-t)/2,r=o-n/2,s=this.options.rtl?-1*o:o,a=this.options.rtl?-1*r:r;this.dom.line.style.transform="translateX(".concat(s,"px)"),this.dom.dot.style.transform="translateX(".concat(a,"px)")}else{var l=this.options.rtl?-1*t:t,h=this.options.rtl?-1*(t-n/2):t-n/2;this.dom.line.style.transform="translateX(".concat(l,"px)"),this.dom.dot.style.transform="translateX(".concat(h,"px)")}}},{key:"repositionXWithoutRanges",value:function(t,e){"right"==e?this.options.rtl?(this.right=t-this.width,this.dom.box.style.right=this.right+"px"):(this.left=t-this.width,this.dom.box.style.left=this.left+"px"):"left"==e?this.options.rtl?(this.right=t,this.dom.box.style.right=this.right+"px"):(this.left=t,this.dom.box.style.left=this.left+"px"):this.options.rtl?(this.right=t-this.width/2,this.dom.box.style.right=this.right+"px"):(this.left=t-this.width/2,this.dom.box.style.left=this.left+"px")}},{key:"repositionXWithRanges",value:function(t,e){var i=Math.round(Math.max(e-t+.5,1));this.options.rtl?this.right=t:this.left=t,this.width=Math.max(i,this.minWidth||0),this.options.rtl?this.dom.box.style.right=this.right+"px":this.dom.box.style.left=this.left+"px",this.dom.box.style.width=i+"px"}},{key:"repositionY",value:function(){var t=this.options.orientation.item,e=this.dom.box;if(e.style.top="top"==t?(this.top||0)+"px":(this.parent.height-this.top-this.height||0)+"px",this.options.showStipes){if("top"==t)this.dom.line.style.top="0",this.dom.line.style.height=this.parent.top+this.top+1+"px",this.dom.line.style.bottom="";else{var i=this.parent.itemSet.props.height,n=i-this.parent.top-this.parent.height+this.top;this.dom.line.style.top=i-n+"px",this.dom.line.style.bottom="0"}this.dom.dot.style.top=-this.dom.dot.offsetHeight/2+"px"}}},{key:"getWidthLeft",value:function(){return this.width/2}},{key:"getWidthRight",value:function(){return this.width/2}},{key:"move",value:function(){this.repositionX(),this.repositionY()}},{key:"attach",value:function(){var t,e,i=Wu(this.data.uiItems);try{for(i.s();!(e=i.n()).done;){e.value.cluster=this}}catch(t){i.e(t)}finally{i.f()}this.data.items=fo(t=this.data.uiItems).call(t,(function(t){return t.data})),this.attached=!0,this.dirty=!0}},{key:"detach",value:function(){var t=arguments.length>0&&void 0!==arguments[0]&&arguments[0];if(this.hasItems()){var e,i=Wu(this.data.uiItems);try{for(i.s();!(e=i.n()).done;){var n=e.value;delete n.cluster}}catch(t){i.e(t)}finally{i.f()}this.attached=!1,t&&this.group&&(this.group.remove(this),this.group=null),this.data.items=[],this.dirty=!0}}},{key:"_onDoubleClick",value:function(){this._fit()}},{key:"_setupRange",value:function(){var t,e,i,n=fo(t=this.data.uiItems).call(t,(function(t){return{start:t.data.start.valueOf(),end:t.data.end?t.data.end.valueOf():t.data.start.valueOf()}}));this.data.min=Math.min.apply(Math,Lr(fo(n).call(n,(function(t){return Math.min(t.start,t.end||t.start)})))),this.data.max=Math.max.apply(Math,Lr(fo(n).call(n,(function(t){return Math.max(t.start,t.end||t.start)}))));var o=fo(e=this.data.uiItems).call(e,(function(t){return t.center})),r=lo(o).call(o,(function(t,e){return t+e}),0)/this.data.uiItems.length;_a(i=this.data.uiItems).call(i,(function(t){return t.data.end}))?(this.data.start=new Date(this.data.min),this.data.end=new Date(this.data.max)):(this.data.start=new Date(r),this.data.end=null)}},{key:"_getUiItems",value:function(){var t,e=this;return this.data.uiItems&&this.data.uiItems.length?gi(t=this.data.uiItems).call(t,(function(t){return t.cluster===e})):[]}},{key:"_createDomElement",value:function(){if(!this.dom){var t;if(this.dom={},this.dom.box=document.createElement("DIV"),this.dom.content=document.createElement("DIV"),this.dom.content.className="vis-item-content",this.dom.box.appendChild(this.dom.content),this.options.showStipes&&(this.dom.line=document.createElement("DIV"),this.dom.line.className="vis-cluster-line",this.dom.line.style.display="none",this.dom.dot=document.createElement("DIV"),this.dom.dot.className="vis-cluster-dot",this.dom.dot.style.display="none"),this.options.fitOnDoubleClick)this.dom.box.ondblclick=xi(t=i.prototype._onDoubleClick).call(t,this);this.dom.box["vis-item"]=this,this.dirty=!0}}},{key:"_appendDomElement",value:function(){if(!this.parent)throw new Error("Cannot redraw item: no parent attached");if(!this.dom.box.parentNode){var t=this.parent.dom.foreground;if(!t)throw new Error("Cannot redraw item: parent has no foreground container element");t.appendChild(this.dom.box)}var e=this.parent.dom.background;if(this.options.showStipes){if(!this.dom.line.parentNode){if(!e)throw new Error("Cannot redraw item: parent has no background container element");e.appendChild(this.dom.line)}if(!this.dom.dot.parentNode){var i=this.parent.dom.axis;if(!e)throw new Error("Cannot redraw item: parent has no axis container element");i.appendChild(this.dom.dot)}}this.displayed=!0}},{key:"_updateDirtyDomComponents",value:function(){if(this.dirty){this._updateContents(this.dom.content),this._updateDataAttributes(this.dom.box),this._updateStyle(this.dom.box);var t=this.baseClassName+" "+(this.data.className?" "+this.data.className:"")+(this.selected?" vis-selected":"")+" vis-readonly";this.dom.box.className="vis-item "+t,this.options.showStipes&&(this.dom.line.className="vis-item vis-cluster-line "+(this.selected?" vis-selected":""),this.dom.dot.className="vis-item vis-cluster-dot "+(this.selected?" vis-selected":"")),this.data.end&&(this.dom.content.style.maxWidth="none")}}},{key:"_getDomComponentsSizes",value:function(){var t={previous:{right:this.dom.box.style.right,left:this.dom.box.style.left},box:{width:this.dom.box.offsetWidth,height:this.dom.box.offsetHeight}};return this.options.showStipes&&(t.dot={height:this.dom.dot.offsetHeight,width:this.dom.dot.offsetWidth},t.line={width:this.dom.line.offsetWidth}),t}},{key:"_updateDomComponentsSizes",value:function(t){this.options.rtl?this.dom.box.style.right="0px":this.dom.box.style.left="0px",this.data.end?this.minWidth=t.box.width:this.width=t.box.width,this.height=t.box.height,this.options.rtl?this.dom.box.style.right=t.previous.right:this.dom.box.style.left=t.previous.left,this.dirty=!1}},{key:"_repaintDomAdditionals",value:function(){this._repaintOnItemUpdateTimeTooltip(this.dom.box)}},{key:"_isStipeVisible",value:function(){return this.minWidth>=this.width||!this.data.end}},{key:"_getFitRange",value:function(){var t=.05*(this.data.max-this.data.min)/2;return{fitStart:this.data.min-t,fitEnd:this.data.max+t}}},{key:"_fit",value:function(){if(this.emitter){var t=this._getFitRange(),e=t.fitStart,i=t.fitEnd,n={start:new Date(e),end:new Date(i),animation:!0};this.emitter.emit("fit",n)}}},{key:"_getItemData",value:function(){return this.data}}]),i}();function qu(t,e){var i;if(void 0===Gr||null==bo(t)){if(Di(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return Ku(t,e);var n=Ar(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Mo(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Ku(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var r,s=!0,a=!1;return{s:function(){i=yo(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,r=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw r}}}}function Ku(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}Xu.prototype.baseClassName="vis-item vis-range vis-cluster";var $u="__ungrouped__",Zu=function(){function t(e){Ci(this,t),this.itemSet=e,this.groups={},this.cache={},this.cache[-1]=[]}return Ii(t,[{key:"createClusterItem",value:function(t,e,i){return new Xu(t,e,i)}},{key:"setItems",value:function(t,e){this.items=t||[],this.dataChanged=!0,this.applyOnChangedLevel=!1,e&&e.applyOnChangedLevel&&(this.applyOnChangedLevel=e.applyOnChangedLevel)}},{key:"updateData",value:function(){this.dataChanged=!0,this.applyOnChangedLevel=!1}},{key:"getClusters",value:function(t,e,i){var n="boolean"==typeof i?{}:i,o=n.maxItems,r=n.clusterCriteria;r||(r=function(){return!0}),o=o||1;var s=-1,a=0;if(e>0){if(e>=1)return[];s=Math.abs(Math.round(Math.log(100/e)/Math.log(2))),a=Math.abs(Math.pow(2,s))}if(this.dataChanged){var l=s!=this.cacheLevel;(!this.applyOnChangedLevel||l)&&(this._dropLevelsCache(),this._filterData())}this.cacheLevel=s;var h=this.cache[s];if(!h){for(var u in h=[],this.groups)if(this.groups.hasOwnProperty(u))for(var d=this.groups[u],c=d.length,p=0;p<c;){for(var m=d[p],f=1,g=p-1;g>=0&&m.center-d[g].center<a/2;)!d[g].cluster&&r(m.data,d[g].data)&&f++,g--;for(var v=p+1;v<d.length&&d[v].center-m.center<a/2;)r(m.data,d[v].data)&&f++,v++;for(var y=h.length-1;y>=0&&m.center-h[y].center<a;)m.group==h[y].group&&r(m.data,h[y].data)&&f++,y--;if(f>o){for(var b=f-o+1,w=[],_=p;w.length<b&&_<d.length;)r(d[p].data,d[_].data)&&w.push(d[_]),_++;var k=this.itemSet.getGroupId(m.data),x=this.itemSet.groups[k]||this.itemSet.groups[$u],S=this._getClusterForItems(w,x,t,i);h.push(S),p+=b}else delete m.cluster,p+=1}this.cache[s]=h}return h}},{key:"_filterData",value:function(){var t={};this.groups=t;for(var e=0,i=Zo(this.items);e<i.length;e++){var n=i[e],o=n.parent?n.parent.groupId:"",r=t[o];r||(r=[],t[o]=r),r.push(n),n.data.start&&(n.data.end?n.center=(n.data.start.valueOf()+n.data.end.valueOf())/2:n.center=n.data.start.valueOf())}for(var s in t){var a;if(t.hasOwnProperty(s))qs(a=t[s]).call(a,(function(t,e){return t.center-e.center}))}this.dataChanged=!1}},{key:"_getClusterForItems",value:function(t,e,i,n){var o,r,s=fo(o=i||[]).call(o,(function(t){var e;return{cluster:t,itemsIds:new Yh(fo(e=t.data.uiItems).call(e,(function(t){return t.id})))}}));if(s.length){var a,l=qu(s);try{var h=function(){var e=a.value;if(e.itemsIds.size===t.length&&Yu(t).call(t,(function(t){return e.itemsIds.has(t.id)})))return r=e.cluster,"break"};for(l.s();!(a=l.n()).done;){if("break"===h())break}}catch(t){l.e(t)}finally{l.f()}}if(r)return r.setUiItems(t),r.group!==e&&(r.group&&r.group.remove(r),e&&(e.add(r),r.group=e)),r;var u=n.titleTemplate||"",d={toScreen:this.itemSet.body.util.toScreen,toTime:this.itemSet.body.util.toTime},c=u.replace(/{count}/,t.length),p='<div title="'+c+'">'+t.length+"</div>",m=ur({},n,this.itemSet.options),f={content:p,title:c,group:e,uiItems:t,eventEmitter:this.itemSet.body.emitter,range:this.itemSet.body.range};return r=this.createClusterItem(f,d,m),e&&(e.add(r),r.group=e),r.attach(),r}},{key:"_dropLevelsCache",value:function(){this.cache={},this.cacheLevel=-1,this.cache[this.cacheLevel]=[]}}]),t}();function Qu(t,e){var i;if(void 0===Gr||null==bo(t)){if(Di(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return Ju(t,e);var n=Ar(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Mo(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Ju(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var r,s=!0,a=!1;return{s:function(){i=yo(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,r=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw r}}}}function Ju(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}function td(t){var e=function(){if("undefined"==typeof Reflect||!Nt)return!1;if(Nt.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Nt(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=Yn(t);if(e){var o=Yn(this).constructor;i=Nt(n,arguments,o)}else i=n.apply(this,arguments);return zn(this,i)}}var ed="__background__",id=function(t){ji(o,Gs);var i=td(o);function o(t,e){var n;Ci(this,o),(n=i.call(this)).body=t,n.defaultOptions={type:null,orientation:{item:"bottom"},align:"auto",stack:!0,stackSubgroups:!0,groupOrderSwap:function(t,e,i){var n=e.order;e.order=t.order,t.order=n},groupOrder:"order",selectable:!0,multiselect:!1,longSelectPressTime:251,itemsAlwaysDraggable:{item:!1,range:!1},editable:{updateTime:!1,updateGroup:!1,add:!1,remove:!1,overrideItems:!1},groupEditable:{order:!1,add:!1,remove:!1},snap:sh.snap,onDropObjectOnItem:function(t,e,i){i(e)},onAdd:function(t,e){e(t)},onUpdate:function(t,e){e(t)},onMove:function(t,e){e(t)},onRemove:function(t,e){e(t)},onMoving:function(t,e){e(t)},onAddGroup:function(t,e){e(t)},onMoveGroup:function(t,e){e(t)},onRemoveGroup:function(t,e){e(t)},margin:{item:{horizontal:10,vertical:10},axis:20},showTooltips:!0,tooltip:{followMouse:!1,overflowMethod:"flip",delay:500},tooltipOnItemUpdateTime:!1},n.options=Os.extend({},n.defaultOptions),n.options.rtl=e.rtl,n.options.onTimeout=e.onTimeout,n.conversion={toScreen:t.util.toScreen,toTime:t.util.toTime},n.dom={},n.props={},n.hammer=null;var r=Mi(n);return n.itemsData=null,n.groupsData=null,n.itemsSettingTime=null,n.initialItemSetDrawn=!1,n.userContinueNotBail=null,n.sequentialSelection=!1,n.itemListeners={add:function(t,e,i){r._onAdd(e.items),r.options.cluster&&r.clusterGenerator.setItems(r.items,{applyOnChangedLevel:!1}),r.redraw()},update:function(t,e,i){r._onUpdate(e.items),r.options.cluster&&r.clusterGenerator.setItems(r.items,{applyOnChangedLevel:!1}),r.redraw()},remove:function(t,e,i){r._onRemove(e.items),r.options.cluster&&r.clusterGenerator.setItems(r.items,{applyOnChangedLevel:!1}),r.redraw()}},n.groupListeners={add:function(t,e,i){if(r._onAddGroups(e.items),r.groupsData&&r.groupsData.length>0){var n,o=r.groupsData.getDataSet();ni(n=o.get()).call(n,(function(t){if(t.nestedGroups){var e;0!=t.showNested&&(t.showNested=!0);var n=[];ni(e=t.nestedGroups).call(e,(function(e){var i=o.get(e);i&&(i.nestedInGroup=t.id,0==t.showNested&&(i.visible=!1),n=zr(n).call(n,i))})),o.update(n,i)}}))}},update:function(t,e,i){r._onUpdateGroups(e.items)},remove:function(t,e,i){r._onRemoveGroups(e.items)}},n.items={},n.groups={},n.groupIds=[],n.selection=[],n.popup=null,n.popupTimer=null,n.touchParams={},n.groupTouchParams={group:null,isDragging:!1},n._create(),n.setOptions(e),n.clusters=[],n}return Ii(o,[{key:"_create",value:function(){var t,e,i,n,o,r,s,a,l,h,u,d,c,p,m,f=this,g=document.createElement("div");g.className="vis-itemset",g["vis-itemset"]=this,this.dom.frame=g;var v=document.createElement("div");v.className="vis-background",g.appendChild(v),this.dom.background=v;var y=document.createElement("div");y.className="vis-foreground",g.appendChild(y),this.dom.foreground=y;var b=document.createElement("div");b.className="vis-axis",this.dom.axis=b;var w=document.createElement("div");w.className="vis-labelset",this.dom.labelSet=w,this._updateUngrouped();var _=new Du(ed,null,this);_.show(),this.groups[ed]=_,this.hammer=new oh(this.body.dom.centerContainer),this.hammer.on("hammer.input",(function(t){t.isFirst&&f._onTouch(t)})),this.hammer.on("panstart",xi(t=this._onDragStart).call(t,this)),this.hammer.on("panmove",xi(e=this._onDrag).call(e,this)),this.hammer.on("panend",xi(i=this._onDragEnd).call(i,this)),this.hammer.get("pan").set({threshold:5,direction:oh.ALL}),this.hammer.on("tap",xi(n=this._onSelectItem).call(n,this)),this.hammer.on("press",xi(o=this._onMultiSelectItem).call(o,this)),this.hammer.on("doubletap",xi(r=this._onAddItem).call(r,this)),this.options.rtl?this.groupHammer=new oh(this.body.dom.rightContainer):this.groupHammer=new oh(this.body.dom.leftContainer),this.groupHammer.on("tap",xi(s=this._onGroupClick).call(s,this)),this.groupHammer.on("panstart",xi(a=this._onGroupDragStart).call(a,this)),this.groupHammer.on("panmove",xi(l=this._onGroupDrag).call(l,this)),this.groupHammer.on("panend",xi(h=this._onGroupDragEnd).call(h,this)),this.groupHammer.get("pan").set({threshold:5,direction:oh.DIRECTION_VERTICAL}),this.body.dom.centerContainer.addEventListener("mouseover",xi(u=this._onMouseOver).call(u,this)),this.body.dom.centerContainer.addEventListener("mouseout",xi(d=this._onMouseOut).call(d,this)),this.body.dom.centerContainer.addEventListener("mousemove",xi(c=this._onMouseMove).call(c,this)),this.body.dom.centerContainer.addEventListener("contextmenu",xi(p=this._onDragEnd).call(p,this)),this.body.dom.centerContainer.addEventListener("mousewheel",xi(m=this._onMouseWheel).call(m,this)),this.show()}},{key:"setOptions",value:function(t){var e=this;if(t){var i,n;Os.selectiveExtend(["type","rtl","align","order","stack","stackSubgroups","selectable","multiselect","sequentialSelection","multiselectPerGroup","longSelectPressTime","groupOrder","dataAttributes","template","groupTemplate","visibleFrameTemplate","hide","snap","groupOrderSwap","showTooltips","tooltip","tooltipOnItemUpdateTime","groupHeightMode","onTimeout"],this.options,t),"itemsAlwaysDraggable"in t&&("boolean"==typeof t.itemsAlwaysDraggable?(this.options.itemsAlwaysDraggable.item=t.itemsAlwaysDraggable,this.options.itemsAlwaysDraggable.range=!1):"object"===Fn(t.itemsAlwaysDraggable)&&(Os.selectiveExtend(["item","range"],this.options.itemsAlwaysDraggable,t.itemsAlwaysDraggable),this.options.itemsAlwaysDraggable.item||(this.options.itemsAlwaysDraggable.range=!1))),"sequentialSelection"in t&&"boolean"==typeof t.sequentialSelection&&(this.options.sequentialSelection=t.sequentialSelection),"orientation"in t&&("string"==typeof t.orientation?this.options.orientation.item="top"===t.orientation?"top":"bottom":"object"===Fn(t.orientation)&&"item"in t.orientation&&(this.options.orientation.item=t.orientation.item)),"margin"in t&&("number"==typeof t.margin?(this.options.margin.axis=t.margin,this.options.margin.item.horizontal=t.margin,this.options.margin.item.vertical=t.margin):"object"===Fn(t.margin)&&(Os.selectiveExtend(["axis"],this.options.margin,t.margin),"item"in t.margin&&("number"==typeof t.margin.item?(this.options.margin.item.horizontal=t.margin.item,this.options.margin.item.vertical=t.margin.item):"object"===Fn(t.margin.item)&&Os.selectiveExtend(["horizontal","vertical"],this.options.margin.item,t.margin.item)))),ni(i=["locale","locales"]).call(i,(function(i){i in t&&(e.options[i]=t[i])})),"editable"in t&&("boolean"==typeof t.editable?(this.options.editable.updateTime=t.editable,this.options.editable.updateGroup=t.editable,this.options.editable.add=t.editable,this.options.editable.remove=t.editable,this.options.editable.overrideItems=!1):"object"===Fn(t.editable)&&Os.selectiveExtend(["updateTime","updateGroup","add","remove","overrideItems"],this.options.editable,t.editable)),"groupEditable"in t&&("boolean"==typeof t.groupEditable?(this.options.groupEditable.order=t.groupEditable,this.options.groupEditable.add=t.groupEditable,this.options.groupEditable.remove=t.groupEditable):"object"===Fn(t.groupEditable)&&Os.selectiveExtend(["order","add","remove"],this.options.groupEditable,t.groupEditable));ni(n=["onDropObjectOnItem","onAdd","onUpdate","onRemove","onMove","onMoving","onAddGroup","onMoveGroup","onRemoveGroup"]).call(n,(function(i){var n=t[i];if(n){var o;if("function"!=typeof n)throw new Error(zr(o="option ".concat(i," must be a function ")).call(o,i,"(item, callback)"));e.options[i]=n}})),t.cluster?(ur(this.options,{cluster:t.cluster}),this.clusterGenerator||(this.clusterGenerator=new Zu(this)),this.clusterGenerator.setItems(this.items,{applyOnChangedLevel:!1}),this.markDirty({refreshItems:!0,restackGroups:!0}),this.redraw()):this.clusterGenerator?(this._detachAllClusters(),this.clusters=[],this.clusterGenerator=null,this.options.cluster=void 0,this.markDirty({refreshItems:!0,restackGroups:!0}),this.redraw()):this.markDirty()}}},{key:"markDirty",value:function(t){this.groupIds=[],t&&(t.refreshItems&&ni(Os).call(Os,this.items,(function(t){t.dirty=!0,t.displayed&&t.redraw()})),t.restackGroups&&ni(Os).call(Os,this.groups,(function(t,e){e!==ed&&(t.stackDirty=!0)})))}},{key:"destroy",value:function(){this.clearPopupTimer(),this.hide(),this.setItems(null),this.setGroups(null),this.hammer&&this.hammer.destroy(),this.groupHammer&&this.groupHammer.destroy(),this.hammer=null,this.body=null,this.conversion=null}},{key:"hide",value:function(){this.dom.frame.parentNode&&this.dom.frame.parentNode.removeChild(this.dom.frame),this.dom.axis.parentNode&&this.dom.axis.parentNode.removeChild(this.dom.axis),this.dom.labelSet.parentNode&&this.dom.labelSet.parentNode.removeChild(this.dom.labelSet)}},{key:"show",value:function(){this.dom.frame.parentNode||this.body.dom.center.appendChild(this.dom.frame),this.dom.axis.parentNode||this.body.dom.backgroundVertical.appendChild(this.dom.axis),this.dom.labelSet.parentNode||(this.options.rtl?this.body.dom.right.appendChild(this.dom.labelSet):this.body.dom.left.appendChild(this.dom.labelSet))}},{key:"setPopupTimer",value:function(t){if(this.clearPopupTimer(),t){var e=this.options.tooltip.delay||"number"==typeof this.options.tooltip.delay?this.options.tooltip.delay:500;this.popupTimer=wi((function(){t.show()}),e)}}},{key:"clearPopupTimer",value:function(){null!=this.popupTimer&&(clearTimeout(this.popupTimer),this.popupTimer=null)}},{key:"setSelection",value:function(t){var e;null==t&&(t=[]),Di(t)||(t=[t]);var i,n=Qu(gi(e=this.selection).call(e,(function(e){return-1===sr(t).call(t,e)})));try{for(n.s();!(i=n.n()).done;){var o=i.value,r=this.getItemById(o);r&&r.unselect()}}catch(t){n.e(t)}finally{n.f()}this.selection=Lr(t);var s,a=Qu(t);try{for(a.s();!(s=a.n()).done;){var l=s.value,h=this.getItemById(l);h&&h.select()}}catch(t){a.e(t)}finally{a.f()}}},{key:"getSelection",value:function(){var t;return zr(t=this.selection).call(t,[])}},{key:"getVisibleItems",value:function(){var t,e,i=this.body.range.getRange();this.options.rtl?(t=this.body.util.toScreen(i.start),e=this.body.util.toScreen(i.end)):(e=this.body.util.toScreen(i.start),t=this.body.util.toScreen(i.end));var n=[];for(var o in this.groups)if(this.groups.hasOwnProperty(o)){var r,s=this.groups[o],a=Qu(s.isVisible?s.visibleItems:[]);try{for(a.s();!(r=a.n()).done;){var l=r.value;this.options.rtl?l.right<e&&l.right+l.width>t&&n.push(l.id):l.left<t&&l.left+l.width>e&&n.push(l.id)}}catch(t){a.e(t)}finally{a.f()}}return n}},{key:"getVisibleGroups",value:function(){var t=[];for(var e in this.groups){if(this.groups.hasOwnProperty(e))this.groups[e].isVisible&&t.push(e)}return t}},{key:"getItemById",value:function(t){var e;return this.items[t]||Kh(e=this.clusters).call(e,(function(e){return e.id===t}))}},{key:"_deselect",value:function(t){for(var e=this.selection,i=0,n=e.length;i<n;i++)if(e[i]==t){Oa(e).call(e,i,1);break}}},{key:"redraw",value:function(){var t=this,e=this.options.margin,i=this.body.range,n=Os.option.asSize,o=this.options,r=o.orientation.item,s=!1,a=this.dom.frame;this.props.top=this.body.domProps.top.height+this.body.domProps.border.top,this.options.rtl?this.props.right=this.body.domProps.right.width+this.body.domProps.border.right:this.props.left=this.body.domProps.left.width+this.body.domProps.border.left,a.className="vis-itemset",this.options.cluster&&this._clusterItems(),s=this._orderGroups()||s;var l=i.end-i.start,h=l!=this.lastVisibleInterval||this.props.width!=this.props.lastWidth,u=i.start!=this.lastRangeStart,d=o.stack!=this.lastStack,c=o.stackSubgroups!=this.lastStackSubgroups,p=h||u||d||c;this.lastVisibleInterval=l,this.lastRangeStart=i.start,this.lastStack=o.stack,this.lastStackSubgroups=o.stackSubgroups,this.props.lastWidth=this.props.width;var m=this._firstGroup(),f={item:e.item,axis:e.axis},g={item:e.item,axis:e.item.vertical/2},v=0,y=e.axis+e.item.vertical;this.groups[ed].redraw(i,g,p);var b={},w=0;return ni(Os).call(Os,this.groups,(function(t,e){if(e!==ed){var n=t==m?f:g;b[e]=t.redraw(i,n,p,!0),w=b[e].length}})),w>0&&function(){for(var e={},i=function(t){ni(Os).call(Os,b,(function(i,n){e[n]=i[t]()}))},n=0;n<w;n++)i(n);ni(Os).call(Os,t.groups,(function(t,i){if(i!==ed){var n=e[i];s=n||s,v+=t.height}})),v=Math.max(v,y)}(),v=Math.max(v,y),a.style.height=n(v),this.props.width=a.offsetWidth,this.props.height=v,this.dom.axis.style.top=n("top"==r?this.body.domProps.top.height+this.body.domProps.border.top:this.body.domProps.top.height+this.body.domProps.centerContainer.height),this.options.rtl?this.dom.axis.style.right="0":this.dom.axis.style.left="0",this.hammer.get("press").set({time:this.options.longSelectPressTime}),this.initialItemSetDrawn=!0,s=this._isResized()||s}},{key:"_firstGroup",value:function(){var t="top"==this.options.orientation.item?0:this.groupIds.length-1,e=this.groupIds[t];return this.groups[e]||this.groups.__ungrouped__||null}},{key:"_updateUngrouped",value:function(){var t,e,i=this.groups.__ungrouped__;if(this.groupsData){if(i)for(e in i.dispose(),delete this.groups.__ungrouped__,this.items)if(this.items.hasOwnProperty(e)){(t=this.items[e]).parent&&t.parent.remove(t);var n=this.getGroupId(t.data),o=this.groups[n];o&&o.add(t)||t.hide()}}else if(!i){for(e in i=new xu(null,null,this),this.groups.__ungrouped__=i,this.items)this.items.hasOwnProperty(e)&&(t=this.items[e],i.add(t));i.show()}}},{key:"getLabelSet",value:function(){return this.dom.labelSet}},{key:"setItems",value:function(t){this.itemsSettingTime=new Date;var i,o=this,r=this.itemsData;if(t){if(!(t instanceof e||t instanceof n))throw new TypeError("Data must be an instance of DataSet or DataView");this.itemsData=Ts(t)}else this.itemsData=null;if(r&&(ni(Os).call(Os,this.itemListeners,(function(t,e){r.off(e,t)})),r.dispose(),i=r.getIds(),this._onRemove(i)),this.itemsData){var s=this.id;ni(Os).call(Os,this.itemListeners,(function(t,e){o.itemsData.on(e,t,s)})),i=this.itemsData.getIds(),this._onAdd(i),this._updateUngrouped()}this.body.emitter.emit("_change",{queue:!0})}},{key:"getItems",value:function(){return null!=this.itemsData?this.itemsData.rawDS:null}},{key:"setGroups",value:function(t){var i,o=this;if(this.groupsData&&(ni(Os).call(Os,this.groupListeners,(function(t,e){o.groupsData.off(e,t)})),i=this.groupsData.getIds(),this.groupsData=null,this._onRemoveGroups(i)),t){if(!(t instanceof e||t instanceof n))throw new TypeError("Data must be an instance of DataSet or DataView");this.groupsData=t}else this.groupsData=null;if(this.groupsData){var r,s=this.groupsData;this.groupsData instanceof n&&(s=this.groupsData.getDataSet()),ni(r=s.get()).call(r,(function(t){var e;t.nestedGroups&&ni(e=t.nestedGroups).call(e,(function(e){var i=s.get(e);i.nestedInGroup=t.id,0==t.showNested&&(i.visible=!1),s.update(i)}))}));var a=this.id;ni(Os).call(Os,this.groupListeners,(function(t,e){o.groupsData.on(e,t,a)})),i=this.groupsData.getIds(),this._onAddGroups(i)}this._updateUngrouped(),this._order(),this.options.cluster&&(this.clusterGenerator.updateData(),this._clusterItems(),this.markDirty({refreshItems:!0,restackGroups:!0})),this.body.emitter.emit("_change",{queue:!0})}},{key:"getGroups",value:function(){return this.groupsData}},{key:"removeItem",value:function(t){var e=this,i=this.itemsData.get(t);i&&this.options.onRemove(i,(function(i){i&&e.itemsData.remove(t)}))}},{key:"_getType",value:function(t){return t.type||this.options.type||(t.end?"range":"box")}},{key:"getGroupId",value:function(t){return"background"==this._getType(t)&&null==t.group?ed:this.groupsData?t.group:"__ungrouped__"}},{key:"_onUpdate",value:function(t){var e=this,i=this;ni(t).call(t,(function(t){var n,r=i.itemsData.get(t),s=i.items[t],a=r?i._getType(r):null,l=o.types[a];if(s&&(l&&s instanceof l?i._updateItem(s,r):(n=s.selected,i._removeItem(s),s=null)),!s&&r){if(!l)throw new TypeError('Unknown item type "'.concat(a,'"'));(s=new l(r,i.conversion,i.options)).id=t,i._addItem(s),n&&(e.selection.push(t),s.select())}})),this._order(),this.options.cluster&&(this.clusterGenerator.setItems(this.items,{applyOnChangedLevel:!1}),this._clusterItems()),this.body.emitter.emit("_change",{queue:!0})}},{key:"_onRemove",value:function(t){var e=0,i=this;ni(t).call(t,(function(t){var n=i.items[t];n&&(e++,i._removeItem(n))})),e&&(this._order(),this.body.emitter.emit("_change",{queue:!0}))}},{key:"_order",value:function(){ni(Os).call(Os,this.groups,(function(t){t.order()}))}},{key:"_onUpdateGroups",value:function(t){this._onAddGroups(t)}},{key:"_onAddGroups",value:function(t){var e=this;ni(t).call(t,(function(t){var i=e.groupsData.get(t),n=e.groups[t];if(n)n.setData(i);else{if("__ungrouped__"==t||t==ed)throw new Error("Illegal group id. ".concat(t," is a reserved id."));var o=Ao(e.options);for(var r in Os.extend(o,{height:null}),n=new xu(t,i,e),e.groups[t]=n,e.items)if(e.items.hasOwnProperty(r)){var s=e.items[r];s.data.group==t&&n.add(s)}n.order(),n.show()}})),this.body.emitter.emit("_change",{queue:!0})}},{key:"_onRemoveGroups",value:function(t){var e=this;ni(t).call(t,(function(t){var i=e.groups[t];i&&(i.dispose(),delete e.groups[t])})),this.options.cluster&&(this.clusterGenerator.updateData(),this._clusterItems()),this.markDirty({restackGroups:!!this.options.cluster}),this.body.emitter.emit("_change",{queue:!0})}},{key:"_orderGroups",value:function(){if(this.groupsData){var t=this.groupsData.getIds({order:this.options.groupOrder});t=this._orderNestedGroups(t);var e=!Os.equalArray(t,this.groupIds);if(e){var i=this.groups;ni(t).call(t,(function(t){i[t].hide()})),ni(t).call(t,(function(t){i[t].show()})),this.groupIds=t}return e}return!1}},{key:"_orderNestedGroups",value:function(t){var e=this;return function t(e,i){var n=[];return ni(i).call(i,(function(i){if(n.push(i),e.groupsData.get(i).nestedGroups){var o,r=fo(o=e.groupsData.get({filter:function(t){return t.nestedInGroup==i},order:e.options.groupOrder})).call(o,(function(t){return t.id}));n=zr(n).call(n,t(e,r))}})),n}(this,gi(t).call(t,(function(t){return!e.groupsData.get(t).nestedInGroup})))}},{key:"_addItem",value:function(t){this.items[t.id]=t;var e=this.getGroupId(t.data),i=this.groups[e];i?i&&i.data&&i.data.showNested&&(t.groupShowing=!0):t.groupShowing=!1,i&&i.add(t)}},{key:"_updateItem",value:function(t,e){t.setData(e);var i=this.getGroupId(t.data),n=this.groups[i];n?n&&n.data&&n.data.showNested&&(t.groupShowing=!0):t.groupShowing=!1}},{key:"_removeItem",value:function(t){var e,i;t.hide(),delete this.items[t.id];var n=sr(e=this.selection).call(e,t.id);-1!=n&&Oa(i=this.selection).call(i,n,1),t.parent&&t.parent.remove(t),null!=this.popup&&this.popup.hide()}},{key:"_constructByEndArray",value:function(t){for(var e=[],i=0;i<t.length;i++)t[i]instanceof Nu&&e.push(t[i]);return e}},{key:"_onTouch",value:function(t){this.touchParams.item=this.itemFromTarget(t),this.touchParams.dragLeftItem=t.target.dragLeftItem||!1,this.touchParams.dragRightItem=t.target.dragRightItem||!1,this.touchParams.itemProps=null}},{key:"_getGroupIndex",value:function(t){for(var e=0;e<this.groupIds.length;e++)if(t==this.groupIds[e])return e}},{key:"_onDragStart",value:function(t){var e=this;if(!this.touchParams.itemIsDragging){var i,n=this.touchParams.item||null,o=this;if(n&&(n.selected||this.options.itemsAlwaysDraggable.item)){if(this.options.editable.overrideItems&&!this.options.editable.updateTime&&!this.options.editable.updateGroup)return;if(null!=n.editable&&!n.editable.updateTime&&!n.editable.updateGroup&&!this.options.editable.overrideItems)return;var r=this.touchParams.dragLeftItem,s=this.touchParams.dragRightItem;if(this.touchParams.itemIsDragging=!0,this.touchParams.selectedItem=n,r)i={item:r,initialX:t.center.x,dragLeft:!0,data:this._cloneItemData(n.data)},this.touchParams.itemProps=[i];else if(s)i={item:s,initialX:t.center.x,dragRight:!0,data:this._cloneItemData(n.data)},this.touchParams.itemProps=[i];else if(this.options.editable.add&&(t.srcEvent.ctrlKey||t.srcEvent.metaKey))this._onDragStartAddItem(t);else{this.groupIds.length<1&&this.redraw();var a=this._getGroupIndex(n.data.group),l=this.options.itemsAlwaysDraggable.item&&!n.selected?[n.id]:this.getSelection();this.touchParams.itemProps=fo(l).call(l,(function(i){var n=o.items[i],r=o._getGroupIndex(n.data.group);return{item:n,initialX:t.center.x,groupOffset:a-r,data:e._cloneItemData(n.data)}}))}t.stopPropagation()}else this.options.editable.add&&(t.srcEvent.ctrlKey||t.srcEvent.metaKey)&&this._onDragStartAddItem(t)}}},{key:"_onDragStartAddItem",value:function(t){var e=this.options.snap||null,i=this.dom.frame.getBoundingClientRect(),n=this.options.rtl?i.right-t.center.x+10:t.center.x-i.left-10,o=this.body.util.toTime(n),r=this.body.util.getScale(),s=this.body.util.getStep(),a=e?e(o,r,s):o,l={type:"range",start:a,end:a,content:"new item"},h=eu();l[this.itemsData.idProp]=h;var u=this.groupFromTarget(t);u&&(l.group=u.groupId);var d=new Nu(l,this.conversion,this.options);d.id=h,d.data=this._cloneItemData(l),this._addItem(d),this.touchParams.selectedItem=d;var c={item:d,initialX:t.center.x,data:d.data};this.options.rtl?c.dragLeft=!0:c.dragRight=!0,this.touchParams.itemProps=[c],t.stopPropagation()}},{key:"_onDrag",value:function(t){var e=this;if(null!=this.popup&&this.options.showTooltips&&!this.popup.hidden){var i=this.body.dom.centerContainer,n=i.getBoundingClientRect();this.popup.setPosition(t.center.x-n.left+i.offsetLeft,t.center.y-n.top+i.offsetTop),this.popup.show()}if(this.touchParams.itemProps){var o;t.stopPropagation();var r=this,s=this.options.snap||null,a=this.body.dom.root.offsetLeft,l=this.options.rtl?a+this.body.domProps.right.width:a+this.body.domProps.left.width,h=this.body.util.getScale(),u=this.body.util.getStep(),d=this.touchParams.selectedItem,c=(this.options.editable.overrideItems||null==d.editable)&&this.options.editable.updateGroup||!this.options.editable.overrideItems&&null!=d.editable&&d.editable.updateGroup,p=null;if(c&&d&&null!=d.data.group){var m=r.groupFromTarget(t);m&&(p=this._getGroupIndex(m.groupId))}ni(o=this.touchParams.itemProps).call(o,(function(i){var n,o,a,m,f,g=r.body.util.toTime(t.center.x-l),v=r.body.util.toTime(i.initialX-l);n=e.options.rtl?-(g-v):g-v;var y=e._cloneItemData(i.item.data);if(null==i.item.editable||i.item.editable.updateTime||i.item.editable.updateGroup||r.options.editable.overrideItems){if((e.options.editable.overrideItems||null==d.editable)&&e.options.editable.updateTime||!e.options.editable.overrideItems&&null!=d.editable&&d.editable.updateTime)if(i.dragLeft)e.options.rtl?null!=y.end&&(a=Os.convert(i.data.end,"Date"),f=new Date(a.valueOf()+n),y.end=s?s(f,h,u):f):null!=y.start&&(o=Os.convert(i.data.start,"Date"),m=new Date(o.valueOf()+n),y.start=s?s(m,h,u):m);else if(i.dragRight)e.options.rtl?null!=y.start&&(o=Os.convert(i.data.start,"Date"),m=new Date(o.valueOf()+n),y.start=s?s(m,h,u):m):null!=y.end&&(a=Os.convert(i.data.end,"Date"),f=new Date(a.valueOf()+n),y.end=s?s(f,h,u):f);else if(null!=y.start)if(o=Os.convert(i.data.start,"Date").valueOf(),m=new Date(o+n),null!=y.end){var b=(a=Os.convert(i.data.end,"Date")).valueOf()-o.valueOf();y.start=s?s(m,h,u):m,y.end=new Date(y.start.valueOf()+b)}else y.start=s?s(m,h,u):m;if(c&&!i.dragLeft&&!i.dragRight&&null!=p&&null!=y.group){var w=p-i.groupOffset;w=Math.max(0,w),w=Math.min(r.groupIds.length-1,w),y.group=r.groupIds[w]}y=e._cloneItemData(y),r.options.onMoving(y,(function(t){t&&i.item.setData(e._cloneItemData(t,"Date"))}))}})),this.body.emitter.emit("_change")}}},{key:"_moveToGroup",value:function(t,e){var i=this.groups[e];if(i&&i.groupId!=t.data.group){var n=t.parent;n.remove(t),n.order(),t.data.group=i.groupId,i.add(t),i.order()}}},{key:"_onDragEnd",value:function(t){var e=this;if(this.touchParams.itemIsDragging=!1,this.touchParams.itemProps){t.stopPropagation();var i=this,n=this.touchParams.itemProps;this.touchParams.itemProps=null,ni(n).call(n,(function(t){var n=t.item.id;if(null!=i.itemsData.get(n)){var o=e._cloneItemData(t.item.data);i.options.onMove(o,(function(o){o?(o[e.itemsData.idProp]=n,e.itemsData.update(o)):(t.item.setData(t.data),i.body.emitter.emit("_change"))}))}else i.options.onAdd(t.item.data,(function(e){i._removeItem(t.item),e&&i.itemsData.add(e),i.body.emitter.emit("_change")}))}))}}},{key:"_onGroupClick",value:function(t){var e=this,i=this.groupFromTarget(t);wi((function(){e.toggleGroupShowNested(i)}),1)}},{key:"toggleGroupShowNested",value:function(t){var e,i=arguments.length>1&&void 0!==arguments[1]?arguments[1]:void 0;if(t&&t.nestedGroups){var n=this.groupsData.getDataSet();t.showNested=null!=i?!!i:!t.showNested;var o=n.get(t.groupId);o.showNested=t.showNested;for(var r=t.nestedGroups,s=r;s.length>0;){var a=s;s=[];for(var l=0;l<a.length;l++){var h=n.get(a[l]);h.nestedGroups&&(s=zr(s).call(s,h.nestedGroups))}s.length>0&&(r=zr(r).call(r,s))}var u=fo(e=n.get(r)).call(e,(function(t){return null==t.visible&&(t.visible=!0),t.visible=!!o.showNested,t}));n.update(zr(u).call(u,o)),o.showNested?(Os.removeClassName(t.dom.label,"collapsed"),Os.addClassName(t.dom.label,"expanded")):(Os.removeClassName(t.dom.label,"expanded"),Os.addClassName(t.dom.label,"collapsed"))}}},{key:"toggleGroupDragClassName",value:function(t){t.dom.label.classList.toggle("vis-group-is-dragging"),t.dom.foreground.classList.toggle("vis-group-is-dragging")}},{key:"_onGroupDragStart",value:function(t){this.groupTouchParams.isDragging||this.options.groupEditable.order&&(this.groupTouchParams.group=this.groupFromTarget(t),this.groupTouchParams.group&&(t.stopPropagation(),this.groupTouchParams.isDragging=!0,this.toggleGroupDragClassName(this.groupTouchParams.group),this.groupTouchParams.originalOrder=this.groupsData.getIds({order:this.options.groupOrder})))}},{key:"_onGroupDrag",value:function(t){if(this.options.groupEditable.order&&this.groupTouchParams.group){t.stopPropagation();var e=this.groupsData;this.groupsData instanceof n&&(e=this.groupsData.getDataSet());var i=this.groupFromTarget(t);if(i&&i.height!=this.groupTouchParams.group.height){var o=i.top<this.groupTouchParams.group.top,r=t.center?t.center.y:t.clientY,s=i.dom.foreground.getBoundingClientRect(),a=this.groupTouchParams.group.height;if(o){if(s.top+a<r)return}else{var l=i.height;if(s.top+l-a>r)return}}if(i&&i!=this.groupTouchParams.group){var h=e.get(i.groupId),u=e.get(this.groupTouchParams.group.groupId);u&&h&&(this.options.groupOrderSwap(u,h,e),e.update(u),e.update(h));var d=e.getIds({order:this.options.groupOrder});if(!Os.equalArray(d,this.groupTouchParams.originalOrder))for(var c=this.groupTouchParams.originalOrder,p=this.groupTouchParams.group.groupId,m=Math.min(c.length,d.length),f=0,g=0,v=0;f<m;){for(;f+g<m&&f+v<m&&d[f+g]==c[f+v];)f++;if(f+g>=m)break;if(d[f+g]==p)g=1;else if(c[f+v]==p)v=1;else{var y=sr(d).call(d,c[f+v]),b=e.get(d[f+g]),w=e.get(c[f+v]);this.options.groupOrderSwap(b,w,e),e.update(b),e.update(w);var _=d[f+g];d[f+g]=c[f+v],d[y]=_,f++}}}}}},{key:"_onGroupDragEnd",value:function(t){if(this.groupTouchParams.isDragging=!1,this.options.groupEditable.order&&this.groupTouchParams.group){t.stopPropagation();var e=this,i=e.groupTouchParams.group.groupId,n=e.groupsData.getDataSet(),o=Os.extend({},n.get(i));e.options.onMoveGroup(o,(function(t){if(t)t[n._idProp]=i,n.update(t);else{var o=n.getIds({order:e.options.groupOrder});if(!Os.equalArray(o,e.groupTouchParams.originalOrder))for(var r=e.groupTouchParams.originalOrder,s=Math.min(r.length,o.length),a=0;a<s;){for(;a<s&&o[a]==r[a];)a++;if(a>=s)break;var l=sr(o).call(o,r[a]),h=n.get(o[a]),u=n.get(r[a]);e.options.groupOrderSwap(h,u,n),n.update(h),n.update(u);var d=o[a];o[a]=r[a],o[l]=d,a++}}})),e.body.emitter.emit("groupDragged",{groupId:i}),this.toggleGroupDragClassName(this.groupTouchParams.group),this.groupTouchParams.group=null}}},{key:"_onSelectItem",value:function(t){if(this.options.selectable){var e=t.srcEvent&&(t.srcEvent.ctrlKey||t.srcEvent.metaKey),i=t.srcEvent&&t.srcEvent.shiftKey;if(e||i)this._onMultiSelectItem(t);else{var n=this.getSelection(),o=this.itemFromTarget(t),r=o&&o.selectable?[o.id]:[];this.setSelection(r);var s=this.getSelection();(s.length>0||n.length>0)&&this.body.emitter.emit("select",{items:s,event:t})}}}},{key:"_onMouseOver",value:function(t){var e=this.itemFromTarget(t);if(e&&e!==this.itemFromRelatedTarget(t)){var i=e.getTitle();if(this.options.showTooltips&&i){null==this.popup&&(this.popup=new ju(this.body.dom.root,this.options.tooltip.overflowMethod||"flip")),this.popup.setText(i);var n=this.body.dom.centerContainer,o=n.getBoundingClientRect();this.popup.setPosition(t.clientX-o.left+n.offsetLeft,t.clientY-o.top+n.offsetTop),this.setPopupTimer(this.popup)}else this.clearPopupTimer(),null!=this.popup&&this.popup.hide();this.body.emitter.emit("itemover",{item:e.id,event:t})}}},{key:"_onMouseOut",value:function(t){var e=this.itemFromTarget(t);e&&(e!==this.itemFromRelatedTarget(t)&&(this.clearPopupTimer(),null!=this.popup&&this.popup.hide(),this.body.emitter.emit("itemout",{item:e.id,event:t})))}},{key:"_onMouseMove",value:function(t){if(this.itemFromTarget(t)&&(null!=this.popupTimer&&this.setPopupTimer(this.popup),this.options.showTooltips&&this.options.tooltip.followMouse&&this.popup&&!this.popup.hidden)){var e=this.body.dom.centerContainer,i=e.getBoundingClientRect();this.popup.setPosition(t.clientX-i.left+e.offsetLeft,t.clientY-i.top+e.offsetTop),this.popup.show()}}},{key:"_onMouseWheel",value:function(t){this.touchParams.itemIsDragging&&this._onDragEnd(t)}},{key:"_onUpdateItem",value:function(t){if(this.options.selectable&&(this.options.editable.updateTime||this.options.editable.updateGroup)){var e=this;if(t){var i=e.itemsData.get(t.id);this.options.onUpdate(i,(function(t){t&&e.itemsData.update(t)}))}}}},{key:"_onDropObjectOnItem",value:function(t){var e=this.itemFromTarget(t),i=JSON.parse(t.dataTransfer.getData("text"));this.options.onDropObjectOnItem(i,e)}},{key:"_onAddItem",value:function(t){if(this.options.selectable&&this.options.editable.add){var e,i,n=this,o=this.options.snap||null,r=this.dom.frame.getBoundingClientRect(),s=this.options.rtl?r.right-t.center.x:t.center.x-r.left,a=this.body.util.toTime(s),l=this.body.util.getScale(),h=this.body.util.getStep();"drop"==t.type?((i=JSON.parse(t.dataTransfer.getData("text"))).content=i.content?i.content:"new item",i.start=i.start?i.start:o?o(a,l,h):a,i.type=i.type||"box",i[this.itemsData.idProp]=i.id||eu(),"range"!=i.type||i.end||(e=this.body.util.toTime(s+this.props.width/5),i.end=o?o(e,l,h):e)):((i={start:o?o(a,l,h):a,content:"new item"})[this.itemsData.idProp]=eu(),"range"===this.options.type&&(e=this.body.util.toTime(s+this.props.width/5),i.end=o?o(e,l,h):e));var u=this.groupFromTarget(t);u&&(i.group=u.groupId),i=this._cloneItemData(i),this.options.onAdd(i,(function(e){e&&(n.itemsData.add(e),"drop"==t.type&&n.setSelection([e.id]))}))}}},{key:"_onMultiSelectItem",value:function(t){var e=this;if(this.options.selectable){var i=this.itemFromTarget(t);if(i){var n=this.options.multiselect?this.getSelection():[];if((t.srcEvent&&t.srcEvent.shiftKey||!1||this.options.sequentialSelection)&&this.options.multiselect){var r=this.itemsData.get(i.id).group,s=void 0;this.options.multiselectPerGroup&&n.length>0&&(s=this.itemsData.get(n[0]).group),this.options.multiselectPerGroup&&null!=s&&s!=r||n.push(i.id);var a=o._getItemRange(this.itemsData.get(n));if(!this.options.multiselectPerGroup||s==r)for(var l in n=[],this.items)if(this.items.hasOwnProperty(l)){var h=this.items[l],u=h.data.start,d=void 0!==h.data.end?h.data.end:u;!(u>=a.min&&d<=a.max)||this.options.multiselectPerGroup&&s!=this.itemsData.get(h.id).group||h instanceof Lu||n.push(h.id)}}else{var c=sr(n).call(n,i.id);-1==c?n.push(i.id):Oa(n).call(n,c,1)}var p=gi(n).call(n,(function(t){return e.getItemById(t).selectable}));this.setSelection(p),this.body.emitter.emit("select",{items:this.getSelection(),event:t})}}}},{key:"itemFromElement",value:function(t){for(var e=t;e;){if(e.hasOwnProperty("vis-item"))return e["vis-item"];e=e.parentNode}return null}},{key:"itemFromTarget",value:function(t){return this.itemFromElement(t.target)}},{key:"itemFromRelatedTarget",value:function(t){return this.itemFromElement(t.relatedTarget)}},{key:"groupFromTarget",value:function(t){var e=t.center?t.center.y:t.clientY,i=this.groupIds;i.length<=0&&this.groupsData&&(i=this.groupsData.getIds({order:this.options.groupOrder}));for(var n=0;n<i.length;n++){var o=i[n],r=this.groups[o],s=r.dom.foreground,a=s.getBoundingClientRect();if(e>=a.top&&e<a.top+s.offsetHeight)return r;if("top"===this.options.orientation.item){if(n===this.groupIds.length-1&&e>a.top)return r}else if(0===n&&e<a.top+s.offset)return r}return null}},{key:"_cloneItemData",value:function(t,e){var i=Os.extend({},t);return e||(e=this.itemsData.type),null!=i.start&&(i.start=Os.convert(i.start,e&&e.start||"Date")),null!=i.end&&(i.end=Os.convert(i.end,e&&e.end||"Date")),i}},{key:"_clusterItems",value:function(){if(this.options.cluster){var t=this.body.range.conversion(this.body.domProps.center.width).scale,e=this.clusterGenerator.getClusters(this.clusters,t,this.options.cluster);if(this.clusters!=e){if(this._detachAllClusters(),e){var i,n=Qu(e);try{for(n.s();!(i=n.n()).done;){i.value.attach()}}catch(t){n.e(t)}finally{n.f()}this.clusters=e}this._updateClusters(e)}}}},{key:"_detachAllClusters",value:function(){if(this.options.cluster&&this.clusters&&this.clusters.length){var t,e=Qu(this.clusters);try{for(e.s();!(t=e.n()).done;){t.value.detach()}}catch(t){e.e(t)}finally{e.f()}}}},{key:"_updateClusters",value:function(t){if(this.clusters&&this.clusters.length){var e,i,n=new Yh(fo(t).call(t,(function(t){return t.id}))),o=!1,r=Qu(gi(e=this.clusters).call(e,(function(t){return!n.has(t.id)})));try{for(r.s();!(i=r.n()).done;){var s,a,l=i.value,h=sr(s=this.selection).call(s,l.id);if(-1!==h)l.unselect(),Oa(a=this.selection).call(a,h,1),o=!0}}catch(t){r.e(t)}finally{r.f()}if(o){var u=this.getSelection();this.body.emitter.emit("select",{items:u,event:event})}}this.clusters=t||[]}}],[{key:"_getItemRange",value:function(t){var e=null,i=null;return ni(t).call(t,(function(t){(null==i||t.start<i)&&(i=t.start),null!=t.end?(null==e||t.end>e)&&(e=t.end):(null==e||t.start>e)&&(e=t.start)})),{min:i,max:e}}},{key:"itemSetFromTarget",value:function(t){for(var e=t.target;e;){if(e.hasOwnProperty("vis-itemset"))return e["vis-itemset"];e=e.parentNode}return null}}]),o}();id.types={background:Lu,box:Iu,range:Nu,point:Au},id.prototype._onAdd=id.prototype._onUpdate;var nd,od=!1,rd="background: #FFeeee; color: #dd0000",sd=function(){function t(){Ci(this,t)}return Ii(t,null,[{key:"validate",value:function(e,i,n){od=!1,nd=i;var o=i;return void 0!==n&&(o=i[n]),t.parse(e,o,[]),od}},{key:"parse",value:function(e,i,n){for(var o in e)e.hasOwnProperty(o)&&t.check(o,e,i,n)}},{key:"check",value:function(e,i,n,o){if(void 0!==n[e]||void 0!==n.__any__){var r=e,s=!0;void 0===n[e]&&void 0!==n.__any__&&(r="__any__",s="object"===t.getType(i[e]));var a=n[r];s&&void 0!==a.__type__&&(a=a.__type__),t.checkFields(e,i,n,r,a,o)}else t.getSuggestion(e,n,o)}},{key:"checkFields",value:function(e,i,n,o,r,s){var a=function(i){console.log("%c"+i+t.printLocation(s,e),rd)},l=t.getType(i[e]),h=r[l];void 0!==h?"array"===t.getType(h)&&-1===sr(h).call(h,i[e])?(a('Invalid option detected in "'+e+'". Allowed values are:'+t.print(h)+' not "'+i[e]+'". '),od=!0):"object"===l&&"__any__"!==o&&(s=Os.copyAndExtendArray(s,e),t.parse(i[e],n[o],s)):void 0===r.any&&(a('Invalid type received for "'+e+'". Expected: '+t.print(eo(r))+". Received ["+l+'] "'+i[e]+'"'),od=!0)}},{key:"getType",value:function(t){var e=Fn(t);return"object"===e?null===t?"null":t instanceof Boolean?"boolean":t instanceof Number?"number":t instanceof String?"string":Di(t)?"array":t instanceof Date?"date":void 0!==t.nodeType?"dom":!0===t._isAMomentObject?"moment":"object":"number"===e?"number":"boolean"===e?"boolean":"string"===e?"string":void 0===e?"undefined":e}},{key:"getSuggestion",value:function(e,i,n){var o,r=t.findInOptions(e,i,n,!1),s=t.findInOptions(e,nd,[],!0);o=void 0!==r.indexMatch?" in "+t.printLocation(r.path,e,"")+'Perhaps it was incomplete? Did you mean: "'+r.indexMatch+'"?\n\n':s.distance<=4&&r.distance>s.distance?" in "+t.printLocation(r.path,e,"")+"Perhaps it was misplaced? Matching option found at: "+t.printLocation(s.path,s.closestMatch,""):r.distance<=8?'. Did you mean "'+r.closestMatch+'"?'+t.printLocation(r.path,e):". Did you mean one of these: "+t.print(eo(i))+t.printLocation(n,e),console.log('%cUnknown option detected: "'+e+'"'+o,rd),od=!0}},{key:"findInOptions",value:function(e,i,n){var o=arguments.length>3&&void 0!==arguments[3]&&arguments[3],r=1e9,s="",a=[],l=e.toLowerCase(),h=void 0;for(var u in i){var d=void 0;if(void 0!==i[u].__type__&&!0===o){var c=t.findInOptions(e,i[u],Os.copyAndExtendArray(n,u));r>c.distance&&(s=c.closestMatch,a=c.path,r=c.distance,h=c.indexMatch)}else{var p;-1!==sr(p=u.toLowerCase()).call(p,l)&&(h=u),r>(d=t.levenshteinDistance(e,u))&&(s=u,a=Os.copyArray(n),r=d)}}return{closestMatch:s,path:a,distance:r,indexMatch:h}}},{key:"printLocation",value:function(t,e){for(var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:"Problem value found at: \n",n="\n\n"+i+"options = {\n",o=0;o<t.length;o++){for(var r=0;r<o+1;r++)n+="  ";n+=t[o]+": {\n"}for(var s=0;s<t.length+1;s++)n+="  ";n+=e+"\n";for(var a=0;a<t.length+1;a++){for(var l=0;l<t.length-a;l++)n+="  ";n+="}\n"}return n+"\n\n"}},{key:"print",value:function(t){return zs(t).replace(/(\")|(\[)|(\])|(,"__type__")/g,"").replace(/(\,)/g,", ")}},{key:"levenshteinDistance",value:function(t,e){if(0===t.length)return e.length;if(0===e.length)return t.length;var i,n,o=[];for(i=0;i<=e.length;i++)o[i]=[i];for(n=0;n<=t.length;n++)o[0][n]=n;for(i=1;i<=e.length;i++)for(n=1;n<=t.length;n++)e.charAt(i-1)==t.charAt(n-1)?o[i][n]=o[i-1][n-1]:o[i][n]=Math.min(o[i-1][n-1]+1,Math.min(o[i][n-1]+1,o[i-1][n]+1));return o[e.length][t.length]}}]),t}(),ad="string",ld="boolean",hd="number",ud="object",dd={configure:{enabled:{boolean:ld},filter:{boolean:ld,function:"function"},container:{dom:"dom"},__type__:{object:ud,boolean:ld,function:"function"}},align:{string:ad},alignCurrentTime:{string:ad,undefined:"undefined"},rtl:{boolean:ld,undefined:"undefined"},rollingMode:{follow:{boolean:ld},offset:{number:hd,undefined:"undefined"},__type__:{object:ud}},onTimeout:{timeoutMs:{number:hd},callback:{function:"function"},__type__:{object:ud}},verticalScroll:{boolean:ld,undefined:"undefined"},horizontalScroll:{boolean:ld,undefined:"undefined"},autoResize:{boolean:ld},throttleRedraw:{number:hd},clickToUse:{boolean:ld},dataAttributes:{string:ad,array:"array"},editable:{add:{boolean:ld,undefined:"undefined"},remove:{boolean:ld,undefined:"undefined"},updateGroup:{boolean:ld,undefined:"undefined"},updateTime:{boolean:ld,undefined:"undefined"},overrideItems:{boolean:ld,undefined:"undefined"},__type__:{boolean:ld,object:ud}},end:{number:hd,date:"date",string:ad,moment:"moment"},format:{minorLabels:{millisecond:{string:ad,undefined:"undefined"},second:{string:ad,undefined:"undefined"},minute:{string:ad,undefined:"undefined"},hour:{string:ad,undefined:"undefined"},weekday:{string:ad,undefined:"undefined"},day:{string:ad,undefined:"undefined"},week:{string:ad,undefined:"undefined"},month:{string:ad,undefined:"undefined"},year:{string:ad,undefined:"undefined"},__type__:{object:ud,function:"function"}},majorLabels:{millisecond:{string:ad,undefined:"undefined"},second:{string:ad,undefined:"undefined"},minute:{string:ad,undefined:"undefined"},hour:{string:ad,undefined:"undefined"},weekday:{string:ad,undefined:"undefined"},day:{string:ad,undefined:"undefined"},week:{string:ad,undefined:"undefined"},month:{string:ad,undefined:"undefined"},year:{string:ad,undefined:"undefined"},__type__:{object:ud,function:"function"}},__type__:{object:ud}},moment:{function:"function"},groupHeightMode:{string:ad},groupOrder:{string:ad,function:"function"},groupEditable:{add:{boolean:ld,undefined:"undefined"},remove:{boolean:ld,undefined:"undefined"},order:{boolean:ld,undefined:"undefined"},__type__:{boolean:ld,object:ud}},groupOrderSwap:{function:"function"},height:{string:ad,number:hd},hiddenDates:{start:{date:"date",number:hd,string:ad,moment:"moment"},end:{date:"date",number:hd,string:ad,moment:"moment"},repeat:{string:ad},__type__:{object:ud,array:"array"}},itemsAlwaysDraggable:{item:{boolean:ld,undefined:"undefined"},range:{boolean:ld,undefined:"undefined"},__type__:{boolean:ld,object:ud}},limitSize:{boolean:ld},locale:{string:ad},locales:{__any__:{any:"any"},__type__:{object:ud}},longSelectPressTime:{number:hd},margin:{axis:{number:hd},item:{horizontal:{number:hd,undefined:"undefined"},vertical:{number:hd,undefined:"undefined"},__type__:{object:ud,number:hd}},__type__:{object:ud,number:hd}},max:{date:"date",number:hd,string:ad,moment:"moment"},maxHeight:{number:hd,string:ad},maxMinorChars:{number:hd},min:{date:"date",number:hd,string:ad,moment:"moment"},minHeight:{number:hd,string:ad},moveable:{boolean:ld},multiselect:{boolean:ld},multiselectPerGroup:{boolean:ld},onAdd:{function:"function"},onDropObjectOnItem:{function:"function"},onUpdate:{function:"function"},onMove:{function:"function"},onMoving:{function:"function"},onRemove:{function:"function"},onAddGroup:{function:"function"},onMoveGroup:{function:"function"},onRemoveGroup:{function:"function"},onInitialDrawComplete:{function:"function"},order:{function:"function"},orientation:{axis:{string:ad,undefined:"undefined"},item:{string:ad,undefined:"undefined"},__type__:{string:ad,object:ud}},selectable:{boolean:ld},sequentialSelection:{boolean:ld},showCurrentTime:{boolean:ld},showMajorLabels:{boolean:ld},showMinorLabels:{boolean:ld},showWeekScale:{boolean:ld},stack:{boolean:ld},stackSubgroups:{boolean:ld},cluster:{maxItems:{number:hd,undefined:"undefined"},titleTemplate:{string:ad,undefined:"undefined"},clusterCriteria:{function:"function",undefined:"undefined"},showStipes:{boolean:ld,undefined:"undefined"},fitOnDoubleClick:{boolean:ld,undefined:"undefined"},__type__:{boolean:ld,object:ud}},snap:{function:"function",null:"null"},start:{date:"date",number:hd,string:ad,moment:"moment"},template:{function:"function"},loadingScreenTemplate:{function:"function"},groupTemplate:{function:"function"},visibleFrameTemplate:{string:ad,function:"function"},showTooltips:{boolean:ld},tooltip:{followMouse:{boolean:ld},overflowMethod:{string:["cap","flip","none"]},delay:{number:hd},template:{function:"function"},__type__:{object:ud}},tooltipOnItemUpdateTime:{template:{function:"function"},__type__:{boolean:ld,object:ud}},timeAxis:{scale:{string:ad,undefined:"undefined"},step:{number:hd,undefined:"undefined"},__type__:{object:ud}},type:{string:ad},width:{string:ad,number:hd},preferZoom:{boolean:ld},zoomable:{boolean:ld},zoomKey:{string:["ctrlKey","altKey","shiftKey","metaKey",""]},zoomFriction:{number:hd},zoomMax:{number:hd},zoomMin:{number:hd},__type__:{object:ud}},cd={global:{align:["center","left","right"],alignCurrentTime:["none","year","month","quarter","week","isoWeek","day","date","hour","minute","second"],direction:!1,autoResize:!0,clickToUse:!1,editable:{add:!1,remove:!1,updateGroup:!1,updateTime:!1},end:"",format:{minorLabels:{millisecond:"SSS",second:"s",minute:"HH:mm",hour:"HH:mm",weekday:"ddd D",day:"D",week:"w",month:"MMM",year:"YYYY"},majorLabels:{millisecond:"HH:mm:ss",second:"D MMMM HH:mm",minute:"ddd D MMMM",hour:"ddd D MMMM",weekday:"MMMM YYYY",day:"MMMM YYYY",week:"MMMM YYYY",month:"YYYY",year:""}},groupHeightMode:["auto","fixed","fitItems"],groupsDraggable:!1,height:"",locale:"",longSelectPressTime:251,margin:{axis:[20,0,100,1],item:{horizontal:[10,0,100,1],vertical:[10,0,100,1]}},max:"",maxHeight:"",maxMinorChars:[7,0,20,1],min:"",minHeight:"",moveable:!1,multiselect:!1,multiselectPerGroup:!1,orientation:{axis:["both","bottom","top"],item:["bottom","top"]},preferZoom:!1,selectable:!0,showCurrentTime:!1,showMajorLabels:!0,showMinorLabels:!0,stack:!0,stackSubgroups:!0,cluster:!1,start:"",showTooltips:!0,tooltip:{followMouse:!1,overflowMethod:"flip",delay:[500,0,99999,100]},tooltipOnItemUpdateTime:!1,type:["box","point","range","background"],width:"100%",zoomable:!0,zoomKey:["ctrlKey","altKey","shiftKey","metaKey",""],zoomMax:[31536e10,10,31536e10,1],zoomMin:[10,10,31536e10,1]}};q({target:"Array",proto:!0},{fill:function(t){for(var e=Jt(this),i=et(e.length),n=arguments.length,o=ot(n>1?arguments[1]:void 0,i),r=n>2?arguments[2]:void 0,s=void 0===r?i:ot(r,i);s>o;)e[o++]=t;return e}});var pd=Je("Array").fill,md=Array.prototype,fd=function(t){var e=t.fill;return t===md||t instanceof Array&&e===md.fill?pd:e},gd={black:"#000000",navy:"#000080",darkblue:"#00008B",mediumblue:"#0000CD",blue:"#0000FF",darkgreen:"#006400",green:"#008000",teal:"#008080",darkcyan:"#008B8B",deepskyblue:"#00BFFF",darkturquoise:"#00CED1",mediumspringgreen:"#00FA9A",lime:"#00FF00",springgreen:"#00FF7F",aqua:"#00FFFF",cyan:"#00FFFF",midnightblue:"#191970",dodgerblue:"#1E90FF",lightseagreen:"#20B2AA",forestgreen:"#228B22",seagreen:"#2E8B57",darkslategray:"#2F4F4F",limegreen:"#32CD32",mediumseagreen:"#3CB371",turquoise:"#40E0D0",royalblue:"#4169E1",steelblue:"#4682B4",darkslateblue:"#483D8B",mediumturquoise:"#48D1CC",indigo:"#4B0082",darkolivegreen:"#556B2F",cadetblue:"#5F9EA0",cornflowerblue:"#6495ED",mediumaquamarine:"#66CDAA",dimgray:"#696969",slateblue:"#6A5ACD",olivedrab:"#6B8E23",slategray:"#708090",lightslategray:"#778899",mediumslateblue:"#7B68EE",lawngreen:"#7CFC00",chartreuse:"#7FFF00",aquamarine:"#7FFFD4",maroon:"#800000",purple:"#800080",olive:"#808000",gray:"#808080",skyblue:"#87CEEB",lightskyblue:"#87CEFA",blueviolet:"#8A2BE2",darkred:"#8B0000",darkmagenta:"#8B008B",saddlebrown:"#8B4513",darkseagreen:"#8FBC8F",lightgreen:"#90EE90",mediumpurple:"#9370D8",darkviolet:"#9400D3",palegreen:"#98FB98",darkorchid:"#9932CC",yellowgreen:"#9ACD32",sienna:"#A0522D",brown:"#A52A2A",darkgray:"#A9A9A9",lightblue:"#ADD8E6",greenyellow:"#ADFF2F",paleturquoise:"#AFEEEE",lightsteelblue:"#B0C4DE",powderblue:"#B0E0E6",firebrick:"#B22222",darkgoldenrod:"#B8860B",mediumorchid:"#BA55D3",rosybrown:"#BC8F8F",darkkhaki:"#BDB76B",silver:"#C0C0C0",mediumvioletred:"#C71585",indianred:"#CD5C5C",peru:"#CD853F",chocolate:"#D2691E",tan:"#D2B48C",lightgrey:"#D3D3D3",palevioletred:"#D87093",thistle:"#D8BFD8",orchid:"#DA70D6",goldenrod:"#DAA520",crimson:"#DC143C",gainsboro:"#DCDCDC",plum:"#DDA0DD",burlywood:"#DEB887",lightcyan:"#E0FFFF",lavender:"#E6E6FA",darksalmon:"#E9967A",violet:"#EE82EE",palegoldenrod:"#EEE8AA",lightcoral:"#F08080",khaki:"#F0E68C",aliceblue:"#F0F8FF",honeydew:"#F0FFF0",azure:"#F0FFFF",sandybrown:"#F4A460",wheat:"#F5DEB3",beige:"#F5F5DC",whitesmoke:"#F5F5F5",mintcream:"#F5FFFA",ghostwhite:"#F8F8FF",salmon:"#FA8072",antiquewhite:"#FAEBD7",linen:"#FAF0E6",lightgoldenrodyellow:"#FAFAD2",oldlace:"#FDF5E6",red:"#FF0000",fuchsia:"#FF00FF",magenta:"#FF00FF",deeppink:"#FF1493",orangered:"#FF4500",tomato:"#FF6347",hotpink:"#FF69B4",coral:"#FF7F50",darkorange:"#FF8C00",lightsalmon:"#FFA07A",orange:"#FFA500",lightpink:"#FFB6C1",pink:"#FFC0CB",gold:"#FFD700",peachpuff:"#FFDAB9",navajowhite:"#FFDEAD",moccasin:"#FFE4B5",bisque:"#FFE4C4",mistyrose:"#FFE4E1",blanchedalmond:"#FFEBCD",papayawhip:"#FFEFD5",lavenderblush:"#FFF0F5",seashell:"#FFF5EE",cornsilk:"#FFF8DC",lemonchiffon:"#FFFACD",floralwhite:"#FFFAF0",snow:"#FFFAFA",yellow:"#FFFF00",lightyellow:"#FFFFE0",ivory:"#FFFFF0",white:"#FFFFFF"},vd=function(){function t(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:1;Ci(this,t),this.pixelRatio=e,this.generated=!1,this.centerCoordinates={x:144.5,y:144.5},this.r=289*.49,this.color={r:255,g:255,b:255,a:1},this.hueCircle=void 0,this.initialColor={r:255,g:255,b:255,a:1},this.previousColor=void 0,this.applied=!1,this.updateCallback=function(){},this.closeCallback=function(){},this._create()}return Ii(t,[{key:"insertTo",value:function(t){void 0!==this.hammer&&(this.hammer.destroy(),this.hammer=void 0),this.container=t,this.container.appendChild(this.frame),this._bindHammer(),this._setSize()}},{key:"setUpdateCallback",value:function(t){if("function"!=typeof t)throw new Error("Function attempted to set as colorPicker update callback is not a function.");this.updateCallback=t}},{key:"setCloseCallback",value:function(t){if("function"!=typeof t)throw new Error("Function attempted to set as colorPicker closing callback is not a function.");this.closeCallback=t}},{key:"_isColorString",value:function(t){if("string"==typeof t)return gd[t]}},{key:"setColor",value:function(t){var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];if("none"!==t){var i,n=this._isColorString(t);if(void 0!==n&&(t=n),!0===Os.isString(t)){if(!0===Os.isValidRGB(t)){var o=t.substr(4).substr(0,t.length-5).split(",");i={r:o[0],g:o[1],b:o[2],a:1}}else if(!0===Os.isValidRGBA(t)){var r=t.substr(5).substr(0,t.length-6).split(",");i={r:r[0],g:r[1],b:r[2],a:r[3]}}else if(!0===Os.isValidHex(t)){var s=Os.hexToRGB(t);i={r:s.r,g:s.g,b:s.b,a:1}}}else if(t instanceof Object&&void 0!==t.r&&void 0!==t.g&&void 0!==t.b){var a=void 0!==t.a?t.a:"1.0";i={r:t.r,g:t.g,b:t.b,a:a}}if(void 0===i)throw new Error("Unknown color passed to the colorPicker. Supported are strings: rgb, hex, rgba. Object: rgb ({r:r,g:g,b:b,[a:a]}). Supplied: "+zs(t));this._setColor(i,e)}}},{key:"show",value:function(){void 0!==this.closeCallback&&(this.closeCallback(),this.closeCallback=void 0),this.applied=!1,this.frame.style.display="block",this._generateHueCircle()}},{key:"_hide",value:function(){var t=this,e=!(arguments.length>0&&void 0!==arguments[0])||arguments[0];!0===e&&(this.previousColor=Os.extend({},this.color)),!0===this.applied&&this.updateCallback(this.initialColor),this.frame.style.display="none",wi((function(){void 0!==t.closeCallback&&(t.closeCallback(),t.closeCallback=void 0)}),0)}},{key:"_save",value:function(){this.updateCallback(this.color),this.applied=!1,this._hide()}},{key:"_apply",value:function(){this.applied=!0,this.updateCallback(this.color),this._updatePicker(this.color)}},{key:"_loadLast",value:function(){void 0!==this.previousColor?this.setColor(this.previousColor,!1):alert("There is no last color to load...")}},{key:"_setColor",value:function(t){var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];!0===e&&(this.initialColor=Os.extend({},t)),this.color=t;var i=Os.RGBToHSV(t.r,t.g,t.b),n=2*Math.PI,o=this.r*i.s,r=this.centerCoordinates.x+o*Math.sin(n*i.h),s=this.centerCoordinates.y+o*Math.cos(n*i.h);this.colorPickerSelector.style.left=r-.5*this.colorPickerSelector.clientWidth+"px",this.colorPickerSelector.style.top=s-.5*this.colorPickerSelector.clientHeight+"px",this._updatePicker(t)}},{key:"_setOpacity",value:function(t){this.color.a=t/100,this._updatePicker(this.color)}},{key:"_setBrightness",value:function(t){var e=Os.RGBToHSV(this.color.r,this.color.g,this.color.b);e.v=t/100;var i=Os.HSVToRGB(e.h,e.s,e.v);i.a=this.color.a,this.color=i,this._updatePicker()}},{key:"_updatePicker",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.color,e=Os.RGBToHSV(t.r,t.g,t.b),i=this.colorPickerCanvas.getContext("2d");void 0===this.pixelRation&&(this.pixelRatio=(window.devicePixelRatio||1)/(i.webkitBackingStorePixelRatio||i.mozBackingStorePixelRatio||i.msBackingStorePixelRatio||i.oBackingStorePixelRatio||i.backingStorePixelRatio||1)),i.setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0);var n=this.colorPickerCanvas.clientWidth,o=this.colorPickerCanvas.clientHeight;i.clearRect(0,0,n,o),i.putImageData(this.hueCircle,0,0),i.fillStyle="rgba(0,0,0,"+(1-e.v)+")",i.circle(this.centerCoordinates.x,this.centerCoordinates.y,this.r),fd(i).call(i),this.brightnessRange.value=100*e.v,this.opacityRange.value=100*t.a,this.initialColorDiv.style.backgroundColor="rgba("+this.initialColor.r+","+this.initialColor.g+","+this.initialColor.b+","+this.initialColor.a+")",this.newColorDiv.style.backgroundColor="rgba("+this.color.r+","+this.color.g+","+this.color.b+","+this.color.a+")"}},{key:"_setSize",value:function(){this.colorPickerCanvas.style.width="100%",this.colorPickerCanvas.style.height="100%",this.colorPickerCanvas.width=289*this.pixelRatio,this.colorPickerCanvas.height=289*this.pixelRatio}},{key:"_create",value:function(){var t,e,i,n;if(this.frame=document.createElement("div"),this.frame.className="vis-color-picker",this.colorPickerDiv=document.createElement("div"),this.colorPickerSelector=document.createElement("div"),this.colorPickerSelector.className="vis-selector",this.colorPickerDiv.appendChild(this.colorPickerSelector),this.colorPickerCanvas=document.createElement("canvas"),this.colorPickerDiv.appendChild(this.colorPickerCanvas),this.colorPickerCanvas.getContext){var o=this.colorPickerCanvas.getContext("2d");this.pixelRatio=(window.devicePixelRatio||1)/(o.webkitBackingStorePixelRatio||o.mozBackingStorePixelRatio||o.msBackingStorePixelRatio||o.oBackingStorePixelRatio||o.backingStorePixelRatio||1),this.colorPickerCanvas.getContext("2d").setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0)}else{var r=document.createElement("DIV");r.style.color="red",r.style.fontWeight="bold",r.style.padding="10px",r.innerHTML="Error: your browser does not support HTML canvas",this.colorPickerCanvas.appendChild(r)}this.colorPickerDiv.className="vis-color",this.opacityDiv=document.createElement("div"),this.opacityDiv.className="vis-opacity",this.brightnessDiv=document.createElement("div"),this.brightnessDiv.className="vis-brightness",this.arrowDiv=document.createElement("div"),this.arrowDiv.className="vis-arrow",this.opacityRange=document.createElement("input");try{this.opacityRange.type="range",this.opacityRange.min="0",this.opacityRange.max="100"}catch(t){}this.opacityRange.value="100",this.opacityRange.className="vis-range",this.brightnessRange=document.createElement("input");try{this.brightnessRange.type="range",this.brightnessRange.min="0",this.brightnessRange.max="100"}catch(t){}this.brightnessRange.value="100",this.brightnessRange.className="vis-range",this.opacityDiv.appendChild(this.opacityRange),this.brightnessDiv.appendChild(this.brightnessRange);var s=this;this.opacityRange.onchange=function(){s._setOpacity(this.value)},this.opacityRange.oninput=function(){s._setOpacity(this.value)},this.brightnessRange.onchange=function(){s._setBrightness(this.value)},this.brightnessRange.oninput=function(){s._setBrightness(this.value)},this.brightnessLabel=document.createElement("div"),this.brightnessLabel.className="vis-label vis-brightness",this.brightnessLabel.innerHTML="brightness:",this.opacityLabel=document.createElement("div"),this.opacityLabel.className="vis-label vis-opacity",this.opacityLabel.innerHTML="opacity:",this.newColorDiv=document.createElement("div"),this.newColorDiv.className="vis-new-color",this.newColorDiv.innerHTML="new",this.initialColorDiv=document.createElement("div"),this.initialColorDiv.className="vis-initial-color",this.initialColorDiv.innerHTML="initial",this.cancelButton=document.createElement("div"),this.cancelButton.className="vis-button vis-cancel",this.cancelButton.innerHTML="cancel",this.cancelButton.onclick=xi(t=this._hide).call(t,this,!1),this.applyButton=document.createElement("div"),this.applyButton.className="vis-button vis-apply",this.applyButton.innerHTML="apply",this.applyButton.onclick=xi(e=this._apply).call(e,this),this.saveButton=document.createElement("div"),this.saveButton.className="vis-button vis-save",this.saveButton.innerHTML="save",this.saveButton.onclick=xi(i=this._save).call(i,this),this.loadButton=document.createElement("div"),this.loadButton.className="vis-button vis-load",this.loadButton.innerHTML="load last",this.loadButton.onclick=xi(n=this._loadLast).call(n,this),this.frame.appendChild(this.colorPickerDiv),this.frame.appendChild(this.arrowDiv),this.frame.appendChild(this.brightnessLabel),this.frame.appendChild(this.brightnessDiv),this.frame.appendChild(this.opacityLabel),this.frame.appendChild(this.opacityDiv),this.frame.appendChild(this.newColorDiv),this.frame.appendChild(this.initialColorDiv),this.frame.appendChild(this.cancelButton),this.frame.appendChild(this.applyButton),this.frame.appendChild(this.saveButton),this.frame.appendChild(this.loadButton)}},{key:"_bindHammer",value:function(){var t=this;this.drag={},this.pinch={},this.hammer=new oh(this.colorPickerCanvas),this.hammer.get("pinch").set({enable:!0}),rh(this.hammer,(function(e){t._moveSelector(e)})),this.hammer.on("tap",(function(e){t._moveSelector(e)})),this.hammer.on("panstart",(function(e){t._moveSelector(e)})),this.hammer.on("panmove",(function(e){t._moveSelector(e)})),this.hammer.on("panend",(function(e){t._moveSelector(e)}))}},{key:"_generateHueCircle",value:function(){if(!1===this.generated){var t=this.colorPickerCanvas.getContext("2d");void 0===this.pixelRation&&(this.pixelRatio=(window.devicePixelRatio||1)/(t.webkitBackingStorePixelRatio||t.mozBackingStorePixelRatio||t.msBackingStorePixelRatio||t.oBackingStorePixelRatio||t.backingStorePixelRatio||1)),t.setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0);var e,i,n,o,r=this.colorPickerCanvas.clientWidth,s=this.colorPickerCanvas.clientHeight;t.clearRect(0,0,r,s),this.centerCoordinates={x:.5*r,y:.5*s},this.r=.49*r;var a,l=2*Math.PI/360,h=1/this.r;for(n=0;n<360;n++)for(o=0;o<this.r;o++)e=this.centerCoordinates.x+o*Math.sin(l*n),i=this.centerCoordinates.y+o*Math.cos(l*n),a=Os.HSVToRGB(n*(1/360),o*h,1),t.fillStyle="rgb("+a.r+","+a.g+","+a.b+")",t.fillRect(e-.5,i-.5,2,2);t.strokeStyle="rgba(0,0,0,1)",t.circle(this.centerCoordinates.x,this.centerCoordinates.y,this.r),t.stroke(),this.hueCircle=t.getImageData(0,0,r,s)}this.generated=!0}},{key:"_moveSelector",value:function(t){var e=this.colorPickerDiv.getBoundingClientRect(),i=t.center.x-e.left,n=t.center.y-e.top,o=.5*this.colorPickerDiv.clientHeight,r=.5*this.colorPickerDiv.clientWidth,s=i-r,a=n-o,l=Math.atan2(s,a),h=.98*Math.min(Math.sqrt(s*s+a*a),r),u=Math.cos(l)*h+o,d=Math.sin(l)*h+r;this.colorPickerSelector.style.top=u-.5*this.colorPickerSelector.clientHeight+"px",this.colorPickerSelector.style.left=d-.5*this.colorPickerSelector.clientWidth+"px";var c=l/(2*Math.PI);c=c<0?c+1:c;var p=h/this.r,m=Os.RGBToHSV(this.color.r,this.color.g,this.color.b);m.h=c,m.s=p;var f=Os.HSVToRGB(m.h,m.s,m.v);f.a=this.color.a,this.color=f,this.initialColorDiv.style.backgroundColor="rgba("+this.initialColor.r+","+this.initialColor.g+","+this.initialColor.b+","+this.initialColor.a+")",this.newColorDiv.style.backgroundColor="rgba("+this.color.r+","+this.color.g+","+this.color.b+","+this.color.a+")"}}]),t}(),yd=function(){function t(e,i,n){var o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:1;Ci(this,t),this.parent=e,this.changedOptions=[],this.container=i,this.allowCreation=!1,this.options={},this.initialized=!1,this.popupCounter=0,this.defaultOptions={enabled:!1,filter:!0,container:void 0,showButton:!0},Os.extend(this.options,this.defaultOptions),this.configureOptions=n,this.moduleOptions={},this.domElements=[],this.popupDiv={},this.popupLimit=5,this.popupHistory={},this.colorPicker=new vd(o),this.wrapper=void 0}return Ii(t,[{key:"setOptions",value:function(t){if(void 0!==t){this.popupHistory={},this._removePopup();var e=!0;if("string"==typeof t)this.options.filter=t;else if(t instanceof Array)this.options.filter=t.join();else if("object"===Fn(t)){if(null==t)throw new TypeError("options cannot be null");void 0!==t.container&&(this.options.container=t.container),void 0!==gi(t)&&(this.options.filter=gi(t)),void 0!==t.showButton&&(this.options.showButton=t.showButton),void 0!==t.enabled&&(e=t.enabled)}else"boolean"==typeof t?(this.options.filter=!0,e=t):"function"==typeof t&&(this.options.filter=t,e=!0);!1===gi(this.options)&&(e=!1),this.options.enabled=e}this._clean()}},{key:"setModuleOptions",value:function(t){this.moduleOptions=t,!0===this.options.enabled&&(this._clean(),void 0!==this.options.container&&(this.container=this.options.container),this._create())}},{key:"_create",value:function(){this._clean(),this.changedOptions=[];var t=gi(this.options),e=0,i=!1;for(var n in this.configureOptions)this.configureOptions.hasOwnProperty(n)&&(this.allowCreation=!1,i=!1,"function"==typeof t?i=(i=t(n,[]))||this._handleObject(this.configureOptions[n],[n],!0):!0!==t&&-1===sr(t).call(t,n)||(i=!0),!1!==i&&(this.allowCreation=!0,e>0&&this._makeItem([]),this._makeHeader(n),this._handleObject(this.configureOptions[n],[n])),e++);this._makeButton(),this._push()}},{key:"_push",value:function(){this.wrapper=document.createElement("div"),this.wrapper.className="vis-configuration-wrapper",this.container.appendChild(this.wrapper);for(var t=0;t<this.domElements.length;t++)this.wrapper.appendChild(this.domElements[t]);this._showPopupIfNeeded()}},{key:"_clean",value:function(){for(var t=0;t<this.domElements.length;t++)this.wrapper.removeChild(this.domElements[t]);void 0!==this.wrapper&&(this.container.removeChild(this.wrapper),this.wrapper=void 0),this.domElements=[],this._removePopup()}},{key:"_getValue",value:function(t){for(var e=this.moduleOptions,i=0;i<t.length;i++){if(void 0===e[t[i]]){e=void 0;break}e=e[t[i]]}return e}},{key:"_makeItem",value:function(t){if(!0===this.allowCreation){var e=document.createElement("div");e.className="vis-configuration vis-config-item vis-config-s"+t.length;for(var i=arguments.length,n=new Array(i>1?i-1:0),o=1;o<i;o++)n[o-1]=arguments[o];return ni(n).call(n,(function(t){e.appendChild(t)})),this.domElements.push(e),this.domElements.length}return 0}},{key:"_makeHeader",value:function(t){var e=document.createElement("div");e.className="vis-configuration vis-config-header",e.innerHTML=t,this._makeItem([],e)}},{key:"_makeLabel",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=document.createElement("div");return n.className="vis-configuration vis-config-label vis-config-s"+e.length,n.innerHTML=!0===i?"<i><b>"+t+":</b></i>":t+":",n}},{key:"_makeDropdown",value:function(t,e,i){var n=document.createElement("select");n.className="vis-configuration vis-config-select";var o=0;void 0!==e&&-1!==sr(t).call(t,e)&&(o=sr(t).call(t,e));for(var r=0;r<t.length;r++){var s=document.createElement("option");s.value=t[r],r===o&&(s.selected="selected"),s.innerHTML=t[r],n.appendChild(s)}var a=this;n.onchange=function(){a._update(this.value,i)};var l=this._makeLabel(i[i.length-1],i);this._makeItem(i,l,n)}},{key:"_makeRange",value:function(t,e,i){var n=t[0],o=t[1],r=t[2],s=t[3],a=document.createElement("input");a.className="vis-configuration vis-config-range";try{a.type="range",a.min=o,a.max=r}catch(t){}a.step=s;var l="",h=0;if(void 0!==e){e<0&&1.2*e<o?(a.min=Math.ceil(1.2*e),h=a.min,l="range increased"):e/1.2<o&&(a.min=Math.ceil(e/1.2),h=a.min,l="range increased"),1.2*e>r&&1!==r&&(a.max=Math.ceil(1.2*e),h=a.max,l="range increased"),a.value=e}else a.value=n;var u=document.createElement("input");u.className="vis-configuration vis-config-rangeinput",u.value=Number(a.value);var d=this;a.onchange=function(){u.value=this.value,d._update(Number(this.value),i)},a.oninput=function(){u.value=this.value};var c=this._makeLabel(i[i.length-1],i),p=this._makeItem(i,c,a,u);""!==l&&this.popupHistory[p]!==h&&(this.popupHistory[p]=h,this._setupPopup(l,p))}},{key:"_makeButton",value:function(){var t=this;if(!0===this.options.showButton){var e=document.createElement("div");e.className="vis-configuration vis-config-button",e.innerHTML="generate options",e.onclick=function(){t._printOptions()},e.onmouseover=function(){e.className="vis-configuration vis-config-button hover"},e.onmouseout=function(){e.className="vis-configuration vis-config-button"},this.optionsContainer=document.createElement("div"),this.optionsContainer.className="vis-configuration vis-config-option-container",this.domElements.push(this.optionsContainer),this.domElements.push(e)}}},{key:"_setupPopup",value:function(t,e){var i=this;if(!0===this.initialized&&!0===this.allowCreation&&this.popupCounter<this.popupLimit){var n=document.createElement("div");n.id="vis-configuration-popup",n.className="vis-configuration-popup",n.innerHTML=t,n.onclick=function(){i._removePopup()},this.popupCounter+=1,this.popupDiv={html:n,index:e}}}},{key:"_removePopup",value:function(){void 0!==this.popupDiv.html&&(this.popupDiv.html.parentNode.removeChild(this.popupDiv.html),clearTimeout(this.popupDiv.hideTimeout),clearTimeout(this.popupDiv.deleteTimeout),this.popupDiv={})}},{key:"_showPopupIfNeeded",value:function(){var t=this;if(void 0!==this.popupDiv.html){var e=this.domElements[this.popupDiv.index].getBoundingClientRect();this.popupDiv.html.style.left=e.left+"px",this.popupDiv.html.style.top=e.top-30+"px",document.body.appendChild(this.popupDiv.html),this.popupDiv.hideTimeout=wi((function(){t.popupDiv.html.style.opacity=0}),1500),this.popupDiv.deleteTimeout=wi((function(){t._removePopup()}),1800)}}},{key:"_makeCheckbox",value:function(t,e,i){var n=document.createElement("input");n.type="checkbox",n.className="vis-configuration vis-config-checkbox",n.checked=t,void 0!==e&&(n.checked=e,e!==t&&("object"===Fn(t)?e!==t.enabled&&this.changedOptions.push({path:i,value:e}):this.changedOptions.push({path:i,value:e})));var o=this;n.onchange=function(){o._update(this.checked,i)};var r=this._makeLabel(i[i.length-1],i);this._makeItem(i,r,n)}},{key:"_makeTextInput",value:function(t,e,i){var n=document.createElement("input");n.type="text",n.className="vis-configuration vis-config-text",n.value=e,e!==t&&this.changedOptions.push({path:i,value:e});var o=this;n.onchange=function(){o._update(this.value,i)};var r=this._makeLabel(i[i.length-1],i);this._makeItem(i,r,n)}},{key:"_makeColorField",value:function(t,e,i){var n=this,o=t[1],r=document.createElement("div");"none"!==(e=void 0===e?o:e)?(r.className="vis-configuration vis-config-colorBlock",r.style.backgroundColor=e):r.className="vis-configuration vis-config-colorBlock none",e=void 0===e?o:e,r.onclick=function(){n._showColorPicker(e,r,i)};var s=this._makeLabel(i[i.length-1],i);this._makeItem(i,s,r)}},{key:"_showColorPicker",value:function(t,e,i){var n=this;e.onclick=function(){},this.colorPicker.insertTo(e),this.colorPicker.show(),this.colorPicker.setColor(t),this.colorPicker.setUpdateCallback((function(t){var o="rgba("+t.r+","+t.g+","+t.b+","+t.a+")";e.style.backgroundColor=o,n._update(o,i)})),this.colorPicker.setCloseCallback((function(){e.onclick=function(){n._showColorPicker(t,e,i)}}))}},{key:"_handleObject",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:[],i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=!1,o=gi(this.options),r=!1;for(var s in t)if(t.hasOwnProperty(s)){n=!0;var a=t[s],l=Os.copyAndExtendArray(e,s);if("function"==typeof o&&!1===(n=o(s,e))&&!(a instanceof Array)&&"string"!=typeof a&&"boolean"!=typeof a&&a instanceof Object&&(this.allowCreation=!1,n=this._handleObject(a,l,!0),this.allowCreation=!1===i),!1!==n){r=!0;var h=this._getValue(l);if(a instanceof Array)this._handleArray(a,h,l);else if("string"==typeof a)this._makeTextInput(a,h,l);else if("boolean"==typeof a)this._makeCheckbox(a,h,l);else if(a instanceof Object){var u=!0;if(-1!==sr(e).call(e,"physics")&&this.moduleOptions.physics.solver!==s&&(u=!1),!0===u)if(void 0!==a.enabled){var d=Os.copyAndExtendArray(l,"enabled"),c=this._getValue(d);if(!0===c){var p=this._makeLabel(s,l,!0);this._makeItem(l,p),r=this._handleObject(a,l)||r}else this._makeCheckbox(a,c,l)}else{var m=this._makeLabel(s,l,!0);this._makeItem(l,m),r=this._handleObject(a,l)||r}}else console.error("dont know how to handle",a,s,l)}}return r}},{key:"_handleArray",value:function(t,e,i){"string"==typeof t[0]&&"color"===t[0]?(this._makeColorField(t,e,i),t[1]!==e&&this.changedOptions.push({path:i,value:e})):"string"==typeof t[0]?(this._makeDropdown(t,e,i),t[0]!==e&&this.changedOptions.push({path:i,value:e})):"number"==typeof t[0]&&(this._makeRange(t,e,i),t[0]!==e&&this.changedOptions.push({path:i,value:Number(e)}))}},{key:"_update",value:function(t,e){var i=this._constructOptions(t,e);this.parent.body&&this.parent.body.emitter&&this.parent.body.emitter.emit&&this.parent.body.emitter.emit("configChange",i),this.initialized=!0,this.parent.setOptions(i)}},{key:"_constructOptions",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{},n=i;t="false"!==(t="true"===t||t)&&t;for(var o=0;o<e.length;o++)"global"!==e[o]&&(void 0===n[e[o]]&&(n[e[o]]={}),o!==e.length-1?n=n[e[o]]:n[e[o]]=t);return i}},{key:"_printOptions",value:function(){var t=this.getOptions();this.optionsContainer.innerHTML="<pre>var options = "+zs(t,null,2)+"</pre>"}},{key:"getOptions",value:function(){for(var t={},e=0;e<this.changedOptions.length;e++)this._constructOptions(this.changedOptions[e].value,this.changedOptions[e].path,t);return t}}]),t}();function bd(t){var e=function(){if("undefined"==typeof Reflect||!Nt)return!1;if(Nt.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Nt(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=Yn(t);if(e){var o=Yn(this).constructor;i=Nt(n,arguments,o)}else i=n.apply(this,arguments);return zn(this,i)}}var wd=function(t){ji(o,Ch);var i=bd(o);function o(t,r,s,a){var l,h,u,d,c,p,m,f;if(Ci(this,o),(f=i.call(this)).initTime=new Date,f.itemsDone=!1,!(Mi(f)instanceof o))throw new SyntaxError("Constructor must be called with the new operator");if(!(Di(s)||s instanceof e||s instanceof n)&&s instanceof Object){var g=a;a=s,s=g}a&&a.throttleRedraw&&console.warn('Timeline option "throttleRedraw" is DEPRICATED and no longer supported. It will be removed in the next MAJOR release.');var v=Mi(f);if(f.defaultOptions={autoResize:!0,longSelectPressTime:251,orientation:{axis:"bottom",item:"bottom"},moment:Wn},f.options=Os.deepExtend({},f.defaultOptions),f._create(t),!a||a&&void 0===a.rtl){var y;f.dom.root.style.visibility="hidden";for(var b=f.dom.root;!y&&b;)y=window.getComputedStyle(b,null).direction,b=b.parentElement;f.options.rtl=y&&"rtl"==y.toLowerCase()}else f.options.rtl=a.rtl;a&&(a.rollingMode&&(f.options.rollingMode=a.rollingMode),a.onInitialDrawComplete&&(f.options.onInitialDrawComplete=a.onInitialDrawComplete),a.onTimeout&&(f.options.onTimeout=a.onTimeout),a.loadingScreenTemplate&&(f.options.loadingScreenTemplate=a.loadingScreenTemplate));var w=document.createElement("div");if(f.options.loadingScreenTemplate){var _,k=xi(_=f.options.loadingScreenTemplate).call(_,Mi(f)),x=k(f.dom.loadingScreen);x instanceof Object&&!(x instanceof Element)?k(w):x instanceof Element?(w.innerHTML="",w.appendChild(x)):null!=x&&(w.innerHTML=x)}function S(t,e){v.hasListeners(t)&&v.emit(t,v.getEventProperties(e))}return f.dom.loadingScreen.appendChild(w),f.components=[],f.body={dom:f.dom,domProps:f.props,emitter:{on:xi(l=f.on).call(l,Mi(f)),off:xi(h=f.off).call(h,Mi(f)),emit:xi(u=f.emit).call(u,Mi(f))},hiddenDates:[],util:{getScale:function(){return v.timeAxis.step.scale},getStep:function(){return v.timeAxis.step.step},toScreen:xi(d=v._toScreen).call(d,v),toGlobalScreen:xi(c=v._toGlobalScreen).call(c,v),toTime:xi(p=v._toTime).call(p,v),toGlobalTime:xi(m=v._toGlobalTime).call(m,v)}},f.range=new pa(f.body,f.options),f.components.push(f.range),f.body.range=f.range,f.timeAxis=new lh(f.body,f.options),f.timeAxis2=null,f.components.push(f.timeAxis),f.currentTime=new Oh(f.body,f.options),f.components.push(f.currentTime),f.itemSet=new id(f.body,f.options),f.components.push(f.itemSet),f.itemsData=null,f.groupsData=null,f.dom.root.onclick=function(t){S("click",t)},f.dom.root.ondblclick=function(t){S("doubleClick",t)},f.dom.root.oncontextmenu=function(t){S("contextmenu",t)},f.dom.root.onmouseover=function(t){S("mouseOver",t)},window.PointerEvent?(f.dom.root.onpointerdown=function(t){S("mouseDown",t)},f.dom.root.onpointermove=function(t){S("mouseMove",t)},f.dom.root.onpointerup=function(t){S("mouseUp",t)}):(f.dom.root.onmousemove=function(t){S("mouseMove",t)},f.dom.root.onmousedown=function(t){S("mouseDown",t)},f.dom.root.onmouseup=function(t){S("mouseUp",t)}),f.initialFitDone=!1,f.on("changed",(function(){if(null!=v.itemsData){if(!v.initialFitDone&&!v.options.rollingMode)if(v.initialFitDone=!0,null!=v.options.start||null!=v.options.end){if(null==v.options.start||null==v.options.end)var t=v.getItemRange();var e=null!=v.options.start?v.options.start:t.min,i=null!=v.options.end?v.options.end:t.max;v.setWindow(e,i,{animation:!1})}else v.fit({animation:!1});v.initialDrawDone||!v.initialRangeChangeDone&&(v.options.start||v.options.end)&&!v.options.rollingMode||(v.initialDrawDone=!0,v.itemSet.initialDrawDone=!0,v.dom.root.style.visibility="visible",v.dom.loadingScreen.parentNode.removeChild(v.dom.loadingScreen),v.options.onInitialDrawComplete&&wi((function(){return v.options.onInitialDrawComplete()}),0))}})),f.on("destroyTimeline",(function(){v.destroy()})),a&&f.setOptions(a),f.body.emitter.on("fit",(function(t){f._onFit(t),f.redraw()})),s&&f.setGroups(s),r&&f.setItems(r),f._redraw(),f}return Ii(o,[{key:"_createConfigurator",value:function(){return new yd(this,this.dom.container,cd)}},{key:"redraw",value:function(){this.itemSet&&this.itemSet.markDirty({refreshItems:!0}),this._redraw()}},{key:"setOptions",value:function(t){if(!0===sd.validate(t,dd)&&console.log("%cErrors have been found in the supplied options object.",rd),Ch.prototype.setOptions.call(this,t),"type"in t&&t.type!==this.options.type){this.options.type=t.type;var e=this.itemsData;if(e){var i=this.getSelection();this.setItems(null),this.setItems(e.rawDS),this.setSelection(i)}}}},{key:"setItems",value:function(t){var i;this.itemsDone=!1,i=t?Ts(t instanceof e||t instanceof n?t:new e(t)):null,this.itemsData&&this.itemsData.dispose(),this.itemsData=i,this.itemSet&&this.itemSet.setItems(null!=i?i.rawDS:null)}},{key:"setGroups",value:function(t){var i;if(t){var o=function(t){return!1!==t.visible};i=t instanceof e||t instanceof n?new n(t,{filter:o}):new e(gi(t).call(t,o))}else i=null;this.groupsData instanceof n&&this.groupsData.setData(null),this.groupsData=i,this.itemSet.setGroups(i)}},{key:"setData",value:function(t){t&&t.groups&&this.setGroups(t.groups),t&&t.items&&this.setItems(t.items)}},{key:"setSelection",value:function(t,e){this.itemSet&&this.itemSet.setSelection(t),e&&e.focus&&this.focus(t,e)}},{key:"getSelection",value:function(){return this.itemSet&&this.itemSet.getSelection()||[]}},{key:"focus",value:function(t,e){if(this.itemsData&&null!=t){var i=Di(t)?t:[t],n=this.itemsData.get(i),o=null,r=null;if(ni(n).call(n,(function(t){var e=t.start.valueOf(),i="end"in t?t.end.valueOf():t.start.valueOf();(null===o||e<o)&&(o=e),(null===r||i>r)&&(r=i)})),null!==o&&null!==r){var s=this,a=this.itemSet.items[i[0]],l=-1*this._getScrollTop(),h=null,u=function(){var t=xd(s,a);t.shouldScroll&&t.itemTop!=h.itemTop&&(s._setScrollTop(-t.scrollOffset),s._redraw())},d=!e||void 0===e.zoom||e.zoom,c=(o+r)/2,p=d?1.1*(r-o):Math.max(this.range.end-this.range.start,1.1*(r-o)),m=!e||void 0===e.animation||e.animation;m||(h={shouldScroll:!1,scrollOffset:-1,itemTop:-1}),this.range.setRange(c-p/2,c+p/2,{animation:m},(function(){u(),wi(u,100)}),(function(t,e,i){var n=xd(s,a);if(!1!==n&&(h||(h=n),h.itemTop!=n.itemTop||h.shouldScroll)){h.itemTop!=n.itemTop&&n.shouldScroll&&(h=n,l=-1*s._getScrollTop());var o=l,r=h.scrollOffset,u=i?r:o+(r-o)*t;s._setScrollTop(-u),e||s._redraw()}}))}}}},{key:"fit",value:function(t,e){var i,n=!t||void 0===t.animation||t.animation;1===this.itemsData.length&&void 0===this.itemsData.get()[0].end?(i=this.getDataRange(),this.moveTo(i.min.valueOf(),{animation:n},e)):(i=this.getItemRange(),this.range.setRange(i.min,i.max,{animation:n},e))}},{key:"getItemRange",value:function(){var t=this,e=this.getDataRange(),i=null!==e.min?e.min.valueOf():null,n=null!==e.max?e.max.valueOf():null,o=null,r=null;if(null!=i&&null!=n){var s=n-i;s<=0&&(s=10);var a=s/this.props.center.width,l={},h=0;if(ni(Os).call(Os,this.itemSet.items,(function(t,e){if(t.groupShowing){l[e]=t.redraw(!0),h=l[e].length}})),h>0)for(var u=function(t){ni(Os).call(Os,l,(function(e){e[t]()}))},d=0;d<h;d++)u(d);if(ni(Os).call(Os,this.itemSet.items,(function(e){var s,l,h=_d(e),u=kd(e);t.options.rtl?(s=h-(e.getWidthRight()+10)*a,l=u+(e.getWidthLeft()+10)*a):(s=h-(e.getWidthLeft()+10)*a,l=u+(e.getWidthRight()+10)*a),s<i&&(i=s,o=e),l>n&&(n=l,r=e)})),o&&r){var c=o.getWidthLeft()+10,p=r.getWidthRight()+10,m=this.props.center.width-c-p;m>0&&(this.options.rtl?(i=_d(o)-p*s/m,n=kd(r)+c*s/m):(i=_d(o)-c*s/m,n=kd(r)+p*s/m))}}return{min:null!=i?new Date(i):null,max:null!=n?new Date(n):null}}},{key:"getDataRange",value:function(){var t,e=null,i=null;this.itemsData&&ni(t=this.itemsData).call(t,(function(t){var n=Os.convert(t.start,"Date").valueOf(),o=Os.convert(null!=t.end?t.end:t.start,"Date").valueOf();(null===e||n<e)&&(e=n),(null===i||o>i)&&(i=o)}));return{min:null!=e?new Date(e):null,max:null!=i?new Date(i):null}}},{key:"getEventProperties",value:function(t){var e=t.center?t.center.x:t.clientX,i=t.center?t.center.y:t.clientY,n=this.dom.centerContainer.getBoundingClientRect(),o=this.options.rtl?n.right-e:e-n.left,r=i-n.top,s=this.itemSet.itemFromTarget(t),a=this.itemSet.groupFromTarget(t),l=Dh.customTimeFromTarget(t),h=this.itemSet.options.snap||null,u=this.body.util.getScale(),d=this.body.util.getStep(),c=this._toTime(o),p=h?h(c,u,d):c,m=Os.getTarget(t),f=null;return null!=s?f="item":null!=l?f="custom-time":Os.hasParent(m,this.timeAxis.dom.foreground)||this.timeAxis2&&Os.hasParent(m,this.timeAxis2.dom.foreground)?f="axis":Os.hasParent(m,this.itemSet.dom.labelSet)?f="group-label":Os.hasParent(m,this.currentTime.bar)?f="current-time":Os.hasParent(m,this.dom.center)&&(f="background"),{event:t,item:s?s.id:null,isCluster:!!s&&!!s.isCluster,items:s?s.items||[]:null,group:a?a.groupId:null,customTime:l?l.options.id:null,what:f,pageX:t.srcEvent?t.srcEvent.pageX:t.pageX,pageY:t.srcEvent?t.srcEvent.pageY:t.pageY,x:o,y:r,time:c,snappedTime:p}}},{key:"toggleRollingMode",value:function(){this.range.rolling?this.range.stopRolling():(null==this.options.rollingMode&&this.setOptions(this.options),this.range.startRolling())}},{key:"_redraw",value:function(){Ch.prototype._redraw.call(this)}},{key:"_onFit",value:function(t){var e=t.start,i=t.end,n=t.animation;i?this.range.setRange(e,i,{animation:n}):this.moveTo(e.valueOf(),{animation:n})}}]),o}();function _d(t){return Os.convert(t.data.start,"Date").valueOf()}function kd(t){var e=null!=t.data.end?t.data.end:t.data.start;return Os.convert(e,"Date").valueOf()}function xd(t,e){if(!e.parent)return!1;var i=t.options.rtl?t.props.rightContainer.height:t.props.leftContainer.height,n=t.props.center.height,o=e.parent,r=o.top,s=!0,a=t.timeAxis.options.orientation.axis,l=function(){return"bottom"==a?o.height-e.top-e.height:e.top},h=-1*t._getScrollTop(),u=r+l(),d=e.height;return u<h?r+i<=r+l()+d&&(r+=l()-t.itemSet.options.margin.item.vertical):u+d>h+i?r+=l()+d-i+t.itemSet.options.margin.item.vertical:s=!1,{shouldScroll:s,scrollOffset:r=Math.min(r,n-i),itemTop:u}}function Sd(t){for(var e in t)t.hasOwnProperty(e)&&(t[e].redundant=t[e].used,t[e].used=[])}function Dd(t){for(var e in t)if(t.hasOwnProperty(e)&&t[e].redundant){for(var i=0;i<t[e].redundant.length;i++)t[e].redundant[i].parentNode.removeChild(t[e].redundant[i]);t[e].redundant=[]}}function Cd(t,e,i){var n;return e.hasOwnProperty(t)?e[t].redundant.length>0?(n=e[t].redundant[0],e[t].redundant.shift()):(n=document.createElementNS("http://www.w3.org/2000/svg",t),i.appendChild(n)):(n=document.createElementNS("http://www.w3.org/2000/svg",t),e[t]={used:[],redundant:[]},i.appendChild(n)),e[t].used.push(n),n}function Td(t,e,i,n){var o;return e.hasOwnProperty(t)?e[t].redundant.length>0?(o=e[t].redundant[0],e[t].redundant.shift()):(o=document.createElement(t),void 0!==n?i.insertBefore(o,n):i.appendChild(o)):(o=document.createElement(t),e[t]={used:[],redundant:[]},void 0!==n?i.insertBefore(o,n):i.appendChild(o)),e[t].used.push(o),o}function Od(t,e,i,n,o,r){var s;if("circle"==i.style?((s=Cd("circle",n,o)).setAttributeNS(null,"cx",t),s.setAttributeNS(null,"cy",e),s.setAttributeNS(null,"r",.5*i.size)):((s=Cd("rect",n,o)).setAttributeNS(null,"x",t-.5*i.size),s.setAttributeNS(null,"y",e-.5*i.size),s.setAttributeNS(null,"width",i.size),s.setAttributeNS(null,"height",i.size)),void 0!==i.styles&&s.setAttributeNS(null,"style",i.styles),s.setAttributeNS(null,"class",i.className+" vis-point"),r){var a=Cd("text",n,o);r.xOffset&&(t+=r.xOffset),r.yOffset&&(e+=r.yOffset),r.content&&(a.textContent=r.content),r.className&&a.setAttributeNS(null,"class",r.className+" vis-label"),a.setAttributeNS(null,"x",t),a.setAttributeNS(null,"y",e)}return s}function Ed(t,e,i,n,o,r,s,a){if(0!=n){n<0&&(e-=n*=-1);var l=Cd("rect",r,s);l.setAttributeNS(null,"x",t-.5*i),l.setAttributeNS(null,"y",e),l.setAttributeNS(null,"width",i),l.setAttributeNS(null,"height",n),l.setAttributeNS(null,"class",o),a&&l.setAttributeNS(null,"style",a)}}var Id=function(){function t(e,i,n,o,r,s){var a=arguments.length>6&&void 0!==arguments[6]&&arguments[6],l=arguments.length>7&&void 0!==arguments[7]&&arguments[7];if(Ci(this,t),this.majorSteps=[1,2,5,10],this.minorSteps=[.25,.5,1,2],this.customLines=null,this.containerHeight=r,this.majorCharHeight=s,this._start=e,this._end=i,this.scale=1,this.minorStepIdx=-1,this.magnitudefactor=1,this.determineScale(),this.zeroAlign=a,this.autoScaleStart=n,this.autoScaleEnd=o,this.formattingFunction=l,n||o){var h=this,u=function(t){var e=t-t%(h.magnitudefactor*h.minorSteps[h.minorStepIdx]);return t%(h.magnitudefactor*h.minorSteps[h.minorStepIdx])>h.magnitudefactor*h.minorSteps[h.minorStepIdx]*.5?e+h.magnitudefactor*h.minorSteps[h.minorStepIdx]:e};n&&(this._start-=2*this.magnitudefactor*this.minorSteps[this.minorStepIdx],this._start=u(this._start)),o&&(this._end+=this.magnitudefactor*this.minorSteps[this.minorStepIdx],this._end=u(this._end)),this.determineScale()}}return Ii(t,[{key:"setCharHeight",value:function(t){this.majorCharHeight=t}},{key:"setHeight",value:function(t){this.containerHeight=t}},{key:"determineScale",value:function(){var t=this._end-this._start;this.scale=this.containerHeight/t;var e=this.majorCharHeight/this.scale,i=t>0?Math.round(Math.log(t)/Math.LN10):0;this.minorStepIdx=-1,this.magnitudefactor=Math.pow(10,i);var n=0;i<0&&(n=i);for(var o=!1,r=n;Math.abs(r)<=Math.abs(i);r++){this.magnitudefactor=Math.pow(10,r);for(var s=0;s<this.minorSteps.length;s++){if(this.magnitudefactor*this.minorSteps[s]>=e){o=!0,this.minorStepIdx=s;break}}if(!0===o)break}}},{key:"is_major",value:function(t){return t%(this.magnitudefactor*this.majorSteps[this.minorStepIdx])==0}},{key:"getStep",value:function(){return this.magnitudefactor*this.minorSteps[this.minorStepIdx]}},{key:"getFirstMajor",value:function(){var t=this.magnitudefactor*this.majorSteps[this.minorStepIdx];return this.convertValue(this._start+(t-this._start%t)%t)}},{key:"formatValue",value:function(t){var e=t.toPrecision(5);return"function"==typeof this.formattingFunction&&(e=this.formattingFunction(t)),"number"==typeof e?"".concat(e):"string"==typeof e?e:t.toPrecision(5)}},{key:"getLines",value:function(){for(var t=[],e=this.getStep(),i=(e-this._start%e)%e,n=this._start+i;this._end-n>1e-5;n+=e)n!=this._start&&t.push({major:this.is_major(n),y:this.convertValue(n),val:this.formatValue(n)});return t}},{key:"followScale",value:function(t){var e=this.minorStepIdx,i=this._start,n=this._end,o=this,r=function(){o.magnitudefactor*=2},s=function(){o.magnitudefactor/=2};t.minorStepIdx<=1&&this.minorStepIdx<=1||t.minorStepIdx>1&&this.minorStepIdx>1||(t.minorStepIdx<this.minorStepIdx?(this.minorStepIdx=1,2==e||r(),r()):(this.minorStepIdx=2,1==e||s(),s()));for(var a=t.convertValue(0),l=t.getStep()*t.scale,h=!1,u=0;!h&&u++<5;){this.scale=l/(this.minorSteps[this.minorStepIdx]*this.magnitudefactor);var d=this.containerHeight/this.scale;this._start=i,this._end=this._start+d;var c=this._end*this.scale,p=this.magnitudefactor*this.majorSteps[this.minorStepIdx],m=this.getFirstMajor()-t.getFirstMajor();if(this.zeroAlign){var f=a-c;this._end+=f/this.scale,this._start=this._end-d}else this.autoScaleStart?(this._start-=m/this.scale,this._end=this._start+d):(this._start+=p-m/this.scale,this._end=this._start+d);if(!this.autoScaleEnd&&this._end>n+1e-5)s(),h=!1;else{if(!this.autoScaleStart&&this._start<i-1e-5){if(!(this.zeroAlign&&i>=0)){s(),h=!1;continue}console.warn("Can't adhere to given 'min' range, due to zeroalign")}this.autoScaleStart&&this.autoScaleEnd&&d<n-i?(r(),h=!1):h=!0}}}},{key:"convertValue",value:function(t){return this.containerHeight-(t-this._start)*this.scale}},{key:"screenToValue",value:function(t){return(this.containerHeight-t)/this.scale+this._start}}]),t}();function Md(t,e){var i;if(void 0===Gr||null==bo(t)){if(Di(t)||(i=function(t,e){var i;if(!t)return;if("string"==typeof t)return Ad(t,e);var n=Ar(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return Mo(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Ad(t,e)}(t))||e&&t&&"number"==typeof t.length){i&&(t=i);var n=0,o=function(){};return{s:o,n:function(){return n>=t.length?{done:!0}:{done:!1,value:t[n++]}},e:function(t){throw t},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var r,s=!0,a=!1;return{s:function(){i=yo(t)},n:function(){var t=i.next();return s=t.done,t},e:function(t){a=!0,r=t},f:function(){try{s||null==i.return||i.return()}finally{if(a)throw r}}}}function Ad(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}function Pd(t){var e=function(){if("undefined"==typeof Reflect||!Nt)return!1;if(Nt.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Nt(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=Yn(t);if(e){var o=Yn(this).constructor;i=Nt(n,arguments,o)}else i=n.apply(this,arguments);return zn(this,i)}}var Nd=function(t){ji(i,Gs);var e=Pd(i);function i(t,n,o,r){var s;Ci(this,i),(s=e.call(this)).id=eu(),s.body=t,s.defaultOptions={orientation:"left",showMinorLabels:!0,showMajorLabels:!0,showWeekScale:!1,icons:!1,majorLinesOffset:7,minorLinesOffset:4,labelOffsetX:10,labelOffsetY:2,iconWidth:20,width:"40px",visible:!0,alignZeros:!0,left:{range:{min:void 0,max:void 0},format:function(t){return"".concat(As(t.toPrecision(3)))},title:{text:void 0,style:void 0}},right:{range:{min:void 0,max:void 0},format:function(t){return"".concat(As(t.toPrecision(3)))},title:{text:void 0,style:void 0}}},s.linegraphOptions=r,s.linegraphSVG=o,s.props={},s.DOMelements={lines:{},labels:{},title:{}},s.dom={},s.scale=void 0,s.range={start:0,end:0},s.options=Os.extend({},s.defaultOptions),s.conversionFactor=1,s.setOptions(n),s.width=Number("".concat(s.options.width).replace("px","")),s.minWidth=s.width,s.height=s.linegraphSVG.getBoundingClientRect().height,s.hidden=!1,s.stepPixels=25,s.zeroCrossing=-1,s.amountOfSteps=-1,s.lineOffset=0,s.master=!0,s.masterAxis=null,s.svgElements={},s.iconsRemoved=!1,s.groups={},s.amountOfGroups=0,s._create(),null==s.scale&&s._redrawLabels(),s.framework={svg:s.svg,svgElements:s.svgElements,options:s.options,groups:s.groups};var a=Mi(s);return s.body.emitter.on("verticalDrag",(function(){a.dom.lineContainer.style.top="".concat(a.body.domProps.scrollTop,"px")})),s}return Ii(i,[{key:"addGroup",value:function(t,e){this.groups.hasOwnProperty(t)||(this.groups[t]=e),this.amountOfGroups+=1}},{key:"updateGroup",value:function(t,e){this.groups.hasOwnProperty(t)||(this.amountOfGroups+=1),this.groups[t]=e}},{key:"removeGroup",value:function(t){this.groups.hasOwnProperty(t)&&(delete this.groups[t],this.amountOfGroups-=1)}},{key:"setOptions",value:function(t){if(t){var e=!1;this.options.orientation!=t.orientation&&void 0!==t.orientation&&(e=!0);Os.selectiveDeepExtend(["orientation","showMinorLabels","showMajorLabels","icons","majorLinesOffset","minorLinesOffset","labelOffsetX","labelOffsetY","iconWidth","width","visible","left","right","alignZeros"],this.options,t),this.minWidth=Number("".concat(this.options.width).replace("px","")),!0===e&&this.dom.frame&&(this.hide(),this.show())}}},{key:"_create",value:function(){this.dom.frame=document.createElement("div"),this.dom.frame.style.width=this.options.width,this.dom.frame.style.height=this.height,this.dom.lineContainer=document.createElement("div"),this.dom.lineContainer.style.width="100%",this.dom.lineContainer.style.height=this.height,this.dom.lineContainer.style.position="relative",this.dom.lineContainer.style.visibility="visible",this.dom.lineContainer.style.display="block",this.svg=document.createElementNS("http://www.w3.org/2000/svg","svg"),this.svg.style.position="absolute",this.svg.style.top="0px",this.svg.style.height="100%",this.svg.style.width="100%",this.svg.style.display="block",this.dom.frame.appendChild(this.svg)}},{key:"_redrawGroupIcons",value:function(){var t;Sd(this.svgElements);var e=this.options.iconWidth,i=11.5;t="left"===this.options.orientation?4:this.width-e-4;var n=eo(this.groups);qs(n).call(n,(function(t,e){return t<e?-1:1}));var o,r=Md(n);try{for(r.s();!(o=r.n()).done;){var s=o.value;!0!==this.groups[s].visible||void 0!==this.linegraphOptions.visibility[s]&&!0!==this.linegraphOptions.visibility[s]||(this.groups[s].getLegend(e,15,this.framework,t,i),i+=19)}}catch(t){r.e(t)}finally{r.f()}Dd(this.svgElements),this.iconsRemoved=!1}},{key:"_cleanupIcons",value:function(){!1===this.iconsRemoved&&(Sd(this.svgElements),Dd(this.svgElements),this.iconsRemoved=!0)}},{key:"show",value:function(){this.hidden=!1,this.dom.frame.parentNode||("left"===this.options.orientation?this.body.dom.left.appendChild(this.dom.frame):this.body.dom.right.appendChild(this.dom.frame)),this.dom.lineContainer.parentNode||this.body.dom.backgroundHorizontal.appendChild(this.dom.lineContainer),this.dom.lineContainer.style.display="block"}},{key:"hide",value:function(){this.hidden=!0,this.dom.frame.parentNode&&this.dom.frame.parentNode.removeChild(this.dom.frame),this.dom.lineContainer.style.display="none"}},{key:"setRange",value:function(t,e){this.range.start=t,this.range.end=e}},{key:"redraw",value:function(){var t=!1,e=0;for(var i in this.dom.lineContainer.style.top="".concat(this.body.domProps.scrollTop,"px"),this.groups)this.groups.hasOwnProperty(i)&&(!0!==this.groups[i].visible||void 0!==this.linegraphOptions.visibility[i]&&!0!==this.linegraphOptions.visibility[i]||e++);if(0===this.amountOfGroups||0===e)this.hide();else{this.show(),this.height=Number(this.linegraphSVG.style.height.replace("px","")),this.dom.lineContainer.style.height="".concat(this.height,"px"),this.width=!0===this.options.visible?Number("".concat(this.options.width).replace("px","")):0;var n=this.props,o=this.dom.frame;o.className="vis-data-axis",this._calculateCharSize();var r=this.options.orientation,s=this.options.showMinorLabels,a=this.options.showMajorLabels,l=this.body.dom.backgroundHorizontal.offsetWidth;n.minorLabelHeight=s?n.minorCharHeight:0,n.majorLabelHeight=a?n.majorCharHeight:0,n.minorLineWidth=l-this.lineOffset-this.width+2*this.options.minorLinesOffset,n.minorLineHeight=1,n.majorLineWidth=l-this.lineOffset-this.width+2*this.options.majorLinesOffset,n.majorLineHeight=1,"left"===r?(o.style.top="0",o.style.left="0",o.style.bottom="",o.style.width="".concat(this.width,"px"),o.style.height="".concat(this.height,"px"),this.props.width=this.body.domProps.left.width,this.props.height=this.body.domProps.left.height):(o.style.top="",o.style.bottom="0",o.style.left="0",o.style.width="".concat(this.width,"px"),o.style.height="".concat(this.height,"px"),this.props.width=this.body.domProps.right.width,this.props.height=this.body.domProps.right.height),t=this._redrawLabels(),t=this._isResized()||t,!0===this.options.icons?this._redrawGroupIcons():this._cleanupIcons(),this._redrawTitle(r)}return t}},{key:"_redrawLabels",value:function(){var t=this,e=!1;Sd(this.DOMelements.lines),Sd(this.DOMelements.labels);var i=this.options.orientation,n=null!=this.options[i].range?this.options[i].range:{},o=!0;null!=n.max&&(this.range.end=n.max,o=!1);var r=!0;null!=n.min&&(this.range.start=n.min,r=!1),this.scale=new Id(this.range.start,this.range.end,r,o,this.dom.frame.offsetHeight,this.props.majorCharHeight,this.options.alignZeros,this.options[i].format),!1===this.master&&null!=this.masterAxis?(this.scale.followScale(this.masterAxis.scale),this.dom.lineContainer.style.display="none"):this.dom.lineContainer.style.display="block",this.maxLabelSize=0;var s=this.scale.getLines();ni(s).call(s,(function(e){var n=e.y,o=e.major;t.options.showMinorLabels&&!1===o&&t._redrawLabel(n-2,e.val,i,"vis-y-axis vis-minor",t.props.minorCharHeight),o&&n>=0&&t._redrawLabel(n-2,e.val,i,"vis-y-axis vis-major",t.props.majorCharHeight),!0===t.master&&(o?t._redrawLine(n,i,"vis-grid vis-horizontal vis-major",t.options.majorLinesOffset,t.props.majorLineWidth):t._redrawLine(n,i,"vis-grid vis-horizontal vis-minor",t.options.minorLinesOffset,t.props.minorLineWidth))}));var a=0;void 0!==this.options[i].title&&void 0!==this.options[i].title.text&&(a=this.props.titleCharHeight);var l=!0===this.options.icons?Math.max(this.options.iconWidth,a)+this.options.labelOffsetX+15:a+this.options.labelOffsetX+15;return this.maxLabelSize>this.width-l&&!0===this.options.visible?(this.width=this.maxLabelSize+l,this.options.width="".concat(this.width,"px"),Dd(this.DOMelements.lines),Dd(this.DOMelements.labels),this.redraw(),e=!0):this.maxLabelSize<this.width-l&&!0===this.options.visible&&this.width>this.minWidth?(this.width=Math.max(this.minWidth,this.maxLabelSize+l),this.options.width="".concat(this.width,"px"),Dd(this.DOMelements.lines),Dd(this.DOMelements.labels),this.redraw(),e=!0):(Dd(this.DOMelements.lines),Dd(this.DOMelements.labels),e=!1),e}},{key:"convertValue",value:function(t){return this.scale.convertValue(t)}},{key:"screenToValue",value:function(t){return this.scale.screenToValue(t)}},{key:"_redrawLabel",value:function(t,e,i,n,o){var r=Td("div",this.DOMelements.labels,this.dom.frame);r.className=n,r.innerHTML=e,"left"===i?(r.style.left="-".concat(this.options.labelOffsetX,"px"),r.style.textAlign="right"):(r.style.right="-".concat(this.options.labelOffsetX,"px"),r.style.textAlign="left"),r.style.top="".concat(t-.5*o+this.options.labelOffsetY,"px"),e+="";var s=Math.max(this.props.majorCharWidth,this.props.minorCharWidth);this.maxLabelSize<e.length*s&&(this.maxLabelSize=e.length*s)}},{key:"_redrawLine",value:function(t,e,i,n,o){if(!0===this.master){var r=Td("div",this.DOMelements.lines,this.dom.lineContainer);r.className=i,r.innerHTML="","left"===e?r.style.left="".concat(this.width-n,"px"):r.style.right="".concat(this.width-n,"px"),r.style.width="".concat(o,"px"),r.style.top="".concat(t,"px")}}},{key:"_redrawTitle",value:function(t){if(Sd(this.DOMelements.title),void 0!==this.options[t].title&&void 0!==this.options[t].title.text){var e=Td("div",this.DOMelements.title,this.dom.frame);e.className="vis-y-axis vis-title vis-".concat(t),e.innerHTML=this.options[t].title.text,void 0!==this.options[t].title.style&&Os.addCssText(e,this.options[t].title.style),"left"===t?e.style.left="".concat(this.props.titleCharHeight,"px"):e.style.right="".concat(this.props.titleCharHeight,"px"),e.style.width="".concat(this.height,"px")}Dd(this.DOMelements.title)}},{key:"_calculateCharSize",value:function(){if(!("minorCharHeight"in this.props)){var t=document.createTextNode("0"),e=document.createElement("div");e.className="vis-y-axis vis-minor vis-measure",e.appendChild(t),this.dom.frame.appendChild(e),this.props.minorCharHeight=e.clientHeight,this.props.minorCharWidth=e.clientWidth,this.dom.frame.removeChild(e)}if(!("majorCharHeight"in this.props)){var i=document.createTextNode("0"),n=document.createElement("div");n.className="vis-y-axis vis-major vis-measure",n.appendChild(i),this.dom.frame.appendChild(n),this.props.majorCharHeight=n.clientHeight,this.props.majorCharWidth=n.clientWidth,this.dom.frame.removeChild(n)}if(!("titleCharHeight"in this.props)){var o=document.createTextNode("0"),r=document.createElement("div");r.className="vis-y-axis vis-title vis-measure",r.appendChild(o),this.dom.frame.appendChild(r),this.props.titleCharHeight=r.clientHeight,this.props.titleCharWidth=r.clientWidth,this.dom.frame.removeChild(r)}}}]),i}();function Rd(t,e){}function Ld(t,e){return{style:(e=void 0===e?{}:e).style||t.options.drawPoints.style,styles:e.styles||t.options.drawPoints.styles,size:e.size||t.options.drawPoints.size,className:e.className||t.className}}function jd(t,e){}function Fd(t,e){}function zd(t,e,i,n){this.id=e;this.options=Os.selectiveBridgeObject(["sampling","style","sort","yAxisOrientation","barChart","drawPoints","shaded","interpolation","zIndex","excludeFromStacking","excludeFromLegend"],i),this.usingDefaultStyle=void 0===t.className,this.groupsUsingDefaultStyles=n,this.zeroPosition=0,this.update(t),1==this.usingDefaultStyle&&(this.groupsUsingDefaultStyles[0]+=1),this.itemsData=[],this.visible=void 0===t.visible||t.visible}function Gd(t,e,i,n){this.body=t,this.defaultOptions={enabled:!1,icons:!0,iconSize:20,iconSpacing:6,left:{visible:!0,position:"top-left"},right:{visible:!0,position:"top-right"}},this.side=i,this.options=Os.extend({},this.defaultOptions),this.linegraphOptions=n,this.svgElements={},this.dom={},this.groups={},this.amountOfGroups=0,this._create(),this.framework={svg:this.svg,svgElements:this.svgElements,options:this.options,groups:this.groups},this.setOptions(e)}Rd.draw=function(t,e,i,n){n=n||0;for(var o=function(t,e){var i=void 0;t.options&&t.options.drawPoints&&t.options.drawPoints.onRender&&"function"==typeof t.options.drawPoints.onRender&&(i=t.options.drawPoints.onRender);e.group.options&&e.group.options.drawPoints&&e.group.options.drawPoints.onRender&&"function"==typeof e.group.options.drawPoints.onRender&&(i=e.group.options.drawPoints.onRender);return i}(i,e),r=0;r<t.length;r++)if(o){var s=o(t[r],e);!0!==s&&"object"!==Fn(s)||Od(t[r].screen_x+n,t[r].screen_y,Ld(e,s),i.svgElements,i.svg,t[r].label)}else Od(t[r].screen_x+n,t[r].screen_y,Ld(e),i.svgElements,i.svg,t[r].label)},Rd.drawIcon=function(t,e,i,n,o,r){var s=.5*o,a=Cd("rect",r.svgElements,r.svg);a.setAttributeNS(null,"x",e),a.setAttributeNS(null,"y",i-s),a.setAttributeNS(null,"width",n),a.setAttributeNS(null,"height",2*s),a.setAttributeNS(null,"class","vis-outline"),Od(e+.5*n,i,Ld(t),r.svgElements,r.svg)},jd.drawIcon=function(t,e,i,n,o,r){var s=.5*o,a=Cd("rect",r.svgElements,r.svg);a.setAttributeNS(null,"x",e),a.setAttributeNS(null,"y",i-s),a.setAttributeNS(null,"width",n),a.setAttributeNS(null,"height",2*s),a.setAttributeNS(null,"class","vis-outline");var l=Math.round(.3*n),h=t.options.barChart.width/l,u=Math.round(.4*o),d=Math.round(.75*o),c=Math.round((n-2*l)/3);if(Ed(e+.5*l+c,i+s-u-1,l,u,t.className+" vis-bar",r.svgElements,r.svg,t.style),Ed(e+1.5*l+c+2,i+s-d-1,l,d,t.className+" vis-bar",r.svgElements,r.svg,t.style),1==t.options.drawPoints.enabled){var p={style:t.options.drawPoints.style,styles:t.options.drawPoints.styles,size:t.options.drawPoints.size/h,className:t.className};Od(e+.5*l+c,i+s-u-1,p,r.svgElements,r.svg),Od(e+1.5*l+c+2,i+s-d-1,p,r.svgElements,r.svg)}},jd.draw=function(t,e,i){var n,o,r,s,a,l,h=[],u={},d=0;for(a=0;a<t.length;a++)if("bar"===(s=i.groups[t[a]]).options.style&&!0===s.visible&&(void 0===i.options.groups.visibility[t[a]]||!0===i.options.groups.visibility[t[a]]))for(l=0;l<e[t[a]].length;l++)h.push({screen_x:e[t[a]][l].screen_x,screen_end:e[t[a]][l].screen_end,screen_y:e[t[a]][l].screen_y,x:e[t[a]][l].x,end:e[t[a]][l].end,y:e[t[a]][l].y,groupId:t[a],label:e[t[a]][l].label}),d+=1;if(0!==d)for(qs(h).call(h,(function(t,e){return t.screen_x===e.screen_x?t.groupId<e.groupId?-1:1:t.screen_x-e.screen_x})),jd._getDataIntersections(u,h),a=0;a<h.length;a++){var c=null!=(s=i.groups[h[a].groupId]).options.barChart.minWidth?s.options.barChart.minWidth:.1*s.options.barChart.width,p=0;if(void 0===u[o=h[a].screen_x])a+1<h.length&&(n=Math.abs(h[a+1].screen_x-o)),r=jd._getSafeDrawData(n,s,c);else{var m=a+(u[o].amount-u[o].resolved);m<h.length&&(n=Math.abs(h[m].screen_x-o)),r=jd._getSafeDrawData(n,s,c),u[o].resolved+=1,!0===s.options.stack&&!0!==s.options.excludeFromStacking?h[a].screen_y<s.zeroPosition?(p=u[o].accumulatedNegative,u[o].accumulatedNegative+=s.zeroPosition-h[a].screen_y):(p=u[o].accumulatedPositive,u[o].accumulatedPositive+=s.zeroPosition-h[a].screen_y):!0===s.options.barChart.sideBySide&&(r.width=r.width/u[o].amount,r.offset+=u[o].resolved*r.width-.5*r.width*(u[o].amount+1))}var f=r.width,g=h[a].screen_x;if(null!=h[a].screen_end?g+=.5*(f=h[a].screen_end-h[a].screen_x):g+=r.offset,Ed(g,h[a].screen_y-p,f,s.zeroPosition-h[a].screen_y,s.className+" vis-bar",i.svgElements,i.svg,s.style),!0===s.options.drawPoints.enabled){var v={screen_x:h[a].screen_x,screen_y:h[a].screen_y-p,x:h[a].x,y:h[a].y,groupId:h[a].groupId,label:h[a].label};Rd.draw([v],s,i,r.offset)}}},jd._getDataIntersections=function(t,e){for(var i,n=0;n<e.length;n++)n+1<e.length&&(i=Math.abs(e[n+1].screen_x-e[n].screen_x)),n>0&&(i=Math.min(i,Math.abs(e[n-1].screen_x-e[n].screen_x))),0===i&&(void 0===t[e[n].screen_x]&&(t[e[n].screen_x]={amount:0,resolved:0,accumulatedPositive:0,accumulatedNegative:0}),t[e[n].screen_x].amount+=1)},jd._getSafeDrawData=function(t,e,i){var n,o;return t<e.options.barChart.width&&t>0?(n=t<i?i:t,o=0,"left"===e.options.barChart.align?o-=.5*t:"right"===e.options.barChart.align&&(o+=.5*t)):(n=e.options.barChart.width,o=0,"left"===e.options.barChart.align?o-=.5*e.options.barChart.width:"right"===e.options.barChart.align&&(o+=.5*e.options.barChart.width)),{width:n,offset:o}},jd.getStackedYRange=function(t,e,i,n,o){if(t.length>0){qs(t).call(t,(function(t,e){return t.screen_x===e.screen_x?t.groupId<e.groupId?-1:1:t.screen_x-e.screen_x}));var r={};jd._getDataIntersections(r,t),e[n]=jd._getStackedYRange(r,t),e[n].yAxisOrientation=o,i.push(n)}},jd._getStackedYRange=function(t,e){for(var i,n=e[0].screen_y,o=e[0].screen_y,r=0;r<e.length;r++)void 0===t[i=e[r].screen_x]?(n=n>e[r].screen_y?e[r].screen_y:n,o=o<e[r].screen_y?e[r].screen_y:o):e[r].screen_y<0?t[i].accumulatedNegative+=e[r].screen_y:t[i].accumulatedPositive+=e[r].screen_y;for(var s in t)t.hasOwnProperty(s)&&(n=(n=n>t[s].accumulatedNegative?t[s].accumulatedNegative:n)>t[s].accumulatedPositive?t[s].accumulatedPositive:n,o=(o=o<t[s].accumulatedNegative?t[s].accumulatedNegative:o)<t[s].accumulatedPositive?t[s].accumulatedPositive:o);return{min:n,max:o}},Fd.calcPath=function(t,e){if(null!=t&&t.length>0){return 1==e.options.interpolation.enabled?Fd._catmullRom(t,e):Fd._linear(t)}},Fd.drawIcon=function(t,e,i,n,o,r){var s,a,l=.5*o,h=Cd("rect",r.svgElements,r.svg);(h.setAttributeNS(null,"x",e),h.setAttributeNS(null,"y",i-l),h.setAttributeNS(null,"width",n),h.setAttributeNS(null,"height",2*l),h.setAttributeNS(null,"class","vis-outline"),(s=Cd("path",r.svgElements,r.svg)).setAttributeNS(null,"class",t.className),void 0!==t.style&&s.setAttributeNS(null,"style",t.style),s.setAttributeNS(null,"d","M"+e+","+i+" L"+(e+n)+","+i),1==t.options.shaded.enabled&&(a=Cd("path",r.svgElements,r.svg),"top"==t.options.shaded.orientation?a.setAttributeNS(null,"d","M"+e+", "+(i-l)+"L"+e+","+i+" L"+(e+n)+","+i+" L"+(e+n)+","+(i-l)):a.setAttributeNS(null,"d","M"+e+","+i+" L"+e+","+(i+l)+" L"+(e+n)+","+(i+l)+"L"+(e+n)+","+i),a.setAttributeNS(null,"class",t.className+" vis-icon-fill"),void 0!==t.options.shaded.style&&""!==t.options.shaded.style&&a.setAttributeNS(null,"style",t.options.shaded.style)),1==t.options.drawPoints.enabled)&&Od(e+.5*n,i,{style:t.options.drawPoints.style,styles:t.options.drawPoints.styles,size:t.options.drawPoints.size,className:t.className},r.svgElements,r.svg)},Fd.drawShading=function(t,e,i,n){if(1==e.options.shaded.enabled){var o,r=Number(n.svg.style.height.replace("px","")),s=Cd("path",n.svgElements,n.svg),a="L";1==e.options.interpolation.enabled&&(a="C");var l=0;l="top"==e.options.shaded.orientation?0:"bottom"==e.options.shaded.orientation?r:Math.min(Math.max(0,e.zeroPosition),r),o="group"==e.options.shaded.orientation&&null!=i&&null!=i?"M"+t[0][0]+","+t[0][1]+" "+this.serializePath(t,a,!1)+" L"+i[i.length-1][0]+","+i[i.length-1][1]+" "+this.serializePath(i,a,!0)+i[0][0]+","+i[0][1]+" Z":"M"+t[0][0]+","+t[0][1]+" "+this.serializePath(t,a,!1)+" V"+l+" H"+t[0][0]+" Z",s.setAttributeNS(null,"class",e.className+" vis-fill"),void 0!==e.options.shaded.style&&s.setAttributeNS(null,"style",e.options.shaded.style),s.setAttributeNS(null,"d",o)}},Fd.draw=function(t,e,i){if(null!=t&&null!=t){var n=Cd("path",i.svgElements,i.svg);n.setAttributeNS(null,"class",e.className),void 0!==e.style&&n.setAttributeNS(null,"style",e.style);var o="L";1==e.options.interpolation.enabled&&(o="C"),n.setAttributeNS(null,"d","M"+t[0][0]+","+t[0][1]+" "+this.serializePath(t,o,!1))}},Fd.serializePath=function(t,e,i){if(t.length<2)return"";var n,o=e;if(i)for(n=t.length-2;n>0;n--)o+=t[n][0]+","+t[n][1]+" ";else for(n=1;n<t.length;n++)o+=t[n][0]+","+t[n][1]+" ";return o},Fd._catmullRomUniform=function(t){var e,i,n,o,r,s,a=[];a.push([Math.round(t[0].screen_x),Math.round(t[0].screen_y)]);for(var l=t.length,h=0;h<l-1;h++)e=0==h?t[0]:t[h-1],i=t[h],n=t[h+1],o=h+2<l?t[h+2]:n,r={screen_x:(-e.screen_x+6*i.screen_x+n.screen_x)*(1/6),screen_y:(-e.screen_y+6*i.screen_y+n.screen_y)*(1/6)},s={screen_x:(i.screen_x+6*n.screen_x-o.screen_x)*(1/6),screen_y:(i.screen_y+6*n.screen_y-o.screen_y)*(1/6)},a.push([r.screen_x,r.screen_y]),a.push([s.screen_x,s.screen_y]),a.push([n.screen_x,n.screen_y]);return a},Fd._catmullRom=function(t,e){var i=e.options.interpolation.alpha;if(0==i||void 0===i)return this._catmullRomUniform(t);var n,o,r,s,a,l,h,u,d,c,p,m,f,g,v,y,b,w,_,k=[];k.push([Math.round(t[0].screen_x),Math.round(t[0].screen_y)]);for(var x=t.length,S=0;S<x-1;S++)n=0==S?t[0]:t[S-1],o=t[S],r=t[S+1],s=S+2<x?t[S+2]:r,h=Math.sqrt(Math.pow(n.screen_x-o.screen_x,2)+Math.pow(n.screen_y-o.screen_y,2)),u=Math.sqrt(Math.pow(o.screen_x-r.screen_x,2)+Math.pow(o.screen_y-r.screen_y,2)),d=Math.sqrt(Math.pow(r.screen_x-s.screen_x,2)+Math.pow(r.screen_y-s.screen_y,2)),g=Math.pow(d,i),y=Math.pow(d,2*i),v=Math.pow(u,i),b=Math.pow(u,2*i),_=Math.pow(h,i),c=2*(w=Math.pow(h,2*i))+3*_*v+b,p=2*y+3*g*v+b,(m=3*_*(_+v))>0&&(m=1/m),(f=3*g*(g+v))>0&&(f=1/f),a={screen_x:(-b*n.screen_x+c*o.screen_x+w*r.screen_x)*m,screen_y:(-b*n.screen_y+c*o.screen_y+w*r.screen_y)*m},l={screen_x:(y*o.screen_x+p*r.screen_x-b*s.screen_x)*f,screen_y:(y*o.screen_y+p*r.screen_y-b*s.screen_y)*f},0==a.screen_x&&0==a.screen_y&&(a=o),0==l.screen_x&&0==l.screen_y&&(l=r),k.push([a.screen_x,a.screen_y]),k.push([l.screen_x,l.screen_y]),k.push([r.screen_x,r.screen_y]);return k},Fd._linear=function(t){for(var e=[],i=0;i<t.length;i++)e.push([t[i].screen_x,t[i].screen_y]);return e},zd.prototype.setItems=function(t){null!=t?(this.itemsData=t,1==qs(this.options)&&Os.insertSort(this.itemsData,(function(t,e){return t.x>e.x?1:-1}))):this.itemsData=[]},zd.prototype.getItems=function(){return this.itemsData},zd.prototype.setZeroPosition=function(t){this.zeroPosition=t},zd.prototype.setOptions=function(t){if(void 0!==t){Os.selectiveDeepExtend(["sampling","style","sort","yAxisOrientation","barChart","zIndex","excludeFromStacking","excludeFromLegend"],this.options,t),"function"==typeof t.drawPoints&&(t.drawPoints={onRender:t.drawPoints}),Os.mergeOptions(this.options,t,"interpolation"),Os.mergeOptions(this.options,t,"drawPoints"),Os.mergeOptions(this.options,t,"shaded"),t.interpolation&&"object"==Fn(t.interpolation)&&t.interpolation.parametrization&&("uniform"==t.interpolation.parametrization?this.options.interpolation.alpha=0:"chordal"==t.interpolation.parametrization?this.options.interpolation.alpha=1:(this.options.interpolation.parametrization="centripetal",this.options.interpolation.alpha=.5))}},zd.prototype.update=function(t){this.group=t,this.content=t.content||"graph",this.className=t.className||this.className||"vis-graph-group"+this.groupsUsingDefaultStyles[0]%10,this.visible=void 0===t.visible||t.visible,this.style=t.style,this.setOptions(t.options)},zd.prototype.getLegend=function(t,e,i,n,o){null!=i&&null!=i||(i={svg:document.createElementNS("http://www.w3.org/2000/svg","svg"),svgElements:{},options:this.options,groups:[this]});switch(null!=n&&null!=n||(n=0),null!=o&&null!=o||(o=.5*e),this.options.style){case"line":Fd.drawIcon(this,n,o,t,e,i);break;case"points":case"point":Rd.drawIcon(this,n,o,t,e,i);break;case"bar":jd.drawIcon(this,n,o,t,e,i)}return{icon:i.svg,label:this.content,orientation:this.options.yAxisOrientation}},zd.prototype.getYRange=function(t){for(var e=t[0].y,i=t[0].y,n=0;n<t.length;n++)e=e>t[n].y?t[n].y:e,i=i<t[n].y?t[n].y:i;return{min:e,max:i,yAxisOrientation:this.options.yAxisOrientation}},Gd.prototype=new Gs,Gd.prototype.clear=function(){this.groups={},this.amountOfGroups=0},Gd.prototype.addGroup=function(t,e){1!=e.options.excludeFromLegend&&(this.groups.hasOwnProperty(t)||(this.groups[t]=e),this.amountOfGroups+=1)},Gd.prototype.updateGroup=function(t,e){this.groups[t]=e},Gd.prototype.removeGroup=function(t){this.groups.hasOwnProperty(t)&&(delete this.groups[t],this.amountOfGroups-=1)},Gd.prototype._create=function(){this.dom.frame=document.createElement("div"),this.dom.frame.className="vis-legend",this.dom.frame.style.position="absolute",this.dom.frame.style.top="10px",this.dom.frame.style.display="block",this.dom.textArea=document.createElement("div"),this.dom.textArea.className="vis-legend-text",this.dom.textArea.style.position="relative",this.dom.textArea.style.top="0px",this.svg=document.createElementNS("http://www.w3.org/2000/svg","svg"),this.svg.style.position="absolute",this.svg.style.top="0px",this.svg.style.width=this.options.iconSize+5+"px",this.svg.style.height="100%",this.dom.frame.appendChild(this.svg),this.dom.frame.appendChild(this.dom.textArea)},Gd.prototype.hide=function(){this.dom.frame.parentNode&&this.dom.frame.parentNode.removeChild(this.dom.frame)},Gd.prototype.show=function(){this.dom.frame.parentNode||this.body.dom.center.appendChild(this.dom.frame)},Gd.prototype.setOptions=function(t){Os.selectiveDeepExtend(["enabled","orientation","icons","left","right"],this.options,t)},Gd.prototype.redraw=function(){var t=0,e=eo(this.groups);qs(e).call(e,(function(t,e){return t<e?-1:1}));for(var i=0;i<e.length;i++){var n=e[i];1!=this.groups[n].visible||void 0!==this.linegraphOptions.visibility[n]&&1!=this.linegraphOptions.visibility[n]||t++}if(0==this.options[this.side].visible||0==this.amountOfGroups||0==this.options.enabled||0==t)this.hide();else{if(this.show(),"top-left"==this.options[this.side].position||"bottom-left"==this.options[this.side].position?(this.dom.frame.style.left="4px",this.dom.frame.style.textAlign="left",this.dom.textArea.style.textAlign="left",this.dom.textArea.style.left=this.options.iconSize+15+"px",this.dom.textArea.style.right="",this.svg.style.left="0px",this.svg.style.right=""):(this.dom.frame.style.right="4px",this.dom.frame.style.textAlign="right",this.dom.textArea.style.textAlign="right",this.dom.textArea.style.right=this.options.iconSize+15+"px",this.dom.textArea.style.left="",this.svg.style.right="0px",this.svg.style.left=""),"top-left"==this.options[this.side].position||"top-right"==this.options[this.side].position)this.dom.frame.style.top=4-Number(this.body.dom.center.style.top.replace("px",""))+"px",this.dom.frame.style.bottom="";else{var o=this.body.domProps.center.height-this.body.domProps.centerContainer.height;this.dom.frame.style.bottom=4+o+Number(this.body.dom.center.style.top.replace("px",""))+"px",this.dom.frame.style.top=""}0==this.options.icons?(this.dom.frame.style.width=this.dom.textArea.offsetWidth+10+"px",this.dom.textArea.style.right="",this.dom.textArea.style.left="",this.svg.style.width="0px"):(this.dom.frame.style.width=this.options.iconSize+15+this.dom.textArea.offsetWidth+10+"px",this.drawLegendIcons());var r="";for(i=0;i<e.length;i++)n=e[i],1!=this.groups[n].visible||void 0!==this.linegraphOptions.visibility[n]&&1!=this.linegraphOptions.visibility[n]||(r+=this.groups[n].content+"<br />");this.dom.textArea.innerHTML=r,this.dom.textArea.style.lineHeight=.75*this.options.iconSize+this.options.iconSpacing+"px"}},Gd.prototype.drawLegendIcons=function(){if(this.dom.frame.parentNode){var t=eo(this.groups);qs(t).call(t,(function(t,e){return t<e?-1:1})),Sd(h=this.svgElements),Dd(h),Sd(h);var e=window.getComputedStyle(this.dom.frame).paddingTop,i=Number(e.replace("px","")),n=i,o=this.options.iconSize,r=.75*this.options.iconSize,s=i+.5*r+3;this.svg.style.width=o+5+i+"px";for(var a=0;a<t.length;a++){var l=t[a];1!=this.groups[l].visible||void 0!==this.linegraphOptions.visibility[l]&&1!=this.linegraphOptions.visibility[l]||(this.groups[l].getLegend(o,r,this.framework,n,s),s+=r+this.options.iconSpacing)}}var h};function Hd(t,e){this.id=eu(),this.body=t,this.defaultOptions={yAxisOrientation:"left",defaultGroup:"default",sort:!0,sampling:!0,stack:!1,graphHeight:"400px",shaded:{enabled:!1,orientation:"bottom"},style:"line",barChart:{width:50,sideBySide:!1,align:"center"},interpolation:{enabled:!0,parametrization:"centripetal",alpha:.5},drawPoints:{enabled:!0,size:6,style:"square"},dataAxis:{},legend:{},groups:{visibility:{}}},this.options=Os.extend({},this.defaultOptions),this.dom={},this.props={},this.hammer=null,this.groups={},this.abortedGraphUpdate=!1,this.updateSVGheight=!1,this.updateSVGheightOnResize=!1,this.forceGraphUpdate=!0;var i=this;this.itemsData=null,this.groupsData=null,this.itemListeners={add:function(t,e,n){i._onAdd(e.items)},update:function(t,e,n){i._onUpdate(e.items)},remove:function(t,e,n){i._onRemove(e.items)}},this.groupListeners={add:function(t,e,n){i._onAddGroups(e.items)},update:function(t,e,n){i._onUpdateGroups(e.items)},remove:function(t,e,n){i._onRemoveGroups(e.items)}},this.items={},this.selection=[],this.lastStart=this.body.range.start,this.touchParams={},this.svgElements={},this.setOptions(e),this.groupsUsingDefaultStyles=[0],this.body.emitter.on("rangechanged",(function(){i.lastStart=i.body.range.start,i.svg.style.left=Os.option.asSize(-i.props.width),i.forceGraphUpdate=!0,i.redraw.call(i)})),this._create(),this.framework={svg:this.svg,svgElements:this.svgElements,options:this.options,groups:this.groups}}Hd.prototype=new Gs,Hd.prototype._create=function(){var t=document.createElement("div");t.className="vis-line-graph",this.dom.frame=t,this.svg=document.createElementNS("http://www.w3.org/2000/svg","svg"),this.svg.style.position="relative",this.svg.style.height=(""+this.options.graphHeight).replace("px","")+"px",this.svg.style.display="block",t.appendChild(this.svg),this.options.dataAxis.orientation="left",this.yAxisLeft=new Nd(this.body,this.options.dataAxis,this.svg,this.options.groups),this.options.dataAxis.orientation="right",this.yAxisRight=new Nd(this.body,this.options.dataAxis,this.svg,this.options.groups),delete this.options.dataAxis.orientation,this.legendLeft=new Gd(this.body,this.options.legend,"left",this.options.groups),this.legendRight=new Gd(this.body,this.options.legend,"right",this.options.groups),this.show()},Hd.prototype.setOptions=function(t){if(t){void 0===t.graphHeight&&void 0!==t.height?(this.updateSVGheight=!0,this.updateSVGheightOnResize=!0):void 0!==this.body.domProps.centerContainer.height&&void 0!==t.graphHeight&&Xo((t.graphHeight+"").replace("px",""))<this.body.domProps.centerContainer.height&&(this.updateSVGheight=!0),Os.selectiveDeepExtend(["sampling","defaultGroup","stack","height","graphHeight","yAxisOrientation","style","barChart","dataAxis","sort","groups"],this.options,t),Os.mergeOptions(this.options,t,"interpolation"),Os.mergeOptions(this.options,t,"drawPoints"),Os.mergeOptions(this.options,t,"shaded"),Os.mergeOptions(this.options,t,"legend"),t.interpolation&&"object"==Fn(t.interpolation)&&t.interpolation.parametrization&&("uniform"==t.interpolation.parametrization?this.options.interpolation.alpha=0:"chordal"==t.interpolation.parametrization?this.options.interpolation.alpha=1:(this.options.interpolation.parametrization="centripetal",this.options.interpolation.alpha=.5)),this.yAxisLeft&&void 0!==t.dataAxis&&(this.yAxisLeft.setOptions(this.options.dataAxis),this.yAxisRight.setOptions(this.options.dataAxis)),this.legendLeft&&void 0!==t.legend&&(this.legendLeft.setOptions(this.options.legend),this.legendRight.setOptions(this.options.legend)),this.groups.hasOwnProperty("__ungrouped__")&&this.groups.__ungrouped__.setOptions(t)}this.dom.frame&&(this.forceGraphUpdate=!0,this.body.emitter.emit("_change",{queue:!0}))},Hd.prototype.hide=function(){this.dom.frame.parentNode&&this.dom.frame.parentNode.removeChild(this.dom.frame)},Hd.prototype.show=function(){this.dom.frame.parentNode||this.body.dom.center.appendChild(this.dom.frame)},Hd.prototype.setItems=function(t){var i,o=this,r=this.itemsData;if(t){if(!(t instanceof e||t instanceof n))throw new TypeError("Data must be an instance of DataSet or DataView");this.itemsData=Ts(t)}else this.itemsData=null;if(r&&(ni(Os).call(Os,this.itemListeners,(function(t,e){r.off(e,t)})),r.dispose(),i=r.getIds(),this._onRemove(i)),this.itemsData){var s=this.id;ni(Os).call(Os,this.itemListeners,(function(t,e){o.itemsData.on(e,t,s)})),i=this.itemsData.getIds(),this._onAdd(i)}},Hd.prototype.setGroups=function(t){var i,o=this;if(this.groupsData){ni(Os).call(Os,this.groupListeners,(function(t,e){o.groupsData.off(e,t)})),i=this.groupsData.getIds(),this.groupsData=null;for(var r=0;r<i.length;r++)this._removeGroup(i[r])}if(t){if(!(t instanceof e||t instanceof n))throw new TypeError("Data must be an instance of DataSet or DataView");this.groupsData=t}else this.groupsData=null;if(this.groupsData){var s=this.id;ni(Os).call(Os,this.groupListeners,(function(t,e){o.groupsData.on(e,t,s)})),i=this.groupsData.getIds(),this._onAddGroups(i)}},Hd.prototype._onUpdate=function(t){this._updateAllGroupData(t)},Hd.prototype._onAdd=function(t){this._onUpdate(t)},Hd.prototype._onRemove=function(t){this._onUpdate(t)},Hd.prototype._onUpdateGroups=function(t){this._updateAllGroupData(null,t)},Hd.prototype._onAddGroups=function(t){this._onUpdateGroups(t)},Hd.prototype._onRemoveGroups=function(t){for(var e=0;e<t.length;e++)this._removeGroup(t[e]);this.forceGraphUpdate=!0,this.body.emitter.emit("_change",{queue:!0})},Hd.prototype._removeGroup=function(t){this.groups.hasOwnProperty(t)&&("right"==this.groups[t].options.yAxisOrientation?(this.yAxisRight.removeGroup(t),this.legendRight.removeGroup(t),this.legendRight.redraw()):(this.yAxisLeft.removeGroup(t),this.legendLeft.removeGroup(t),this.legendLeft.redraw()),delete this.groups[t])},Hd.prototype._updateGroup=function(t,e){this.groups.hasOwnProperty(e)?(this.groups[e].update(t),"right"==this.groups[e].options.yAxisOrientation?(this.yAxisRight.updateGroup(e,this.groups[e]),this.legendRight.updateGroup(e,this.groups[e]),this.yAxisLeft.removeGroup(e),this.legendLeft.removeGroup(e)):(this.yAxisLeft.updateGroup(e,this.groups[e]),this.legendLeft.updateGroup(e,this.groups[e]),this.yAxisRight.removeGroup(e),this.legendRight.removeGroup(e))):(this.groups[e]=new zd(t,e,this.options,this.groupsUsingDefaultStyles),"right"==this.groups[e].options.yAxisOrientation?(this.yAxisRight.addGroup(e,this.groups[e]),this.legendRight.addGroup(e,this.groups[e])):(this.yAxisLeft.addGroup(e,this.groups[e]),this.legendLeft.addGroup(e,this.groups[e]))),this.legendLeft.redraw(),this.legendRight.redraw()},Hd.prototype._updateAllGroupData=function(t,e){if(null!=this.itemsData){var i={},n=this.itemsData.get(),o=this.itemsData.idProp,r={};t&&fo(t).call(t,(function(t){r[t]=t}));for(var s={},a=0;a<n.length;a++){var l=n[a],h=l.group;null==h&&(h="__ungrouped__"),s.hasOwnProperty(h)?s[h]++:s[h]=1}var u={};if(!e&&t)for(h in this.groups)if(this.groups.hasOwnProperty(h)){var d=(f=this.groups[h]).getItems();i[h]=gi(d).call(d,(function(t){return u[t[o]]=t[o],t[o]!==r[t[o]]}));var c=s[h];s[h]-=i[h].length,i[h].length<c&&(i[h][c-1]={})}for(a=0;a<n.length;a++)if(null==(h=(l=n[a]).group)&&(h="__ungrouped__"),e||!t||l[o]===r[l[o]]||!u.hasOwnProperty(l[o])){i.hasOwnProperty(h)||(i[h]=new Array(s[h]));var p=Os.bridgeObject(l);p.x=Os.convert(l.x,"Date"),p.end=Os.convert(l.end,"Date"),p.orginalY=l.y,p.y=Number(l.y),p[o]=l[o];var m=i[h].length-s[h]--;i[h][m]=p}for(h in this.groups)this.groups.hasOwnProperty(h)&&(i.hasOwnProperty(h)||(i[h]=new Array(0)));for(h in i)if(i.hasOwnProperty(h))if(0==i[h].length)this.groups.hasOwnProperty(h)&&this._removeGroup(h);else{var f=void 0;null!=this.groupsData&&(f=this.groupsData.get(h)),null==f&&(f={id:h,content:this.options.defaultGroup+h}),this._updateGroup(f,h),this.groups[h].setItems(i[h])}this.forceGraphUpdate=!0,this.body.emitter.emit("_change",{queue:!0})}},Hd.prototype.redraw=function(){var t=!1;this.props.width=this.dom.frame.offsetWidth,this.props.height=this.body.domProps.centerContainer.height-this.body.domProps.border.top-this.body.domProps.border.bottom,t=this._isResized()||t;var e,i=this.body.range.end-this.body.range.start,n=i!=this.lastVisibleInterval;(this.lastVisibleInterval=i,1==t)&&(this.svg.style.width=Os.option.asSize(3*this.props.width),this.svg.style.left=Os.option.asSize(-this.props.width),-1==sr(e=this.options.height+"").call(e,"%")&&1!=this.updateSVGheightOnResize||(this.updateSVGheight=!0));if(1==this.updateSVGheight?(this.options.graphHeight!=this.props.height+"px"&&(this.options.graphHeight=this.props.height+"px",this.svg.style.height=this.props.height+"px"),this.updateSVGheight=!1):this.svg.style.height=(""+this.options.graphHeight).replace("px","")+"px",1==t||1==n||1==this.abortedGraphUpdate||1==this.forceGraphUpdate)t=this._updateGraph()||t,this.forceGraphUpdate=!1;else if(0!=this.lastStart){var o=this.body.range.start-this.lastStart,r=this.body.range.end-this.body.range.start;if(0!=this.props.width){var s=o*(this.props.width/r);this.svg.style.left=-this.props.width-s+"px"}}return this.legendLeft.redraw(),this.legendRight.redraw(),t},Hd.prototype._getSortedGroupIds=function(){var t=[];for(var e in this.groups)if(this.groups.hasOwnProperty(e)){var i=this.groups[e];1!=i.visible||void 0!==this.options.groups.visibility[e]&&1!=this.options.groups.visibility[e]||t.push({id:e,zIndex:i.options.zIndex})}Os.insertSort(t,(function(t,e){var i=t.zIndex,n=e.zIndex;return void 0===i&&(i=0),void 0===n&&(n=0),i==n?0:i<n?-1:1}));for(var n=new Array(t.length),o=0;o<t.length;o++)n[o]=t[o].id;return n},Hd.prototype._updateGraph=function(){if(Sd(this.svgElements),0!=this.props.width&&null!=this.itemsData){var t,e,i={},n=this.body.util.toGlobalTime(-this.body.domProps.root.width),o=this.body.util.toGlobalTime(2*this.body.domProps.root.width),r=this._getSortedGroupIds();if(r.length>0){var s={};for(this._getRelevantData(r,s,n,o),this._applySampling(r,s),e=0;e<r.length;e++)this._convertXcoordinates(s[r[e]]);if(this._getYRanges(r,s,i),1==this._updateYAxis(r,i))return Dd(this.svgElements),this.abortedGraphUpdate=!0,!0;this.abortedGraphUpdate=!1;var a=void 0;for(e=0;e<r.length;e++)t=this.groups[r[e]],!0===this.options.stack&&"line"===this.options.style&&(null!=t.options.excludeFromStacking&&t.options.excludeFromStacking||(null!=a&&(this._stack(s[t.id],s[a.id]),1==t.options.shaded.enabled&&"group"!==t.options.shaded.orientation&&("top"==t.options.shaded.orientation&&"group"!==a.options.shaded.orientation?(a.options.shaded.orientation="group",a.options.shaded.groupId=t.id):(t.options.shaded.orientation="group",t.options.shaded.groupId=a.id))),a=t)),this._convertYcoordinates(s[r[e]],t);var l={};for(e=0;e<r.length;e++)if("line"===(t=this.groups[r[e]]).options.style&&1==t.options.shaded.enabled){var h=s[r[e]];if(null==h||0==h.length)continue;if(l.hasOwnProperty(r[e])||(l[r[e]]=Fd.calcPath(h,t)),"group"===t.options.shaded.orientation){var u=t.options.shaded.groupId;if(-1===sr(r).call(r,u)){console.log(t.id+": Unknown shading group target given:"+u);continue}l.hasOwnProperty(u)||(l[u]=Fd.calcPath(s[u],this.groups[u])),Fd.drawShading(l[r[e]],t,l[u],this.framework)}else Fd.drawShading(l[r[e]],t,void 0,this.framework)}for(jd.draw(r,s,this.framework),e=0;e<r.length;e++)if(t=this.groups[r[e]],s[r[e]].length>0)switch(t.options.style){case"line":l.hasOwnProperty(r[e])||(l[r[e]]=Fd.calcPath(s[r[e]],t)),Fd.draw(l[r[e]],t,this.framework);case"point":case"points":"point"!=t.options.style&&"points"!=t.options.style&&1!=t.options.drawPoints.enabled||Rd.draw(s[r[e]],t,this.framework)}}}return Dd(this.svgElements),!1},Hd.prototype._stack=function(t,e){var i,n,o,r,s;i=0;for(var a=0;a<t.length;a++){r=void 0,s=void 0;for(var l=i;l<e.length;l++){if(e[l].x===t[a].x){r=e[l],s=e[l],i=l;break}if(e[l].x>t[a].x){s=e[l],r=0==l?s:e[l-1],i=l;break}}void 0===s&&(r=e[e.length-1],s=e[e.length-1]),n=s.x-r.x,o=s.y-r.y,t[a].y=0==n?t[a].orginalY+s.y:t[a].orginalY+o/n*(t[a].x-r.x)+r.y}},Hd.prototype._getRelevantData=function(t,e,i,n){var o,r,s,a;if(t.length>0)for(r=0;r<t.length;r++){var l=(o=this.groups[t[r]]).getItems();if(1==qs(o.options)){var h=function(t,e){return t.getTime()==e.getTime()?0:t<e?-1:1},u=Math.max(0,Os.binarySearchValue(l,i,"x","before",h)),d=Math.min(l.length,Os.binarySearchValue(l,n,"x","after",h)+1);d<=0&&(d=l.length);var c=new Array(d-u);for(s=u;s<d;s++)a=o.itemsData[s],c[s-u]=a;e[t[r]]=c}else e[t[r]]=o.itemsData}},Hd.prototype._applySampling=function(t,e){if(t.length>0)for(var i=0;i<t.length;i++)if(1==this.groups[t[i]].options.sampling){var n=e[t[i]];if(n.length>0){var o,r=n.length,s=r/(this.body.util.toGlobalScreen(n[n.length-1].x)-this.body.util.toGlobalScreen(n[0].x));o=Math.min(Math.ceil(.2*r),Math.max(1,Math.round(s)));for(var a=new Array(r),l=0;l<r;l+=o){a[Math.round(l/o)]=n[l]}e[t[i]]=Oa(a).call(a,0,Math.round(r/o))}}},Hd.prototype._getYRanges=function(t,e,i){var n,o,r,s,a=[],l=[];if(t.length>0){for(r=0;r<t.length;r++)n=e[t[r]],s=this.groups[t[r]].options,n.length>0&&(o=this.groups[t[r]],!0===s.stack&&"bar"===s.style?"left"===s.yAxisOrientation?a=zr(a).call(a,n):l=zr(l).call(l,n):i[t[r]]=o.getYRange(n,t[r]));jd.getStackedYRange(a,i,t,"__barStackLeft","left"),jd.getStackedYRange(l,i,t,"__barStackRight","right")}},Hd.prototype._updateYAxis=function(t,e){var i,n,o=!1,r=!1,s=!1,a=1e9,l=1e9,h=-1e9,u=-1e9;if(t.length>0){for(var d=0;d<t.length;d++){var c=this.groups[t[d]];c&&"right"!=c.options.yAxisOrientation?(r=!0,a=1e9,h=-1e9):c&&c.options.yAxisOrientation&&(s=!0,l=1e9,u=-1e9)}for(d=0;d<t.length;d++)e.hasOwnProperty(t[d])&&!0!==e[t[d]].ignore&&(i=e[t[d]].min,n=e[t[d]].max,"right"!=e[t[d]].yAxisOrientation?(r=!0,a=a>i?i:a,h=h<n?n:h):(s=!0,l=l>i?i:l,u=u<n?n:u));1==r&&this.yAxisLeft.setRange(a,h),1==s&&this.yAxisRight.setRange(l,u)}o=this._toggleAxisVisiblity(r,this.yAxisLeft)||o,o=this._toggleAxisVisiblity(s,this.yAxisRight)||o,1==s&&1==r?(this.yAxisLeft.drawIcons=!0,this.yAxisRight.drawIcons=!0):(this.yAxisLeft.drawIcons=!1,this.yAxisRight.drawIcons=!1),this.yAxisRight.master=!r,this.yAxisRight.masterAxis=this.yAxisLeft,0==this.yAxisRight.master?(this.yAxisLeft.lineOffset=1==s?this.yAxisRight.width:0,o=this.yAxisLeft.redraw()||o,o=this.yAxisRight.redraw()||o):o=this.yAxisRight.redraw()||o;var p=["__barStackLeft","__barStackRight","__lineStackLeft","__lineStackRight"];for(d=0;d<p.length;d++)-1!=sr(t).call(t,p[d])&&Oa(t).call(t,sr(t).call(t,p[d]),1);return o},Hd.prototype._toggleAxisVisiblity=function(t,e){var i=!1;return 0==t?e.dom.frame.parentNode&&0==e.hidden&&(e.hide(),i=!0):e.dom.frame.parentNode||1!=e.hidden||(e.show(),i=!0),i},Hd.prototype._convertXcoordinates=function(t){for(var e=this.body.util.toScreen,i=0;i<t.length;i++)t[i].screen_x=e(t[i].x)+this.props.width,t[i].screen_y=t[i].y,null!=t[i].end?t[i].screen_end=e(t[i].end)+this.props.width:t[i].screen_end=void 0},Hd.prototype._convertYcoordinates=function(t,e){var i=this.yAxisLeft,n=Number(this.svg.style.height.replace("px",""));"right"==e.options.yAxisOrientation&&(i=this.yAxisRight);for(var o=0;o<t.length;o++)t[o].screen_y=Math.round(i.convertValue(t[o].y));e.setZeroPosition(Math.min(n,i.convertValue(0)))};var Bd="boolean",Yd={configure:{enabled:{boolean:Bd},filter:{boolean:Bd,function:"function"},container:{dom:"dom"},__type__:{object:"object",boolean:Bd,function:"function"}},alignCurrentTime:{string:"string",undefined:"undefined"},yAxisOrientation:{string:["left","right"]},defaultGroup:{string:"string"},sort:{boolean:Bd},sampling:{boolean:Bd},stack:{boolean:Bd},graphHeight:{string:"string",number:"number"},shaded:{enabled:{boolean:Bd},orientation:{string:["bottom","top","zero","group"]},groupId:{object:"object"},__type__:{boolean:Bd,object:"object"}},style:{string:["line","bar","points"]},barChart:{width:{number:"number"},minWidth:{number:"number"},sideBySide:{boolean:Bd},align:{string:["left","center","right"]},__type__:{object:"object"}},interpolation:{enabled:{boolean:Bd},parametrization:{string:["centripetal","chordal","uniform"]},alpha:{number:"number"},__type__:{object:"object",boolean:Bd}},drawPoints:{enabled:{boolean:Bd},onRender:{function:"function"},size:{number:"number"},style:{string:["square","circle"]},__type__:{object:"object",boolean:Bd,function:"function"}},dataAxis:{showMinorLabels:{boolean:Bd},showMajorLabels:{boolean:Bd},showWeekScale:{boolean:Bd},icons:{boolean:Bd},width:{string:"string",number:"number"},visible:{boolean:Bd},alignZeros:{boolean:Bd},left:{range:{min:{number:"number",undefined:"undefined"},max:{number:"number",undefined:"undefined"},__type__:{object:"object"}},format:{function:"function"},title:{text:{string:"string",number:"number",undefined:"undefined"},style:{string:"string",undefined:"undefined"},__type__:{object:"object"}},__type__:{object:"object"}},right:{range:{min:{number:"number",undefined:"undefined"},max:{number:"number",undefined:"undefined"},__type__:{object:"object"}},format:{function:"function"},title:{text:{string:"string",number:"number",undefined:"undefined"},style:{string:"string",undefined:"undefined"},__type__:{object:"object"}},__type__:{object:"object"}},__type__:{object:"object"}},legend:{enabled:{boolean:Bd},icons:{boolean:Bd},left:{visible:{boolean:Bd},position:{string:["top-right","bottom-right","top-left","bottom-left"]},__type__:{object:"object"}},right:{visible:{boolean:Bd},position:{string:["top-right","bottom-right","top-left","bottom-left"]},__type__:{object:"object"}},__type__:{object:"object",boolean:Bd}},groups:{visibility:{any:"any"},__type__:{object:"object"}},autoResize:{boolean:Bd},throttleRedraw:{number:"number"},clickToUse:{boolean:Bd},end:{number:"number",date:"date",string:"string",moment:"moment"},format:{minorLabels:{millisecond:{string:"string",undefined:"undefined"},second:{string:"string",undefined:"undefined"},minute:{string:"string",undefined:"undefined"},hour:{string:"string",undefined:"undefined"},weekday:{string:"string",undefined:"undefined"},day:{string:"string",undefined:"undefined"},week:{string:"string",undefined:"undefined"},month:{string:"string",undefined:"undefined"},quarter:{string:"string",undefined:"undefined"},year:{string:"string",undefined:"undefined"},__type__:{object:"object"}},majorLabels:{millisecond:{string:"string",undefined:"undefined"},second:{string:"string",undefined:"undefined"},minute:{string:"string",undefined:"undefined"},hour:{string:"string",undefined:"undefined"},weekday:{string:"string",undefined:"undefined"},day:{string:"string",undefined:"undefined"},week:{string:"string",undefined:"undefined"},month:{string:"string",undefined:"undefined"},quarter:{string:"string",undefined:"undefined"},year:{string:"string",undefined:"undefined"},__type__:{object:"object"}},__type__:{object:"object"}},moment:{function:"function"},height:{string:"string",number:"number"},hiddenDates:{start:{date:"date",number:"number",string:"string",moment:"moment"},end:{date:"date",number:"number",string:"string",moment:"moment"},repeat:{string:"string"},__type__:{object:"object",array:"array"}},locale:{string:"string"},locales:{__any__:{any:"any"},__type__:{object:"object"}},max:{date:"date",number:"number",string:"string",moment:"moment"},maxHeight:{number:"number",string:"string"},maxMinorChars:{number:"number"},min:{date:"date",number:"number",string:"string",moment:"moment"},minHeight:{number:"number",string:"string"},moveable:{boolean:Bd},multiselect:{boolean:Bd},orientation:{string:"string"},showCurrentTime:{boolean:Bd},showMajorLabels:{boolean:Bd},showMinorLabels:{boolean:Bd},showWeekScale:{boolean:Bd},start:{date:"date",number:"number",string:"string",moment:"moment"},timeAxis:{scale:{string:"string",undefined:"undefined"},step:{number:"number",undefined:"undefined"},__type__:{object:"object"}},width:{string:"string",number:"number"},zoomable:{boolean:Bd},zoomKey:{string:["ctrlKey","altKey","metaKey",""]},zoomMax:{number:"number"},zoomMin:{number:"number"},zIndex:{number:"number"},__type__:{object:"object"}},Wd={global:{alignCurrentTime:["none","year","month","quarter","week","isoWeek","day","date","hour","minute","second"],sort:!0,sampling:!0,stack:!1,shaded:{enabled:!1,orientation:["zero","top","bottom","group"]},style:["line","bar","points"],barChart:{width:[50,5,100,5],minWidth:[50,5,100,5],sideBySide:!1,align:["left","center","right"]},interpolation:{enabled:!0,parametrization:["centripetal","chordal","uniform"]},drawPoints:{enabled:!0,size:[6,2,30,1],style:["square","circle"]},dataAxis:{showMinorLabels:!0,showMajorLabels:!0,showWeekScale:!1,icons:!1,width:[40,0,200,1],visible:!0,alignZeros:!0,left:{title:{text:"",style:""}},right:{title:{text:"",style:""}}},legend:{enabled:!1,icons:!0,left:{visible:!0,position:["top-right","bottom-right","top-left","bottom-left"]},right:{visible:!0,position:["top-right","bottom-right","top-left","bottom-left"]}},autoResize:!0,clickToUse:!1,end:"",format:{minorLabels:{millisecond:"SSS",second:"s",minute:"HH:mm",hour:"HH:mm",weekday:"ddd D",day:"D",week:"w",month:"MMM",quarter:"[Q]Q",year:"YYYY"},majorLabels:{millisecond:"HH:mm:ss",second:"D MMMM HH:mm",minute:"ddd D MMMM",hour:"ddd D MMMM",weekday:"MMMM YYYY",day:"MMMM YYYY",week:"MMMM YYYY",month:"YYYY",quarter:"YYYY",year:""}},height:"",locale:"",max:"",maxHeight:"",maxMinorChars:[7,0,20,1],min:"",minHeight:"",moveable:!0,orientation:["both","bottom","top"],showCurrentTime:!1,showMajorLabels:!0,showMinorLabels:!0,showWeekScale:!1,start:"",width:"100%",zoomable:!0,zoomKey:["ctrlKey","altKey","metaKey",""],zoomMax:[31536e10,10,31536e10,1],zoomMin:[10,10,31536e10,1],zIndex:0}};function Vd(t,i,o,r){var s,a,l,h,u,d,c;if(!(Di(o)||o instanceof e||o instanceof n)&&o instanceof Object){var p=r;r=o,o=p}r&&r.throttleRedraw&&console.warn('Graph2d option "throttleRedraw" is DEPRICATED and no longer supported. It will be removed in the next MAJOR release.');var m=this;this.defaultOptions={start:null,end:null,autoResize:!0,orientation:{axis:"bottom",item:"bottom"},moment:Wn,width:null,height:null,maxHeight:null,minHeight:null},this.options=Os.deepExtend({},this.defaultOptions),this._create(t),this.components=[],this.body={dom:this.dom,domProps:this.props,emitter:{on:xi(s=this.on).call(s,this),off:xi(a=this.off).call(a,this),emit:xi(l=this.emit).call(l,this)},hiddenDates:[],util:{toScreen:xi(h=m._toScreen).call(h,m),toGlobalScreen:xi(u=m._toGlobalScreen).call(u,m),toTime:xi(d=m._toTime).call(d,m),toGlobalTime:xi(c=m._toGlobalTime).call(c,m)}},this.range=new pa(this.body),this.components.push(this.range),this.body.range=this.range,this.timeAxis=new lh(this.body),this.components.push(this.timeAxis),this.currentTime=new Oh(this.body),this.components.push(this.currentTime),this.linegraph=new Hd(this.body),this.components.push(this.linegraph),this.itemsData=null,this.groupsData=null,this.on("tap",(function(t){m.emit("click",m.getEventProperties(t))})),this.on("doubletap",(function(t){m.emit("doubleClick",m.getEventProperties(t))})),this.dom.root.oncontextmenu=function(t){m.emit("contextmenu",m.getEventProperties(t))},this.initialFitDone=!1,this.on("changed",(function(){if(null!=m.itemsData){if(!m.initialFitDone&&!m.options.rollingMode)if(m.initialFitDone=!0,null!=m.options.start||null!=m.options.end){if(null==m.options.start||null==m.options.end)var t=m.getItemRange();var e=null!=m.options.start?m.options.start:t.min,i=null!=m.options.end?m.options.end:t.max;m.setWindow(e,i,{animation:!1})}else m.fit({animation:!1});m.initialDrawDone||!m.initialRangeChangeDone&&(m.options.start||m.options.end)&&!m.options.rollingMode||(m.initialDrawDone=!0,m.dom.root.style.visibility="visible",m.dom.loadingScreen.parentNode.removeChild(m.dom.loadingScreen),m.options.onInitialDrawComplete&&wi((function(){return m.options.onInitialDrawComplete()}),0))}})),r&&this.setOptions(r),o&&this.setGroups(o),i&&this.setItems(i),this._redraw()}Vd.prototype=new Ch,Vd.prototype.setOptions=function(t){!0===sd.validate(t,Yd)&&console.log("%cErrors have been found in the supplied options object.",rd),Ch.prototype.setOptions.call(this,t)},Vd.prototype.setItems=function(t){var i,o=null==this.itemsData;if(i=t?Ts(t instanceof e||t instanceof n?t:new e(t)):null,this.itemsData&&this.itemsData.dispose(),this.itemsData=i,this.linegraph&&this.linegraph.setItems(null!=i?i.rawDS:null),o)if(null!=this.options.start||null!=this.options.end){var r=null!=this.options.start?this.options.start:null,s=null!=this.options.end?this.options.end:null;this.setWindow(r,s,{animation:!1})}else this.fit({animation:!1})},Vd.prototype.setGroups=function(t){var i;i=t?t instanceof e||t instanceof n?t:new e(t):null,this.groupsData=i,this.linegraph.setGroups(i)},Vd.prototype.getLegend=function(t,e,i){return void 0===e&&(e=15),void 0===i&&(i=15),void 0!==this.linegraph.groups[t]?this.linegraph.groups[t].getLegend(e,i):"cannot find group:'"+t+"'"},Vd.prototype.isGroupVisible=function(t){return void 0!==this.linegraph.groups[t]&&(this.linegraph.groups[t].visible&&(void 0===this.linegraph.options.groups.visibility[t]||1==this.linegraph.options.groups.visibility[t]))},Vd.prototype.getDataRange=function(){var t=null,e=null;for(var i in this.linegraph.groups)if(this.linegraph.groups.hasOwnProperty(i)&&1==this.linegraph.groups[i].visible)for(var n=0;n<this.linegraph.groups[i].itemsData.length;n++){var o=this.linegraph.groups[i].itemsData[n],r=Os.convert(o.x,"Date").valueOf();t=null==t||t>r?r:t,e=null==e||e<r?r:e}return{min:null!=t?new Date(t):null,max:null!=e?new Date(e):null}},Vd.prototype.getEventProperties=function(t){var e=t.center?t.center.x:t.clientX,i=t.center?t.center.y:t.clientY,n=e-Os.getAbsoluteLeft(this.dom.centerContainer),o=i-Os.getAbsoluteTop(this.dom.centerContainer),r=this._toTime(n),s=Dh.customTimeFromTarget(t),a=Os.getTarget(t),l=null;Os.hasParent(a,this.timeAxis.dom.foreground)||this.timeAxis2&&Os.hasParent(a,this.timeAxis2.dom.foreground)?l="axis":Os.hasParent(a,this.linegraph.yAxisLeft.dom.frame)||Os.hasParent(a,this.linegraph.yAxisRight.dom.frame)?l="data-axis":Os.hasParent(a,this.linegraph.legendLeft.dom.frame)||Os.hasParent(a,this.linegraph.legendRight.dom.frame)?l="legend":null!=s?l="custom-time":Os.hasParent(a,this.currentTime.bar)?l="current-time":Os.hasParent(a,this.dom.center)&&(l="background");var h=[],u=this.linegraph.yAxisLeft,d=this.linegraph.yAxisRight;return!u.hidden&&this.itemsData.length>0&&h.push(u.screenToValue(o)),!d.hidden&&this.itemsData.length>0&&h.push(d.screenToValue(o)),{event:t,customTime:s?s.options.id:null,what:l,pageX:t.srcEvent?t.srcEvent.pageX:t.pageX,pageY:t.srcEvent?t.srcEvent.pageY:t.pageY,x:n,y:o,time:r,value:h}},Vd.prototype._createConfigurator=function(){return new yd(this,this.dom.container,Wd)};var Ud=function(){try{return navigator?navigator.languages&&navigator.languages.length?navigator.languages:navigator.userLanguage||navigator.language||navigator.browserLanguage||"en":"en"}catch(t){return"en"}}();t.locale(Ud);var Xd={Core:Ch,DateUtil:da,Range:pa,stack:_u,TimeStep:sh,components:{items:{Item:Ou,BackgroundItem:Lu,BoxItem:Iu,PointItem:Au,RangeItem:Nu},BackgroundGroup:Du,Component:Gs,CurrentTime:Oh,CustomTime:Dh,DataAxis:Nd,DataScale:Id,GraphGroup:zd,Group:xu,ItemSet:id,Legend:Gd,LineGraph:Hd,TimeAxis:lh}};export{Vd as Graph2d,wd as Timeline,Xd as timeline};
//# sourceMappingURL=vis-timeline-graph2d.min.js.map
